(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.3' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[    245984,       5099]
NotebookOptionsPosition[    230778,       4838]
NotebookOutlinePosition[    231133,       4854]
CellTagsIndexPosition[    231090,       4851]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell["Lempel\[Dash]Ziv encoding and decoding", "Section",
 CellChangeTimes->{{3.784655088694475*^9, 3.7846550922881117`*^9}, {
  3.7848250301837378`*^9, 
  3.7848250314398613`*^9}},ExpressionUUID->"71e0176d-c335-43a7-8158-\
16e8baa297db"],

Cell[CellGroupData[{

Cell["Preliminary functions", "Subsubsection",
 CellChangeTimes->{{3.785075902011648*^9, 
  3.785075903923799*^9}},ExpressionUUID->"95f52f2f-fb58-4660-8273-\
3f156cf740e0"],

Cell[BoxData[
 RowBox[{
  RowBox[{"ToBinaryLE", "[", 
   RowBox[{"0", ",", "_"}], "]"}], ":=", 
  RowBox[{"{", "}"}]}]], "Input",
 CellChangeTimes->{{3.784818909159525*^9, 3.784818917647101*^9}},
 CellLabel->
  "In[792]:=",ExpressionUUID->"34187b30-e74b-4edb-8c58-0d8621ff79d4"],

Cell[BoxData[
 RowBox[{
  RowBox[{"ToBinaryLE", "[", 
   RowBox[{"l_", ",", "x_"}], "]"}], ":=", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"Mod", "[", 
     RowBox[{"x", ",", "2"}], "]"}], "}"}], "~", "Join", "~", 
   RowBox[{"ToBinaryLE", "[", 
    RowBox[{
     RowBox[{"l", "-", "1"}], ",", 
     RowBox[{"Quotient", "[", 
      RowBox[{"x", ",", "2"}], "]"}]}], "]"}]}]}]], "Input",
 CellChangeTimes->{{3.7848188833545322`*^9, 3.7848189273302593`*^9}},
 CellLabel->
  "In[793]:=",ExpressionUUID->"67b72d17-b089-4123-8417-9e577a0c61c2"],

Cell[BoxData[
 RowBox[{
  RowBox[{"ToBinary", "[", 
   RowBox[{"l_", ",", "x_"}], "]"}], ":=", 
  RowBox[{
   RowBox[{"ToBinaryLE", "[", 
    RowBox[{"l", ",", "x"}], "]"}], "//", "Reverse"}]}]], "Input",
 CellChangeTimes->{{3.784818913153555*^9, 3.784818939480802*^9}},
 CellLabel->
  "In[794]:=",ExpressionUUID->"5c7c2389-0290-4db4-bdab-ea34da654adc"],

Cell[BoxData[
 RowBox[{
  RowBox[{"FromBinary", "[", "bs_", "]"}], ":=", 
  RowBox[{"FromBinaryLE", "[", 
   RowBox[{"bs", "//", "Reverse"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.784826866790262*^9, 3.784826876428035*^9}},
 CellLabel->
  "In[795]:=",ExpressionUUID->"805fd72e-02d7-4a76-98f6-5cc333108bde"],

Cell[BoxData[
 RowBox[{
  RowBox[{"FromBinaryLE", "[", 
   RowBox[{"{", "}"}], "]"}], ":=", "0"}]], "Input",
 CellChangeTimes->{{3.784826877282872*^9, 3.784826883400885*^9}},
 CellLabel->
  "In[796]:=",ExpressionUUID->"99f16aa0-eb49-4148-af82-931f931bbf94"],

Cell[BoxData[
 RowBox[{
  RowBox[{"FromBinaryLE", "[", 
   RowBox[{"{", 
    RowBox[{"x_", ",", "xs___"}], "}"}], "]"}], ":=", 
  RowBox[{"x", "+", 
   RowBox[{"2", "*", 
    RowBox[{"FromBinaryLE", "[", 
     RowBox[{"xs", "//", "List"}], "]"}]}]}]}]], "Input",
 CellChangeTimes->{{3.784826884043572*^9, 3.7848269174002857`*^9}},
 CellLabel->
  "In[797]:=",ExpressionUUID->"419ae4f4-d395-4f92-8316-16062780c9eb"],

Cell[BoxData[
 RowBox[{
  RowBox[{"TF", "[", "xs_", "]"}], ":=", 
  RowBox[{"TableForm", "[", 
   RowBox[{"xs", ",", 
    RowBox[{"TableDepth", "\[Rule]", "2"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.78482194625737*^9, 3.784821952227086*^9}},
 CellLabel->
  "In[798]:=",ExpressionUUID->"0996957a-3bfc-43d8-a8ff-20a1bc6298f5"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Lempel\[Dash]Ziv encoding", "Section",
 CellChangeTimes->{{3.784825034198957*^9, 
  3.784825037514133*^9}},ExpressionUUID->"0123ad71-1a3a-47af-9c31-\
11ea77e0c5b4"],

Cell[BoxData[
 RowBox[{
  RowBox[{"LengthLongestPrefix", "[", 
   RowBox[{"dict_", ",", "xs_"}], "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", "m", "}"}], ",", 
    RowBox[{"If", "[", 
     RowBox[{
      RowBox[{"KeyExistsQ", "[", 
       RowBox[{"dict", ",", "xs"}], "]"}], ",", 
      RowBox[{"Length", "[", "xs", "]"}], ",", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"For", "[", 
        RowBox[{
         RowBox[{"m", "=", "1"}], ",", 
         RowBox[{"KeyExistsQ", "[", 
          RowBox[{"dict", ",", 
           RowBox[{"xs", "[", 
            RowBox[{"[", 
             RowBox[{"1", ";;", "m"}], "]"}], "]"}]}], "]"}], ",", 
         RowBox[{"m", "=", 
          RowBox[{"m", "+", "1"}]}], ",", "Null"}], "]"}], ";", 
       RowBox[{"m", "-", "1"}]}]}], "]"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.78465569730779*^9, 3.7846557021726513`*^9}, {
  3.784655734027452*^9, 3.784655736383966*^9}, {3.784655788469046*^9, 
  3.784655871459318*^9}, {3.784816407587088*^9, 3.784816463772545*^9}, {
  3.784816739681425*^9, 3.784816747519165*^9}, {3.78481681672543*^9, 
  3.784816818106373*^9}},
 CellLabel->
  "In[799]:=",ExpressionUUID->"5e235ebe-7198-4409-9f42-1968a22d12bd"],

Cell[BoxData[
 RowBox[{
  RowBox[{"ExtendLempelZiv", "[", 
   RowBox[{"dict_", ",", "xs_"}], "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"m", "=", 
       RowBox[{"LengthLongestPrefix", "[", 
        RowBox[{"dict", ",", "xs"}], "]"}]}], ",", 
      RowBox[{"r", "=", 
       RowBox[{"Max", "[", 
        RowBox[{"Values", "[", "dict", "]"}], "]"}]}], ",", "dictNew"}], 
     "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{"If", "[", 
     RowBox[{
      RowBox[{"m", "\[Equal]", 
       RowBox[{"Length", "[", "xs", "]"}]}], ",", "\[IndentingNewLine]", 
      RowBox[{"{", 
       RowBox[{"dict", ",", 
        RowBox[{"{", 
         RowBox[{"xs", ",", 
          RowBox[{"dict", "[", "xs", "]"}]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"dict", "[", "xs", "]"}], ",", 
          RowBox[{"{", "}"}]}], "}"}], ",", 
        RowBox[{"{", "}"}]}], "}"}], ",", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"dictNew", "=", 
        RowBox[{"Append", "[", 
         RowBox[{"dict", ",", 
          RowBox[{
           RowBox[{"xs", "[", 
            RowBox[{"[", 
             RowBox[{"1", ";;", 
              RowBox[{"m", "+", "1"}]}], "]"}], "]"}], "->", 
           RowBox[{"r", "+", "1"}]}]}], "]"}]}], ";", 
       RowBox[{"{", 
        RowBox[{"dictNew", ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"xs", "[", 
            RowBox[{"[", 
             RowBox[{"1", ";;", 
              RowBox[{"m", "+", "1"}]}], "]"}], "]"}], ",", 
           RowBox[{"r", "+", "1"}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"dict", "[", 
            RowBox[{"xs", "[", 
             RowBox[{"[", 
              RowBox[{"1", ";;", "m"}], "]"}], "]"}], "]"}], ",", 
           RowBox[{"{", 
            RowBox[{"xs", "[", 
             RowBox[{"[", 
              RowBox[{"m", "+", "1"}], "]"}], "]"}], "}"}]}], "}"}], ",", 
         RowBox[{"xs", "[", 
          RowBox[{"[", 
           RowBox[{
            RowBox[{"m", "+", "2"}], ";;"}], "]"}], "]"}]}], "}"}]}]}], 
     "]"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.78465509320017*^9, 3.7846551170614357`*^9}, {
  3.784655343479044*^9, 3.784655693684923*^9}, {3.784656037357543*^9, 
  3.7846561046525307`*^9}, {3.784816501257977*^9, 3.784816503788732*^9}, {
  3.7848166617337103`*^9, 3.784816708459798*^9}, {3.784816754155067*^9, 
  3.7848167627128897`*^9}, {3.784817839697773*^9, 3.7848179321975803`*^9}, {
  3.784819314148705*^9, 3.784819315512249*^9}},
 CellLabel->
  "In[800]:=",ExpressionUUID->"40603496-ee41-4879-a93d-2f4deedefa65"],

Cell[BoxData[
 RowBox[{"StartDictionary", ":=", 
  RowBox[{"<|", 
   RowBox[{
    RowBox[{"{", "}"}], "\[Rule]", "0"}], "|>"}]}]], "Input",
 CellChangeTimes->{{3.784816861267577*^9, 3.784816875888068*^9}},
 CellLabel->
  "In[801]:=",ExpressionUUID->"136b24a8-e123-4baa-80fb-dad0121f9d38"],

Cell[BoxData[
 RowBox[{
  RowBox[{"LempelZivFrom", "[", 
   RowBox[{"dict_", ",", "xs_", ",", "ys_"}], "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
     "dictNew", ",", "keyNew", ",", "valueNew", ",", "valueUsed", ",", 
      "newBit", ",", "xsNew", ",", "ysNew"}], "}"}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{
      RowBox[{"{", 
       RowBox[{"dictNew", ",", 
        RowBox[{"{", 
         RowBox[{"keyNew", ",", "valueNew"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"valueUsed", ",", "newBit"}], "}"}], ",", "xsNew"}], "}"}], 
      "=", 
      RowBox[{"ExtendLempelZiv", "[", 
       RowBox[{"dict", ",", "xs"}], "]"}]}], ";", 
     RowBox[{"ysNew", "=", 
      RowBox[{"ys", "~", "Join", "~", 
       RowBox[{"{", 
        RowBox[{"{", 
         RowBox[{"valueUsed", ",", "newBit"}], "}"}], "}"}]}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{"xsNew", "\[Equal]", 
        RowBox[{"{", "}"}]}], ",", 
       RowBox[{"{", 
        RowBox[{"dictNew", ",", "ysNew"}], "}"}], ",", 
       RowBox[{"LempelZivFrom", "[", 
        RowBox[{"dictNew", ",", "xsNew", ",", "ysNew"}], "]"}]}], "]"}]}]}], 
   "]"}]}]], "Input",
 CellChangeTimes->{{3.784816886171625*^9, 3.784817041457206*^9}, {
  3.784817443895262*^9, 3.784817516346733*^9}, {3.78481794514292*^9, 
  3.7848180062277517`*^9}},
 CellLabel->
  "In[802]:=",ExpressionUUID->"9844e364-67c9-4943-bbd9-50bb8c68c329"],

Cell[BoxData[
 RowBox[{
  RowBox[{"LempelZivPairs", "[", "xs_", "]"}], ":=", 
  RowBox[{"LempelZivFrom", "[", 
   RowBox[{"StartDictionary", ",", "xs", ",", 
    RowBox[{"{", "}"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.7848183867641163`*^9, 3.784818398880559*^9}, {
  3.784819072406722*^9, 3.7848190729125633`*^9}},
 CellLabel->
  "In[803]:=",ExpressionUUID->"b1d1e10c-85ef-4614-9513-7f1bdfec04b3"],

Cell["\<\
At step t the dictionary has t words and the pointer to the word we are \
extended takes values in {0,..,t-1}, and so can be stored using \
Ceiling(Log[2,t]) bits.\
\>", "Subsubsection",
 CellChangeTimes->{{3.784818428301551*^9, 3.7848184941787157`*^9}, {
  3.784818616872718*^9, 3.7848186204879007`*^9}, {3.784818705693565*^9, 
  3.784818712330304*^9}},ExpressionUUID->"2a791389-d59b-4a79-822f-\
782d44116269"],

Cell[CellGroupData[{

Cell["\<\
E.g. step 1 must point to 0, so empty word; steps 2 points to 0 or 1, so 1 \
bit, steps 3 and 4 point to 0,1,2 / 0,1,2,3 so 2 bits, steps 5,6,7,8 point to \
0,1,2,3,4 ..., 7 so 3 bits, and so on.\
\>", "Subsubsection",
 CellChangeTimes->{{3.784818498962572*^9, 3.784818514212536*^9}, {
  3.784818552363505*^9, 
  3.78481861049673*^9}},ExpressionUUID->"81bc71a8-4d89-4f0e-94de-\
6e356bc7fa90"],

Cell[BoxData[
 RowBox[{
  RowBox[{"LempelZivBinaryPairs", "[", "xs_", "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"dict", ",", "ys"}], "}"}], ",", 
    RowBox[{
     RowBox[{
      RowBox[{"{", 
       RowBox[{"dict", ",", "ys"}], "}"}], "=", 
      RowBox[{"LempelZivPairs", "[", "xs", "]"}]}], ";", 
     RowBox[{"{", 
      RowBox[{"dict", ",", 
       RowBox[{"Table", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"ToBinary", "[", 
            RowBox[{
             RowBox[{"Ceiling", "[", 
              RowBox[{"Log", "[", 
               RowBox[{"2", ",", "t"}], "]"}], "]"}], ",", 
             RowBox[{
              RowBox[{"ys", "[", 
               RowBox[{"[", "t", "]"}], "]"}], "[", 
              RowBox[{"[", "1", "]"}], "]"}]}], "]"}], ",", 
           RowBox[{
            RowBox[{"ys", "[", 
             RowBox[{"[", "t", "]"}], "]"}], "[", 
            RowBox[{"[", "2", "]"}], "]"}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"t", ",", "1", ",", 
           RowBox[{"Length", "[", "ys", "]"}]}], "}"}]}], "]"}]}], "}"}]}]}], 
   "]"}]}]], "Input",
 CellChangeTimes->{{3.784818635741954*^9, 3.7848187035913677`*^9}, {
  3.7848188297611933`*^9, 3.7848188749690943`*^9}, {3.784818968508958*^9, 
  3.784819001448864*^9}, {3.784819076857656*^9, 3.784819081886777*^9}, {
  3.78481928114003*^9, 3.784819283275709*^9}},
 CellLabel->
  "In[804]:=",ExpressionUUID->"d38768b3-bffa-4369-bc65-16b1eb228790"],

Cell[BoxData[
 RowBox[{
  RowBox[{"LempelZivWords", "[", "xs_", "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"dict", ",", "zs"}], "}"}], ",", 
    RowBox[{
     RowBox[{
      RowBox[{"{", 
       RowBox[{"dict", ",", "zs"}], "}"}], "=", 
      RowBox[{"LempelZivBinaryPairs", "[", "xs", "]"}]}], ";", 
     RowBox[{"{", 
      RowBox[{"dict", ",", 
       RowBox[{"Table", "[", 
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{"zs", "[", 
            RowBox[{"[", "t", "]"}], "]"}], "[", 
           RowBox[{"[", "1", "]"}], "]"}], "~", "Join", "~", 
          RowBox[{
           RowBox[{"zs", "[", 
            RowBox[{"[", "t", "]"}], "]"}], "[", 
           RowBox[{"[", "2", "]"}], "]"}]}], ",", 
         RowBox[{"{", 
          RowBox[{"t", ",", "1", ",", 
           RowBox[{"Length", "[", "zs", "]"}]}], "}"}]}], "]"}]}], "}"}]}]}], 
   "]"}]}]], "Input",
 CellChangeTimes->{{3.7848190833798037`*^9, 3.784819178582567*^9}, {
  3.784819225055726*^9, 3.7848192667193003`*^9}, {3.78481933342661*^9, 
  3.7848193353546267`*^9}, {3.78481949530912*^9, 3.7848194958899307`*^9}},
 CellLabel->
  "In[805]:=",ExpressionUUID->"0311b7c4-44e0-4c03-9b2a-c3660a9e3175"],

Cell[BoxData[
 RowBox[{
  RowBox[{"LempelZivWithDictionary", "[", "xs_", "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"dict", ",", "ws"}], "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{
      RowBox[{"{", 
       RowBox[{"dict", ",", "ws"}], "}"}], "=", 
      RowBox[{"LempelZivWords", "[", "xs", "]"}]}], ";", 
     RowBox[{"{", 
      RowBox[{"dict", ",", 
       RowBox[{"Join", "@@", "ws"}]}], "}"}]}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.7848194983882933`*^9, 3.784819578818904*^9}},
 CellLabel->
  "In[806]:=",ExpressionUUID->"27617b31-c9c5-4f28-b271-93fdbf0c847a"],

Cell[BoxData[
 RowBox[{
  RowBox[{"LempelZiv", "[", "xs_", "]"}], ":=", 
  RowBox[{
   RowBox[{"LempelZivWithDictionary", "[", "xs", "]"}], "[", 
   RowBox[{"[", "2", "]"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.7848195800799513`*^9, 3.784819589279368*^9}},
 CellLabel->
  "In[807]:=",ExpressionUUID->"9274d15d-348e-4986-9722-395d22bc1be6"]
}, Open  ]],

Cell[CellGroupData[{

Cell["Example of growing dictionary", "Subsection",
 CellChangeTimes->{{3.784656127793748*^9, 3.784656128370945*^9}, {
  3.78482025422048*^9, 
  3.784820260142839*^9}},ExpressionUUID->"6970314e-02be-4267-8830-\
ab007b8c2cc7"],

Cell[BoxData[
 RowBox[{"TestDictionary", ":=", 
  RowBox[{"<|", 
   RowBox[{
    RowBox[{
     RowBox[{"{", "}"}], "\[Rule]", "0"}], ",", 
    RowBox[{
     RowBox[{"{", "1", "}"}], "\[Rule]", "1"}], ",", 
    RowBox[{
     RowBox[{"{", "0", "}"}], "\[Rule]", "2"}], ",", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"0", ",", "0"}], "}"}], "\[Rule]", "3"}], ",", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"1", ",", "0"}], "}"}], "\[Rule]", "4"}], ",", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"1", ",", "0", ",", "1"}], "}"}], "\[Rule]", "5"}]}], 
   "|>"}]}]], "Input",
 CellChangeTimes->{{3.784655124713872*^9, 3.78465513978332*^9}, {
  3.7846552483843184`*^9, 3.784655279389133*^9}},
 CellLabel->
  "In[808]:=",ExpressionUUID->"8c68ec87-a857-4468-aac6-b3f0634591e9"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"LengthLongestPrefix", "[", 
  RowBox[{"TestDictionary", ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "0", ",", "1"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.784816549389122*^9, 3.7848165656306868`*^9}, {
  3.7848168012896357`*^9, 3.78481682848365*^9}},
 CellLabel->
  "In[809]:=",ExpressionUUID->"6fdf87a3-2d0d-43a8-8c14-11d2959bfc73"],

Cell[BoxData["3"], "Output",
 CellChangeTimes->{{3.784816557670685*^9, 3.784816566110612*^9}, 
   3.784816607069289*^9, 3.7848166746819353`*^9, 3.784816720567677*^9, {
   3.7848168018830347`*^9, 3.784816828776771*^9}, {3.78482023059737*^9, 
   3.784820235830398*^9}, 3.7848825052388783`*^9, 3.785060272354467*^9, 
   3.785082745955748*^9, 3.7854237644045887`*^9, 3.786972789784615*^9, 
   3.800086398024866*^9},
 CellLabel->
  "Out[809]=",ExpressionUUID->"54a3e0dc-f5cd-413c-b306-509302365be4"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ExtendLempelZiv", "[", 
  RowBox[{"TestDictionary", ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "0", ",", "1"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.784816332059721*^9, 3.7848163495304003`*^9}, {
  3.7848165284919033`*^9, 3.784816528742153*^9}, {3.784816778230833*^9, 
  3.784816780473279*^9}},
 CellLabel->
  "In[810]:=",ExpressionUUID->"cb1934ca-a86c-4a3b-81d1-6ea9bcbc0ac3"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"\[LeftAssociation]", 
    RowBox[{
     RowBox[{
      RowBox[{"{", "}"}], "\[Rule]", "0"}], ",", 
     RowBox[{
      RowBox[{"{", "1", "}"}], "\[Rule]", "1"}], ",", 
     RowBox[{
      RowBox[{"{", "0", "}"}], "\[Rule]", "2"}], ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"0", ",", "0"}], "}"}], "\[Rule]", "3"}], ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"1", ",", "0"}], "}"}], "\[Rule]", "4"}], ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"1", ",", "0", ",", "1"}], "}"}], "\[Rule]", "5"}]}], 
    "\[RightAssociation]"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"1", ",", "0", ",", "1"}], "}"}], ",", "5"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"5", ",", 
     RowBox[{"{", "}"}]}], "}"}], ",", 
   RowBox[{"{", "}"}]}], "}"}]], "Output",
 CellChangeTimes->{{3.7848163435426607`*^9, 3.784816350036502*^9}, 
   3.784816471546349*^9, {3.784816516499938*^9, 3.78481652913479*^9}, 
   3.7848166093892736`*^9, {3.784816644508128*^9, 3.784816669401421*^9}, 
   3.784816711258358*^9, {3.7848167671711483`*^9, 3.784816780748067*^9}, 
   3.784816830509663*^9, {3.784820224715979*^9, 3.784820236832191*^9}, 
   3.784882505349111*^9, 3.785060272518427*^9, 3.785082746086916*^9, 
   3.785423764497246*^9, 3.786972789904113*^9, 3.800086398130031*^9},
 CellLabel->
  "Out[810]=",ExpressionUUID->"20484482-a68b-4f07-bdfd-be559422cdbf"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ExtendLempelZiv", "[", 
  RowBox[{"TestDictionary", ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "0", ",", "1", ",", "0"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.784820242591878*^9, 3.78482024286068*^9}},
 CellLabel->
  "In[811]:=",ExpressionUUID->"283cf792-b395-4593-b233-eb12f9571641"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"\[LeftAssociation]", 
    RowBox[{
     RowBox[{
      RowBox[{"{", "}"}], "\[Rule]", "0"}], ",", 
     RowBox[{
      RowBox[{"{", "1", "}"}], "\[Rule]", "1"}], ",", 
     RowBox[{
      RowBox[{"{", "0", "}"}], "\[Rule]", "2"}], ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"0", ",", "0"}], "}"}], "\[Rule]", "3"}], ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"1", ",", "0"}], "}"}], "\[Rule]", "4"}], ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"1", ",", "0", ",", "1"}], "}"}], "\[Rule]", "5"}], ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"1", ",", "0", ",", "1", ",", "0"}], "}"}], "\[Rule]", "6"}]}],
     "\[RightAssociation]"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"1", ",", "0", ",", "1", ",", "0"}], "}"}], ",", "6"}], "}"}], 
   ",", 
   RowBox[{"{", 
    RowBox[{"5", ",", 
     RowBox[{"{", "0", "}"}]}], "}"}], ",", 
   RowBox[{"{", "}"}]}], "}"}]], "Output",
 CellChangeTimes->{3.784820243228093*^9, 3.784882505458197*^9, 
  3.78506027265098*^9, 3.785082746191169*^9, 3.7854237645874157`*^9, 
  3.786972790020844*^9, 3.8000863982469463`*^9},
 CellLabel->
  "Out[811]=",ExpressionUUID->"ef1416b6-785a-48a9-9ac6-de564f9dce15"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Example 13.9 (taken from Dr Kay\[CloseCurlyQuote]s notes)", "Subsection",
 CellChangeTimes->{{3.7848196838890953`*^9, 3.78481968514841*^9}, {
  3.784820264398016*^9, 3.784820267877812*^9}, {3.785060293822592*^9, 
  3.785060306218171*^9}},ExpressionUUID->"b7dae278-8a82-47d0-a079-\
0dad5dcc9dad"],

Cell[BoxData[
 RowBox[{"AKExample", ":=", 
  RowBox[{"{", 
   RowBox[{
   "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", 
    ",", "0", ",", "0", ",", "0", ",", "1", ",", "0"}], "}"}]}]], "Input",
 CellChangeTimes->{{3.784819687343313*^9, 3.784819692356545*^9}},
 CellLabel->
  "In[812]:=",ExpressionUUID->"c75d20a4-3a1c-4714-ac7a-0f46c89ab41b"],

Cell[BoxData[
 RowBox[{"AKExampleLZ", ":=", 
  RowBox[{"{", 
   RowBox[{
   "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", 
    ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",",
     "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0"}], 
   "}"}]}]], "Input",
 CellChangeTimes->{{3.784820155799152*^9, 3.784820176899078*^9}},
 CellLabel->
  "In[813]:=",ExpressionUUID->"13f90f0d-875e-4a47-8f00-244f0a84138a"],

Cell[BoxData[
 RowBox[{"AKExampleCheck", ":=", 
  RowBox[{
   RowBox[{"LempelZiv", "[", "AKExample", "]"}], "\[Equal]", 
   "AKExampleLZ"}]}]], "Input",
 CellChangeTimes->{{3.784820181301743*^9, 3.7848201901451807`*^9}},
 CellLabel->
  "In[814]:=",ExpressionUUID->"d3f010c5-cdc9-4c5c-9461-d42d1219ebe9"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"LempelZivPairs", "[", "AKExample", "]"}]], "Input",
 CellChangeTimes->{3.784819737230752*^9},
 CellLabel->
  "In[815]:=",ExpressionUUID->"aa127229-fc6c-4b4a-b709-779d672aad99"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"\[LeftAssociation]", 
    RowBox[{
     RowBox[{
      RowBox[{"{", "}"}], "\[Rule]", "0"}], ",", 
     RowBox[{
      RowBox[{"{", "1", "}"}], "\[Rule]", "1"}], ",", 
     RowBox[{
      RowBox[{"{", "0", "}"}], "\[Rule]", "2"}], ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"1", ",", "1"}], "}"}], "\[Rule]", "3"}], ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"0", ",", "1"}], "}"}], "\[Rule]", "4"}], ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"0", ",", "1", ",", "0"}], "}"}], "\[Rule]", "5"}], ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"0", ",", "0"}], "}"}], "\[Rule]", "6"}], ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"1", ",", "0"}], "}"}], "\[Rule]", "7"}]}], 
    "\[RightAssociation]"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"0", ",", 
       RowBox[{"{", "1", "}"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", 
       RowBox[{"{", "0", "}"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", 
       RowBox[{"{", "1", "}"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", 
       RowBox[{"{", "1", "}"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"4", ",", 
       RowBox[{"{", "0", "}"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", 
       RowBox[{"{", "0", "}"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", 
       RowBox[{"{", "0", "}"}]}], "}"}]}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{3.784819737907362*^9, 3.784882505607575*^9, 
  3.7850602730220213`*^9, 3.785082746457087*^9, 3.7851332012383833`*^9, 
  3.785423764693116*^9, 3.786972790167568*^9, 3.800086398410943*^9},
 CellLabel->
  "Out[815]=",ExpressionUUID->"6a4f2a27-d52d-4764-9c7d-6dfe115b36ae"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"LempelZivBinaryPairs", "[", "AKExample", "]"}]], "Input",
 CellChangeTimes->{{3.7848196436489143`*^9, 3.784819660651124*^9}, {
  3.784819694502202*^9, 3.784819716542261*^9}},
 CellLabel->
  "In[816]:=",ExpressionUUID->"ac9015f7-c626-4c33-873f-4726b5b6905d"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"\[LeftAssociation]", 
    RowBox[{
     RowBox[{
      RowBox[{"{", "}"}], "\[Rule]", "0"}], ",", 
     RowBox[{
      RowBox[{"{", "1", "}"}], "\[Rule]", "1"}], ",", 
     RowBox[{
      RowBox[{"{", "0", "}"}], "\[Rule]", "2"}], ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"1", ",", "1"}], "}"}], "\[Rule]", "3"}], ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"0", ",", "1"}], "}"}], "\[Rule]", "4"}], ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"0", ",", "1", ",", "0"}], "}"}], "\[Rule]", "5"}], ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"0", ",", "0"}], "}"}], "\[Rule]", "6"}], ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"1", ",", "0"}], "}"}], "\[Rule]", "7"}]}], 
    "\[RightAssociation]"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", "}"}], ",", 
       RowBox[{"{", "1", "}"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", "0", "}"}], ",", 
       RowBox[{"{", "0", "}"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"0", ",", "1"}], "}"}], ",", 
       RowBox[{"{", "1", "}"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"1", ",", "0"}], "}"}], ",", 
       RowBox[{"{", "1", "}"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"1", ",", "0", ",", "0"}], "}"}], ",", 
       RowBox[{"{", "0", "}"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"0", ",", "1", ",", "0"}], "}"}], ",", 
       RowBox[{"{", "0", "}"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"0", ",", "0", ",", "1"}], "}"}], ",", 
       RowBox[{"{", "0", "}"}]}], "}"}]}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{
  3.784819661117552*^9, {3.784819708224949*^9, 3.784819716908656*^9}, 
   3.784882505715673*^9, 3.785060273118032*^9, 3.785082746589625*^9, 
   3.7854237647885637`*^9, 3.786972790269453*^9, 3.800086398530096*^9},
 CellLabel->
  "Out[816]=",ExpressionUUID->"4e536527-7a61-40a0-b98b-16f5bc800058"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"LempelZiv", "[", "AKExample", "]"}]], "Input",
 CellChangeTimes->{{3.7848201392600613`*^9, 3.784820142915852*^9}},
 CellLabel->
  "In[817]:=",ExpressionUUID->"3170d3b6-4f2a-4461-b72c-f31be5bdac97"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", 
   ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
   "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0"}], "}"}]], "Output",
 CellChangeTimes->{3.784820143342539*^9, 3.7848201923167667`*^9, 
  3.7848825059310713`*^9, 3.78506027322099*^9, 3.785082746727474*^9, 
  3.785133233832408*^9, 3.785423764879154*^9, 3.78697279046789*^9, 
  3.8000863987300453`*^9},
 CellLabel->
  "Out[817]=",ExpressionUUID->"13ccf847-b6d8-4110-9ce9-ea027ef9d27a"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData["AKExampleCheck"], "Input",
 CellChangeTimes->{{3.7848201934359703`*^9, 3.784820195105592*^9}},
 CellLabel->
  "In[818]:=",ExpressionUUID->"7d44cfb1-27cf-4344-bc29-70ff53ccc123"],

Cell[BoxData["True"], "Output",
 CellChangeTimes->{3.784820195425282*^9, 3.7848825060401*^9, 
  3.785060273324176*^9, 3.785082746862512*^9, 3.785423765027*^9, 
  3.7869727905905533`*^9, 3.8000863988472967`*^9},
 CellLabel->
  "Out[818]=",ExpressionUUID->"752006ef-a436-499e-8b98-41bd33ef0e54"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Regular example", "Subsection",
 CellChangeTimes->{{3.7848206252790956`*^9, 
  3.784820636519956*^9}},ExpressionUUID->"7d3d2c43-c72d-4004-8943-\
87c3ea7a7eac"],

Cell[BoxData[
 RowBox[{"ClearAll", "[", "RegularExample", "]"}]], "Input",
 CellChangeTimes->{{3.7848218608987293`*^9, 3.784821863843079*^9}},
 CellLabel->
  "In[819]:=",ExpressionUUID->"84843017-b134-4965-a9ae-2469a6f24618"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"RegularExample", "[", "s_", "]"}], ":=", 
   RowBox[{"Join", "@@", 
    RowBox[{"Table", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"0", ",", "1"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"t", ",", "1", ",", "s"}], "}"}]}], "]"}]}]}], ";", 
  RowBox[{"RegularExample", "[", "10", "]"}]}]], "Input",
 CellChangeTimes->{{3.784820637023747*^9, 3.784820671388754*^9}, {
  3.784821847287664*^9, 3.784821876272497*^9}, {3.78482193383794*^9, 
  3.784821934102387*^9}},
 CellLabel->
  "In[820]:=",ExpressionUUID->"6616df0f-7044-4b59-a110-bcf65520e669"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", 
   ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
   "1", ",", "0", ",", "1", ",", "0", ",", "1"}], "}"}]], "Output",
 CellChangeTimes->{
  3.784820671663259*^9, {3.784821857908366*^9, 3.784821877598134*^9}, 
   3.784821934766374*^9, 3.78488250617279*^9, 3.785060273430752*^9, 
   3.785082747033326*^9, 3.785423765464209*^9, 3.7869727906960363`*^9, 
   3.800086398991436*^9},
 CellLabel->
  "Out[820]=",ExpressionUUID->"08f575de-2f7d-4f40-90ec-e1ab2db4f60b"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"RegularExample10LZ", ":=", 
  RowBox[{"{", 
   RowBox[{
   "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", "1", 
    ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "0", ",",
     "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
    "1", ",", "1"}], "}"}]}]], "Input",
 CellChangeTimes->{{3.784821794473365*^9, 3.7848218070814753`*^9}, {
  3.784821881559017*^9, 3.784821881646716*^9}},
 CellLabel->
  "In[821]:=",ExpressionUUID->"feb1773b-58f1-421e-ad4c-b8340cf66f79"],

Cell[BoxData[
 RowBox[{"CheckRegularExample10", ":=", 
  RowBox[{
   RowBox[{"LempelZiv", "[", 
    RowBox[{"RegularExample", "[", "10", "]"}], "]"}], "\[Equal]", 
   "RegularExample10LZ"}]}]], "Input",
 CellChangeTimes->{{3.7848218100043583`*^9, 3.784821825087964*^9}, {
  3.784821885607059*^9, 3.784821904060627*^9}, {3.784882524803526*^9, 
  3.7848825249441767`*^9}},
 CellLabel->
  "In[822]:=",ExpressionUUID->"dd618faf-2054-4a5c-9a20-6db13e0533cc"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"LempelZivPairs", "[", 
  RowBox[{"RegularExample", "[", "10", "]"}], "]"}]], "Input",
 CellChangeTimes->{{3.784820666975417*^9, 3.784820680131898*^9}, {
  3.7848218898896914`*^9, 3.784821890412174*^9}},
 CellLabel->
  "In[823]:=",ExpressionUUID->"5ee230bc-9b1c-48c5-900e-c90c9740e425"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"\[LeftAssociation]", 
    RowBox[{
     RowBox[{
      RowBox[{"{", "}"}], "\[Rule]", "0"}], ",", 
     RowBox[{
      RowBox[{"{", "0", "}"}], "\[Rule]", "1"}], ",", 
     RowBox[{
      RowBox[{"{", "1", "}"}], "\[Rule]", "2"}], ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"0", ",", "1"}], "}"}], "\[Rule]", "3"}], ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"0", ",", "1", ",", "0"}], "}"}], "\[Rule]", "4"}], ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"1", ",", "0"}], "}"}], "\[Rule]", "5"}], ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"1", ",", "0", ",", "1"}], "}"}], "\[Rule]", "6"}], ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"0", ",", "1", ",", "0", ",", "1"}], "}"}], "\[Rule]", "7"}]}],
     "\[RightAssociation]"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"0", ",", 
       RowBox[{"{", "0", "}"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", 
       RowBox[{"{", "1", "}"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", 
       RowBox[{"{", "1", "}"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"3", ",", 
       RowBox[{"{", "0", "}"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", 
       RowBox[{"{", "0", "}"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"5", ",", 
       RowBox[{"{", "1", "}"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"4", ",", 
       RowBox[{"{", "1", "}"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"7", ",", 
       RowBox[{"{", "}"}]}], "}"}]}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{3.7848206804343853`*^9, 3.784821890928203*^9, 
  3.784882506298531*^9, 3.785060273553651*^9, 3.785082747209839*^9, 
  3.78542376578863*^9, 3.786972790833296*^9, 3.800086399123782*^9},
 CellLabel->
  "Out[823]=",ExpressionUUID->"2d6d5912-5d1a-46f6-8039-7dbfae827173"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"LempelZivBinaryPairs", "[", 
  RowBox[{"RegularExample", "[", "10", "]"}], "]"}]], "Input",
 CellChangeTimes->{{3.7848206951763573`*^9, 3.7848206957233543`*^9}, {
  3.784821893151573*^9, 3.78482189356901*^9}},
 CellLabel->
  "In[824]:=",ExpressionUUID->"a594b822-5749-462f-91b1-390a6a46eefb"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"\[LeftAssociation]", 
    RowBox[{
     RowBox[{
      RowBox[{"{", "}"}], "\[Rule]", "0"}], ",", 
     RowBox[{
      RowBox[{"{", "0", "}"}], "\[Rule]", "1"}], ",", 
     RowBox[{
      RowBox[{"{", "1", "}"}], "\[Rule]", "2"}], ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"0", ",", "1"}], "}"}], "\[Rule]", "3"}], ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"0", ",", "1", ",", "0"}], "}"}], "\[Rule]", "4"}], ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"1", ",", "0"}], "}"}], "\[Rule]", "5"}], ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"1", ",", "0", ",", "1"}], "}"}], "\[Rule]", "6"}], ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"0", ",", "1", ",", "0", ",", "1"}], "}"}], "\[Rule]", "7"}]}],
     "\[RightAssociation]"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", "}"}], ",", 
       RowBox[{"{", "0", "}"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", "0", "}"}], ",", 
       RowBox[{"{", "1", "}"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"0", ",", "1"}], "}"}], ",", 
       RowBox[{"{", "1", "}"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"1", ",", "1"}], "}"}], ",", 
       RowBox[{"{", "0", "}"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"0", ",", "1", ",", "0"}], "}"}], ",", 
       RowBox[{"{", "0", "}"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"1", ",", "0", ",", "1"}], "}"}], ",", 
       RowBox[{"{", "1", "}"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"1", ",", "0", ",", "0"}], "}"}], ",", 
       RowBox[{"{", "1", "}"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"1", ",", "1", ",", "1"}], "}"}], ",", 
       RowBox[{"{", "}"}]}], "}"}]}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{3.784820696128162*^9, 3.784821893927177*^9, 
  3.784882506407241*^9, 3.785060273652617*^9, 3.7850827473401737`*^9, 
  3.785423765946732*^9, 3.786972790940371*^9, 3.8000863992310762`*^9},
 CellLabel->
  "Out[824]=",ExpressionUUID->"b877781d-75de-47c1-b7c7-9a637a6b2d12"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"LempelZiv", "[", 
  RowBox[{"RegularExample", "[", "10", "]"}], "]"}]], "Input",
 CellChangeTimes->{{3.7848217831462183`*^9, 3.784821787062327*^9}, {
  3.784821895656704*^9, 3.784821896066835*^9}},
 CellLabel->
  "In[825]:=",ExpressionUUID->"a917346d-73f1-459c-b609-4426fc1254ad"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", "1", 
   ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
   "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", 
   ",", "1"}], "}"}]], "Output",
 CellChangeTimes->{3.78482178737122*^9, 3.78482189644514*^9, 
  3.784882506518518*^9, 3.7850602737532587`*^9, 3.7850827475098543`*^9, 
  3.785423766024333*^9, 3.786972791053172*^9, 3.8000863993479443`*^9},
 CellLabel->
  "Out[825]=",ExpressionUUID->"b0858cb8-0af9-4c0c-85da-9226a21351e1"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData["CheckRegularExample10"], "Input",
 CellChangeTimes->{{3.78488253539851*^9, 3.78488253812955*^9}},
 CellLabel->
  "In[826]:=",ExpressionUUID->"cdfb1be4-e9a2-4a75-847e-28cab51187c0"],

Cell[BoxData["True"], "Output",
 CellChangeTimes->{3.7848825385238237`*^9, 3.785060273855514*^9, 
  3.785082747642193*^9, 3.7854237661144238`*^9, 3.786972791155014*^9, 
  3.8000863994560623`*^9},
 CellLabel->
  "Out[826]=",ExpressionUUID->"e84fe7e4-3474-4266-8b14-406b096f7906"]
}, Open  ]],

Cell[CellGroupData[{

Cell["Big regular example", "Subsubsection",
 CellChangeTimes->{{3.784822095037582*^9, 
  3.784822096962735*^9}},ExpressionUUID->"4613f65c-9965-4117-95dc-\
ed479dacdaf8"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"LempelZivBinaryPairs", "[", 
  RowBox[{"RegularExample", "[", "100", "]"}], "]"}]], "Input",
 CellChangeTimes->{{3.7848221245259867`*^9, 3.784822130270013*^9}, {
  3.784822274263567*^9, 3.784822294351692*^9}},
 CellLabel->
  "In[827]:=",ExpressionUUID->"903f63c3-5b46-4fa9-90f9-3501422a0071"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"\[LeftAssociation]", 
    RowBox[{
     RowBox[{
      RowBox[{"{", "}"}], "\[Rule]", "0"}], ",", 
     RowBox[{
      RowBox[{"{", "0", "}"}], "\[Rule]", "1"}], ",", 
     RowBox[{
      RowBox[{"{", "1", "}"}], "\[Rule]", "2"}], ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"0", ",", "1"}], "}"}], "\[Rule]", "3"}], ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"0", ",", "1", ",", "0"}], "}"}], "\[Rule]", "4"}], ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"1", ",", "0"}], "}"}], "\[Rule]", "5"}], ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"1", ",", "0", ",", "1"}], "}"}], "\[Rule]", "6"}], ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"0", ",", "1", ",", "0", ",", "1"}], "}"}], "\[Rule]", "7"}], 
     ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"0", ",", "1", ",", "0", ",", "1", ",", "0"}], "}"}], 
      "\[Rule]", "8"}], ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"1", ",", "0", ",", "1", ",", "0"}], "}"}], "\[Rule]", "9"}], 
     ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"1", ",", "0", ",", "1", ",", "0", ",", "1"}], "}"}], 
      "\[Rule]", "10"}], ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"0", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1"}], "}"}],
       "\[Rule]", "11"}], ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
       "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0"}], 
       "}"}], "\[Rule]", "12"}], ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0"}], "}"}],
       "\[Rule]", "13"}], ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
       "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1"}], 
       "}"}], "\[Rule]", "14"}], ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
       "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
        "1"}], "}"}], "\[Rule]", "15"}], ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
       "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
        "1", ",", "0"}], "}"}], "\[Rule]", "16"}], ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
       "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
        "0"}], "}"}], "\[Rule]", "17"}], ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
       "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
        "0", ",", "1"}], "}"}], "\[Rule]", "18"}], ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
       "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
        "1", ",", "0", ",", "1"}], "}"}], "\[Rule]", "19"}], ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
       "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
        "1", ",", "0", ",", "1", ",", "0"}], "}"}], "\[Rule]", "20"}], ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
       "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
        "0", ",", "1", ",", "0"}], "}"}], "\[Rule]", "21"}], ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
       "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
        "0", ",", "1", ",", "0", ",", "1"}], "}"}], "\[Rule]", "22"}], ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
       "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
        "1", ",", "0", ",", "1", ",", "0", ",", "1"}], "}"}], "\[Rule]", 
      "23"}], ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
       "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
        "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0"}], "}"}], 
      "\[Rule]", "24"}], ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
       "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
        "0", ",", "1", ",", "0", ",", "1", ",", "0"}], "}"}], "\[Rule]", 
      "25"}], ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
       "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
        "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1"}], "}"}], 
      "\[Rule]", "26"}], ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
       "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
        "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1"}], 
       "}"}], "\[Rule]", "27"}]}], "\[RightAssociation]"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", "}"}], ",", 
       RowBox[{"{", "0", "}"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", "0", "}"}], ",", 
       RowBox[{"{", "1", "}"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"0", ",", "1"}], "}"}], ",", 
       RowBox[{"{", "1", "}"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"1", ",", "1"}], "}"}], ",", 
       RowBox[{"{", "0", "}"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"0", ",", "1", ",", "0"}], "}"}], ",", 
       RowBox[{"{", "0", "}"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"1", ",", "0", ",", "1"}], "}"}], ",", 
       RowBox[{"{", "1", "}"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"1", ",", "0", ",", "0"}], "}"}], ",", 
       RowBox[{"{", "1", "}"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"1", ",", "1", ",", "1"}], "}"}], ",", 
       RowBox[{"{", "0", "}"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"0", ",", "1", ",", "1", ",", "0"}], "}"}], ",", 
       RowBox[{"{", "0", "}"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"1", ",", "0", ",", "0", ",", "1"}], "}"}], ",", 
       RowBox[{"{", "1", "}"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"1", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
       RowBox[{"{", "1", "}"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"1", ",", "0", ",", "1", ",", "1"}], "}"}], ",", 
       RowBox[{"{", "0", "}"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"1", ",", "0", ",", "1", ",", "0"}], "}"}], ",", 
       RowBox[{"{", "0", "}"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"1", ",", "1", ",", "0", ",", "1"}], "}"}], ",", 
       RowBox[{"{", "1", "}"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"1", ",", "1", ",", "0", ",", "0"}], "}"}], ",", 
       RowBox[{"{", "1", "}"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"1", ",", "1", ",", "1", ",", "1"}], "}"}], ",", 
       RowBox[{"{", "0", "}"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"0", ",", "1", ",", "1", ",", "1", ",", "0"}], "}"}], ",", 
       RowBox[{"{", "0", "}"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"1", ",", "0", ",", "0", ",", "0", ",", "1"}], "}"}], ",", 
       RowBox[{"{", "1", "}"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"1", ",", "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
       RowBox[{"{", "1", "}"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"1", ",", "0", ",", "0", ",", "1", ",", "1"}], "}"}], ",", 
       RowBox[{"{", "0", "}"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"1", ",", "0", ",", "0", ",", "1", ",", "0"}], "}"}], ",", 
       RowBox[{"{", "0", "}"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"1", ",", "0", ",", "1", ",", "0", ",", "1"}], "}"}], ",", 
       RowBox[{"{", "1", "}"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"1", ",", "0", ",", "1", ",", "0", ",", "0"}], "}"}], ",", 
       RowBox[{"{", "1", "}"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"1", ",", "0", ",", "1", ",", "1", ",", "1"}], "}"}], ",", 
       RowBox[{"{", "0", "}"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"1", ",", "0", ",", "1", ",", "1", ",", "0"}], "}"}], ",", 
       RowBox[{"{", "0", "}"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"1", ",", "1", ",", "0", ",", "0", ",", "1"}], "}"}], ",", 
       RowBox[{"{", "1", "}"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"1", ",", "1", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
       RowBox[{"{", "1", "}"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"0", ",", "0", ",", "1", ",", "1", ",", "1"}], "}"}], ",", 
       RowBox[{"{", "}"}]}], "}"}]}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{
  3.784822130701912*^9, {3.7848222751454077`*^9, 3.784822294889834*^9}, 
   3.784882506751422*^9, 3.785060273961789*^9, 3.7850827478030233`*^9, 
   3.785423766204493*^9, 3.786972791260201*^9, 3.800086399586084*^9},
 CellLabel->
  "Out[827]=",ExpressionUUID->"845dffd9-6525-4346-9fa0-dd0c563658cf"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"LempelZiv", "[", 
    RowBox[{"RegularExample", "[", "100", "]"}], "]"}], ",", 
   RowBox[{
    RowBox[{"LempelZiv", "[", 
     RowBox[{"RegularExample", "[", "100", "]"}], "]"}], "//", "Length"}]}], 
  "}"}]], "Input",
 CellChangeTimes->{{3.7848222703763857`*^9, 3.784822329631721*^9}},
 CellLabel->
  "In[828]:=",ExpressionUUID->"36895429-ccba-4e54-a4f8-e3e06f70835d"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
    "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", "1",
      ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "0", 
     ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", 
     ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", 
     ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", 
     ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "1", 
     ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", "0", 
     ",", "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", "1", 
     ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", 
     ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", 
     ",", "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", 
     ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", 
     ",", "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", "0", 
     ",", "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", 
     ",", "1", ",", "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", "0", 
     ",", "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", 
     ",", "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", 
     ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "1", 
     ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", 
     ",", "1", ",", "1"}], "}"}], ",", "136"}], "}"}]], "Output",
 CellChangeTimes->{{3.784822282138626*^9, 3.784822330126727*^9}, 
   3.784882506893096*^9, 3.785060274359683*^9, 3.785082748007382*^9, 
   3.785423766291134*^9, 3.786972791374721*^9, 3.800086399808187*^9},
 CellLabel->
  "Out[828]=",ExpressionUUID->"77a005a6-fc54-4c81-88aa-b334b775e584"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Asymptotic win for regular example", "Subsubsection",
 CellChangeTimes->{{3.784822107972127*^9, 3.784822115109047*^9}, {
  3.7848223350811443`*^9, 
  3.7848223355782633`*^9}},ExpressionUUID->"cda34530-753e-43ab-89fb-\
5b237ce040a5"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"sMax", "=", "120"}], ";", 
  RowBox[{"encs", "=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"LempelZiv", "[", 
      RowBox[{"RegularExample", "[", "s", "]"}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"s", ",", "1", ",", "sMax"}], "}"}]}], "]"}]}], ";", 
  RowBox[{"encsTable", "=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"s", ",", 
       RowBox[{"2", "*", "s"}], ",", 
       RowBox[{
        RowBox[{
         RowBox[{"Length", "[", 
          RowBox[{"encs", "[", 
           RowBox[{"[", "s", "]"}], "]"}], "]"}], "/", 
         RowBox[{"(", 
          RowBox[{"2", "*", "s"}], ")"}]}], "//", "N"}], ",", 
       RowBox[{"encs", "[", 
        RowBox[{"[", "s", "]"}], "]"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"s", ",", "1", ",", "sMax"}], "}"}]}], "]"}]}], ";", 
  RowBox[{"encsTable", "//", "TF"}]}]], "Input",
 CellChangeTimes->{{3.784821909093707*^9, 3.784822068266733*^9}, {
  3.7848223424866734`*^9, 3.784822487054513*^9}, {3.784823144016863*^9, 
  3.7848231509872293`*^9}, {3.784823203381301*^9, 3.784823223471572*^9}, {
  3.784823512414377*^9, 3.784823512598756*^9}, {3.784823979877666*^9, 
  3.784823999039721*^9}},
 CellLabel->
  "In[829]:=",ExpressionUUID->"90bf7ea5-ae75-4957-840c-b59b8bcc84ba"],

Cell[BoxData[
 TagBox[GridBox[{
    {"1", "2", "1.5`", 
     RowBox[{"{", 
      RowBox[{"0", ",", "0", ",", "1"}], "}"}]},
    {"2", "4", "1.5`", 
     RowBox[{"{", 
      RowBox[{"0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "1"}], 
      "}"}]},
    {"3", "6", "1.3333333333333333`", 
     RowBox[{"{", 
      RowBox[{
      "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "1"}], "}"}]},
    {"4", "8", "1.5`", 
     RowBox[{"{", 
      RowBox[{
      "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "0"}], "}"}]},
    {"5", "10", "1.6`", 
     RowBox[{"{", 
      RowBox[{
      "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
       "1", ",", "0"}], "}"}]},
    {"6", "12", "1.4166666666666667`", 
     RowBox[{"{", 
      RowBox[{
      "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
       "0", ",", "1", ",", "1"}], "}"}]},
    {"7", "14", "1.4285714285714286`", 
     RowBox[{"{", 
      RowBox[{
      "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
       "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "1"}], "}"}]},
    {"8", "16", "1.3125`", 
     RowBox[{"{", 
      RowBox[{
      "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
       "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1"}], 
      "}"}]},
    {"9", "18", "1.3333333333333333`", 
     RowBox[{"{", 
      RowBox[{
      "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
       "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
       "0", ",", "1", ",", "1"}], "}"}]},
    {"10", "20", "1.2`", 
     RowBox[{"{", 
      RowBox[{
      "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
       "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
       "1", ",", "1", ",", "1"}], "}"}]},
    {"11", "22", "1.3181818181818181`", 
     RowBox[{"{", 
      RowBox[{
      "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
       "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
       "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
       "0"}], "}"}]},
    {"12", "24", "1.2083333333333333`", 
     RowBox[{"{", 
      RowBox[{
      "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
       "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
       "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "0"}], "}"}]},
    {"13", "26", "1.3076923076923077`", 
     RowBox[{"{", 
      RowBox[{
      "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
       "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
       "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0"}], "}"}]},
    {"14", "28", "1.2142857142857142`", 
     RowBox[{"{", 
      RowBox[{
      "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
       "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
       "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0"}], "}"}]},
    {"15", "30", "1.1666666666666667`", 
     RowBox[{"{", 
      RowBox[{
      "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
       "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
       "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1"}], 
      "}"}]},
    {"16", "32", "1.21875`", 
     RowBox[{"{", 
      RowBox[{
      "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
       "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
       "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "0", ",", "0", ",", "1", ",", "1"}], "}"}]},
    {"17", "34", "1.1470588235294117`", 
     RowBox[{"{", 
      RowBox[{
      "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
       "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
       "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "0", ",", "1", ",", "1", ",", "1"}], "}"}]},
    {"18", "36", "1.1111111111111112`", 
     RowBox[{"{", 
      RowBox[{
      "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
       "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
       "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "0", ",", "1"}], "}"}]},
    {"19", "38", "1.1578947368421053`", 
     RowBox[{"{", 
      RowBox[{
      "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
       "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
       "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
       "1", ",", "1"}], "}"}]},
    {"20", "40", "1.1`", 
     RowBox[{"{", 
      RowBox[{
      "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
       "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
       "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
       "1", ",", "1"}], "}"}]},
    {"21", "42", "1.0476190476190477`", 
     RowBox[{"{", 
      RowBox[{
      "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
       "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
       "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
       "1", ",", "1"}], "}"}]},
    {"22", "44", "1.1136363636363635`", 
     RowBox[{"{", 
      RowBox[{
      "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
       "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
       "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
       "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0"}], 
      "}"}]},
    {"23", "46", "1.065217391304348`", 
     RowBox[{"{", 
      RowBox[{
      "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
       "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
       "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
       "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0"}], 
      "}"}]},
    {"24", "48", "1.0208333333333333`", 
     RowBox[{"{", 
      RowBox[{
      "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
       "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
       "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
       "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0"}], 
      "}"}]},
    {"25", "50", "1.08`", 
     RowBox[{"{", 
      RowBox[{
      "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
       "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
       "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
       "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
       "0", ",", "0", ",", "0", ",", "1", ",", "0"}], "}"}]},
    {"26", "52", "1.0384615384615385`", 
     RowBox[{"{", 
      RowBox[{
      "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
       "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
       "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
       "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
       "0", ",", "0", ",", "1", ",", "1", ",", "0"}], "}"}]},
    {"27", "54", "1.`", 
     RowBox[{"{", 
      RowBox[{
      "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
       "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
       "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
       "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "0", ",", "1", ",", "0"}], "}"}]},
    {"28", "56", "0.9821428571428571`", 
     RowBox[{"{", 
      RowBox[{
      "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
       "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
       "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
       "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "1"}], "}"}]},
    {"29", "58", "1.0172413793103448`", 
     RowBox[{"{", 
      RowBox[{
      "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
       "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
       "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
       "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "1"}], "}"}]},
    {"30", "60", "0.9833333333333333`", 
     RowBox[{"{", 
      RowBox[{
      "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
       "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
       "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
       "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
       "1", ",", "1", ",", "1"}], "}"}]},
    {"31", "62", "0.9516129032258065`", 
     RowBox[{"{", 
      RowBox[{
      "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
       "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
       "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
       "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "0", ",", "1", ",", "1"}], "}"}]},
    {"32", "64", "0.9375`", 
     RowBox[{"{", 
      RowBox[{
      "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
       "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
       "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
       "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1"}], "}"}]},
    {"33", "66", "0.9696969696969697`", 
     RowBox[{"{", 
      RowBox[{
      "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
       "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
       "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
       "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
       "1"}], "}"}]},
    {"34", "68", "0.9411764705882353`", 
     RowBox[{"{", 
      RowBox[{
      "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
       "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
       "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
       "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", 
       "1"}], "}"}]},
    {"35", "70", "0.9142857142857143`", 
     RowBox[{"{", 
      RowBox[{
      "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
       "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
       "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
       "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", 
       "1"}], "}"}]},
    {"36", "72", "0.8888888888888888`", 
     RowBox[{"{", 
      RowBox[{
      "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
       "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
       "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
       "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
       "1"}], "}"}]},
    {"37", "74", "0.9459459459459459`", 
     RowBox[{"{", 
      RowBox[{
      "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
       "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
       "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
       "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0"}], 
      "}"}]},
    {"38", "76", "0.9210526315789473`", 
     RowBox[{"{", 
      RowBox[{
      "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
       "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
       "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
       "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0"}], 
      "}"}]},
    {"39", "78", "0.8974358974358975`", 
     RowBox[{"{", 
      RowBox[{
      "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
       "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
       "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
       "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0"}], 
      "}"}]},
    {"40", "80", "0.875`", 
     RowBox[{"{", 
      RowBox[{
      "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
       "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
       "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
       "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0"}], 
      "}"}]},
    {"41", "82", "0.926829268292683`", 
     RowBox[{"{", 
      RowBox[{
      "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
       "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
       "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
       "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", 
       "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0"}], "}"}]},
    {"42", "84", "0.9047619047619048`", 
     RowBox[{"{", 
      RowBox[{
      "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
       "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
       "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
       "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", 
       "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0"}], "}"}]},
    {"43", "86", "0.8837209302325582`", 
     RowBox[{"{", 
      RowBox[{
      "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
       "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
       "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
       "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", 
       "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0"}], "}"}]},
    {"44", "88", "0.8636363636363636`", 
     RowBox[{"{", 
      RowBox[{
      "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
       "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
       "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
       "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", 
       "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0"}], "}"}]},
    {"45", "90", "0.8555555555555555`", 
     RowBox[{"{", 
      RowBox[{
      "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
       "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
       "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
       "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1"}], 
      "}"}]},
    {"46", "92", "0.8913043478260869`", 
     RowBox[{"{", 
      RowBox[{
      "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
       "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
       "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
       "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "0", ",", "0", ",", "0", ",", "1", ",", "1"}], "}"}]},
    {"47", "94", "0.8723404255319149`", 
     RowBox[{"{", 
      RowBox[{
      "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
       "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
       "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
       "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "0", ",", "0", ",", "1", ",", "1", ",", "1"}], "}"}]},
    {"48", "96", "0.8541666666666666`", 
     RowBox[{"{", 
      RowBox[{
      "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
       "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
       "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
       "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "0", ",", "1", ",", "0", ",", "1", ",", "1"}], "}"}]},
    {"49", "98", "0.8367346938775511`", 
     RowBox[{"{", 
      RowBox[{
      "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
       "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
       "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
       "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "0", ",", "1", ",", "1", ",", "1", ",", "1"}], "}"}]},
    {"50", "100", "0.83`", 
     RowBox[{"{", 
      RowBox[{
      "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
       "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
       "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
       "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1"}], "}"}]},
    {"51", "102", "0.8627450980392157`", 
     RowBox[{"{", 
      RowBox[{
      "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
       "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
       "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
       "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
       "0", ",", "0", ",", "1", ",", "1"}], "}"}]},
    {"52", "104", "0.8461538461538461`", 
     RowBox[{"{", 
      RowBox[{
      "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
       "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
       "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
       "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "1", ",", "1"}], "}"}]},
    {"53", "106", "0.8301886792452831`", 
     RowBox[{"{", 
      RowBox[{
      "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
       "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
       "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
       "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
       "1", ",", "0", ",", "1", ",", "1"}], "}"}]},
    {"54", "108", "0.8148148148148148`", 
     RowBox[{"{", 
      RowBox[{
      "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
       "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
       "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
       "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
       "1", ",", "1", ",", "1", ",", "1"}], "}"}]},
    {"55", "110", "0.8`", 
     RowBox[{"{", 
      RowBox[{
      "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
       "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
       "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
       "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "0", ",", "0", ",", "1", ",", "1"}], "}"}]},
    {"56", "112", "0.8392857142857143`", 
     RowBox[{"{", 
      RowBox[{
      "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
       "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
       "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
       "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
       "0", ",", "1", ",", "0"}], "}"}]},
    {"57", "114", "0.8245614035087719`", 
     RowBox[{"{", 
      RowBox[{
      "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
       "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
       "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
       "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
       "1", ",", "1", ",", "0"}], "}"}]},
    {"58", "116", "0.8103448275862069`", 
     RowBox[{"{", 
      RowBox[{
      "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
       "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
       "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
       "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
       "0", ",", "1", ",", "0"}], "}"}]},
    {"59", "118", "0.7966101694915254`", 
     RowBox[{"{", 
      RowBox[{
      "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
       "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
       "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
       "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
       "1", ",", "1", ",", "0"}], "}"}]},
    {"60", "120", "0.7833333333333333`", 
     RowBox[{"{", 
      RowBox[{
      "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
       "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
       "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
       "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "0"}], "}"}]},
    {"61", "122", "0.819672131147541`", 
     RowBox[{"{", 
      RowBox[{
      "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
       "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
       "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
       "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
       "1", ",", "0"}], "}"}]},
    {"62", "124", "0.8064516129032258`", 
     RowBox[{"{", 
      RowBox[{
      "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
       "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
       "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
       "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
       "1", ",", "0"}], "}"}]},
    {"63", "126", "0.7936507936507936`", 
     RowBox[{"{", 
      RowBox[{
      "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
       "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
       "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
       "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
       "1", ",", "0"}], "}"}]},
    {"64", "128", "0.78125`", 
     RowBox[{"{", 
      RowBox[{
      "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
       "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
       "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
       "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "1", ",", "0"}], "}"}]},
    {"65", "130", "0.7692307692307693`", 
     RowBox[{"{", 
      RowBox[{
      "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
       "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
       "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
       "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
       "1", ",", "0"}], "}"}]},
    {"66", "132", "0.7651515151515151`", 
     RowBox[{"{", 
      RowBox[{
      "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
       "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
       "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
       "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
       "0", ",", "1", ",", "1"}], "}"}]},
    {"67", "134", "0.7910447761194029`", 
     RowBox[{"{", 
      RowBox[{
      "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
       "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
       "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
       "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
       "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
       "1"}], "}"}]},
    {"68", "136", "0.7794117647058824`", 
     RowBox[{"{", 
      RowBox[{
      "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
       "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
       "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
       "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
       "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "1"}], "}"}]},
    {"69", "138", "0.7681159420289855`", 
     RowBox[{"{", 
      RowBox[{
      "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
       "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
       "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
       "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
       "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
       "1"}], "}"}]},
    {"70", "140", "0.7571428571428571`", 
     RowBox[{"{", 
      RowBox[{
      "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
       "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
       "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
       "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
       "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "1"}], "}"}]},
    {"71", "142", "0.7464788732394366`", 
     RowBox[{"{", 
      RowBox[{
      "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
       "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
       "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
       "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
       "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
       "1"}], "}"}]},
    {"72", "144", "0.7430555555555556`", 
     RowBox[{"{", 
      RowBox[{
      "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
       "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
       "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
       "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
       "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
       "0", ",", "1"}], "}"}]},
    {"73", "146", "0.7671232876712328`", 
     RowBox[{"{", 
      RowBox[{
      "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
       "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
       "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
       "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
       "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1"}], 
      "}"}]},
    {"74", "148", "0.7567567567567568`", 
     RowBox[{"{", 
      RowBox[{
      "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
       "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
       "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
       "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
       "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1"}], 
      "}"}]},
    {"75", "150", "0.7466666666666667`", 
     RowBox[{"{", 
      RowBox[{
      "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
       "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
       "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
       "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
       "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "1"}], 
      "}"}]},
    {"76", "152", "0.7368421052631579`", 
     RowBox[{"{", 
      RowBox[{
      "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
       "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
       "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
       "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
       "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", "1"}], 
      "}"}]},
    {"77", "154", "0.7272727272727273`", 
     RowBox[{"{", 
      RowBox[{
      "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
       "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
       "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
       "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
       "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1"}], 
      "}"}]},
    {"78", "156", "0.717948717948718`", 
     RowBox[{"{", 
      RowBox[{
      "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
       "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
       "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
       "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
       "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1"}], 
      "}"}]},
    {"79", "158", "0.7468354430379747`", 
     RowBox[{"{", 
      RowBox[{
      "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
       "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
       "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
       "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
       "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0"}], "}"}]},
    {"80", "160", "0.7375`", 
     RowBox[{"{", 
      RowBox[{
      "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
       "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
       "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
       "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
       "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0"}], "}"}]},
    {"81", "162", "0.7283950617283951`", 
     RowBox[{"{", 
      RowBox[{
      "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
       "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
       "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
       "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
       "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0"}], "}"}]},
    {"82", "164", "0.7195121951219512`", 
     RowBox[{"{", 
      RowBox[{
      "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
       "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
       "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
       "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
       "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0"}], "}"}]},
    {"83", "166", "0.7108433734939759`", 
     RowBox[{"{", 
      RowBox[{
      "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
       "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
       "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
       "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
       "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "0"}], "}"}]},
    {"84", "168", "0.7023809523809523`", 
     RowBox[{"{", 
      RowBox[{
      "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
       "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
       "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
       "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
       "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "0"}], "}"}]},
    {"85", "170", "0.7294117647058823`", 
     RowBox[{"{", 
      RowBox[{
      "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
       "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
       "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
       "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
       "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
       "0", ",", "0", ",", "0", ",", "1", ",", "0"}], "}"}]},
    {"86", "172", "0.7209302325581395`", 
     RowBox[{"{", 
      RowBox[{
      "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
       "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
       "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
       "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
       "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
       "0", ",", "0", ",", "1", ",", "1", ",", "0"}], "}"}]},
    {"87", "174", "0.7126436781609196`", 
     RowBox[{"{", 
      RowBox[{
      "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
       "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
       "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
       "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
       "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
       "0", ",", "1", ",", "0", ",", "1", ",", "0"}], "}"}]},
    {"88", "176", "0.7045454545454546`", 
     RowBox[{"{", 
      RowBox[{
      "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
       "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
       "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
       "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
       "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
       "0", ",", "1", ",", "1", ",", "1", ",", "0"}], "}"}]},
    {"89", "178", "0.6966292134831461`", 
     RowBox[{"{", 
      RowBox[{
      "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
       "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
       "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
       "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
       "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "0"}], "}"}]},
    {"90", "180", "0.6888888888888889`", 
     RowBox[{"{", 
      RowBox[{
      "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
       "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
       "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
       "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
       "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
       "1", ",", "0", ",", "1", ",", "1", ",", "0"}], "}"}]},
    {"91", "182", "0.6868131868131868`", 
     RowBox[{"{", 
      RowBox[{
      "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
       "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
       "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
       "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
       "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
       "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1"}], "}"}]},
    {"92", "184", "0.7065217391304348`", 
     RowBox[{"{", 
      RowBox[{
      "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
       "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
       "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
       "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
       "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
       "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
       "0", ",", "0", ",", "1", ",", "1"}], "}"}]},
    {"93", "186", "0.6989247311827957`", 
     RowBox[{"{", 
      RowBox[{
      "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
       "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
       "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
       "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
       "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
       "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "1", ",", "1"}], "}"}]},
    {"94", "188", "0.6914893617021277`", 
     RowBox[{"{", 
      RowBox[{
      "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
       "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
       "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
       "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
       "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
       "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
       "1", ",", "0", ",", "1", ",", "1"}], "}"}]},
    {"95", "190", "0.6842105263157895`", 
     RowBox[{"{", 
      RowBox[{
      "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
       "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
       "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
       "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
       "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
       "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
       "1", ",", "1", ",", "1", ",", "1"}], "}"}]},
    {"96", "192", "0.6770833333333334`", 
     RowBox[{"{", 
      RowBox[{
      "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
       "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
       "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
       "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
       "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
       "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "0", ",", "0", ",", "1", ",", "1"}], "}"}]},
    {"97", "194", "0.6701030927835051`", 
     RowBox[{"{", 
      RowBox[{
      "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
       "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
       "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
       "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
       "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
       "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "0", ",", "1", ",", "1", ",", "1"}], "}"}]},
    {"98", "196", "0.6683673469387755`", 
     RowBox[{"{", 
      RowBox[{
      "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
       "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
       "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
       "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
       "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
       "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "0", ",", "1"}], "}"}]},
    {"99", "198", "0.6868686868686869`", 
     RowBox[{"{", 
      RowBox[{
      "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
       "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
       "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
       "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
       "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
       "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
       "0", ",", "1", ",", "1"}], "}"}]},
    {"100", "200", "0.68`", 
     RowBox[{"{", 
      RowBox[{
      "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
       "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
       "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
       "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
       "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
       "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
       "1", ",", "1", ",", "1"}], "}"}]},
    {"101", "202", "0.6732673267326733`", 
     RowBox[{"{", 
      RowBox[{
      "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
       "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
       "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
       "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
       "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
       "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
       "0", ",", "1", ",", "1"}], "}"}]},
    {"102", "204", "0.6666666666666666`", 
     RowBox[{"{", 
      RowBox[{
      "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
       "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
       "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
       "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
       "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
       "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
       "1", ",", "1", ",", "1"}], "}"}]},
    {"103", "206", "0.6601941747572816`", 
     RowBox[{"{", 
      RowBox[{
      "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
       "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
       "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
       "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
       "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
       "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "1"}], "}"}]},
    {"104", "208", "0.6538461538461539`", 
     RowBox[{"{", 
      RowBox[{
      "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
       "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
       "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
       "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
       "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
       "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
       "1", ",", "1", ",", "1"}], "}"}]},
    {"105", "210", "0.6476190476190476`", 
     RowBox[{"{", 
      RowBox[{
      "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
       "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
       "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
       "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
       "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
       "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "0", ",", "1", ",", "1"}], "}"}]},
    {"106", "212", "0.6698113207547169`", 
     RowBox[{"{", 
      RowBox[{
      "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
       "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
       "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
       "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
       "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
       "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
       "1", ",", "0"}], "}"}]},
    {"107", "214", "0.6635514018691588`", 
     RowBox[{"{", 
      RowBox[{
      "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
       "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
       "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
       "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
       "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
       "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
       "1", ",", "0"}], "}"}]},
    {"108", "216", "0.6574074074074074`", 
     RowBox[{"{", 
      RowBox[{
      "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
       "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
       "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
       "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
       "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
       "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
       "1", ",", "0"}], "}"}]},
    {"109", "218", "0.6513761467889908`", 
     RowBox[{"{", 
      RowBox[{
      "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
       "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
       "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
       "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
       "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
       "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "1", ",", "0"}], "}"}]},
    {"110", "220", "0.6454545454545455`", 
     RowBox[{"{", 
      RowBox[{
      "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
       "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
       "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
       "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
       "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
       "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
       "1", ",", "0"}], "}"}]},
    {"111", "222", "0.6396396396396397`", 
     RowBox[{"{", 
      RowBox[{
      "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
       "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
       "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
       "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
       "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
       "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
       "1", ",", "0"}], "}"}]},
    {"112", "224", "0.6339285714285714`", 
     RowBox[{"{", 
      RowBox[{
      "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
       "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
       "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
       "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
       "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
       "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
       "1", ",", "0"}], "}"}]},
    {"113", "226", "0.6548672566371682`", 
     RowBox[{"{", 
      RowBox[{
      "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
       "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
       "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
       "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
       "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
       "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
       "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
       "0"}], "}"}]},
    {"114", "228", "0.6491228070175439`", 
     RowBox[{"{", 
      RowBox[{
      "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
       "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
       "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
       "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
       "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
       "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
       "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "0"}], "}"}]},
    {"115", "230", "0.6434782608695652`", 
     RowBox[{"{", 
      RowBox[{
      "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
       "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
       "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
       "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
       "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
       "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
       "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
       "0"}], "}"}]},
    {"116", "232", "0.6379310344827587`", 
     RowBox[{"{", 
      RowBox[{
      "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
       "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
       "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
       "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
       "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
       "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
       "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "0"}], "}"}]},
    {"117", "234", "0.6324786324786325`", 
     RowBox[{"{", 
      RowBox[{
      "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
       "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
       "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
       "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
       "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
       "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
       "0"}], "}"}]},
    {"118", "236", "0.6271186440677966`", 
     RowBox[{"{", 
      RowBox[{
      "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
       "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
       "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
       "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
       "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
       "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", 
       "0"}], "}"}]},
    {"119", "238", "0.6218487394957983`", 
     RowBox[{"{", 
      RowBox[{
      "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
       "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
       "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
       "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
       "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
       "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", 
       "0"}], "}"}]},
    {"120", "240", "0.6208333333333333`", 
     RowBox[{"{", 
      RowBox[{
      "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
       "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
       "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
       "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
       "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
       "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", 
       "1", ",", "1"}], "}"}]}
   },
   GridBoxAlignment->{
    "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
     "RowsIndexed" -> {}},
   GridBoxSpacings->{"Columns" -> {
       Offset[0.27999999999999997`], {
        Offset[2.0999999999999996`]}, 
       Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
       Offset[0.2], {
        Offset[0.4]}, 
       Offset[0.2]}, "RowsIndexed" -> {}}],
  Function[BoxForm`e$, 
   TableForm[BoxForm`e$, TableDepth -> 2]]]], "Output",
 CellChangeTimes->{{3.784822422270159*^9, 3.7848224936927853`*^9}, 
   3.7848231561998587`*^9, {3.7848232077101927`*^9, 3.7848232241598883`*^9}, 
   3.7848235135853033`*^9, {3.7848239819970217`*^9, 3.7848239996273317`*^9}, 
   3.784882507377874*^9, 3.7850602748972893`*^9, 3.7850827487496023`*^9, 
   3.7854237665609007`*^9, 3.786972791882338*^9, 3.800086400438154*^9},
 CellLabel->
  "Out[829]//TableForm=",ExpressionUUID->"3dcea32f-f5c4-4d71-9630-\
27d481656cf7"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ListPlot", "[", 
  RowBox[{
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"enc", "[", 
      RowBox[{"[", "3", "]"}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"enc", ",", "encsTable"}], "}"}]}], "]"}], ",", 
   RowBox[{"PlotRange", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"0.5", ",", "1.6"}], "}"}]}]}], "]"}]], "Input",
 CellChangeTimes->{{3.7848231714137*^9, 3.784823193538612*^9}, {
  3.78482323755037*^9, 3.784823242629422*^9}, {3.784823517531988*^9, 
  3.784823517596401*^9}, {3.784824999204095*^9, 3.7848250010511293`*^9}},
 CellLabel->
  "In[830]:=",ExpressionUUID->"59266278-bf29-4760-aa05-c92a7d5bea01"],

Cell[BoxData[
 GraphicsBox[{{}, {{}, 
    {RGBColor[0.368417, 0.506779, 0.709798], PointSize[0.009166666666666668], 
     AbsoluteThickness[1.6], PointBox[CompressedData["
1:eJxdlH9M1GUcx2/V1IC2Dpm4BoJmiKUCiRIg8IaTOzh+3E847idNujEbdFEG
YVjXwJLBlOoUFbC0MqymEzeIVgs9xJyFtm4l2Y8ZHGeAiCIsyD/6fr98Pm35
2XP77rX383qe557v83xXbnPpnQ/IZLJXhZ/4XKipjIXn3/SU4f+8BEVSzRA/
el8ehsOHxJojXo7PPhVrljgCPZXXuiuvMUeTz+Otum/81dgo1TRxDMLtO37I
Duc8lvpz/iTOF070F07cJV4HcbbuSs430HruEMcvzO/mPAEWqTh/Gi9FXKiK
uHCbeCMqYk8d/eotzhPp/3K+CQkh3vgQL+/jZgiLFVbMeRLe2b3uuZXBzM/Q
+rl/MnKu7ww7qeI8BUONHVcbOzhPpf1i3kL/7xZxGia3N/iPKDlPR41UnGdg
x2ByoP3lSWLQeMRuYElU3dTZxdw/Eyuk4jwTkb5Mod2kPAvS9lRNUJ4Fw8iZ
F+KzeXwFPD9rHYpa6u9WYNelnrpLPdRftpXmZ38rTtgbf9nfyeNnI+3y9JbL
05xnI7SmP7JKxb4SHzZt+PLGsXHKlQjuflZoxDIVvs1a1tWym30Vpip8NZvH
OM+h/Wc/B13piT+9PTBGeS72nZuJte0jdueivU0s9tVIPb1UaOyrETRgHQq0
sJ+HuKNfN8yGsp9H5+UvyvPpPnCej/XHzxwc3MZ+AcS3WTJJ/d0FsMoT2327
2C+EXCrOC3EvrDXkbAr7Gkive5BzDcwHnEJjX0v7Twwtnbcb1F8L8TRE1RH3
aXHdVLYqTcu+DrenxKIcOjS+r/uz3MO+Dp31KUJjXwfnveoTa4YD5OvpfhFD
j/498seVzezrUV2/9o45iX09/OF5r58eYd8ARe0j/k0e9g1QSh8IYrcBra65
A665UfIN+O7W81VLR9k30vtg34i2qGVrH9Swb8SiQNmL6YuI+4z4oCHpcMo3
NJ6sCEcCtUIjRhFMUrFfBPG0/ipnvwjH/qiInP+e/WI0i8e3if1iOJ94ynxR
TewuhnScg3n9xTheOv9x6byffBPGClw7f2xj3wRH9ZCz1c6+CYdsmfkno9k3
QecQd4z9EvoeEqMEM/V7g+qqiN0lMEc9Nq4oI+4rgXbcFOT7b34zvOL1OMe+
GW2Le8fLm9g30/1i34z3prv2aKLZt9D3eoR8C/bn9XryeondFswmfxSz3MW+
BZ4BVcyVVPatOHjFkfXawzy/FW8W/HMx9Cr7VnQ+VKtu+YS4z4o3VKeab9YQ
y2x4d3Wu0Hh+G7xqzfrP77JvgyW/PKHjPPs25Pq9X5S2sm/HqHg9t7Nvh0+R
JjT27VjzSukKq5x9O4xxo4a40WHyHfj9N7GGM/4FAy81aA==
      
      "]]}, {}}, {}, {}, {}, {}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->{True, True},
  AxesLabel->{None, None},
  AxesOrigin->{0., 0.5055},
  DisplayFunction->Identity,
  Frame->{{False, False}, {False, False}},
  FrameLabel->{{None, None}, {None, None}},
  FrameTicks->{{Automatic, Automatic}, {Automatic, Automatic}},
  GridLines->{None, None},
  GridLinesStyle->Directive[
    GrayLevel[0.5, 0.4]],
  ImagePadding->All,
  Method->{"CoordinatesToolOptions" -> {"DisplayFunction" -> ({
        (Identity[#]& )[
         Part[#, 1]], 
        (Identity[#]& )[
         Part[#, 2]]}& ), "CopiedValueFunction" -> ({
        (Identity[#]& )[
         Part[#, 1]], 
        (Identity[#]& )[
         Part[#, 2]]}& )}},
  PlotRange->{{0., 120.}, {0.5, 1.6}},
  PlotRangeClipping->True,
  PlotRangePadding->{{
     Scaled[0.02], 
     Scaled[0.02]}, {0, 0}},
  Ticks->{Automatic, Automatic}]], "Output",
 CellChangeTimes->{{3.7848231906744423`*^9, 3.78482324331671*^9}, 
   3.78482351860954*^9, 3.784825001536809*^9, 3.784882507937969*^9, 
   3.7850602750983973`*^9, 3.78508274913822*^9, 3.785423768483397*^9, 
   3.786972796037369*^9, 3.800086401066575*^9},
 CellLabel->
  "Out[830]=",ExpressionUUID->"234a36b8-3811-4ed9-b84f-9046244203d1"]
}, Open  ]]
}, Open  ]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Lempel\[Dash]Ziv decoding", "Section",
 CellChangeTimes->{{3.784820414833907*^9, 
  3.7848204181426277`*^9}},ExpressionUUID->"f7b5349d-26cf-41f9-927f-\
0f8e9eb32d37"],

Cell[BoxData[
 RowBox[{
  RowBox[{"LempelZivDecodeSplitFrom", "[", 
   RowBox[{"j_", ",", "bs_"}], "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"m", "=", 
      RowBox[{"Ceiling", "[", 
       RowBox[{"Log", "[", 
        RowBox[{"2", ",", "j"}], "]"}], "]"}]}], "}"}], ",", 
    RowBox[{"If", "[", 
     RowBox[{
      RowBox[{"m", "==", 
       RowBox[{"Length", "[", "bs", "]"}]}], ",", 
      RowBox[{"{", 
       RowBox[{"{", 
        RowBox[{"bs", ",", 
         RowBox[{"{", "}"}]}], "}"}], "}"}], ",", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{"m", ">", 
         RowBox[{"Length", "[", "bs", "]"}]}], ",", 
        RowBox[{"{", "}"}], ",", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"bs", "[", 
             RowBox[{"[", 
              RowBox[{"1", ";;", "m"}], "]"}], "]"}], ",", 
            RowBox[{"{", 
             RowBox[{"bs", "[", 
              RowBox[{"[", 
               RowBox[{"m", "+", "1"}], "]"}], "]"}], "}"}]}], "}"}], "}"}], 
         "~", "Join", "~", 
         RowBox[{"LempelZivDecodeSplitFrom", "[", 
          RowBox[{
           RowBox[{"j", "+", "1"}], ",", 
           RowBox[{"bs", "[", 
            RowBox[{"[", 
             RowBox[{
              RowBox[{"m", "+", "2"}], ";;"}], "]"}], "]"}]}], "]"}]}]}], 
       "]"}]}], "]"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.7848264021080723`*^9, 3.7848265067106543`*^9}, {
   3.784826813385872*^9, 3.784826819470378*^9}, {3.784827172132298*^9, 
   3.784827181679132*^9}, 3.784827224221252*^9, {3.784827297433518*^9, 
   3.784827299152954*^9}, {3.7848274283481693`*^9, 3.784827431065051*^9}, {
   3.7848275198210087`*^9, 3.78482751995529*^9}, {3.784827598600402*^9, 
   3.78482763323239*^9}, {3.784828926451002*^9, 3.784828927070045*^9}, {
   3.784882551159021*^9, 3.7848825518911057`*^9}},
 CellLabel->
  "In[831]:=",ExpressionUUID->"9b4d5748-2361-4f28-8a0c-fb25b7d2a8b2"],

Cell[BoxData[
 RowBox[{
  RowBox[{"LempelZivDecodeSplit", "[", "bs_", "]"}], ":=", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"bs", "[", 
        RowBox[{"[", "1", "]"}], "]"}], "}"}]}], "}"}], "}"}], "~", "Join", 
   "~", 
   RowBox[{"LempelZivDecodeSplitFrom", "[", 
    RowBox[{"2", ",", 
     RowBox[{"bs", "[", 
      RowBox[{"[", 
       RowBox[{"2", ";;"}], "]"}], "]"}]}], "]"}]}]}]], "Input",
 CellChangeTimes->{{3.784826317240035*^9, 3.784826348015584*^9}, {
  3.784826386159341*^9, 3.784826397478979*^9}, {3.784826636336371*^9, 
  3.784826666699936*^9}, {3.784826822529562*^9, 3.7848268278365192`*^9}, {
  3.784827011211673*^9, 3.7848270130909853`*^9}, {3.7848289306207457`*^9, 
  3.784828933544012*^9}},
 CellLabel->
  "In[832]:=",ExpressionUUID->"2843237e-73ef-4edd-8e53-143e41c644b0"],

Cell[BoxData[
 RowBox[{
  RowBox[{"LempelZivDecodeSplitDictionary", "[", "bs_", "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", "ps", "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"ps", "=", 
      RowBox[{"LempelZivDecodeSplit", "[", "bs", "]"}]}], ";", 
     RowBox[{"Table", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"FromBinary", "[", 
          RowBox[{"p", "[", 
           RowBox[{"[", "1", "]"}], "]"}], "]"}], ",", 
         RowBox[{"p", "[", 
          RowBox[{"[", "2", "]"}], "]"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"p", ",", "ps"}], "}"}]}], "]"}]}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.784826834532608*^9, 3.784826858310009*^9}, {
  3.784826934483741*^9, 3.78482698622747*^9}, {3.78482893568827*^9, 
  3.7848289395216713`*^9}},
 CellLabel->
  "In[833]:=",ExpressionUUID->"8efc4409-b0e9-44ad-b68c-e74543063d27"],

Cell[BoxData[
 RowBox[{
  RowBox[{"LempelZivDecodeDictionaryFrom", "[", 
   RowBox[{"dict_", ",", 
    RowBox[{"{", "}"}]}], "]"}], ":=", "dict"}]], "Input",
 CellChangeTimes->{{3.784828005205447*^9, 3.784828012898069*^9}, {
  3.7848289428108063`*^9, 3.784828946056696*^9}, {3.784828988741118*^9, 
  3.784828988956799*^9}},
 CellLabel->
  "In[834]:=",ExpressionUUID->"60eef777-632c-4aac-b148-45453dd3f37a"],

Cell[BoxData[
 RowBox[{
  RowBox[{"LempelZivDecodeDictionaryFrom", "[", 
   RowBox[{"dict_", ",", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"r_", ",", "b_"}], "}"}], ",", "ps___"}], "}"}]}], "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", "rNew", "}"}], ",", 
    RowBox[{
     RowBox[{"rNew", ":=", 
      RowBox[{
       RowBox[{"Max", "[", 
        RowBox[{"Keys", "[", "dict", "]"}], "]"}], "+", "1"}]}], ";", 
     RowBox[{"LempelZivDecodeDictionaryFrom", "[", 
      RowBox[{
       RowBox[{"Append", "[", 
        RowBox[{"dict", ",", 
         RowBox[{"rNew", "->", 
          RowBox[{
           RowBox[{"dict", "[", "r", "]"}], "~", "Join", "~", "b"}]}]}], 
        "]"}], ",", 
       RowBox[{"ps", "//", "List"}]}], "]"}]}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.7848279559189777`*^9, 3.784828056001718*^9}, {
  3.7848282712302732`*^9, 3.784828271326157*^9}, {3.784828323473838*^9, 
  3.7848283304039707`*^9}, {3.784828361276752*^9, 3.78482845537309*^9}, {
  3.7848284907910957`*^9, 3.7848284915726423`*^9}, {3.7848285350018806`*^9, 
  3.7848285352284203`*^9}, {3.784828947978613*^9, 3.784828955651826*^9}},
 CellLabel->
  "In[835]:=",ExpressionUUID->"0fa0b0d4-324c-4d8a-a08e-97f572791706"],

Cell[BoxData[
 RowBox[{
  RowBox[{"LempelZivDecodeDictionary", "[", "bs_", "]"}], ":=", 
  RowBox[{"LempelZivDecodeDictionaryFrom", "[", 
   RowBox[{
    RowBox[{"<|", 
     RowBox[{"0", "\[Rule]", 
      RowBox[{"{", "}"}]}], "|>"}], ",", 
    RowBox[{"LempelZivDecodeSplitDictionary", "[", "bs", "]"}]}], 
   "]"}]}]], "Input",
 CellChangeTimes->{{3.78482787814712*^9, 3.784827952020113*^9}, {
  3.78482895809531*^9, 3.784828978211309*^9}},
 CellLabel->
  "In[836]:=",ExpressionUUID->"40813c28-d6fe-49fa-aa64-5f141c78cbd2"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"LempelZivDecodeDictionary", "[", "AKExampleLZ", "]"}]], "Input",
 CellChangeTimes->{{3.784828460818631*^9, 3.7848284687063513`*^9}, {
  3.784828967125577*^9, 3.784828967803226*^9}},
 CellLabel->
  "In[837]:=",ExpressionUUID->"517dc25f-b8eb-48fe-857a-4f74e0a91f88"],

Cell[BoxData[
 RowBox[{"\[LeftAssociation]", 
  RowBox[{
   RowBox[{"0", "\[Rule]", 
    RowBox[{"{", "}"}]}], ",", 
   RowBox[{"1", "\[Rule]", 
    RowBox[{"{", "1", "}"}]}], ",", 
   RowBox[{"2", "\[Rule]", 
    RowBox[{"{", "0", "}"}]}], ",", 
   RowBox[{"3", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"1", ",", "1"}], "}"}]}], ",", 
   RowBox[{"4", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"0", ",", "1"}], "}"}]}], ",", 
   RowBox[{"5", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"0", ",", "1", ",", "0"}], "}"}]}], ",", 
   RowBox[{"6", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"0", ",", "0"}], "}"}]}], ",", 
   RowBox[{"7", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"1", ",", "0"}], "}"}]}]}], "\[RightAssociation]"}]], "Output",
 CellChangeTimes->{{3.784828469019678*^9, 3.784828493589468*^9}, 
   3.784828537198841*^9, {3.7848289681693077`*^9, 3.784828990874259*^9}, 
   3.7848825088531313`*^9, 3.784882556006789*^9, 3.785060275284952*^9, 
   3.785082749267961*^9, 3.78542377034898*^9, 3.786972796896864*^9, 
   3.800086401235907*^9},
 CellLabel->
  "Out[837]=",ExpressionUUID->"a0f12d78-6000-4ac5-bf78-148c4532fe20"]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
Can now get original word just by joining up the dictionary elements in order!\
\>", "Subsubsection",
 CellChangeTimes->{{3.784829136200691*^9, 
  3.7848291480139027`*^9}},ExpressionUUID->"a0374780-6d3d-45d4-8fc5-\
85e1b1277935"],

Cell[BoxData[
 RowBox[{
  RowBox[{"LempelZivDecode", "[", "bs_", "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", "dict", "}"}], ",", 
    RowBox[{
     RowBox[{"dict", "=", 
      RowBox[{"LempelZivDecodeDictionary", "[", "bs", "]"}]}], ";", 
     RowBox[{"Join", "@@", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"dict", "[", "i", "]"}], ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", "1", ",", 
          RowBox[{"Max", "[", 
           RowBox[{"Keys", "[", "dict", "]"}], "]"}]}], "}"}]}], "]"}]}]}]}], 
   "]"}]}]], "Input",
 CellChangeTimes->{{3.784829130414633*^9, 3.784829192229105*^9}, {
  3.784829228426271*^9, 3.7848292294800663`*^9}},
 CellLabel->
  "In[838]:=",ExpressionUUID->"165bb550-266f-489b-b606-f22ce6b011e3"]
}, Open  ]],

Cell[CellGroupData[{

Cell["Checking", "Subsubsection",
 CellChangeTimes->{{3.784829272731575*^9, 
  3.7848292734785557`*^9}},ExpressionUUID->"c6062ae1-7368-433e-ab14-\
a4cd4644b11b"],

Cell[BoxData[
 RowBox[{
  RowBox[{"CheckLZ", "[", "bs_", "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"bsLZ", ",", "bsP"}], "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"bsLZ", "=", 
      RowBox[{"LempelZiv", "[", "bs", "]"}]}], ";", 
     RowBox[{"bsP", "=", 
      RowBox[{"LempelZivDecode", "[", "bsLZ", "]"}]}], ";", 
     RowBox[{"{", 
      RowBox[{"bs", ",", "bsLZ", ",", "bsP", ",", 
       RowBox[{"bs", "\[Equal]", "bsP"}]}], "}"}]}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.784829275058913*^9, 3.7848293747863493`*^9}},
 CellLabel->
  "In[839]:=",ExpressionUUID->"cdd879b1-fefc-45b5-836a-692e24879bc3"]
}, Open  ]],

Cell[CellGroupData[{

Cell["Testing", "Subsection",
 CellChangeTimes->{{3.784828885740883*^9, 
  3.784828886436245*^9}},ExpressionUUID->"78075efc-62a3-4c47-b866-\
e7a3a0b2e2ef"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"LempelZivWithDictionary", "[", "AKExample", "]"}]], "Input",
 CellChangeTimes->{{3.784828887668537*^9, 3.7848288958417377`*^9}},
 CellLabel->
  "In[840]:=",ExpressionUUID->"19443a5c-69cc-40a0-b89a-ad54fa910d29"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"\[LeftAssociation]", 
    RowBox[{
     RowBox[{
      RowBox[{"{", "}"}], "\[Rule]", "0"}], ",", 
     RowBox[{
      RowBox[{"{", "1", "}"}], "\[Rule]", "1"}], ",", 
     RowBox[{
      RowBox[{"{", "0", "}"}], "\[Rule]", "2"}], ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"1", ",", "1"}], "}"}], "\[Rule]", "3"}], ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"0", ",", "1"}], "}"}], "\[Rule]", "4"}], ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"0", ",", "1", ",", "0"}], "}"}], "\[Rule]", "5"}], ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"0", ",", "0"}], "}"}], "\[Rule]", "6"}], ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"1", ",", "0"}], "}"}], "\[Rule]", "7"}]}], 
    "\[RightAssociation]"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0",
      ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", 
     ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0"}], "}"}]}], 
  "}"}]], "Output",
 CellChangeTimes->{3.784828896283386*^9, 3.784882509669959*^9, 
  3.785060275419005*^9, 3.785082749391811*^9, 3.785423770454324*^9, 
  3.786972797123189*^9, 3.8000864015502567`*^9},
 CellLabel->
  "Out[840]=",ExpressionUUID->"7d834787-164c-4c62-9902-47e72623a247"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData["AKExampleLZ"], "Input",
 CellChangeTimes->{{3.784827683987115*^9, 3.7848276856773663`*^9}},
 CellLabel->
  "In[841]:=",ExpressionUUID->"aafa3593-9324-4b18-ae19-39bec798526a"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", 
   ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
   "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0"}], "}"}]], "Output",
 CellChangeTimes->{3.784827686066321*^9, 3.784882509808886*^9, 
  3.7850602755194283`*^9, 3.785082749502201*^9, 3.78542377054123*^9, 
  3.7869727973877487`*^9, 3.800086401685052*^9},
 CellLabel->
  "Out[841]=",ExpressionUUID->"1dc00405-d883-4e3e-b5d1-def64effdc73"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"LempelZivDecodeSplitDictionary", "[", "AKExampleLZ", "]"}]], "Input",\

 CellChangeTimes->{{3.784826794762759*^9, 3.784826796136261*^9}, {
  3.784826988368239*^9, 3.78482699263231*^9}, {3.784882565724815*^9, 
  3.784882566461728*^9}},
 CellLabel->
  "In[842]:=",ExpressionUUID->"4778a422-6991-49ad-b01b-8128990bffd8"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"0", ",", 
     RowBox[{"{", "1", "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", 
     RowBox[{"{", "0", "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", 
     RowBox[{"{", "1", "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2", ",", 
     RowBox[{"{", "1", "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"4", ",", 
     RowBox[{"{", "0", "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2", ",", 
     RowBox[{"{", "0", "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", 
     RowBox[{"{", "0", "}"}]}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{{3.78482699313972*^9, 3.784827022217102*^9}, 
   3.7848278449474697`*^9, 3.784828511451343*^9, 3.784882509952923*^9, {
   3.784882560947321*^9, 3.784882566837655*^9}, 3.785060275619885*^9, 
   3.7850827495841846`*^9, 3.785423770634542*^9, 3.786972797538991*^9, 
   3.8000864018204803`*^9},
 CellLabel->
  "Out[842]=",ExpressionUUID->"63486d07-046f-4ee8-b934-1edf7520cfc4"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"LempelZivDecodeDictionary", "[", "AKExampleLZ", "]"}]], "Input",
 CellChangeTimes->{{3.7848292454546413`*^9, 3.784829259615797*^9}},
 CellLabel->
  "In[843]:=",ExpressionUUID->"8fcc4cb8-f172-4ad7-bb02-cdd0c683819e"],

Cell[BoxData[
 RowBox[{"\[LeftAssociation]", 
  RowBox[{
   RowBox[{"0", "\[Rule]", 
    RowBox[{"{", "}"}]}], ",", 
   RowBox[{"1", "\[Rule]", 
    RowBox[{"{", "1", "}"}]}], ",", 
   RowBox[{"2", "\[Rule]", 
    RowBox[{"{", "0", "}"}]}], ",", 
   RowBox[{"3", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"1", ",", "1"}], "}"}]}], ",", 
   RowBox[{"4", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"0", ",", "1"}], "}"}]}], ",", 
   RowBox[{"5", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"0", ",", "1", ",", "0"}], "}"}]}], ",", 
   RowBox[{"6", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"0", ",", "0"}], "}"}]}], ",", 
   RowBox[{"7", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"1", ",", "0"}], "}"}]}]}], "\[RightAssociation]"}]], "Output",
 CellChangeTimes->{{3.784829251816325*^9, 3.7848292598587627`*^9}, 
   3.784882510240011*^9, 3.7848825697508163`*^9, 3.7850602757198553`*^9, 
   3.7850827496674433`*^9, 3.7854237707246523`*^9, 3.786972797688154*^9, 
   3.800086402049325*^9},
 CellLabel->
  "Out[843]=",ExpressionUUID->"1d5f7728-3d59-4b6d-9b07-da3b0e3038ea"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"CheckLZ", "[", "AKExample", "]"}]], "Input",
 CellChangeTimes->{{3.784829350408009*^9, 3.784829357109337*^9}},
 CellLabel->
  "In[844]:=",ExpressionUUID->"a1890299-c1c8-4248-9d3c-77b04f960235"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
    "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1",
      ",", "0", ",", "0", ",", "0", ",", "1", ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0",
      ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", 
     ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1",
      ",", "0", ",", "0", ",", "0", ",", "1", ",", "0"}], "}"}], ",", 
   "True"}], "}"}]], "Output",
 CellChangeTimes->{{3.784829357551429*^9, 3.784829394398244*^9}, 
   3.784882511191793*^9, 3.7848825721293793`*^9, 3.7850602758236427`*^9, 
   3.7850827497515697`*^9, 3.785423770817779*^9, 3.78697279782164*^9, 
   3.8000864022033873`*^9},
 CellLabel->
  "Out[844]=",ExpressionUUID->"c95c9207-3ca7-4ad3-bd46-72669ca1d2d7"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"CheckLZ", "[", 
  RowBox[{"RegularExample", "[", "20", "]"}], "]"}]], "Input",
 CellChangeTimes->{{3.784829394905394*^9, 3.784829403208735*^9}},
 CellLabel->
  "In[845]:=",ExpressionUUID->"2c0a2adc-9c8b-49fe-b4a4-0aba1e44666d"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
    "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1",
      ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", 
     ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", 
     ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", 
     ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", 
     ",", "0", ",", "1", ",", "0", ",", "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", "1",
      ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "0", 
     ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", 
     ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", 
     ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", 
     ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", 
     ",", "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1",
      ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", 
     ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", 
     ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", 
     ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", 
     ",", "0", ",", "1", ",", "0", ",", "1"}], "}"}], ",", "True"}], 
  "}"}]], "Output",
 CellChangeTimes->{{3.7848293988168707`*^9, 3.784829403568622*^9}, 
   3.784882511872589*^9, 3.784882574662448*^9, 3.7850602759198103`*^9, 
   3.785082749851163*^9, 3.785423770907064*^9, 3.7869727979601793`*^9, 
   3.800086402347445*^9},
 CellLabel->
  "Out[845]=",ExpressionUUID->"9d892b26-1bc7-4a94-89e8-ed1876146737"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"CheckLZ", "[", 
  RowBox[{"{", 
   RowBox[{
   "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", 
    ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",",
     "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
    "1"}], "}"}], "]"}]], "Input",
 CellChangeTimes->{{3.784882577890074*^9, 3.7848826110437937`*^9}},
 CellLabel->
  "In[846]:=",ExpressionUUID->"952142b3-4a66-4b4c-97f9-a19ce78e3031"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
    "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0",
      ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", 
     ",", "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", 
     ",", "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1",
      ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", 
     ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", "1", 
     ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "1", 
     ",", "0", ",", "0", ",", "1", ",", "0", ",", "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0",
      ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", 
     ",", "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", 
     ",", "1"}], "}"}], ",", "True"}], "}"}]], "Output",
 CellChangeTimes->{{3.7848825839688*^9, 3.784882611506899*^9}, 
   3.7850602760163116`*^9, 3.785082750047903*^9, 3.78542377098365*^9, 
   3.786972798104035*^9, 3.800086402486809*^9},
 CellLabel->
  "Out[846]=",ExpressionUUID->"114bd191-f866-4502-bdbc-d6042a579911"]
}, Open  ]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Problem Sheet 9 Question 4", "Section",
 CellChangeTimes->{{3.7850828518769703`*^9, 3.785082855649877*^9}, 
   3.785083380527878*^9},ExpressionUUID->"fa0e5859-9249-471f-a830-\
5835c770e9f5"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Q4x", "[", "1", "]"}], ":=", 
  RowBox[{"{", 
   RowBox[{"0", ",", "1"}], "}"}]}]], "Input",
 CellChangeTimes->{{3.785426187707302*^9, 3.785426197105928*^9}},
 CellLabel->
  "In[847]:=",ExpressionUUID->"bdef34b3-f8a5-4591-9d45-fa872a3609e2"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Q4x", "[", "m_", "]"}], ":=", 
  RowBox[{
   RowBox[{"Q4x", "[", 
    RowBox[{"m", "-", "1"}], "]"}], "~", "Join", "~", 
   RowBox[{"Table", "[", 
    RowBox[{"0", ",", 
     RowBox[{"{", 
      RowBox[{"i", ",", "1", ",", "m"}], "}"}]}], "]"}], "~", "Join", "~", 
   RowBox[{"Table", "[", 
    RowBox[{"1", ",", 
     RowBox[{"{", 
      RowBox[{"i", ",", "1", ",", "m"}], "}"}]}], "]"}]}]}]], "Input",
 CellChangeTimes->{{3.785426197937289*^9, 3.785426214422698*^9}},
 CellLabel->
  "In[848]:=",ExpressionUUID->"4612090f-81fe-48cd-af13-62f2871ba8ee"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Q4y", "[", "m_", "]"}], ":=", 
  RowBox[{"LempelZivWithDictionary", "[", 
   RowBox[{"Q4x", "[", "m", "]"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.785426216154657*^9, 3.785426229536503*^9}},
 CellLabel->
  "In[849]:=",ExpressionUUID->"e4fcbac9-c0bd-48c5-8011-9a74ab7377c6"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"Print", "[", 
   RowBox[{"Q4x", "[", "5", "]"}], "]"}], ";", 
  RowBox[{"Print", "[", 
   RowBox[{"Q4y", "[", "5", "]"}], "]"}], ";"}]], "Input",
 CellChangeTimes->{{3.785426236725257*^9, 3.785426250114768*^9}},
 CellLabel->
  "In[850]:=",ExpressionUUID->"0774fc1d-b8e3-4967-b6c3-4384c5a0f486"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", 
   ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
   "0", ",", "1", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", 
   ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1"}], 
  "}"}]], "Print",
 CellChangeTimes->{3.785426250556115*^9, 3.786972798319921*^9, 
  3.800086402627161*^9},
 CellLabel->
  "During evaluation of \
In[850]:=",ExpressionUUID->"52a84851-0089-4116-a077-4f85e78b63d1"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"\[LeftAssociation]", 
    RowBox[{
     RowBox[{
      RowBox[{"{", "}"}], "\[Rule]", "0"}], ",", 
     RowBox[{
      RowBox[{"{", "0", "}"}], "\[Rule]", "1"}], ",", 
     RowBox[{
      RowBox[{"{", "1", "}"}], "\[Rule]", "2"}], ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"0", ",", "0"}], "}"}], "\[Rule]", "3"}], ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"1", ",", "1"}], "}"}], "\[Rule]", "4"}], ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"0", ",", "0", ",", "0"}], "}"}], "\[Rule]", "5"}], ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"1", ",", "1", ",", "1"}], "}"}], "\[Rule]", "6"}], ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"0", ",", "0", ",", "0", ",", "0"}], "}"}], "\[Rule]", "7"}], 
     ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"1", ",", "1", ",", "1", ",", "1"}], "}"}], "\[Rule]", "8"}], 
     ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"0", ",", "0", ",", "0", ",", "0", ",", "0"}], "}"}], 
      "\[Rule]", "9"}], ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"1", ",", "1", ",", "1", ",", "1", ",", "1"}], "}"}], 
      "\[Rule]", "10"}]}], "\[RightAssociation]"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0",
      ",", "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "0", 
     ",", "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", 
     ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", 
     ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "1"}], "}"}]}], 
  "}"}]], "Print",
 CellChangeTimes->{3.785426250556115*^9, 3.786972798319921*^9, 
  3.800086402643886*^9},
 CellLabel->
  "During evaluation of \
In[850]:=",ExpressionUUID->"fe3f47f8-f86c-4115-bd9e-a43bcd30b9b9"]
}, Open  ]]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"Q4Length", "[", "m_", "]"}], ":=", 
  RowBox[{"3", "+", 
   RowBox[{"2", "*", 
    RowBox[{"(", 
     RowBox[{"m", "-", "1"}], ")"}]}], "+", 
   RowBox[{"2", "*", 
    RowBox[{"Sum", "[", 
     RowBox[{
      RowBox[{"Ceiling", "[", 
       RowBox[{"Log", "[", 
        RowBox[{"2", ",", 
         RowBox[{"2", "*", "k"}]}], "]"}], "]"}], ",", 
      RowBox[{"{", 
       RowBox[{"k", ",", "2", ",", "m"}], "}"}]}], "]"}]}]}]}]], "Input",
 CellChangeTimes->{{3.785426107301063*^9, 3.7854261627335367`*^9}, {
  3.78542650994234*^9, 3.785426510217244*^9}},
 CellLabel->
  "In[851]:=",ExpressionUUID->"a804cb02-c847-4eb3-8c8d-790516de2243"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Q4LengthP", "[", "m_", "]"}], ":=", 
  RowBox[{
   RowBox[{"4", "m"}], "-", "1", "+", 
   RowBox[{"2", "*", 
    RowBox[{"Sum", "[", 
     RowBox[{
      RowBox[{"Ceiling", "[", 
       RowBox[{"Log", "[", 
        RowBox[{"2", ",", "k"}], "]"}], "]"}], ",", 
      RowBox[{"{", 
       RowBox[{"k", ",", "1", ",", "m"}], "}"}]}], "]"}]}]}]}]], "Input",
 CellChangeTimes->{{3.785426643598873*^9, 3.785426653543603*^9}, {
  3.785426722582144*^9, 3.7854267229813757`*^9}},
 CellLabel->
  "In[852]:=",ExpressionUUID->"f38f90ef-4b96-4235-becd-c9a68b408e77"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Q4LengthPP", "[", "m_", "]"}], ":=", 
  RowBox[{
   RowBox[{"4", "m"}], "-", "1", "+", 
   RowBox[{"2", "*", 
    RowBox[{"Sum", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"2", "^", 
        RowBox[{"(", 
         RowBox[{"s", "-", "1"}], ")"}]}], "*", "s"}], ",", 
      RowBox[{"{", 
       RowBox[{"s", ",", "0", ",", 
        RowBox[{"Floor", "[", 
         RowBox[{"Log", "[", 
          RowBox[{"2", ",", "m"}], "]"}], "]"}]}], "}"}]}], "]"}]}], "+", 
   RowBox[{"Floor", "[", 
    RowBox[{"Log", "[", 
     RowBox[{"2", ",", "m"}], "]"}], "]"}]}]}]], "Input",
 CellChangeTimes->{{3.785427869120289*^9, 3.785427919778347*^9}, {
  3.785427983988748*^9, 3.785428010486723*^9}},
 CellLabel->
  "In[853]:=",ExpressionUUID->"b30a6844-60dd-4394-bc1a-605cadf31313"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"Q4y", "[", "m", "]"}], "[", 
       RowBox[{"[", "2", "]"}], "]"}], "//", "Length"}], ",", 
     RowBox[{"{", 
      RowBox[{"m", ",", "1", ",", "10"}], "}"}]}], "]"}], ",", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"Q4Length", "[", "m", "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"m", ",", "1", ",", "10"}], "}"}]}], "]"}], ",", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"Q4LengthP", "[", "m", "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"m", ",", "1", ",", "10"}], "}"}]}], "]"}]}], "}"}]], "Input",
 CellChangeTimes->{{3.785426260760929*^9, 3.785426275208622*^9}, {
  3.7854266579684677`*^9, 3.785426666961356*^9}},
 CellLabel->
  "In[854]:=",ExpressionUUID->"20685219-3018-4c90-b09f-05779dfe321c"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
    "3", ",", "9", ",", "17", ",", "25", ",", "35", ",", "45", ",", "55", ",",
      "65", ",", "77", ",", "89"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "3", ",", "9", ",", "17", ",", "25", ",", "35", ",", "45", ",", "55", ",",
      "65", ",", "77", ",", "89"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "3", ",", "9", ",", "17", ",", "25", ",", "35", ",", "45", ",", "55", ",",
      "65", ",", "77", ",", "89"}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{{3.7854262695987864`*^9, 3.785426276025367*^9}, 
   3.78542651147803*^9, 3.785426667498548*^9, 3.785426724223482*^9, 
   3.786972798559389*^9, 3.800086402821978*^9},
 CellLabel->
  "Out[854]=",ExpressionUUID->"c3fc7f94-afe2-4a25-9ce9-54e1ac096d22"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Table", "[", 
  RowBox[{
   RowBox[{"Q4Length", "[", "m", "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"m", ",", "1", ",", "10"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.785426139097867*^9, 3.785426170537425*^9}},
 CellLabel->
  "In[855]:=",ExpressionUUID->"03fecff6-822c-4835-9658-d452a53b5bc5"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "3", ",", "9", ",", "17", ",", "25", ",", "35", ",", "45", ",", "55", ",", 
   "65", ",", "77", ",", "89"}], "}"}]], "Output",
 CellChangeTimes->{{3.785426141702599*^9, 3.78542617079116*^9}, 
   3.7854265130440073`*^9, 3.786972798706217*^9, 3.800086402953033*^9},
 CellLabel->
  "Out[855]=",ExpressionUUID->"999fb3a1-2964-43cd-ac64-ac35572dceb4"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Problem Sheet 9 Question 5", "Section",
 CellChangeTimes->{{3.7850828518769703`*^9, 3.785082855649877*^9}, 
   3.785083380527878*^9, 
   3.78508385863444*^9},ExpressionUUID->"4c0960a5-6d41-4914-8ce2-\
7b3ebd99deab"],

Cell[BoxData[
 RowBox[{"xQ5", ":=", 
  RowBox[{"{", 
   RowBox[{
   "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", 
    ",", "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", "0", ",",
     "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", "1"}], 
   "}"}]}]], "Input",
 CellChangeTimes->{{3.785083469512733*^9, 3.785083558324095*^9}, {
  3.7850838612998962`*^9, 3.785083884015874*^9}, {3.785083938930822*^9, 
  3.785083950378565*^9}},
 CellLabel->
  "In[856]:=",ExpressionUUID->"b53962b6-96fd-4316-ab2b-fc667806557b"],

Cell[BoxData[
 RowBox[{"yQ5", ":=", 
  RowBox[{"LempelZiv", "[", "xQ5", "]"}]}]], "Input",
 CellChangeTimes->{{3.785084324273567*^9, 3.7850843289945307`*^9}},
 CellLabel->
  "In[857]:=",ExpressionUUID->"69b4d6cf-b10f-40fc-89bd-9b621064b81d"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"{", 
   RowBox[{"xQ5", ",", "yQ5"}], "}"}], "//", "TF"}]], "Input",
 CellChangeTimes->{{3.7850843328684387`*^9, 3.785084336368578*^9}},
 CellLabel->
  "In[858]:=",ExpressionUUID->"53be3c5e-068c-4c37-96dd-59810400bc69"],

Cell[BoxData[
 TagBox[GridBox[{
    {"0", "1", "1", "0", "1", "1", "1", "0", "0", "0", "1", "0", "1", "0", 
     "0", "1", "1", "0", "1", "1", "0", 
     "1", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\
\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>"},
    {"0", "0", "1", "1", "0", "0", "1", "0", "1", "0", "1", "1", "0", "0", 
     "0", "1", "1", "1", "1", "0", "0", "1", "1", "0", "1", "1", "0", "0", 
     "0", "0", "0", "0", "1", "0"}
   },
   GridBoxAlignment->{
    "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
     "RowsIndexed" -> {}},
   GridBoxSpacings->{"Columns" -> {
       Offset[0.27999999999999997`], {
        Offset[2.0999999999999996`]}, 
       Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
       Offset[0.2], {
        Offset[0.4]}, 
       Offset[0.2]}, "RowsIndexed" -> {}}],
  Function[BoxForm`e$, 
   TableForm[BoxForm`e$, TableDepth -> 2]]]], "Output",
 CellChangeTimes->{3.785084336727433*^9, 3.785423771574067*^9, 
  3.7869727988855467`*^9, 3.8000864031016493`*^9},
 CellLabel->
  "Out[858]//TableForm=",ExpressionUUID->"2f7c18d2-40dc-4314-81a1-\
b234254ceca6"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"LempelZivBinaryPairs", "[", "xQ5", "]"}]], "Input",
 CellChangeTimes->{{3.7848196436489143`*^9, 3.784819660651124*^9}, {
  3.784819694502202*^9, 3.784819716542261*^9}, {3.785083952772497*^9, 
  3.78508395457353*^9}},
 CellLabel->
  "In[859]:=",ExpressionUUID->"ae5bec4a-19d9-41df-9295-e945d137b690"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"\[LeftAssociation]", 
    RowBox[{
     RowBox[{
      RowBox[{"{", "}"}], "\[Rule]", "0"}], ",", 
     RowBox[{
      RowBox[{"{", "0", "}"}], "\[Rule]", "1"}], ",", 
     RowBox[{
      RowBox[{"{", "1", "}"}], "\[Rule]", "2"}], ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"1", ",", "0"}], "}"}], "\[Rule]", "3"}], ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"1", ",", "1"}], "}"}], "\[Rule]", "4"}], ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"1", ",", "0", ",", "0"}], "}"}], "\[Rule]", "5"}], ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"0", ",", "1"}], "}"}], "\[Rule]", "6"}], ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"0", ",", "1", ",", "0"}], "}"}], "\[Rule]", "7"}], ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"0", ",", "1", ",", "1"}], "}"}], "\[Rule]", "8"}], ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"0", ",", "1", ",", "1", ",", "0"}], "}"}], "\[Rule]", "9"}]}],
     "\[RightAssociation]"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", "}"}], ",", 
       RowBox[{"{", "0", "}"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", "0", "}"}], ",", 
       RowBox[{"{", "1", "}"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"1", ",", "0"}], "}"}], ",", 
       RowBox[{"{", "0", "}"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"1", ",", "0"}], "}"}], ",", 
       RowBox[{"{", "1", "}"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"0", ",", "1", ",", "1"}], "}"}], ",", 
       RowBox[{"{", "0", "}"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"0", ",", "0", ",", "1"}], "}"}], ",", 
       RowBox[{"{", "1", "}"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"1", ",", "1", ",", "0"}], "}"}], ",", 
       RowBox[{"{", "0", "}"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"1", ",", "1", ",", "0"}], "}"}], ",", 
       RowBox[{"{", "1", "}"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"1", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
       RowBox[{"{", "0", "}"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"0", ",", "0", ",", "1", ",", "0"}], "}"}], ",", 
       RowBox[{"{", "}"}]}], "}"}]}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{
  3.784819661117552*^9, {3.784819708224949*^9, 3.784819716908656*^9}, 
   3.784882505715673*^9, 3.785060273118032*^9, 3.785082746589625*^9, 
   3.7850839551032124`*^9, 3.785423771688327*^9, 3.786972799161827*^9, 
   3.800086403222095*^9},
 CellLabel->
  "Out[859]=",ExpressionUUID->"4fab3a5f-c98c-47d8-a71f-2dae2d64059f"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"LempelZivDecode", "[", "yQ5", "]"}], "\[Equal]", "xQ5"}]], "Input",\

 CellChangeTimes->{{3.785084314184649*^9, 3.7850843504933147`*^9}},
 CellLabel->
  "In[860]:=",ExpressionUUID->"e07a27b1-bac5-4199-9a18-344c2955841f"],

Cell[BoxData["True"], "Output",
 CellChangeTimes->{{3.785084320885969*^9, 3.785084350878078*^9}, 
   3.785423771800704*^9, 3.786972799618734*^9, 3.800086403363275*^9},
 CellLabel->
  "Out[860]=",ExpressionUUID->"aafa5098-ff6c-42fc-801e-72655fff3443"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["2018/19 Examination Paper Question 3", "Section",
 CellChangeTimes->{{3.78697280509435*^9, 
  3.786972809372409*^9}},ExpressionUUID->"c8c05079-0ef8-4f0e-9829-\
c6c1e3b4aa5f"],

Cell[BoxData[
 RowBox[{"yExamQ3", ":=", 
  RowBox[{"{", 
   RowBox[{
   "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", 
    ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "1", ",",
     "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0"}], 
   "}"}]}]], "Input",
 CellChangeTimes->{{3.786972852957251*^9, 3.7869728642730227`*^9}},
 CellLabel->
  "In[861]:=",ExpressionUUID->"7170abc6-4979-4405-be0c-fff4bb54a8e5"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"LempelZivDecode", "[", "yExamQ3", "]"}]], "Input",
 CellChangeTimes->{{3.786972818697156*^9, 3.786972831321958*^9}, {
  3.786972867783437*^9, 3.78697286920603*^9}},
 CellLabel->
  "In[862]:=",ExpressionUUID->"008a3957-b018-4b91-af81-37be5d4a85c0"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", 
   ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], "}"}]], "Output",
 CellChangeTimes->{3.786972831644596*^9, 3.786972869538681*^9, 
  3.800086403502768*^9},
 CellLabel->
  "Out[862]=",ExpressionUUID->"0eb8af84-eaff-40b4-8651-dd40941706bb"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"LempelZivDecodeDictionary", "[", "yExamQ3", "]"}]], "Input",
 CellChangeTimes->{{3.7869728728495197`*^9, 3.786972874009408*^9}},
 CellLabel->
  "In[863]:=",ExpressionUUID->"50a1dc04-9316-4eca-a21f-5fcf9ab8d69d"],

Cell[BoxData[
 RowBox[{"\[LeftAssociation]", 
  RowBox[{
   RowBox[{"0", "\[Rule]", 
    RowBox[{"{", "}"}]}], ",", 
   RowBox[{"1", "\[Rule]", 
    RowBox[{"{", "1", "}"}]}], ",", 
   RowBox[{"2", "\[Rule]", 
    RowBox[{"{", "0", "}"}]}], ",", 
   RowBox[{"3", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"1", ",", "0"}], "}"}]}], ",", 
   RowBox[{"4", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"0", ",", "1"}], "}"}]}], ",", 
   RowBox[{"5", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"1", ",", "1"}], "}"}]}], ",", 
   RowBox[{"6", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"0", ",", "0"}], "}"}]}], ",", 
   RowBox[{"7", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"0", ",", "0", ",", "0"}], "}"}]}]}], 
  "\[RightAssociation]"}]], "Output",
 CellChangeTimes->{3.786972874699895*^9, 3.800086403615068*^9},
 CellLabel->
  "Out[863]=",ExpressionUUID->"b43e0914-09c0-4a0d-a098-408203d69a2b"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["2019/20 Mock Examination Paper Question 6", "Section",
 CellChangeTimes->{{3.78697280509435*^9, 3.786972809372409*^9}, {
  3.8000864464113617`*^9, 
  3.800086450531307*^9}},ExpressionUUID->"1d0fbe04-1c2d-4efb-b931-\
ff5f032017db"],

Cell[BoxData[
 RowBox[{"yExamQ6", " ", ":=", 
  RowBox[{"{", 
   RowBox[{
   "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", 
    ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1"}], 
   "}"}]}]], "Input",
 CellChangeTimes->{{3.786972852957251*^9, 3.7869728642730227`*^9}, {
  3.80008647884077*^9, 3.8000864886604633`*^9}},
 CellLabel->
  "In[864]:=",ExpressionUUID->"9c27f4a7-9b53-4bd7-8825-07b059f38a25"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"LempelZiv", "[", "yExamQ6", "]"}]], "Input",
 CellChangeTimes->{{3.786972818697156*^9, 3.786972831321958*^9}, {
  3.786972867783437*^9, 3.78697286920603*^9}, {3.800086491498954*^9, 
  3.800086512202276*^9}},
 CellLabel->
  "In[868]:=",ExpressionUUID->"fdd78c39-a64c-4c52-b013-39759c5b5226"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", 
   ",", "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
   "1", ",", "1"}], "}"}]], "Output",
 CellChangeTimes->{
  3.786972831644596*^9, 3.786972869538681*^9, 3.800086403502768*^9, {
   3.800086492035214*^9, 3.800086512452129*^9}},
 CellLabel->
  "Out[868]=",ExpressionUUID->"ca69db16-fbc9-491e-bea9-fa56aa15fe6e"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"LempelZivBinaryPairs", "[", "yExamQ6", "]"}]], "Input",
 CellChangeTimes->{{3.7869728728495197`*^9, 3.786972874009408*^9}, {
  3.800086494778941*^9, 3.80008652362731*^9}},
 CellLabel->
  "In[869]:=",ExpressionUUID->"2cdd2574-6a6c-482a-8140-955f0fec9047"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"\[LeftAssociation]", 
    RowBox[{
     RowBox[{
      RowBox[{"{", "}"}], "\[Rule]", "0"}], ",", 
     RowBox[{
      RowBox[{"{", "0", "}"}], "\[Rule]", "1"}], ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"0", ",", "1"}], "}"}], "\[Rule]", "2"}], ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"0", ",", "0"}], "}"}], "\[Rule]", "3"}], ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"0", ",", "0", ",", "1"}], "}"}], "\[Rule]", "4"}], ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"0", ",", "0", ",", "0"}], "}"}], "\[Rule]", "5"}], ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"0", ",", "0", ",", "0", ",", "1"}], "}"}], "\[Rule]", "6"}]}],
     "\[RightAssociation]"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", "}"}], ",", 
       RowBox[{"{", "0", "}"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", "1", "}"}], ",", 
       RowBox[{"{", "1", "}"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"0", ",", "1"}], "}"}], ",", 
       RowBox[{"{", "0", "}"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"1", ",", "1"}], "}"}], ",", 
       RowBox[{"{", "1", "}"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"0", ",", "1", ",", "1"}], "}"}], ",", 
       RowBox[{"{", "0", "}"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"1", ",", "0", ",", "1"}], "}"}], ",", 
       RowBox[{"{", "1", "}"}]}], "}"}]}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{
  3.786972874699895*^9, 3.800086403615068*^9, {3.800086495509688*^9, 
   3.800086523960978*^9}},
 CellLabel->
  "Out[869]=",ExpressionUUID->"aed250cc-341f-4b60-9920-01ec88d7ef71"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"yExamQ6", "//", "Length"}], ",", 
   RowBox[{
    RowBox[{"LempelZiv", "[", "yExamQ6", "]"}], "//", "Length"}]}], 
  "}"}]], "Input",
 CellChangeTimes->{{3.800088150745254*^9, 3.800088160586234*^9}},
 CellLabel->
  "In[871]:=",ExpressionUUID->"c4472641-3d16-4943-8151-8794c8fde423"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"15", ",", "17"}], "}"}]], "Output",
 CellChangeTimes->{{3.800088153678433*^9, 3.8000881608688087`*^9}},
 CellLabel->
  "Out[871]=",ExpressionUUID->"e74157a3-6610-4451-9dfd-4e87670af714"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"yExamQ6", "~", "Join", "~", 
   RowBox[{"{", 
    RowBox[{
    "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0",
      ",", "1", ",", "1"}], "}"}]}], "//", "Length"}]], "Input",
 CellChangeTimes->{{3.800088327201832*^9, 3.800088344585084*^9}},
 CellLabel->
  "In[880]:=",ExpressionUUID->"809628b1-e56a-4577-ad91-dd6edd6618ec"],

Cell[BoxData["25"], "Output",
 CellChangeTimes->{{3.800088328540668*^9, 3.8000883452771273`*^9}},
 CellLabel->
  "Out[880]=",ExpressionUUID->"463f9b0b-5b88-4ac2-aa2a-99073cd0a5e1"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"LempelZiv", "[", 
  RowBox[{"yExamQ6", "~", "Join", "~", 
   RowBox[{"{", 
    RowBox[{
    "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0",
      ",", "1", ",", "1"}], "}"}]}], "]"}]], "Input",
 CellLabel->
  "In[881]:=",ExpressionUUID->"3d0ee3ad-2050-4f62-b08a-cdfaec905470"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", 
   ",", "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
   "1", ",", "1", ",", "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", 
   ",", "1"}], "}"}]], "Output",
 CellChangeTimes->{3.800088407715373*^9},
 CellLabel->
  "Out[881]=",ExpressionUUID->"c39fe5b3-f45b-4d79-b5e3-9ccd7608c35f"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"LempelZiv", "[", 
   RowBox[{"yExamQ6", "~", "Join", "~", 
    RowBox[{"{", 
     RowBox[{
     "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
      "0", ",", "1", ",", "1"}], "}"}]}], "]"}], "//", "Length"}]], "Input",
 CellChangeTimes->{{3.800088258016816*^9, 3.800088333049198*^9}},
 CellLabel->
  "In[879]:=",ExpressionUUID->"5fa2a6cd-09c4-45cf-ae70-37e9d42e7b8e"],

Cell[BoxData["24"], "Output",
 CellChangeTimes->{{3.800088276319771*^9, 3.8000883336600933`*^9}},
 CellLabel->
  "Out[879]=",ExpressionUUID->"04e2753a-7e3d-45c9-93c2-286af673e129"]
}, Open  ]]
}, Open  ]]
},
WindowSize->{1080, 855},
WindowMargins->{{Automatic, -64}, {Automatic, 0}},
FrontEndVersion->"11.3 for Mac OS X x86 (32-bit, 64-bit Kernel) (March 5, \
2018)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[580, 22, 238, 4, 67, "Section",ExpressionUUID->"71e0176d-c335-43a7-8158-16e8baa297db"],
Cell[CellGroupData[{
Cell[843, 30, 172, 3, 45, "Subsubsection",ExpressionUUID->"95f52f2f-fb58-4660-8273-3f156cf740e0"],
Cell[1018, 35, 278, 7, 30, "Input",ExpressionUUID->"34187b30-e74b-4edb-8c58-0d8621ff79d4"],
Cell[1299, 44, 538, 15, 30, "Input",ExpressionUUID->"67b72d17-b089-4123-8417-9e577a0c61c2"],
Cell[1840, 61, 353, 9, 30, "Input",ExpressionUUID->"5c7c2389-0290-4db4-bdab-ea34da654adc"],
Cell[2196, 72, 309, 7, 30, "Input",ExpressionUUID->"805fd72e-02d7-4a76-98f6-5cc333108bde"],
Cell[2508, 81, 257, 6, 30, "Input",ExpressionUUID->"99f16aa0-eb49-4148-af82-931f931bbf94"],
Cell[2768, 89, 413, 11, 30, "Input",ExpressionUUID->"419ae4f4-d395-4f92-8316-16062780c9eb"],
Cell[3184, 102, 330, 8, 30, "Input",ExpressionUUID->"0996957a-3bfc-43d8-a8ff-20a1bc6298f5"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[3563, 116, 170, 3, 67, "Section",ExpressionUUID->"0123ad71-1a3a-47af-9c31-11ea77e0c5b4"],
Cell[3736, 121, 1217, 30, 73, "Input",ExpressionUUID->"5e235ebe-7198-4409-9f42-1968a22d12bd"],
Cell[4956, 153, 2637, 70, 115, "Input",ExpressionUUID->"40603496-ee41-4879-a93d-2f4deedefa65"],
Cell[7596, 225, 288, 7, 30, "Input",ExpressionUUID->"136b24a8-e123-4baa-80fb-dad0121f9d38"],
Cell[7887, 234, 1493, 41, 94, "Input",ExpressionUUID->"9844e364-67c9-4943-bbd9-50bb8c68c329"],
Cell[9383, 277, 404, 9, 30, "Input",ExpressionUUID->"b1d1e10c-85ef-4614-9513-7f1bdfec04b3"],
Cell[9790, 288, 421, 8, 71, "Subsubsection",ExpressionUUID->"2a791389-d59b-4a79-822f-782d44116269"],
Cell[CellGroupData[{
Cell[10236, 300, 402, 8, 63, "Subsubsection",ExpressionUUID->"81bc71a8-4d89-4f0e-94de-6e356bc7fa90"],
Cell[10641, 310, 1509, 40, 52, "Input",ExpressionUUID->"d38768b3-bffa-4369-bc65-16b1eb228790"],
Cell[12153, 352, 1227, 33, 52, "Input",ExpressionUUID->"0311b7c4-44e0-4c03-9b2a-c3660a9e3175"],
Cell[13383, 387, 633, 17, 52, "Input",ExpressionUUID->"27617b31-c9c5-4f28-b271-93fdbf0c847a"],
Cell[14019, 406, 343, 8, 30, "Input",ExpressionUUID->"9274d15d-348e-4986-9722-395d22bc1be6"]
}, Open  ]],
Cell[CellGroupData[{
Cell[14399, 419, 225, 4, 54, "Subsection",ExpressionUUID->"6970314e-02be-4267-8830-ab007b8c2cc7"],
Cell[14627, 425, 783, 23, 30, "Input",ExpressionUUID->"8c68ec87-a857-4468-aac6-b3f0634591e9"],
Cell[CellGroupData[{
Cell[15435, 452, 368, 8, 30, "Input",ExpressionUUID->"6fdf87a3-2d0d-43a8-8c14-11d2959bfc73"],
Cell[15806, 462, 494, 8, 34, "Output",ExpressionUUID->"54a3e0dc-f5cd-413c-b306-509302365be4"]
}, Open  ]],
Cell[CellGroupData[{
Cell[16337, 475, 414, 9, 30, "Input",ExpressionUUID->"cb1934ca-a86c-4a3b-81d1-6ea9bcbc0ac3"],
Cell[16754, 486, 1448, 37, 34, "Output",ExpressionUUID->"20484482-a68b-4f07-bdfd-be559422cdbf"]
}, Open  ]],
Cell[CellGroupData[{
Cell[18239, 528, 321, 7, 30, "Input",ExpressionUUID->"283cf792-b395-4593-b233-eb12f9571641"],
Cell[18563, 537, 1268, 37, 34, "Output",ExpressionUUID->"ef1416b6-785a-48a9-9ac6-de564f9dce15"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[19880, 580, 301, 4, 54, "Subsection",ExpressionUUID->"b7dae278-8a82-47d0-a079-0dad5dcc9dad"],
Cell[20184, 586, 373, 8, 30, "Input",ExpressionUUID->"c75d20a4-3a1c-4714-ac7a-0f46c89ab41b"],
Cell[20560, 596, 464, 10, 30, "Input",ExpressionUUID->"13f90f0d-875e-4a47-8f00-244f0a84138a"],
Cell[21027, 608, 303, 7, 30, "Input",ExpressionUUID->"d3f010c5-cdc9-4c5c-9461-d42d1219ebe9"],
Cell[CellGroupData[{
Cell[21355, 619, 200, 4, 30, "Input",ExpressionUUID->"aa127229-fc6c-4b4a-b709-779d672aad99"],
Cell[21558, 625, 1794, 54, 56, "Output",ExpressionUUID->"6a4f2a27-d52d-4764-9c7d-6dfe115b36ae"]
}, Open  ]],
Cell[CellGroupData[{
Cell[23389, 684, 281, 5, 30, "Input",ExpressionUUID->"ac9015f7-c626-4c33-873f-4726b5b6905d"],
Cell[23673, 691, 2187, 67, 56, "Output",ExpressionUUID->"4e536527-7a61-40a0-b98b-16f5bc800058"]
}, Open  ]],
Cell[CellGroupData[{
Cell[25897, 763, 221, 4, 30, "Input",ExpressionUUID->"3170d3b6-4f2a-4461-b72c-f31be5bdac97"],
Cell[26121, 769, 588, 11, 34, "Output",ExpressionUUID->"13ccf847-b6d8-4110-9ce9-ea027ef9d27a"]
}, Open  ]],
Cell[CellGroupData[{
Cell[26746, 785, 191, 3, 30, "Input",ExpressionUUID->"7d44cfb1-27cf-4344-bc29-70ff53ccc123"],
Cell[26940, 790, 293, 5, 34, "Output",ExpressionUUID->"752006ef-a436-499e-8b98-41bd33ef0e54"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[27282, 801, 165, 3, 54, "Subsection",ExpressionUUID->"7d3d2c43-c72d-4004-8943-87c3ea7a7eac"],
Cell[27450, 806, 225, 4, 30, "Input",ExpressionUUID->"84843017-b134-4965-a9ae-2469a6f24618"],
Cell[CellGroupData[{
Cell[27700, 814, 612, 16, 30, "Input",ExpressionUUID->"6616df0f-7044-4b59-a110-bcf65520e669"],
Cell[28315, 832, 605, 12, 34, "Output",ExpressionUUID->"08f575de-2f7d-4f40-90ec-e1ab2db4f60b"]
}, Open  ]],
Cell[28935, 847, 553, 11, 30, "Input",ExpressionUUID->"feb1773b-58f1-421e-ad4c-b8340cf66f79"],
Cell[29491, 860, 453, 10, 30, "Input",ExpressionUUID->"dd618faf-2054-4a5c-9a20-6db13e0533cc"],
Cell[CellGroupData[{
Cell[29969, 874, 309, 6, 30, "Input",ExpressionUUID->"5ee230bc-9b1c-48c5-900e-c90c9740e425"],
Cell[30281, 882, 1907, 57, 56, "Output",ExpressionUUID->"2d6d5912-5d1a-46f6-8039-7dbfae827173"]
}, Open  ]],
Cell[CellGroupData[{
Cell[32225, 944, 316, 6, 30, "Input",ExpressionUUID->"a594b822-5749-462f-91b1-390a6a46eefb"],
Cell[32544, 952, 2343, 71, 56, "Output",ExpressionUUID->"b877781d-75de-47c1-b7c7-9a637a6b2d12"]
}, Open  ]],
Cell[CellGroupData[{
Cell[34924, 1028, 304, 6, 30, "Input",ExpressionUUID->"a917346d-73f1-459c-b609-4426fc1254ad"],
Cell[35231, 1036, 597, 11, 34, "Output",ExpressionUUID->"b0858cb8-0af9-4c0c-85da-9226a21351e1"]
}, Open  ]],
Cell[CellGroupData[{
Cell[35865, 1052, 194, 3, 30, "Input",ExpressionUUID->"cdfb1be4-e9a2-4a75-847e-28cab51187c0"],
Cell[36062, 1057, 278, 5, 34, "Output",ExpressionUUID->"e84fe7e4-3474-4266-8b14-406b096f7906"]
}, Open  ]],
Cell[CellGroupData[{
Cell[36377, 1067, 170, 3, 45, "Subsubsection",ExpressionUUID->"4613f65c-9965-4117-95dc-ed479dacdaf8"],
Cell[CellGroupData[{
Cell[36572, 1074, 316, 6, 30, "Input",ExpressionUUID->"903f63c3-5b46-4fa9-90f9-3501422a0071"],
Cell[36891, 1082, 9534, 272, 266, "Output",ExpressionUUID->"845dffd9-6525-4346-9fa0-dd0c563658cf"]
}, Open  ]],
Cell[CellGroupData[{
Cell[46462, 1359, 422, 11, 30, "Input",ExpressionUUID->"36895429-ccba-4e54-a4f8-e3e06f70835d"],
Cell[46887, 1372, 1872, 29, 98, "Output",ExpressionUUID->"77a005a6-fc54-4c81-88aa-b334b775e584"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[48808, 1407, 238, 4, 45, "Subsubsection",ExpressionUUID->"cda34530-753e-43ab-89fb-5b237ce040a5"],
Cell[CellGroupData[{
Cell[49071, 1415, 1310, 34, 94, "Input",ExpressionUUID->"90bf7ea5-ae75-4957-840c-b59b8bcc84ba"],
Cell[50384, 1451, 132511, 2012, 2186, "Output",ExpressionUUID->"3dcea32f-f5c4-4d71-9630-27d481656cf7"]
}, Open  ]],
Cell[CellGroupData[{
Cell[182932, 3468, 650, 16, 30, "Input",ExpressionUUID->"59266278-bf29-4760-aa05-c92a7d5bea01"],
Cell[183585, 3486, 2839, 61, 254, "Output",ExpressionUUID->"234a36b8-3811-4ed9-b84f-9046244203d1"]
}, Open  ]]
}, Open  ]]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[186497, 3555, 172, 3, 67, "Section",ExpressionUUID->"f7b5349d-26cf-41f9-927f-0f8e9eb32d37"],
Cell[186672, 3560, 1981, 52, 94, "Input",ExpressionUUID->"9b4d5748-2361-4f28-8a0c-fb25b7d2a8b2"],
Cell[188656, 3614, 883, 23, 30, "Input",ExpressionUUID->"2843237e-73ef-4edd-8e53-143e41c644b0"],
Cell[189542, 3639, 921, 24, 73, "Input",ExpressionUUID->"8efc4409-b0e9-44ad-b68c-e74543063d27"],
Cell[190466, 3665, 406, 9, 30, "Input",ExpressionUUID->"60eef777-632c-4aac-b148-45453dd3f37a"],
Cell[190875, 3676, 1254, 31, 52, "Input",ExpressionUUID->"0fa0b0d4-324c-4d8a-a08e-97f572791706"],
Cell[192132, 3709, 525, 13, 30, "Input",ExpressionUUID->"40813c28-d6fe-49fa-aa64-5f141c78cbd2"],
Cell[CellGroupData[{
Cell[192682, 3726, 288, 5, 30, "Input",ExpressionUUID->"517dc25f-b8eb-48fe-857a-4f74e0a91f88"],
Cell[192973, 3733, 1133, 30, 34, "Output",ExpressionUUID->"a0f12d78-6000-4ac5-bf78-148c4532fe20"]
}, Open  ]],
Cell[CellGroupData[{
Cell[194143, 3768, 239, 5, 45, "Subsubsection",ExpressionUUID->"a0374780-6d3d-45d4-8fc5-85e1b1277935"],
Cell[194385, 3775, 775, 21, 52, "Input",ExpressionUUID->"165bb550-266f-489b-b606-f22ce6b011e3"]
}, Open  ]],
Cell[CellGroupData[{
Cell[195197, 3801, 161, 3, 45, "Subsubsection",ExpressionUUID->"c6062ae1-7368-433e-ab14-a4cd4644b11b"],
Cell[195361, 3806, 672, 17, 94, "Input",ExpressionUUID->"cdd879b1-fefc-45b5-836a-692e24879bc3"]
}, Open  ]],
Cell[CellGroupData[{
Cell[196070, 3828, 155, 3, 54, "Subsection",ExpressionUUID->"78075efc-62a3-4c47-b866-e7a3a0b2e2ef"],
Cell[CellGroupData[{
Cell[196250, 3835, 235, 4, 30, "Input",ExpressionUUID->"19443a5c-69cc-40a0-b89a-ad54fa910d29"],
Cell[196488, 3841, 1363, 37, 56, "Output",ExpressionUUID->"7d834787-164c-4c62-9902-47e72623a247"]
}, Open  ]],
Cell[CellGroupData[{
Cell[197888, 3883, 188, 3, 30, "Input",ExpressionUUID->"aafa3593-9324-4b18-ae19-39bec798526a"],
Cell[198079, 3888, 540, 10, 34, "Output",ExpressionUUID->"1dc00405-d883-4e3e-b5d1-def64effdc73"]
}, Open  ]],
Cell[CellGroupData[{
Cell[198656, 3903, 341, 7, 30, "Input",ExpressionUUID->"4778a422-6991-49ad-b01b-8128990bffd8"],
Cell[199000, 3912, 1040, 30, 34, "Output",ExpressionUUID->"63486d07-046f-4ee8-b934-1edf7520cfc4"]
}, Open  ]],
Cell[CellGroupData[{
Cell[200077, 3947, 239, 4, 30, "Input",ExpressionUUID->"8fcc4cb8-f172-4ad7-bb02-cdd0c683819e"],
Cell[200319, 3953, 1068, 29, 34, "Output",ExpressionUUID->"1d5f7728-3d59-4b6d-9b07-da3b0e3038ea"]
}, Open  ]],
Cell[CellGroupData[{
Cell[201424, 3987, 217, 4, 30, "Input",ExpressionUUID->"a1890299-c1c8-4248-9d3c-77b04f960235"],
Cell[201644, 3993, 1018, 22, 56, "Output",ExpressionUUID->"c95c9207-3ca7-4ad3-bd46-72669ca1d2d7"]
}, Open  ]],
Cell[CellGroupData[{
Cell[202699, 4020, 251, 5, 30, "Input",ExpressionUUID->"2c0a2adc-9c8b-49fe-b4a4-0aba1e44666d"],
Cell[202953, 4027, 1858, 34, 77, "Output",ExpressionUUID->"9d892b26-1bc7-4a94-89e8-ed1876146737"]
}, Open  ]],
Cell[CellGroupData[{
Cell[204848, 4066, 487, 10, 30, "Input",ExpressionUUID->"952142b3-4a66-4b4c-97f9-a19ce78e3031"],
Cell[205338, 4078, 1324, 26, 77, "Output",ExpressionUUID->"114bd191-f866-4502-bdbc-d6042a579911"]
}, Open  ]]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[206723, 4111, 196, 3, 67, "Section",ExpressionUUID->"fa0e5859-9249-471f-a830-5835c770e9f5"],
Cell[206922, 4116, 276, 7, 30, "Input",ExpressionUUID->"bdef34b3-f8a5-4591-9d45-fa872a3609e2"],
Cell[207201, 4125, 587, 16, 30, "Input",ExpressionUUID->"4612090f-81fe-48cd-af13-62f2871ba8ee"],
Cell[207791, 4143, 311, 7, 30, "Input",ExpressionUUID->"e4fcbac9-c0bd-48c5-8011-9a74ab7377c6"],
Cell[CellGroupData[{
Cell[208127, 4154, 329, 8, 30, "Input",ExpressionUUID->"0774fc1d-b8e3-4967-b6c3-4384c5a0f486"],
Cell[CellGroupData[{
Cell[208481, 4166, 565, 12, 24, "Print",ExpressionUUID->"52a84851-0089-4116-a077-4f85e78b63d1"],
Cell[209049, 4180, 1867, 51, 44, "Print",ExpressionUUID->"fe3f47f8-f86c-4115-bd9e-a43bcd30b9b9"]
}, Open  ]]
}, Open  ]],
Cell[210943, 4235, 672, 19, 30, "Input",ExpressionUUID->"a804cb02-c847-4eb3-8c8d-790516de2243"],
Cell[211618, 4256, 588, 16, 30, "Input",ExpressionUUID->"f38f90ef-4b96-4235-becd-c9a68b408e77"],
Cell[212209, 4274, 806, 23, 30, "Input",ExpressionUUID->"b30a6844-60dd-4394-bc1a-605cadf31313"],
Cell[CellGroupData[{
Cell[213040, 4301, 852, 24, 30, "Input",ExpressionUUID->"20685219-3018-4c90-b09f-05779dfe321c"],
Cell[213895, 4327, 795, 19, 34, "Output",ExpressionUUID->"c3fc7f94-afe2-4a25-9ce9-54e1ac096d22"]
}, Open  ]],
Cell[CellGroupData[{
Cell[214727, 4351, 326, 8, 30, "Input",ExpressionUUID->"03fecff6-822c-4835-9658-d452a53b5bc5"],
Cell[215056, 4361, 388, 8, 34, "Output",ExpressionUUID->"999fb3a1-2964-43cd-ac64-ac35572dceb4"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[215493, 4375, 221, 4, 67, "Section",ExpressionUUID->"4c0960a5-6d41-4914-8ce2-7b3ebd99deab"],
Cell[215717, 4381, 566, 12, 30, "Input",ExpressionUUID->"b53962b6-96fd-4316-ab2b-fc667806557b"],
Cell[216286, 4395, 241, 5, 30, "Input",ExpressionUUID->"69b4d6cf-b10f-40fc-89bd-9b621064b81d"],
Cell[CellGroupData[{
Cell[216552, 4404, 253, 6, 30, "Input",ExpressionUUID->"53be3c5e-068c-4c37-96dd-59810400bc69"],
Cell[216808, 4412, 1192, 26, 60, "Output",ExpressionUUID->"2f7c18d2-40dc-4314-81a1-b234254ceca6"]
}, Open  ]],
Cell[CellGroupData[{
Cell[218037, 4443, 323, 6, 30, "Input",ExpressionUUID->"ae5bec4a-19d9-41df-9295-e945d137b690"],
Cell[218363, 4451, 2936, 89, 77, "Output",ExpressionUUID->"4fab3a5f-c98c-47d8-a71f-2dae2d64059f"]
}, Open  ]],
Cell[CellGroupData[{
Cell[221336, 4545, 255, 6, 30, "Input",ExpressionUUID->"e07a27b1-bac5-4199-9a18-344c2955841f"],
Cell[221594, 4553, 250, 4, 34, "Output",ExpressionUUID->"aafa5098-ff6c-42fc-801e-72655fff3443"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[221893, 4563, 180, 3, 67, "Section",ExpressionUUID->"c8c05079-0ef8-4f0e-9829-c6c1e3b4aa5f"],
Cell[222076, 4568, 462, 10, 30, "Input",ExpressionUUID->"7170abc6-4979-4405-be0c-fff4bb54a8e5"],
Cell[CellGroupData[{
Cell[222563, 4582, 271, 5, 30, "Input",ExpressionUUID->"008a3957-b018-4b91-af81-37be5d4a85c0"],
Cell[222837, 4589, 362, 8, 34, "Output",ExpressionUUID->"0eb8af84-eaff-40b4-8651-dd40941706bb"]
}, Open  ]],
Cell[CellGroupData[{
Cell[223236, 4602, 235, 4, 30, "Input",ExpressionUUID->"50a1dc04-9316-4eca-a21f-5fcf9ab8d69d"],
Cell[223474, 4608, 893, 27, 34, "Output",ExpressionUUID->"b43e0914-09c0-4a0d-a098-408203d69a2b"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[224416, 4641, 236, 4, 67, "Section",ExpressionUUID->"1d0fbe04-1c2d-4efb-b931-ff5f032017db"],
Cell[224655, 4647, 452, 10, 30, "Input",ExpressionUUID->"9c27f4a7-9b53-4bd7-8825-07b059f38a25"],
Cell[CellGroupData[{
Cell[225132, 4661, 314, 6, 30, "Input",ExpressionUUID->"fdd78c39-a64c-4c52-b013-39759c5b5226"],
Cell[225449, 4669, 456, 10, 34, "Output",ExpressionUUID->"ca69db16-fbc9-491e-bea9-fa56aa15fe6e"]
}, Open  ]],
Cell[CellGroupData[{
Cell[225942, 4684, 278, 5, 30, "Input",ExpressionUUID->"2cdd2574-6a6c-482a-8140-955f0fec9047"],
Cell[226223, 4691, 1874, 59, 56, "Output",ExpressionUUID->"aed250cc-341f-4b60-9920-01ec88d7ef71"]
}, Open  ]],
Cell[CellGroupData[{
Cell[228134, 4755, 334, 9, 30, "Input",ExpressionUUID->"c4472641-3d16-4943-8151-8794c8fde423"],
Cell[228471, 4766, 226, 5, 34, "Output",ExpressionUUID->"e74157a3-6610-4451-9dfd-4e87670af714"]
}, Open  ]],
Cell[CellGroupData[{
Cell[228734, 4776, 386, 9, 30, "Input",ExpressionUUID->"809628b1-e56a-4577-ad91-dd6edd6618ec"],
Cell[229123, 4787, 180, 3, 34, "Output",ExpressionUUID->"463f9b0b-5b88-4ac2-aa2a-99073cd0a5e1"]
}, Open  ]],
Cell[CellGroupData[{
Cell[229340, 4795, 327, 8, 30, "Input",ExpressionUUID->"3d0ee3ad-2050-4f62-b08a-cdfaec905470"],
Cell[229670, 4805, 433, 9, 34, "Output",ExpressionUUID->"c39fe5b3-f45b-4d79-b5e3-9ccd7608c35f"]
}, Open  ]],
Cell[CellGroupData[{
Cell[230140, 4819, 427, 10, 30, "Input",ExpressionUUID->"5fa2a6cd-09c4-45cf-ae70-37e9d42e7b8e"],
Cell[230570, 4831, 180, 3, 34, "Output",ExpressionUUID->"04e2753a-7e3d-45c9-93c2-286af673e129"]
}, Open  ]]
}, Open  ]]
}
]
*)

