(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[         0,          0]
NotebookDataLength[    347412,       8990]
NotebookOptionsPosition[    320616,       8514]
NotebookOutlinePosition[    321007,       8531]
CellTagsIndexPosition[    320964,       8528]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell["\<\
Shannon codes,  Huffman codes and the construction used to prove \
\[OpenCurlyQuote]if\[CloseCurlyQuote] in Kraft\[CloseCurlyQuote]s Inequality\
\>", "Section",
 CellChangeTimes->{{3.77908641470793*^9, 3.7790864242248793`*^9}, {
  3.7796893863735743`*^9, 3.779689410726223*^9}, {3.7796904785061283`*^9, 
  3.779690501947613*^9}, {3.7796910826583014`*^9, 
  3.779691107917379*^9}},ExpressionUUID->"a875ba7e-0401-48f1-bd1d-\
340ae123d0b2"],

Cell[TextData[StyleBox["Remember: shift-return to execute, use \
\[OpenCurlyQuote]Evaluate Notebook\[CloseCurlyQuote] in \
\[OpenCurlyQuote]Evaluation\[CloseCurlyQuote] menu to get started.",
 FontWeight->"Bold"]], "Subsection",
 CellChangeTimes->{{3.779086363398024*^9, 3.779086381719405*^9}, {
  3.779689447019022*^9, 3.779689458291551*^9}, {3.7797145774980288`*^9, 
  3.7797146065614767`*^9}},ExpressionUUID->"d2025e46-bb02-4812-8ab3-\
e707a367bb69"],

Cell[CellGroupData[{

Cell["\<\
Scroll down by about  a screen for Shannon codes as in Problem Sheet 2 \
Question  4 and the useful function \[OpenCurlyQuote]FractionalBinaryForm\
\[CloseCurlyQuote]. Problem Sheet 2 Question 3 can also be done using these \
functions.\
\>", "Subsection",
 CellChangeTimes->{{3.779689415926104*^9, 3.7796895416106853`*^9}, {
  3.7796903409836884`*^9, 3.779690353950221*^9}, {3.782308755190246*^9, 
  3.782308759908063*^9}},ExpressionUUID->"6a89dd2c-12c2-49ec-8975-\
c2d9c5ff035b"],

Cell[CellGroupData[{

Cell["Useful functions", "Subsubsection",
 CellChangeTimes->{{3.7796320716768084`*^9, 
  3.779632073412519*^9}},ExpressionUUID->"1b0f790f-c4fe-4051-a49e-\
af4b4163ea9e"],

Cell[BoxData[
 RowBox[{
  RowBox[{"TF", "[", "xs_", "]"}], ":=", 
  RowBox[{"TableForm", "[", 
   RowBox[{"xs", ",", 
    RowBox[{"TableDepth", "\[Rule]", "2"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.776848418166206*^9, 3.776848425662076*^9}},
 CellLabel->"In[1]:=",ExpressionUUID->"abda408d-17e1-43d5-94eb-fc90a3813f4e"],

Cell[BoxData[
 RowBox[{
  RowBox[{"DeleteElement", "[", 
   RowBox[{"xs_", ",", "x_"}], "]"}], ":=", 
  RowBox[{"DeleteCases", "[", 
   RowBox[{"xs", ",", "x", ",", "1", ",", "1"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.779629385298852*^9, 3.779629392399891*^9}},
 CellLabel->"In[2]:=",ExpressionUUID->"ff795b01-60d6-453b-be34-9b3e34dca02c"],

Cell[BoxData[
 RowBox[{
  RowBox[{"ListComplement", "[", 
   RowBox[{"xs_", ",", "ys_"}], "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"zs", "=", "xs"}], "}"}], ",", 
    RowBox[{
     RowBox[{"For", "[", 
      RowBox[{
       RowBox[{"i", "=", "1"}], ",", 
       RowBox[{"i", "<=", 
        RowBox[{"Length", "[", "ys", "]"}]}], ",", 
       RowBox[{"i", "++"}], ",", 
       RowBox[{"zs", "=", 
        RowBox[{"DeleteElement", "[", 
         RowBox[{"zs", ",", 
          RowBox[{"ys", "[", 
           RowBox[{"[", "i", "]"}], "]"}]}], "]"}]}]}], "]"}], ";", "zs"}]}], 
   "]"}]}]], "Input",
 CellChangeTimes->{{3.779629524602778*^9, 3.779629634227829*^9}, {
  3.779629668228918*^9, 3.779629693407116*^9}, {3.779629738495246*^9, 
  3.779629866481534*^9}},
 CellLabel->"In[3]:=",ExpressionUUID->"88cbb730-8203-4642-91c4-ec1847364828"],

Cell[BoxData[
 RowBox[{
  RowBox[{"AllBinaryWords", "[", "0", "]"}], ":=", 
  RowBox[{"{", 
   RowBox[{"{", "}"}], "}"}]}]], "Input",
 CellChangeTimes->{{3.7784891460199327`*^9, 3.778489168273425*^9}},
 CellLabel->"In[4]:=",ExpressionUUID->"858c1861-dc1d-448f-9a7e-6fb5163b10de"],

Cell[BoxData[
 RowBox[{
  RowBox[{"AllBinaryWords", "[", "l_", "]"}], ":=", 
  RowBox[{"Join", "@@", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"u", "~", "Join", "~", 
        RowBox[{"{", "0", "}"}]}], ",", 
       RowBox[{"u", "~", "Join", "~", 
        RowBox[{"{", "1", "}"}]}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"u", ",", 
       RowBox[{"AllBinaryWords", "[", 
        RowBox[{"l", "-", "1"}], "]"}]}], "}"}]}], "]"}]}]}]], "Input",
 CellChangeTimes->{{3.778489170982335*^9, 3.778489197608116*^9}},
 CellLabel->"In[5]:=",ExpressionUUID->"a2644d18-4a99-4420-8d13-d396863e5458"],

Cell[BoxData[
 RowBox[{
  RowBox[{"ToBinaryLE", "[", 
   RowBox[{"x_", ",", "0"}], "]"}], ":=", 
  RowBox[{"{", "}"}]}]], "Input",
 CellChangeTimes->{{3.779626842646665*^9, 3.779626863279668*^9}},
 CellLabel->"In[6]:=",ExpressionUUID->"24adcfbd-b4ce-4d94-9235-7609494842cd"],

Cell[BoxData[
 RowBox[{
  RowBox[{"ToBinaryLE", "[", 
   RowBox[{"x_", ",", "l_"}], "]"}], ":=", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"Mod", "[", 
     RowBox[{"x", ",", "2"}], "]"}], "}"}], "~", "Join", "~", 
   RowBox[{"ToBinaryLE", "[", 
    RowBox[{
     RowBox[{"Quotient", "[", 
      RowBox[{"x", ",", "2"}], "]"}], ",", 
     RowBox[{"l", "-", "1"}]}], "]"}]}]}]], "Input",
 CellChangeTimes->{{3.779626852369396*^9, 3.77962688683256*^9}},
 CellLabel->"In[7]:=",ExpressionUUID->"f57e00c3-5abf-4b3d-a465-0a9034543394"],

Cell[BoxData[
 RowBox[{
  RowBox[{"ToBinary", "[", 
   RowBox[{"x_", ",", "l_"}], "]"}], ":=", 
  RowBox[{
   RowBox[{"ToBinaryLE", "[", 
    RowBox[{"x", ",", "l"}], "]"}], "//", "Reverse"}]}]], "Input",
 CellChangeTimes->{{3.77962691646706*^9, 3.779626924077487*^9}},
 CellLabel->"In[8]:=",ExpressionUUID->"f46a9341-9ceb-415b-ab6f-840062ba9eb6"],

Cell[BoxData[
 RowBox[{
  RowBox[{"FractionalBinaryForm", "[", 
   RowBox[{"_", ",", "0"}], "]"}], ":=", 
  RowBox[{"{", "}"}]}]], "Input",
 CellChangeTimes->{{3.779643077124905*^9, 3.77964308353412*^9}, {
  3.779643196520289*^9, 3.779643199615556*^9}},
 CellLabel->"In[9]:=",ExpressionUUID->"f02a61d3-7f82-4082-a61a-02a7a2a6d875"],

Cell[BoxData[
 RowBox[{
  RowBox[{"FractionalBinaryForm", "[", 
   RowBox[{"p_", ",", 
    RowBox[{"l_:", "10"}]}], "]"}], ":=", 
  RowBox[{"If", "[", 
   RowBox[{
    RowBox[{"p", "\[GreaterEqual]", 
     RowBox[{"1", "/", "2"}]}], ",", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", "1", "}"}], "~", "Join", "~", 
     RowBox[{"FractionalBinaryForm", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"2", "*", "p"}], "-", "1"}], ",", 
       RowBox[{"l", "-", "1"}]}], "]"}]}], ",", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", "0", "}"}], "~", "Join", "~", 
     RowBox[{"FractionalBinaryForm", "[", 
      RowBox[{
       RowBox[{"2", "*", "p"}], ",", 
       RowBox[{"l", "-", "1"}]}], "]"}]}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.779643024371582*^9, 3.779643159408101*^9}, {
  3.7796432018824797`*^9, 3.779643250528635*^9}},
 CellLabel->"In[10]:=",ExpressionUUID->"f6f54314-8df0-4735-bf50-1deecc5a4b94"],

Cell[BoxData[
 RowBox[{
  RowBox[{"BigListPlot", "[", 
   RowBox[{"xs_", ",", "yMin_", ",", "yMax_", ",", "cols_"}], "]"}], ":=", 
  RowBox[{"ListPlot", "[", 
   RowBox[{"xs", ",", 
    RowBox[{"PlotMarkers", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"Style", "[", 
          RowBox[{"\"\<+\>\"", ",", 
           RowBox[{"FontSize", "\[Rule]", "18"}]}], "]"}], ",", "1"}], "}"}], 
       ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"Style", "[", 
          RowBox[{"\"\<+\>\"", ",", 
           RowBox[{"FontSize", "\[Rule]", "18"}]}], "]"}], ",", "1"}], "}"}], 
       ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"Style", "[", 
          RowBox[{"\"\<+\>\"", ",", 
           RowBox[{"FontSize", "\[Rule]", "15"}]}], "]"}], ",", "1"}], 
        "}"}]}], "}"}]}], ",", 
    RowBox[{"PlotStyle", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"Black", ",", 
         RowBox[{"PointSize", "[", "0.01", "]"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"Blue", ",", 
         RowBox[{"PointSize", "[", "0.01", "]"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"Red", ",", 
         RowBox[{"PointSize", "[", "0.01", "]"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"Orange", ",", 
         RowBox[{"PointSize", "[", "0.01", "]"}]}], "}"}]}], "}"}]}], ",", 
    RowBox[{"PlotRange", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"yMin", ",", "yMax"}], "}"}]}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.75130337462801*^9, 3.751303378811008*^9}, {
   3.751304313699641*^9, 3.7513043423261633`*^9}, {3.751304651259473*^9, 
   3.7513046655417423`*^9}, {3.782310806631536*^9, 3.7823108224259367`*^9}, 
   3.782310912665886*^9, {3.782311035653578*^9, 3.782311080863496*^9}, {
   3.7823111298540373`*^9, 3.782311176763321*^9}, {3.782311223251659*^9, 
   3.782311228182371*^9}, {3.782311261622093*^9, 3.782311346950445*^9}, {
   3.782311394566839*^9, 3.782311416882813*^9}, {3.782311802476761*^9, 
   3.782311804752386*^9}, {3.78231204264144*^9, 3.782312045351812*^9}, {
   3.782318242591219*^9, 3.782318246278777*^9}},
 CellLabel->"In[11]:=",ExpressionUUID->"5be75c4e-f687-4947-a80f-39b60ba731a0"],

Cell[BoxData[
 RowBox[{
  RowBox[{"BigListPlot", "[", 
   RowBox[{"xs_", ",", "yMin_", ",", "yMax_"}], "]"}], ":=", 
  RowBox[{"BigListPlot", "[", 
   RowBox[{"xs", ",", "yMin", ",", "yMax", ",", 
    RowBox[{"{", "Black", "}"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.751303118964024*^9, 3.751303125299849*^9}, {
  3.7513033814981413`*^9, 3.751303386349511*^9}, {3.7513046685236588`*^9, 
  3.7513046745830317`*^9}, {3.782310829319722*^9, 3.782310830108102*^9}},
 CellLabel->"In[12]:=",ExpressionUUID->"f8cf1a7d-76ce-478e-9d28-7adcc1190609"],

Cell[BoxData[
 RowBox[{
  RowBox[{"BigListPlot", "[", "xs_", "]"}], ":=", 
  RowBox[{"BigListPlot", "[", 
   RowBox[{"xs", ",", 
    RowBox[{"-", "1"}], ",", "1"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.751370352631255*^9, 3.751370358377068*^9}},
 CellLabel->"In[13]:=",ExpressionUUID->"9b78d3f7-db55-474a-bf13-0488e06afc48"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Tally", "[", 
  RowBox[{"{", 
   RowBox[{"1", ",", "1", ",", "2", ",", "2", ",", "3", ",", "1"}], "}"}], 
  "]"}]], "Input",
 CellChangeTimes->{{3.782317397583206*^9, 3.782317401012395*^9}},
 CellLabel->"In[14]:=",ExpressionUUID->"6d3a8497-29a4-477e-b654-a375a06662cd"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"1", ",", "3"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2", ",", "2"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"3", ",", "1"}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{3.782317402157995*^9, 3.782458025062051*^9, 
  3.7824643749972258`*^9, 3.782464432104773*^9},
 CellLabel->"Out[14]=",ExpressionUUID->"18c10ed7-753d-4466-8910-cdcd09478dda"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"Subwords", "[", 
   RowBox[{"xs_", ",", "m_"}], "]"}], ":=", 
  RowBox[{"Table", "[", 
   RowBox[{
    RowBox[{"xs", "[", 
     RowBox[{"[", 
      RowBox[{"i", ";;", 
       RowBox[{"i", "+", "m", "-", "1"}]}], "]"}], "]"}], ",", 
    RowBox[{"{", 
     RowBox[{"i", ",", "1", ",", 
      RowBox[{
       RowBox[{"Length", "[", "xs", "]"}], "-", "m", "+", "1"}]}], "}"}]}], 
   "]"}]}]], "Input",
 CellChangeTimes->{{3.782317413774343*^9, 3.782317444327585*^9}},
 CellLabel->"In[15]:=",ExpressionUUID->"9e322fe7-e590-4946-9251-f7ac5e283531"],

Cell[BoxData[
 RowBox[{
  RowBox[{"SubwordFrequencyPairs", "[", 
   RowBox[{"xs_", ",", "m_"}], "]"}], ":=", 
  RowBox[{
   RowBox[{"Tally", "[", 
    RowBox[{"Subwords", "[", 
     RowBox[{"xs", ",", "m"}], "]"}], "]"}], "//", "Sort"}]}]], "Input",
 CellChangeTimes->{{3.782317365166581*^9, 3.782317395138789*^9}, {
  3.782317449410336*^9, 3.782317505573701*^9}},
 CellLabel->"In[16]:=",ExpressionUUID->"bcf4c60b-6c50-48b6-a96c-8e2616f109f9"],

Cell[BoxData[
 RowBox[{
  RowBox[{"SubwordFrequencies", "[", 
   RowBox[{"xs_", ",", "m_"}], "]"}], ":=", 
  RowBox[{
   RowBox[{
    RowBox[{"#", "[", 
     RowBox[{"[", "2", "]"}], "]"}], "&"}], "/@", 
   RowBox[{"SubwordFrequencyPairs", "[", 
    RowBox[{"xs", ",", "m"}], "]"}]}]}]], "Input",
 CellChangeTimes->{{3.782317506472026*^9, 3.782317524491836*^9}},
 CellLabel->"In[17]:=",ExpressionUUID->"e2be2bee-5c81-411d-a5db-cfbdf5011fc4"]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
Entropy: NB Mathematica defines entropy for a sample (not helpful)\
\>", "Subsubsection",
 CellChangeTimes->{{3.780158090879107*^9, 3.780158091531135*^9}, {
  3.782315919875972*^9, 
  3.78231593584797*^9}},ExpressionUUID->"deb9df8e-0913-47ef-bafe-\
b7b6e48c083c"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"H", "[", "ps_", "]"}], ":=", 
   RowBox[{"-", 
    RowBox[{"Sum", "[", 
     RowBox[{
      RowBox[{"p", "*", 
       RowBox[{"Log", "[", 
        RowBox[{"2", ",", "p"}], "]"}]}], ",", 
      RowBox[{"{", 
       RowBox[{"p", ",", "ps"}], "}"}]}], "]"}]}]}], ";", 
  RowBox[{"Unprotect", "[", "Entropy", "]"}], ";", 
  RowBox[{"ClearAll", "[", "Entropy", "]"}], ";", 
  RowBox[{"Entropy", ":=", "H"}]}]], "Input",
 CellChangeTimes->{{3.780157955296465*^9, 3.780157964028562*^9}, {
  3.7823159456752768`*^9, 3.78231594593738*^9}, {3.782465307164914*^9, 
  3.782465311823262*^9}},
 CellLabel->
  "In[170]:=",ExpressionUUID->"6aedb948-00c4-4673-adae-5f7170a977ab"]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
For example we write 13 in binary using 6 bits and find the fractional binary \
form of 1/3.\
\>", "Subsubsection",
 CellChangeTimes->{{3.77968932844643*^9, 
  3.779689365614855*^9}},ExpressionUUID->"21c41a8a-245f-4a7c-824d-\
25f56ece8c98"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ToBinary", "[", 
  RowBox[{"13", ",", "6"}], "]"}]], "Input",
 CellChangeTimes->{{3.779689343266*^9, 3.7796893506277227`*^9}},
 CellLabel->"In[19]:=",ExpressionUUID->"2d9b37c7-0e8f-4adf-a4d8-cbf7df2312cd"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "1"}], 
  "}"}]], "Output",
 CellChangeTimes->{
  3.779689351018997*^9, 3.779690583849152*^9, 3.779691315862137*^9, 
   3.7801575919914703`*^9, 3.780215625445918*^9, 3.780230181724908*^9, {
   3.780230288156646*^9, 3.780230338388171*^9}, 3.7802306975057697`*^9, 
   3.780414296212166*^9, 3.780582014001588*^9, 3.780894780417746*^9, 
   3.781245308324073*^9, 3.781448053174461*^9, 3.781538131030416*^9, 
   3.781539242508544*^9, 3.782308669075897*^9, 3.7823157566683407`*^9, 
   3.782458025252315*^9, 3.782464375306841*^9, 3.782464435583662*^9},
 CellLabel->"Out[19]=",ExpressionUUID->"1ded3356-105d-449b-b08e-0eb412f5bea7"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"FractionalBinaryForm", "[", 
  RowBox[{
   RowBox[{"1", "/", "3"}], ",", "20"}], "]"}]], "Input",
 CellChangeTimes->{{3.779689314708994*^9, 3.7796893408304462`*^9}},
 CellLabel->"In[20]:=",ExpressionUUID->"c47092a3-9db4-4447-897a-a2c4daec6707"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", 
   ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
   "1", ",", "0", ",", "1", ",", "0", ",", "1"}], "}"}]], "Output",
 CellChangeTimes->{{3.779689319781015*^9, 3.779689341860785*^9}, 
   3.779690583931273*^9, 3.77969131595335*^9, 3.780157592090452*^9, 
   3.780215625548299*^9, 3.780230181843236*^9, {3.780230288251144*^9, 
   3.780230338491197*^9}, 3.780230697621543*^9, 3.780414296295862*^9, 
   3.7805820141004133`*^9, 3.780894780485026*^9, 3.78124530841077*^9, 
   3.781448053275372*^9, 3.781538131130128*^9, 3.7815392426153603`*^9, 
   3.782308669166832*^9, 3.782315756784409*^9, 3.782458025369585*^9, 
   3.782464375461087*^9, 3.782464435742064*^9},
 CellLabel->"Out[20]=",ExpressionUUID->"7f4d796e-b260-4ccd-bce2-4913a0fc6dd0"]
}, Open  ]]
}, Open  ]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Shannon code: as in Problem Sheet 2 Question 4", "Section",
 CellChangeTimes->{{3.779626626746312*^9, 3.779626636697033*^9}, {
  3.779689013909855*^9, 3.779689026337813*^9}, {3.779690289547305*^9, 
  3.779690292714395*^9}},ExpressionUUID->"d8af78ac-0d51-4fe4-b5b1-\
da4288f32242"],

Cell[CellGroupData[{

Cell["\<\
Given probabilities p[1] >= ...>= p[s] > 0 of symbols 1, ..., s, let l[i] = \
Ceiling[Log[2,1/p[i]], so 2^{-l[i]} < p[i]. Then take the first l[i] digits \
of the binary form of p[1] + ... + p[s-1] as the codeword to encode symbol i.\
\
\>", "Subsubsection",
 CellChangeTimes->{{3.779626640640698*^9, 3.779626723196424*^9}, {
  3.779627271000215*^9, 3.7796272710353413`*^9}, {3.77962744579593*^9, 
  3.779627459217896*^9}, {3.779689080133911*^9, 
  3.7796890841734457`*^9}},ExpressionUUID->"dfb9e7be-b114-4bc9-a592-\
311603257294"],

Cell[BoxData[
 RowBox[{
  RowBox[{"ProbabilitiesToLengths", "[", "ps_", "]"}], ":=", 
  RowBox[{"Table", "[", 
   RowBox[{
    RowBox[{"Ceiling", "[", 
     RowBox[{"Log", "[", 
      RowBox[{"2", ",", 
       RowBox[{"1", "/", "p"}]}], "]"}], "]"}], ",", 
    RowBox[{"{", 
     RowBox[{"p", ",", "ps"}], "}"}]}], "]"}]}]], "Input",
 CellLabel->"In[21]:=",ExpressionUUID->"7e33cdfb-bebc-44fd-a0ae-c86d01fa302e"],

Cell[BoxData[
 RowBox[{
  RowBox[{"ShannonCode", "[", "ps_", "]"}], " ", ":=", " ", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"ls", "=", 
       RowBox[{"ProbabilitiesToLengths", "[", "ps", "]"}]}], ",", "rs"}], 
     "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"rs", "=", 
      RowBox[{
       RowBox[{"{", "0", "}"}], "~", "Join", "~", 
       RowBox[{"FoldList", "[", 
        RowBox[{"Plus", ",", "ps"}], "]"}]}]}], ";", 
     RowBox[{"Table", "[", 
      RowBox[{
       RowBox[{"ToBinary", "[", 
        RowBox[{
         RowBox[{"Floor", "[", 
          RowBox[{
           RowBox[{"2", "^", 
            RowBox[{"ls", "[", 
             RowBox[{"[", "i", "]"}], "]"}]}], "*", 
           RowBox[{"rs", "[", 
            RowBox[{"[", "i", "]"}], "]"}]}], "]"}], ",", 
         RowBox[{"ls", "[", 
          RowBox[{"[", "i", "]"}], "]"}]}], "]"}], ",", 
       RowBox[{"{", 
        RowBox[{"i", ",", "1", ",", 
         RowBox[{"Length", "[", "ps", "]"}]}], "}"}]}], "]"}]}]}], 
   "]"}]}]], "Input",
 CellChangeTimes->{{3.779626727700079*^9, 3.7796268392193747`*^9}, {
  3.779627144198557*^9, 3.779627173654958*^9}, {3.77962722890375*^9, 
  3.7796272750267973`*^9}, {3.779627429921707*^9, 3.779627432160798*^9}, {
  3.77962870577316*^9, 3.779628727780911*^9}, {3.779689301340555*^9, 
  3.779689304827265*^9}, {3.779689737741003*^9, 3.779689753085944*^9}},
 CellLabel->"In[22]:=",ExpressionUUID->"42ebe7f3-051d-4f9a-92e0-c77c2a1b1f76"],

Cell[BoxData[
 RowBox[{
  RowBox[{"ShannonEncoder", "[", 
   RowBox[{"ps_", ",", "ts_"}], "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"us", "=", 
      RowBox[{"ShannonCode", "[", "ps", "]"}]}], "}"}], ",", 
    RowBox[{"<|", 
     RowBox[{"Table", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"ts", "[", 
         RowBox[{"[", "i", "]"}], "]"}], "\[Rule]", 
        RowBox[{"us", "[", 
         RowBox[{"[", "i", "]"}], "]"}]}], ",", 
       RowBox[{"{", 
        RowBox[{"i", ",", "1", ",", 
         RowBox[{"Length", "[", "us", "]"}]}], "}"}]}], "]"}], "|>"}]}], 
   "]"}]}]], "Input",
 CellChangeTimes->{{3.782315086574679*^9, 3.782315089130603*^9}, {
  3.782315135070807*^9, 3.7823151755181093`*^9}},
 CellLabel->"In[23]:=",ExpressionUUID->"901d1a02-a693-4bc5-bf32-400901396d72"]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
The example in the exercise is (p[1],p[2],p[3],p[4]) = (1/3,1/3,1/4,1/12). \
The partial sums r[1], r[2], r[3], r[4] are 0, 1/3, 2/3 and 11/12 with the \
fractional binary forms below .\
\>", "Subsubsection",
 CellChangeTimes->{{3.779689032994541*^9, 3.779689073732274*^9}, {
  3.77968915915595*^9, 3.779689166260005*^9}, {3.779689225516313*^9, 
  3.779689246608409*^9}, {3.7796895691417437`*^9, 
  3.77968957058182*^9}},ExpressionUUID->"8e02664d-fb42-4de5-bc36-\
82e528f1527b"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"{", 
     RowBox[{"#", ",", 
      RowBox[{"FractionalBinaryForm", "[", 
       RowBox[{"#", ",", "8"}], "]"}]}], "}"}], "&"}], "/@", 
   RowBox[{"{", 
    RowBox[{"0", ",", 
     RowBox[{"1", "/", "3"}], ",", 
     RowBox[{
      RowBox[{"1", "/", "3"}], "+", 
      RowBox[{"1", "/", "3"}]}], ",", 
     RowBox[{
      RowBox[{"1", "/", "3"}], "+", 
      RowBox[{"1", "/", "3"}], "+", 
      RowBox[{"1", "/", "4"}]}]}], "}"}]}], "//", "TF"}]], "Input",
 CellChangeTimes->{{3.779689199593246*^9, 3.779689222693983*^9}},
 CellLabel->"In[24]:=",ExpressionUUID->"5d1f1b22-a0b2-4a1d-ba42-04b286a07dda"],

Cell[BoxData[
 TagBox[GridBox[{
    {"0", 
     RowBox[{"{", 
      RowBox[{
      "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
       "0"}], "}"}]},
    {
     FractionBox["1", "3"], 
     RowBox[{"{", 
      RowBox[{
      "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
       "1"}], "}"}]},
    {
     FractionBox["2", "3"], 
     RowBox[{"{", 
      RowBox[{
      "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
       "0"}], "}"}]},
    {
     FractionBox["11", "12"], 
     RowBox[{"{", 
      RowBox[{
      "1", ",", "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
       "0"}], "}"}]}
   },
   GridBoxAlignment->{
    "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
     "RowsIndexed" -> {}},
   GridBoxSpacings->{"Columns" -> {
       Offset[0.27999999999999997`], {
        Offset[2.0999999999999996`]}, 
       Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
       Offset[0.2], {
        Offset[0.4]}, 
       Offset[0.2]}, "RowsIndexed" -> {}}],
  Function[BoxForm`e$, 
   TableForm[BoxForm`e$, TableDepth -> 2]]]], "Output",
 CellChangeTimes->{{3.779689216869351*^9, 3.779689222885769*^9}, 
   3.779690584078912*^9, 3.779691316077292*^9, 3.7801575921922197`*^9, 
   3.780215625664057*^9, 3.780230181965021*^9, {3.780230288370966*^9, 
   3.780230338614717*^9}, 3.780230697763772*^9, 3.780414296501688*^9, 
   3.780582014221079*^9, 3.7808947805816317`*^9, 3.781245308541552*^9, 
   3.7814480534063663`*^9, 3.781538131263936*^9, 3.781539243556108*^9, 
   3.7823086692717123`*^9, 3.7823157576244297`*^9, 3.782458025505764*^9, 
   3.782464375797892*^9, 3.782464435934824*^9},
 CellLabel->
  "Out[24]//TableForm=",ExpressionUUID->"f4adf490-dddf-49f0-b959-\
5b83f1e016b2"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["The lengths are", "Subsubsection",
 CellChangeTimes->{{3.779689277490315*^9, 3.7796892823711567`*^9}, {
  3.779689550722733*^9, 
  3.7796895824522543`*^9}},ExpressionUUID->"3b0fd21b-1038-4fd6-a6d5-\
0f21a76c9255"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ProbabilitiesToLengths", "[", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"1", "/", "3"}], ",", 
    RowBox[{"1", "/", "3"}], ",", 
    RowBox[{"1", "/", "4"}], ",", 
    RowBox[{"1", "/", "12"}]}], "}"}], "]"}]], "Input",
 CellChangeTimes->{{3.7796895569022083`*^9, 3.7796895766791487`*^9}},
 CellLabel->"In[25]:=",ExpressionUUID->"4364d70a-96f0-43df-a80b-24462d9b007d"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"2", ",", "2", ",", "2", ",", "4"}], "}"}]], "Output",
 CellChangeTimes->{{3.779689573999927*^9, 3.7796895769525547`*^9}, 
   3.779690584180089*^9, 3.779691316159347*^9, 3.780157592287388*^9, 
   3.780215625765745*^9, 3.780230182065312*^9, {3.78023028848451*^9, 
   3.7802303387095537`*^9}, 3.780230697870489*^9, 3.780414296915763*^9, 
   3.78058201431735*^9, 3.780894780652804*^9, 3.78124530864298*^9, 
   3.7814480535117273`*^9, 3.7815381313646803`*^9, 3.781539243661503*^9, 
   3.782308669376205*^9, 3.782315757736429*^9, 3.782458025982094*^9, 
   3.782464375940175*^9, 3.7824644360999537`*^9},
 CellLabel->"Out[25]=",ExpressionUUID->"0e7b8196-3654-4168-adbd-689c48695225"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
So we take 2 bits from r[1] = 000000 ... , r[2] = 010101 ... , r[3] = 101010 \
... and 4 bits from r[4] = 1110101 ... getting the code {00, 01, 10, 1110}. \
In one go:\
\>", "Subsubsection",
 CellChangeTimes->{{3.779689585036582*^9, 3.779689638661304*^9}, 
   3.779689761304706*^9},ExpressionUUID->"9681e551-6473-4ef0-ab36-\
8de42933c212"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ShannonCode", "[", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"1", "/", "3"}], ",", 
    RowBox[{"1", "/", "3"}], ",", 
    RowBox[{"1", "/", "4"}], ",", 
    RowBox[{"1", "/", "12"}]}], "}"}], "]"}]], "Input",
 CellChangeTimes->{{3.779689634290476*^9, 3.7796896477476473`*^9}},
 CellLabel->"In[26]:=",ExpressionUUID->"c78dfb08-c4f6-4813-bdb5-51285b619d7c"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"0", ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "1", ",", "1", ",", "0"}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{{3.779689648239133*^9, 3.7796896723800983`*^9}, 
   3.779689756190475*^9, 3.779690584279831*^9, 3.779691316248461*^9, 
   3.780157592369533*^9, 3.780215625862566*^9, 3.780230182822472*^9, {
   3.780230288603992*^9, 3.780230339329261*^9}, 3.780230698491064*^9, 
   3.780414297106923*^9, 3.780582014423018*^9, 3.780894780737267*^9, 
   3.78124530874503*^9, 3.781448053629223*^9, 3.781538131467729*^9, 
   3.7815392437608013`*^9, 3.7823086694656887`*^9, 3.782315757854903*^9, 
   3.782458026351761*^9, 3.7824643760631227`*^9, 3.782464436253091*^9},
 CellLabel->"Out[26]=",ExpressionUUID->"acac196b-1c97-42af-96be-f111edcbab86"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Shannon expected length (within 1 of entropy bound)", "Subsection",
 CellChangeTimes->{{3.780158053724608*^9, 
  3.780158072701345*^9}},ExpressionUUID->"8f239119-e3c6-4f01-8672-\
77d43d1c8d38"],

Cell[BoxData[
 RowBox[{
  RowBox[{"ShannonExpectedLength", "[", "ps_", "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"C", "=", 
      RowBox[{"ShannonCode", "[", "ps", "]"}]}], "}"}], ",", 
    RowBox[{"Sum", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"ps", "[", 
        RowBox[{"[", "i", "]"}], "]"}], "*", 
       RowBox[{"Length", "[", 
        RowBox[{"C", "[", 
         RowBox[{"[", "i", "]"}], "]"}], "]"}]}], ",", 
      RowBox[{"{", 
       RowBox[{"i", ",", "1", ",", 
        RowBox[{"Length", "[", "ps", "]"}]}], "}"}]}], "]"}]}], 
   "]"}]}]], "Input",
 CellChangeTimes->{{3.78015809586763*^9, 3.780158120910632*^9}},
 CellLabel->"In[27]:=",ExpressionUUID->"542c6b6c-794e-40ca-91ab-36be20d1d5e0"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Kraft code", "Section",
 CellChangeTimes->{{3.779631811631575*^9, 
  3.779631818206771*^9}},ExpressionUUID->"e4065850-46e4-4a56-86ef-\
c295f4464e0d"],

Cell[CellGroupData[{

Cell["\<\
We call a prefix-free code constructed to have given codeword lengths by \
following the proof of the \[OpenCurlyQuote]if\[CloseCurlyQuote] direction of \
Proposition 2.9 a \[OpenCurlyQuote]Kraft code\[CloseCurlyQuote]. (This term \
is not standard.) The code below implements the algorithm used in Example \
2.10.\
\>", "Subsection",
 CellChangeTimes->{{3.779631819970016*^9, 3.7796318339902687`*^9}, {
  3.7796319638999147`*^9, 3.779631984578067*^9}, {3.7796898281683073`*^9, 
  3.779689880333765*^9}},ExpressionUUID->"338b820d-21e1-40ec-b0a5-\
267e7c261a0f"],

Cell[CellGroupData[{

Cell["\<\
Extend \[OpenCurlyQuote]grows\[CloseCurlyQuote] the tree of forbidden \
prefixes. For example: extending {0,0} gives {0,0,0}, {0,0,1}, and extending \
{0,1} gives {0,1,0},{0,1,1}\
\>", "Subsubsection",
 CellChangeTimes->{{3.779632520560524*^9, 3.779632532983494*^9}, {
  3.779632625048974*^9, 3.779632641101869*^9}, {3.779633005837352*^9, 
  3.7796330160644903`*^9}},ExpressionUUID->"2a5f42ea-c0bf-4daf-ba1e-\
464727d1e2c5"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Extend", "[", "us_", "]"}], ":=", 
  RowBox[{
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"u", "~", "Join", "~", 
      RowBox[{"{", "0", "}"}]}], ",", 
     RowBox[{"{", 
      RowBox[{"u", ",", "us"}], "}"}]}], "]"}], "~", "Join", "~", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"u", "~", "Join", "~", 
      RowBox[{"{", "1", "}"}]}], ",", 
     RowBox[{"{", 
      RowBox[{"u", ",", "us"}], "}"}]}], "]"}]}]}]], "Input",
 CellChangeTimes->{{3.779632593705091*^9, 3.7796326204326153`*^9}},
 CellLabel->"In[28]:=",ExpressionUUID->"2648a8c6-0f83-4213-976e-1d4741c1aabf"]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
KraftStep chooses exactly c new codewords, avoiding forbidden prefixes of \
length l. \
\>", "Subsubsection",
 CellChangeTimes->{{3.7796330099600143`*^9, 3.7796330122229357`*^9}, {
  3.7796333477915993`*^9, 3.77963335926394*^9}, {3.779689890974703*^9, 
  3.779689894042492*^9}, {3.779690446781788*^9, 
  3.779690446843923*^9}},ExpressionUUID->"83ff3f6b-5727-47ec-8603-\
9ca7ccb5acdb"],

Cell[BoxData[
 RowBox[{
  RowBox[{"KraftStep", "[", 
   RowBox[{"forbiddenPrefixes_", ",", "c_", ",", "l_"}], "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"newCodewords", ",", "newForbiddenPrefixes"}], "}"}], ",", 
    RowBox[{
     RowBox[{"newCodewords", "=", 
      RowBox[{
       RowBox[{"ListComplement", "[", 
        RowBox[{
         RowBox[{"AllBinaryWords", "[", "l", "]"}], ",", 
         "forbiddenPrefixes"}], "]"}], "[", 
       RowBox[{"[", 
        RowBox[{"1", ";;", "c"}], "]"}], "]"}]}], ";", 
     RowBox[{"{", 
      RowBox[{"newCodewords", ",", 
       RowBox[{
        RowBox[{"Extend", "[", "forbiddenPrefixes", "]"}], "~", "Join", "~", 
        RowBox[{"Extend", "[", "newCodewords", "]"}]}]}], "}"}]}]}], 
   "]"}]}]], "Input",
 CellChangeTimes->{{3.779631998771081*^9, 3.779632058349897*^9}, {
  3.779632132165924*^9, 3.779632355759613*^9}, {3.779632415202961*^9, 
  3.7796324347757196`*^9}, {3.7796326930753736`*^9, 3.779632721525928*^9}, {
  3.779634427797657*^9, 3.779634434722739*^9}, {3.779690450049058*^9, 
  3.779690451795908*^9}},
 CellLabel->"In[29]:=",ExpressionUUID->"41cfd7cf-2de8-433d-a294-4c7a2b1d66cd"],

Cell[BoxData[
 RowBox[{
  RowBox[{"KraftCodeA", "[", "as_", "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"l", ",", "t", ",", 
      RowBox[{"us", "=", 
       RowBox[{"{", "}"}]}], ",", 
      RowBox[{"forbiddenPrefixes", "=", 
       RowBox[{"{", "}"}]}]}], "}"}], ",", 
    RowBox[{
     RowBox[{"For", "[", 
      RowBox[{
       RowBox[{"l", "=", "1"}], ",", 
       RowBox[{"l", "\[LessEqual]", 
        RowBox[{"Length", "[", "as", "]"}]}], ",", 
       RowBox[{"l", "++"}], ",", 
       RowBox[{
        RowBox[{"t", "=", 
         RowBox[{"KraftStep", "[", 
          RowBox[{"forbiddenPrefixes", ",", 
           RowBox[{"as", "[", 
            RowBox[{"[", "l", "]"}], "]"}], ",", "l"}], "]"}]}], ";", " ", 
        RowBox[{"us", "=", 
         RowBox[{"us", "~", "Join", "~", 
          RowBox[{"t", "[", 
           RowBox[{"[", "1", "]"}], "]"}]}]}], ";", " ", 
        RowBox[{"forbiddenPrefixes", "=", 
         RowBox[{"t", "[", 
          RowBox[{"[", "2", "]"}], "]"}]}]}]}], "]"}], ";", "us"}]}], 
   "]"}]}]], "Input",
 CellChangeTimes->{{3.7796323599589453`*^9, 3.7796323612486277`*^9}, {
  3.779632885360738*^9, 3.7796329814118023`*^9}, {3.779633132581417*^9, 
  3.779633150625833*^9}, {3.779633234784522*^9, 3.779633236883534*^9}, {
  3.779633290608089*^9, 3.7796333081511507`*^9}, {3.779633367013773*^9, 
  3.779633367867972*^9}, {3.779634422868729*^9, 3.7796344711646833`*^9}},
 CellLabel->"In[30]:=",ExpressionUUID->"51ae24fa-e0fc-458f-9676-162ec125f542"],

Cell[BoxData[
 RowBox[{
  RowBox[{"LengthsToMultiplicities", "[", "ls_", "]"}], ":=", 
  RowBox[{"Table", "[", 
   RowBox[{
    RowBox[{"Length", "[", 
     RowBox[{"Select", "[", 
      RowBox[{"ls", ",", 
       RowBox[{
        RowBox[{"#", "\[Equal]", "l"}], "&"}]}], "]"}], "]"}], ",", 
    RowBox[{"{", 
     RowBox[{"l", ",", "1", ",", 
      RowBox[{"Max", "[", "ls", "]"}]}], "}"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.779633508134819*^9, 3.779633517596281*^9}, {
  3.779633565726829*^9, 3.779633573321204*^9}},
 CellLabel->"In[31]:=",ExpressionUUID->"d1a0c254-0b80-43c4-8f24-51a5e8bb37a3"],

Cell[BoxData[
 RowBox[{
  RowBox[{"KraftCodeL", "[", "ls_", "]"}], ":=", 
  RowBox[{"KraftCodeA", "[", 
   RowBox[{"LengthsToMultiplicities", "[", "ls", "]"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.779633437794104*^9, 3.779633492708577*^9}, {
   3.779633588991713*^9, 3.779633592987948*^9}, 3.779690045283039*^9},
 CellLabel->"In[32]:=",ExpressionUUID->"bb02457a-01bc-46f4-9d47-b5080a3e40cc"]
}, Open  ]],

Cell[CellGroupData[{

Cell["Example 2.8(v) and Example 2.10", "Subsubsection",
 CellChangeTimes->{{3.779633319581955*^9, 3.7796333224142227`*^9}, {
  3.7796899144278*^9, 
  3.779689915988345*^9}},ExpressionUUID->"a94eafad-81cd-4e7a-a0e1-\
17cd63f712e1"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"KraftCodeL", "[", 
  RowBox[{"{", 
   RowBox[{
   "1", ",", "3", ",", "3", ",", "4", ",", "4", ",", "4", ",", "5", ",", 
    "5"}], "}"}], "]"}]], "Input",
 CellChangeTimes->{{3.779632983297035*^9, 3.779632992798272*^9}, {
   3.779633088943983*^9, 3.779633111783428*^9}, {3.779633323748273*^9, 
   3.779633334302951*^9}, {3.779633669661935*^9, 3.779633673639392*^9}, 
   3.7796900489932337`*^9},
 CellLabel->"In[33]:=",ExpressionUUID->"1e0865b0-fa5b-4dd6-ae35-a01945a1c26f"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", "0", "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "0", ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "0", ",", "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "1", ",", "0", ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "1", ",", "0", ",", "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "1", ",", "1", ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "1", ",", "1", ",", "1", ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "1", ",", "1", ",", "1", ",", "1"}], "}"}]}], 
  "}"}]], "Output",
 CellChangeTimes->{
  3.779633674038535*^9, 3.779634477420998*^9, 3.7796899078412123`*^9, 
   3.7796900493195467`*^9, 3.779690457418977*^9, 3.779690584568016*^9, 
   3.779691316526977*^9, 3.780157592511772*^9, 3.780215626002697*^9, 
   3.780230183116757*^9, {3.780230288777379*^9, 3.780230339578638*^9}, 
   3.7802306987954493`*^9, 3.780414297251526*^9, 3.780582014568338*^9, 
   3.780894784857562*^9, 3.7812453089030657`*^9, 3.7814480539412947`*^9, 
   3.7815381317456703`*^9, 3.7815392467736197`*^9, 3.782308669606244*^9, 
   3.782315761068544*^9, 3.782458026518189*^9, 3.782464376302554*^9, 
   3.782464436694332*^9},
 CellLabel->"Out[33]=",ExpressionUUID->"c1107dec-204a-4c6e-a583-7a8e0c78c5c9"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
Kraft code from probabilities, using the lengths from the Shannon code. Since \
the Kraft step above chooses the least binary word not having a forbidden \
prefix, the Kraft code is exactly the Shannon code.\
\>", "Subsubsection",
 CellChangeTimes->{{3.779634016140429*^9, 3.779634018105049*^9}, {
  3.779689933912945*^9, 3.779689960484906*^9}, {3.779690075376898*^9, 
  3.779690105328498*^9}, {3.7796901491728992`*^9, 3.7796901551836843`*^9}, {
  3.779690231842161*^9, 
  3.779690232513896*^9}},ExpressionUUID->"02f5db8b-cf6f-447b-b61d-\
16d2df5f8554"],

Cell[BoxData[
 RowBox[{
  RowBox[{"KraftCode", "[", "ps_", "]"}], ":=", 
  RowBox[{"KraftCodeL", "[", 
   RowBox[{"ProbabilitiesToLengths", "[", "ps", "]"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.779690051459507*^9, 3.7796900535502853`*^9}},
 CellLabel->"In[34]:=",ExpressionUUID->"fa2a2989-3895-4262-9c2f-6395cede1f53"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"{", 
   RowBox[{
    RowBox[{"KraftCode", "[", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"1", "/", "3"}], ",", 
       RowBox[{"1", "/", "3"}], ",", 
       RowBox[{"1", "/", "3"}]}], "}"}], "]"}], ",", 
    RowBox[{"ShannonCode", "[", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"1", "/", "3"}], ",", 
       RowBox[{"1", "/", "3"}], ",", 
       RowBox[{"1", "/", "3"}]}], "}"}], "]"}]}], "}"}], "//", 
  "TF"}]], "Input",
 CellChangeTimes->{{3.7796901251425323`*^9, 3.779690130302504*^9}, {
  3.779690243773937*^9, 3.779690244268216*^9}},
 CellLabel->"In[35]:=",ExpressionUUID->"9ab72c29-b8fc-4780-aa04-a2dbc51c4ed8"],

Cell[BoxData[
 TagBox[GridBox[{
    {
     RowBox[{"{", 
      RowBox[{"0", ",", "0"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"0", ",", "1"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"1", ",", "0"}], "}"}]},
    {
     RowBox[{"{", 
      RowBox[{"0", ",", "0"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"0", ",", "1"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"1", ",", "0"}], "}"}]}
   },
   GridBoxAlignment->{
    "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
     "RowsIndexed" -> {}},
   GridBoxSpacings->{"Columns" -> {
       Offset[0.27999999999999997`], {
        Offset[2.0999999999999996`]}, 
       Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
       Offset[0.2], {
        Offset[0.4]}, 
       Offset[0.2]}, "RowsIndexed" -> {}}],
  Function[BoxForm`e$, 
   TableForm[BoxForm`e$, TableDepth -> 2]]]], "Output",
 CellChangeTimes->{
  3.779690130657125*^9, 3.7796902444791813`*^9, 3.7796905846950006`*^9, 
   3.7796913166289*^9, 3.7801575926364098`*^9, 3.780215626112238*^9, 
   3.780230183242445*^9, {3.780230288899778*^9, 3.7802303397070713`*^9}, 
   3.780230698921232*^9, 3.780414297348607*^9, 3.780582014671482*^9, 
   3.780894784988975*^9, 3.781245309021865*^9, 3.781448054077166*^9, 
   3.781538131878788*^9, 3.781539246882223*^9, 3.782308669721643*^9, 
   3.782315761183016*^9, 3.782458026657148*^9, 3.782464376469081*^9, 
   3.7824644368642*^9},
 CellLabel->
  "Out[35]//TableForm=",ExpressionUUID->"a6cb3993-e428-4161-a2a0-\
9ea94bc0ca33"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"{", 
   RowBox[{
    RowBox[{"KraftCode", "[", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"1", "/", "2"}], ",", 
       RowBox[{"1", "/", "8"}], ",", 
       RowBox[{"1", "/", "8"}], ",", 
       RowBox[{"1", "/", "16"}], ",", 
       RowBox[{"1", "/", "16"}], ",", 
       RowBox[{"1", "/", "16"}], ",", 
       RowBox[{"1", "/", "32"}], ",", 
       RowBox[{"1", "/", "32"}]}], "}"}], "]"}], ",", 
    RowBox[{"ShannonCode", "[", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"1", "/", "2"}], ",", 
       RowBox[{"1", "/", "8"}], ",", 
       RowBox[{"1", "/", "8"}], ",", 
       RowBox[{"1", "/", "16"}], ",", 
       RowBox[{"1", "/", "16"}], ",", 
       RowBox[{"1", "/", "16"}], ",", 
       RowBox[{"1", "/", "32"}], ",", 
       RowBox[{"1", "/", "32"}]}], "}"}], "]"}]}], "}"}], "//", 
  "TF"}]], "Input",
 CellChangeTimes->{{3.779634580133525*^9, 3.779634599165125*^9}, 
   3.779690055581708*^9, {3.779690112079064*^9, 3.779690119784629*^9}},
 CellLabel->"In[36]:=",ExpressionUUID->"4ccf0b60-2978-480b-9d6c-b920af6c4ceb"],

Cell[BoxData[
 TagBox[GridBox[{
    {
     RowBox[{"{", "0", "}"}], 
     RowBox[{"{", 
      RowBox[{"1", ",", "0", ",", "0"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"1", ",", "0", ",", "1"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"1", ",", "1", ",", "0", ",", "0"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"1", ",", "1", ",", "0", ",", "1"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"1", ",", "1", ",", "1", ",", "0"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"1", ",", "1", ",", "1", ",", "1", ",", "0"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"1", ",", "1", ",", "1", ",", "1", ",", "1"}], "}"}]},
    {
     RowBox[{"{", "0", "}"}], 
     RowBox[{"{", 
      RowBox[{"1", ",", "0", ",", "0"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"1", ",", "0", ",", "1"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"1", ",", "1", ",", "0", ",", "0"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"1", ",", "1", ",", "0", ",", "1"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"1", ",", "1", ",", "1", ",", "0"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"1", ",", "1", ",", "1", ",", "1", ",", "0"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"1", ",", "1", ",", "1", ",", "1", ",", "1"}], "}"}]}
   },
   GridBoxAlignment->{
    "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
     "RowsIndexed" -> {}},
   GridBoxSpacings->{"Columns" -> {
       Offset[0.27999999999999997`], {
        Offset[2.0999999999999996`]}, 
       Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
       Offset[0.2], {
        Offset[0.4]}, 
       Offset[0.2]}, "RowsIndexed" -> {}}],
  Function[BoxForm`e$, 
   TableForm[BoxForm`e$, TableDepth -> 2]]]], "Output",
 CellChangeTimes->{{3.779634594086441*^9, 3.779634599790391*^9}, 
   3.779690055866839*^9, {3.779690117375627*^9, 3.779690120041953*^9}, 
   3.779690248913575*^9, 3.779690584797345*^9, 3.779691316708263*^9, 
   3.780157592723537*^9, 3.7802156262165537`*^9, 3.780230186220153*^9, {
   3.780230289001198*^9, 3.780230339806922*^9}, 3.780230699037078*^9, 
   3.780414297447473*^9, 3.780582014754243*^9, 3.780894785106668*^9, 
   3.781245309221779*^9, 3.781448054178442*^9, 3.781538131969611*^9, 
   3.7815392470163603`*^9, 3.782308669815884*^9, 3.782315761320896*^9, 
   3.782458026769711*^9, 3.782464376639709*^9, 3.782464437033977*^9},
 CellLabel->
  "Out[36]//TableForm=",ExpressionUUID->"8635fee6-52ce-40a4-b8a2-\
d9e2b5ad641d"]
}, Open  ]]
}, Open  ]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Huffman codes: probabilities in increasing order", "Section",
 CellChangeTimes->{{3.776613777160657*^9, 3.776613778596027*^9}, {
  3.777187002639249*^9, 3.777187022582489*^9}, {3.777187060849073*^9, 
  3.777187089489975*^9}, {3.77718734169631*^9, 3.777187362092306*^9}, {
  3.777187406137991*^9, 3.7771874119600353`*^9}, {3.7771875714765587`*^9, 
  3.777187574317*^9}},ExpressionUUID->"66de8343-baef-47dd-b60d-1aa031dfa333"],

Cell[CellGroupData[{

Cell["\<\
startOrTags: put 0 or 1 to number codewords from 0 or 1, or supply a list of \
labels. If omitted, taken as 1.\
\>", "Subsubsection",
 CellChangeTimes->{{3.779631738890758*^9, 
  3.7796317872497387`*^9}},ExpressionUUID->"10dc3dca-8126-44a3-9a45-\
5ad2eb440d49"],

Cell[BoxData[
 RowBox[{
  RowBox[{"TagAndSortForHuffmanCode", "[", 
   RowBox[{"ps_", ",", 
    RowBox[{"startOrTags_:", "1"}]}], "]"}], ":=", 
  RowBox[{"If", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"Length", "[", "startOrTags", "]"}], "\[Equal]", 
     RowBox[{"Length", "[", "ps", "]"}]}], ",", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"Table", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"ps", "[", 
          RowBox[{"[", "j", "]"}], "]"}], ",", 
         RowBox[{"{", 
          RowBox[{"{", 
           RowBox[{"startOrTags", "[", 
            RowBox[{"[", "j", "]"}], "]"}], "}"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"{", "}"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"j", ",", "1", ",", 
         RowBox[{"Length", "[", "ps", "]"}]}], "}"}]}], "]"}], "//", "Sort"}],
     ",", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"Table", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"ps", "[", 
          RowBox[{"[", "j", "]"}], "]"}], ",", 
         RowBox[{"{", 
          RowBox[{"{", 
           RowBox[{"j", "-", "1", "+", "startOrTags"}], "}"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"{", "}"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"j", ",", "1", ",", 
         RowBox[{"Length", "[", "ps", "]"}]}], "}"}]}], "]"}], "//", 
     "Sort"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.776869937249401*^9, 3.7768700152546387`*^9}, {
  3.776870106384386*^9, 3.776870107576283*^9}, {3.776870577952312*^9, 
  3.7768705989143763`*^9}, {3.7768706404933777`*^9, 3.776870675306686*^9}, {
  3.779086647187669*^9, 3.779086672514433*^9}, {3.779086724329544*^9, 
  3.779086724867075*^9}, {3.779086942956109*^9, 3.779086947169244*^9}, {
  3.7790881968523493`*^9, 3.77908819812502*^9}, {3.7790883309759817`*^9, 
  3.779088331737414*^9}, {3.779088530771265*^9, 3.779088589870181*^9}, {
  3.7790899421358137`*^9, 3.779089989033407*^9}, {3.779090086742653*^9, 
  3.779090113425108*^9}, {3.779690903940599*^9, 3.779690904988253*^9}},
 CellLabel->"In[37]:=",ExpressionUUID->"b7b747e8-e529-4bf9-ac17-3dd639ad6a00"],

Cell[BoxData[
 RowBox[{
  RowBox[{"HuffmanCodeOneStep", "[", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"p1_", ",", "tags1_", ",", "us1_"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"p2_", ",", "tags2_", ",", "us2_"}], "}"}], ",", "tpuss___"}], 
    "}"}], "]"}], ":=", "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"p1", "+", "p2"}], ",", 
      RowBox[{"tags1", "~", "Join", "~", "tags2"}], ",", 
      RowBox[{"Join", "[", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"Table", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"{", "0", "}"}], "~", "Join", "~", "u1"}], ",", 
          RowBox[{"{", 
           RowBox[{"u1", ",", "us1"}], "}"}]}], "]"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"Table", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"{", "1", "}"}], "~", "Join", "~", "u2"}], ",", 
          RowBox[{"{", 
           RowBox[{"u2", ",", "us2"}], "}"}]}], "]"}]}], "]"}]}], "}"}], 
    "}"}], "~", "Join", "~", "\[IndentingNewLine]", 
   RowBox[{"(", 
    RowBox[{"tpuss", "//", "List"}], ")"}]}]}]], "Input",
 CellChangeTimes->{{3.7790870599406157`*^9, 3.7790870905206947`*^9}, {
  3.779087193038843*^9, 3.779087193592642*^9}},
 CellLabel->"In[38]:=",ExpressionUUID->"68c72cdd-3595-421b-b2c8-4fe88ff2da9f"],

Cell[BoxData[
 RowBox[{
  RowBox[{"HuffmanCodeAllSteps", "[", 
   RowBox[{"{", "finished_", "}"}], "]"}], ":=", "finished"}]], "Input",
 CellChangeTimes->{{3.779087160552166*^9, 3.779087173099084*^9}},
 CellLabel->"In[39]:=",ExpressionUUID->"d5dcb474-4d19-42fa-bf55-8a4c6c27996f"],

Cell[BoxData[
 RowBox[{
  RowBox[{"HuffmanCodeAllSteps", "[", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"p1_", ",", "tags1_", ",", "us1_"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"p2_", ",", "tags2_", ",", "us2_"}], "}"}], ",", "tpuss___"}], 
    "}"}], "]"}], ":=", "\[IndentingNewLine]", 
  RowBox[{"HuffmanCodeAllSteps", "[", 
   RowBox[{"Sort", "[", 
    RowBox[{"HuffmanCodeOneStep", "[", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"p1", ",", "tags1", ",", "us1"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"p2", ",", "tags2", ",", "us2"}], "}"}], ",", "tpuss"}], 
      "}"}], "]"}], "]"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.7768701526445293`*^9, 3.7768702014905376`*^9}, {
   3.77687023486726*^9, 3.7768702816328783`*^9}, {3.776870443497715*^9, 
   3.7768704559068317`*^9}, {3.776870519223734*^9, 3.7768705221792517`*^9}, {
   3.7768706059837713`*^9, 3.776870610009653*^9}, {3.776870682371257*^9, 
   3.7768706935851517`*^9}, {3.776870748805278*^9, 3.776870853217132*^9}, {
   3.776871325413897*^9, 3.776871325505291*^9}, {3.776871467417767*^9, 
   3.77687146918464*^9}, {3.776871566772121*^9, 3.7768716162136717`*^9}, {
   3.7768722439318647`*^9, 3.776872269063093*^9}, {3.7790866079509907`*^9, 
   3.7790866359602737`*^9}, {3.779086700549138*^9, 3.77908683518958*^9}, {
   3.779086906500636*^9, 3.779086916637218*^9}, {3.7790870292271423`*^9, 
   3.779087031062818*^9}, {3.779087107096231*^9, 3.7790871481653748`*^9}, 
   3.7790872051228237`*^9},
 CellLabel->"In[40]:=",ExpressionUUID->"bc6eff28-3986-4e10-a16e-fc9dab13383b"],

Cell[BoxData[
 RowBox[{
  RowBox[{"HuffmanCode", "[", 
   RowBox[{"ps_", ",", 
    RowBox[{"startOrTags_:", "1"}]}], "]"}], " ", ":=", " ", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"r", "=", 
       RowBox[{"HuffmanCodeAllSteps", "[", 
        RowBox[{"TagAndSortForHuffmanCode", "[", 
         RowBox[{"ps", ",", "startOrTags"}], "]"}], "]"}]}], ",", "tags", ",",
       "us"}], "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"tags", "=", 
      RowBox[{"r", "[", 
       RowBox[{"[", "2", "]"}], "]"}]}], ";", 
     RowBox[{"us", "=", 
      RowBox[{"r", "[", 
       RowBox[{"[", "3", "]"}], "]"}]}], ";", " ", "\[IndentingNewLine]", 
     RowBox[{"<|", 
      RowBox[{
       RowBox[{"Table", "[", 
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{"tags", "[", 
            RowBox[{"[", "i", "]"}], "]"}], "[", 
           RowBox[{"[", "1", "]"}], "]"}], "\[Rule]", 
          RowBox[{"us", "[", 
           RowBox[{"[", "i", "]"}], "]"}]}], ",", 
         RowBox[{"{", 
          RowBox[{"i", ",", "1", ",", 
           RowBox[{"Length", "[", "us", "]"}]}], "}"}]}], "]"}], "//", 
       "Sort"}], "|>"}]}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.779087267018111*^9, 3.7790872715186567`*^9}, {
  3.7790881739751368`*^9, 3.779088316206182*^9}, {3.7790890646390543`*^9, 
  3.779089083177026*^9}, {3.7790897329689693`*^9, 3.779089742661015*^9}, {
  3.779089810529503*^9, 3.77908986593797*^9}, {3.779089929085327*^9, 
  3.7790899291643543`*^9}, {3.7790900581741457`*^9, 3.779090080339493*^9}, {
  3.779690895690997*^9, 3.779690900748415*^9}},
 CellLabel->"In[41]:=",ExpressionUUID->"1f8bae97-8a4a-43ae-8d00-a76c345c49e5"]
}, Open  ]],

Cell[CellGroupData[{

Cell["Huffman code expected length", "Subsection",
 CellChangeTimes->{{3.7801578575157757`*^9, 3.780157860770794*^9}, {
  3.780157941711985*^9, 3.7801579533202257`*^9}, {3.7801580631573133`*^9, 
  3.7801580666765537`*^9}, {3.781248537913958*^9, 
  3.78124854513693*^9}},ExpressionUUID->"42028e1b-fea8-4433-a867-\
53272c7bab79"],

Cell[BoxData[
 RowBox[{
  RowBox[{"HuffmanExpectedLength", "[", "ps_", "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"f", " ", "=", " ", 
      RowBox[{"HuffmanCode", "[", "ps", "]"}]}], "}"}], ",", 
    RowBox[{"Sum", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"ps", "[", 
        RowBox[{"[", "i", "]"}], "]"}], "*", 
       RowBox[{"Length", "[", 
        RowBox[{"f", "[", "i", "]"}], "]"}]}], ",", 
      RowBox[{"{", 
       RowBox[{"i", ",", "1", ",", 
        RowBox[{"Length", "[", "ps", "]"}]}], "}"}]}], "]"}]}], 
   "]"}]}]], "Input",
 CellChangeTimes->{{3.780157865864002*^9, 3.780157901254381*^9}},
 CellLabel->"In[42]:=",ExpressionUUID->"27b789cf-e627-4f78-b9e3-2efb29dab7cf"]
}, Open  ]],

Cell[CellGroupData[{

Cell["Huffman code examples", "Subsection",
 CellChangeTimes->{{3.776872230327924*^9, 
  3.776872233135666*^9}},ExpressionUUID->"b6450b4f-c27c-44b4-b5e3-\
4b1bedb857fa"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"psExample", ":=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"0.15", ",", "0.16", ",", "0.17", ",", "0.17", ",", "0.35"}], 
      "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       FractionBox["1", "4"], ",", 
       FractionBox["1", "4"], ",", 
       FractionBox["1", "2"]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       FractionBox["1", "4"], ",", 
       FractionBox["1", "4"], ",", 
       FractionBox["1", "4"], ",", 
       FractionBox["1", "4"]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       FractionBox["1", "8"], ",", 
       FractionBox["1", "8"], ",", 
       FractionBox["1", "8"], ",", 
       FractionBox["1", "8"], ",", 
       FractionBox["1", "4"], ",", 
       FractionBox["1", "4"]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       FractionBox["1", "32"], ",", 
       FractionBox["1", "32"], ",", 
       FractionBox["1", "16"], ",", 
       FractionBox["1", "8"], ",", 
       FractionBox["1", "4"], ",", 
       FractionBox["1", "2"]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
      "0.1", ",", "0.1", ",", "0.1", ",", "0.1", ",", "0.2", ",", "0.4"}], 
      "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       FractionBox["1", "16"], ",", 
       FractionBox["1", "16"], ",", 
       FractionBox["1", "8"], ",", 
       FractionBox["1", "8"], ",", 
       FractionBox["1", "8"], ",", 
       FractionBox["1", "4"], ",", 
       FractionBox["1", "4"]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       FractionBox["1", "3"], ",", 
       FractionBox["1", "3"], ",", 
       FractionBox["1", "3"]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"1", "/", "10"}], ",", 
       RowBox[{"1", "/", "10"}], ",", 
       RowBox[{"1", "/", "10"}], ",", 
       RowBox[{"1", "/", "10"}], ",", 
       RowBox[{"6", "/", "10"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"1", "/", "30"}], ",", 
       RowBox[{"1", "/", "30"}], ",", 
       RowBox[{"1", "/", "30"}], ",", 
       RowBox[{"1", "/", "30"}], ",", 
       RowBox[{"1", "/", "30"}], ",", 
       RowBox[{"1", "/", "30"}], ",", 
       RowBox[{"1", "/", "30"}], ",", 
       RowBox[{"1", "/", "30"}], ",", 
       RowBox[{"1", "/", "30"}], ",", 
       RowBox[{"1", "/", "30"}], ",", 
       RowBox[{"1", "/", "30"}], ",", 
       RowBox[{"1", "/", "30"}], ",", 
       RowBox[{"1", "/", "30"}], ",", 
       RowBox[{"1", "/", "30"}], ",", 
       RowBox[{"1", "/", "30"}], ",", 
       RowBox[{"1", "/", "2"}]}], "}"}]}], "}"}]}], ";", 
  RowBox[{
   RowBox[{"HuffmanCode", "/@", "psExample"}], "//", "TF"}]}]], "Input",
 CellChangeTimes->{{3.7768722344476633`*^9, 3.7768722545479307`*^9}, {
  3.776872287096283*^9, 3.776872287657199*^9}, {3.776872323317645*^9, 
  3.776872353404937*^9}, {3.7768730062977858`*^9, 3.776873008725998*^9}, {
  3.777187415428383*^9, 3.777187436952795*^9}, {3.777187813989731*^9, 
  3.7771878262679987`*^9}, {3.777187857382037*^9, 3.77718787984595*^9}, {
  3.7789133035481367`*^9, 3.7789133327650127`*^9}, {3.782315817487115*^9, 
  3.782315835926393*^9}},
 CellLabel->"In[43]:=",ExpressionUUID->"d06c0043-0150-4890-a5bf-9728d628d63b"],

Cell[BoxData[
 TagBox[GridBox[{
    {
     RowBox[{"\[LeftAssociation]", 
      RowBox[{
       RowBox[{"1", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{"1", ",", "0", ",", "0"}], "}"}]}], ",", 
       RowBox[{"2", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{"1", ",", "0", ",", "1"}], "}"}]}], ",", 
       RowBox[{"3", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{"1", ",", "1", ",", "0"}], "}"}]}], ",", 
       RowBox[{"4", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{"1", ",", "1", ",", "1"}], "}"}]}], ",", 
       RowBox[{"5", "\[Rule]", 
        RowBox[{"{", "0", "}"}]}]}], "\[RightAssociation]"}]},
    {
     RowBox[{"\[LeftAssociation]", 
      RowBox[{
       RowBox[{"1", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{"1", ",", "0"}], "}"}]}], ",", 
       RowBox[{"2", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{"1", ",", "1"}], "}"}]}], ",", 
       RowBox[{"3", "\[Rule]", 
        RowBox[{"{", "0", "}"}]}]}], "\[RightAssociation]"}]},
    {
     RowBox[{"\[LeftAssociation]", 
      RowBox[{
       RowBox[{"1", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{"0", ",", "0"}], "}"}]}], ",", 
       RowBox[{"2", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{"0", ",", "1"}], "}"}]}], ",", 
       RowBox[{"3", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{"1", ",", "0"}], "}"}]}], ",", 
       RowBox[{"4", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{"1", ",", "1"}], "}"}]}]}], "\[RightAssociation]"}]},
    {
     RowBox[{"\[LeftAssociation]", 
      RowBox[{
       RowBox[{"1", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{"1", ",", "0", ",", "0"}], "}"}]}], ",", 
       RowBox[{"2", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{"1", ",", "0", ",", "1"}], "}"}]}], ",", 
       RowBox[{"3", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{"1", ",", "1", ",", "0"}], "}"}]}], ",", 
       RowBox[{"4", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{"1", ",", "1", ",", "1"}], "}"}]}], ",", 
       RowBox[{"5", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{"0", ",", "0"}], "}"}]}], ",", 
       RowBox[{"6", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{"0", ",", "1"}], "}"}]}]}], "\[RightAssociation]"}]},
    {
     RowBox[{"\[LeftAssociation]", 
      RowBox[{
       RowBox[{"1", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{"1", ",", "1", ",", "1", ",", "1", ",", "0"}], "}"}]}], ",", 
       
       RowBox[{"2", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{"1", ",", "1", ",", "1", ",", "1", ",", "1"}], "}"}]}], ",", 
       
       RowBox[{"3", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{"1", ",", "1", ",", "1", ",", "0"}], "}"}]}], ",", 
       RowBox[{"4", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{"1", ",", "1", ",", "0"}], "}"}]}], ",", 
       RowBox[{"5", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{"1", ",", "0"}], "}"}]}], ",", 
       RowBox[{"6", "\[Rule]", 
        RowBox[{"{", "0", "}"}]}]}], "\[RightAssociation]"}]},
    {
     RowBox[{"\[LeftAssociation]", 
      RowBox[{
       RowBox[{"1", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{"0", ",", "1", ",", "0"}], "}"}]}], ",", 
       RowBox[{"2", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{"0", ",", "1", ",", "1"}], "}"}]}], ",", 
       RowBox[{"3", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{"1", ",", "0", ",", "0"}], "}"}]}], ",", 
       RowBox[{"4", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{"1", ",", "0", ",", "1"}], "}"}]}], ",", 
       RowBox[{"5", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{"0", ",", "0"}], "}"}]}], ",", 
       RowBox[{"6", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{"1", ",", "1"}], "}"}]}]}], "\[RightAssociation]"}]},
    {
     RowBox[{"\[LeftAssociation]", 
      RowBox[{
       RowBox[{"1", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{"1", ",", "1", ",", "1", ",", "0"}], "}"}]}], ",", 
       RowBox[{"2", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{"1", ",", "1", ",", "1", ",", "1"}], "}"}]}], ",", 
       RowBox[{"3", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{"1", ",", "0", ",", "0"}], "}"}]}], ",", 
       RowBox[{"4", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{"1", ",", "0", ",", "1"}], "}"}]}], ",", 
       RowBox[{"5", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{"1", ",", "1", ",", "0"}], "}"}]}], ",", 
       RowBox[{"6", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{"0", ",", "0"}], "}"}]}], ",", 
       RowBox[{"7", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{"0", ",", "1"}], "}"}]}]}], "\[RightAssociation]"}]},
    {
     RowBox[{"\[LeftAssociation]", 
      RowBox[{
       RowBox[{"1", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{"1", ",", "0"}], "}"}]}], ",", 
       RowBox[{"2", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{"1", ",", "1"}], "}"}]}], ",", 
       RowBox[{"3", "\[Rule]", 
        RowBox[{"{", "0", "}"}]}]}], "\[RightAssociation]"}]},
    {
     RowBox[{"\[LeftAssociation]", 
      RowBox[{
       RowBox[{"1", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{"0", ",", "0", ",", "0"}], "}"}]}], ",", 
       RowBox[{"2", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{"0", ",", "0", ",", "1"}], "}"}]}], ",", 
       RowBox[{"3", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{"0", ",", "1", ",", "0"}], "}"}]}], ",", 
       RowBox[{"4", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{"0", ",", "1", ",", "1"}], "}"}]}], ",", 
       RowBox[{"5", "\[Rule]", 
        RowBox[{"{", "1", "}"}]}]}], "\[RightAssociation]"}]},
    {
     RowBox[{"\[LeftAssociation]", 
      RowBox[{
       RowBox[{"1", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{"1", ",", "0", ",", "0", ",", "1", ",", "0"}], "}"}]}], ",", 
       
       RowBox[{"2", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{"1", ",", "0", ",", "0", ",", "1", ",", "1"}], "}"}]}], ",", 
       
       RowBox[{"3", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{"1", ",", "0", ",", "1", ",", "0", ",", "0"}], "}"}]}], ",", 
       
       RowBox[{"4", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{"1", ",", "0", ",", "1", ",", "0", ",", "1"}], "}"}]}], ",", 
       
       RowBox[{"5", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{"1", ",", "0", ",", "1", ",", "1", ",", "0"}], "}"}]}], ",", 
       
       RowBox[{"6", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{"1", ",", "0", ",", "1", ",", "1", ",", "1"}], "}"}]}], ",", 
       
       RowBox[{"7", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{"1", ",", "1", ",", "0", ",", "0", ",", "0"}], "}"}]}], ",", 
       
       RowBox[{"8", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{"1", ",", "1", ",", "0", ",", "0", ",", "1"}], "}"}]}], ",", 
       
       RowBox[{"9", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{"1", ",", "1", ",", "0", ",", "1", ",", "0"}], "}"}]}], ",", 
       
       RowBox[{"10", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{"1", ",", "1", ",", "0", ",", "1", ",", "1"}], "}"}]}], ",", 
       
       RowBox[{"11", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{"1", ",", "1", ",", "1", ",", "0", ",", "0"}], "}"}]}], ",", 
       
       RowBox[{"12", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{"1", ",", "1", ",", "1", ",", "0", ",", "1"}], "}"}]}], ",", 
       
       RowBox[{"13", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{"1", ",", "1", ",", "1", ",", "1", ",", "0"}], "}"}]}], ",", 
       
       RowBox[{"14", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{"1", ",", "1", ",", "1", ",", "1", ",", "1"}], "}"}]}], ",", 
       
       RowBox[{"15", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{"1", ",", "0", ",", "0", ",", "0"}], "}"}]}], ",", 
       RowBox[{"16", "\[Rule]", 
        RowBox[{"{", "0", "}"}]}]}], "\[RightAssociation]"}]}
   },
   GridBoxAlignment->{
    "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
     "RowsIndexed" -> {}},
   GridBoxSpacings->{"Columns" -> {
       Offset[0.27999999999999997`], {
        Offset[2.0999999999999996`]}, 
       Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
       Offset[0.2], {
        Offset[0.4]}, 
       Offset[0.2]}, "RowsIndexed" -> {}}],
  Function[BoxForm`e$, 
   TableForm[BoxForm`e$, TableDepth -> 2]]]], "Output",
 CellChangeTimes->{{3.778913333385399*^9, 3.778913356150268*^9}, 
   3.779631171018825*^9, 3.779631789564458*^9, 3.7796905447764883`*^9, 
   3.779690584960754*^9, 3.77969131684638*^9, 3.7801575929224873`*^9, 
   3.780215626416092*^9, 3.780230186506382*^9, {3.780230289203417*^9, 
   3.7802303132981567`*^9}, 3.780230343360107*^9, 3.78023070182759*^9, 
   3.780414297596467*^9, 3.780582015030539*^9, 3.780894785458704*^9, 
   3.781245309374104*^9, 3.78144805438978*^9, 3.7815381321599493`*^9, 
   3.781539247178627*^9, 3.782308670028768*^9, 3.7823157614839563`*^9, 
   3.782315836664878*^9, 3.782458026953671*^9, 3.782464376905574*^9, 
   3.7824644372766533`*^9},
 CellLabel->
  "Out[43]//TableForm=",ExpressionUUID->"5ccd64ca-7326-4e95-ba5c-\
a15f0239fd33"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"{", 
   RowBox[{
    RowBox[{
     RowBox[{"HuffmanExpectedLength", "/@", "psExample"}], "//", "N"}], ",", 
    RowBox[{
     RowBox[{"Entropy", "/@", "psExample"}], "//", "N"}]}], "}"}], "//", 
  "TF"}]], "Input",
 CellChangeTimes->{{3.782315796849103*^9, 3.782315858964747*^9}},
 CellLabel->"In[44]:=",ExpressionUUID->"de47cfb2-0e50-4ac0-89de-ab179b4acdde"],

Cell[BoxData[
 TagBox[GridBox[{
    {"2.3`", "1.5`", "2.`", "2.5`", "1.9375`", "2.4000000000000004`", 
     "2.625`", "1.6666666666666667`", "1.8`", "2.966666666666667`"},
    {"1.3321790402101221`", "0.636514168294813`", "0.`", 
     "0.6365141682948128`", "1.5607104090414066`", "0.8675632284814613`", 
     "1.078992207877583`", "0.`", "0.5004024235381879`", 
     "0.23379165870645924`"}
   },
   GridBoxAlignment->{
    "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
     "RowsIndexed" -> {}},
   GridBoxSpacings->{"Columns" -> {
       Offset[0.27999999999999997`], {
        Offset[2.0999999999999996`]}, 
       Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
       Offset[0.2], {
        Offset[0.4]}, 
       Offset[0.2]}, "RowsIndexed" -> {}}],
  Function[BoxForm`e$, 
   TableForm[BoxForm`e$, TableDepth -> 2]]]], "Output",
 CellChangeTimes->{
  3.782315801287346*^9, {3.782315848846171*^9, 3.782315859132208*^9}, 
   3.782315969210495*^9, 3.782458027070491*^9, 3.7824643771747627`*^9, 
   3.782464437467717*^9},
 CellLabel->
  "Out[44]//TableForm=",ExpressionUUID->"511094c9-f046-4d25-b710-\
90e8b169a753"]
}, Open  ]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Shannon and Huffman code on English text.", "Section",
 CellChangeTimes->{{3.777186230479885*^9, 3.7771862358263617`*^9}, {
   3.779690621040553*^9, 3.77969067953933*^9}, {3.7815392036741877`*^9, 
   3.781539221551935*^9}, {3.782309308379794*^9, 3.78230935075218*^9}, 
   3.7823098039454412`*^9, {3.7823160040178337`*^9, 
   3.7823160080021133`*^9}},ExpressionUUID->"fc73fc71-97a3-4516-b1cd-\
1a356800bb37"],

Cell[CellGroupData[{

Cell["\<\
 The second sample below was used as in MT362/462/5462  to illustrate the \
Vigen\[EGrave]re Cipher. This time we keep the capitalisation and all \
punctuation.\
\>", "Subsection",
 CellChangeTimes->{{3.782309805249604*^9, 
  3.78230980636784*^9}},ExpressionUUID->"98fd4dd2-3dda-4d7b-bbca-\
89e32035b328"],

Cell[BoxData[
 RowBox[{"AustenStartChapter1", ":=", 
  "\"\<Such were Elizabeth Elliot's sentiments and sensations; such the cares \
to alloy, the agitations to vary, the sameness and the elegance, the \
prosperity and the nothingness of her scene of life; such the feelings to \
give interest to a long, uneventful residence in one country circle, to fill \
the vacancies which there were no habits of utility abroad, no talents or \
accomplishments for home, to occupy.  But now, another occupation and \
solicitude of mind was beginning to be added to these.  Her father was \
growing distressed for money. She knew, that when he now took up the \
Baronetage, it was to drive the heavy bills of his tradespeople, and the \
unwelcome hints of Mr Shepherd, his agent, from his thoughts.  The Kellynch \
property was good, but not equal to Sir Walter's apprehension of the state \
required in its possessor.  While Lady Elliot lived, there had been method, \
moderation, and economy, which had just kept him within his income; but with \
her had died all such right-mindedness, and from that period he had been \
constantly exceeding it.  It had not been possible for him to spend less; he \
had done nothing but what Sir Walter Elliot was imperiously called on to do; \
but blameless as he was, he was not only growing dreadfully in debt, but was \
hearing of it so often, that it became vain to attempt concealing it longer, \
even partially, from his daughter. He had given her some hints of it the last \
spring in town; he had gone so far even as to say, 'Can we retrench?  Does it \
occur to you that there is any one article in which we can retrench?' and \
Elizabeth, to do her justice, had, in the first ardour of female alarm, set \
seriously to think what could be done, and had finally proposed these two \
branches of economy, to cut off some unnecessary charities, and to refrain \
from new furnishing the drawing-room; to which expedients she afterwards \
added the happy thought of their taking no present down to Anne, as had been \
the usual yearly custom.  But these measures, however good in themselves, \
were insufficient for the real extent of the evil, the whole of which Sir \
Walter found himself obliged to confess to her soon afterwards.  Elizabeth \
had nothing to propose of deeper efficacy.  She felt herself ill-used and \
unfortunate, as did her father; and they were neither of them able to devise \
any means of lessening their expenses without compromising their dignity, or \
relinquishing their comforts in a way not to be borne.  There was only a \
small part of his estate that Sir Walter could dispose of; but had every acre \
been alienable, it would have made no difference.  He had condescended to \
mortgage as far as he had the power, but he would never condescend to sell. \
No; he would never disgrace his name so far. The Kellynch estate should be \
transmitted whole and entire, as he had received it. Their two confidential \
friends, Mr Shepherd, who lived in the neighbouring market town, and Lady \
Russell, were called to advise them; and both father and daughter seemed to \
expect that something should be struck out by one or the other to remove \
their embarrassments and reduce their expenditure, without involving the loss \
of any indulgence of taste or pride..\>\""}]], "Input",
 CellChangeTimes->{{3.714492567122336*^9, 3.714492605309312*^9}, {
   3.714492646656283*^9, 3.7144927549042253`*^9}, {3.7771915907175007`*^9, 
   3.7771915954778833`*^9}, {3.782309303651929*^9, 3.782309305440855*^9}, 
   3.7823093613634357`*^9},
 CellLabel->"In[45]:=",ExpressionUUID->"8d0550bb-8534-4f79-b65d-42b9e95180e4"],

Cell[BoxData[
 RowBox[{"AustenEndChapter1", ":=", 
  "\"\<Such were Elizabeth Elliot's sentiments and sensations; such the cares \
to alloy, the agitations to vary, the sameness and the elegance, the \
prosperity and the nothingness of her scene of life; such the feelings to \
give interest to a long, uneventful residence in one country circle, to fill \
the vacancies which there were no habits of utility abroad, no talents or \
accomplishments for home, to occupy.  But now, another occupation and \
solicitude of mind was beginning to be added to these.  Her father was \
growing distressed for money. She knew, that when he now took up the \
Baronetage, it was to drive the heavy bills of his tradespeople, and the \
unwelcome hints of Mr Shepherd, his agent, from his thoughts.  The Kellynch \
property was good, but not equal to Sir Walter's apprehension of the state \
required in its possessor.  While Lady Elliot lived, there had been method, \
moderation, and economy, which had just kept him within his income; but with \
her had died all such right-mindedness, and from that period he had been \
constantly exceeding it.  It had not been possible for him to spend less; he \
had done nothing but what Sir Walter Elliot was imperiously called on to do; \
but blameless as he was, he was not only growing dreadfully in debt, but was \
hearing of it so often, that it became vain to attempt concealing it longer, \
even partially, from his daughter. He had given her some hints of it the last \
spring in town; he had gone so far even as to say, 'Can we retrench?  Does it \
occur to you that there is any one article in which we can retrench?' and \
Elizabeth, to do her justice, had, in the first ardour of female alarm, set \
seriously to think what could be done, and had finally proposed these two \
branches of economy, to cut off some unnecessary charities, and to refrain \
from new furnishing the drawing-room; to which expedients she afterwards \
added the happy thought of their taking no present down to Anne, as had been \
the usual yearly custom.  But these measures, however good in themselves, \
were insufficient for the real extent of the evil, the whole of which Sir \
Walter found himself obliged to confess to her soon afterwards.  Elizabeth \
had nothing to propose of deeper efficacy.  She felt herself ill-used and \
unfortunate, as did her father; and they were neither of them able to devise \
any means of lessening their expenses without compromising their dignity, or \
relinquishing their comforts in a way not to be borne.  There was only a \
small part of his estate that Sir Walter could dispose of; but had every acre \
been alienable, it would have made no difference.  He had condescendedto \
mortgage as far as he had the power, but he would never condescend to sell.  \
No; he would never disgrace his name so far.  The Kellynch estate should be \
transmitted whole and entire, as he had received it. Their two confidential \
friends, Mr Shepherd, who lived in the neighbouring market town, and Lady \
Russell, were called to advise them; and both father and daughter seemed to \
expect that something should be struck out by one or the other to remove \
their embarrassments and reduce their expenditure, without involving the loss \
of any indulgence of taste or pride..\>\""}]], "Input",
 CellChangeTimes->{{3.7771864163493347`*^9, 3.7771864176456223`*^9}, {
  3.782309273592966*^9, 3.782309279096781*^9}},
 CellLabel->"In[46]:=",ExpressionUUID->"2617b313-80fc-43bc-89c6-6e3bdfb7c83e"],

Cell[BoxData[
 RowBox[{"Austen", ":=", 
  RowBox[{
  "AustenStartChapter1", "~", "StringJoin", "~", "\"\< \>\"", "~", 
   "StringJoin", "~", "AustenEndChapter1"}]}]], "Input",
 CellChangeTimes->{{3.7823093664167128`*^9, 3.7823093866993637`*^9}},
 CellLabel->"In[47]:=",ExpressionUUID->"108614e1-a8f8-48ac-b2e6-d856866e145c"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"AustenFrequencies", "=", 
  RowBox[{
   RowBox[{"SortBy", "[", 
    RowBox[{
     RowBox[{"Tally", "[", 
      RowBox[{"Characters", "[", "Austen", "]"}], "]"}], ",", 
     RowBox[{
      RowBox[{"#", "[", 
       RowBox[{"[", "2", "]"}], "]"}], "&"}]}], "]"}], "//", 
   "Reverse"}]}]], "Input",
 CellChangeTimes->{{3.7771864491285*^9, 3.777186460352173*^9}, {
  3.777186508486236*^9, 3.777186550610654*^9}, {3.777186653381482*^9, 
  3.777186667367276*^9}, {3.779690731662415*^9, 3.779690785500227*^9}},
 CellLabel->"In[48]:=",ExpressionUUID->"eb005118-280c-4431-84ec-274fa3c29295"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"\<\" \"\>", ",", "1126"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"\<\"e\"\>", ",", "696"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"\<\"t\"\>", ",", "460"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"\<\"o\"\>", ",", "400"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"\<\"n\"\>", ",", "364"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"\<\"h\"\>", ",", "340"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"\<\"a\"\>", ",", "340"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"\<\"i\"\>", ",", "324"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"\<\"s\"\>", ",", "310"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"\<\"r\"\>", ",", "294"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"\<\"d\"\>", ",", "234"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"\<\"l\"\>", ",", "202"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"\<\"c\"\>", ",", "142"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"\<\"u\"\>", ",", "130"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"\<\"f\"\>", ",", "130"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"\<\"w\"\>", ",", "104"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"\<\"m\"\>", ",", "100"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"\<\"g\"\>", ",", "92"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"\<\",\"\>", ",", "92"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"\<\"p\"\>", ",", "80"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"\<\"y\"\>", ",", "76"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"\<\"b\"\>", ",", "74"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"\<\"v\"\>", ",", "50"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"\<\".\"\>", ",", "34"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"\<\";\"\>", ",", "22"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"\<\"S\"\>", ",", "18"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"\<\"k\"\>", ",", "14"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"\<\"x\"\>", ",", "12"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"\<\"E\"\>", ",", "12"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"\<\"W\"\>", ",", "10"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"\<\"T\"\>", ",", "8"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"\<\"'\"\>", ",", "8"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"\<\"z\"\>", ",", "6"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"\<\"q\"\>", ",", "6"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"\<\"H\"\>", ",", "6"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"\<\"B\"\>", ",", "6"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"\<\"-\"\>", ",", "6"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"\<\"M\"\>", ",", "4"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"\<\"L\"\>", ",", "4"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"\<\"K\"\>", ",", "4"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"\<\"j\"\>", ",", "4"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"\<\"?\"\>", ",", "4"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"\<\"R\"\>", ",", "2"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"\<\"N\"\>", ",", "2"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"\<\"I\"\>", ",", "2"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"\<\"D\"\>", ",", "2"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"\<\"C\"\>", ",", "2"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"\<\"A\"\>", ",", "2"}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{{3.779690776895575*^9, 3.779690785866495*^9}, 
   3.779691316958555*^9, 3.780157593053241*^9, 3.780215626527788*^9, 
   3.7802301866740417`*^9, {3.780230289317748*^9, 3.780230313438253*^9}, 
   3.78023034353164*^9, 3.780230701955037*^9, 3.780414297719297*^9, 
   3.780582015135666*^9, 3.780894787444477*^9, 3.7812453094892178`*^9, 
   3.781249641546165*^9, 3.781448054659109*^9, 3.781538132281513*^9, 
   3.781539247309087*^9, 3.7823086701456957`*^9, 3.782309389689337*^9, 
   3.782315761631843*^9, 3.782458027276153*^9, 3.782464377338025*^9, 
   3.7824644376629763`*^9},
 CellLabel->"Out[48]=",ExpressionUUID->"9e5bfc7c-834e-4641-96cb-b745c09f1865"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"AustenProbabilities", "=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"n", "=", 
      RowBox[{"Length", "[", 
       RowBox[{"Characters", "[", "Austen", "]"}], "]"}]}], "}"}], ",", 
    RowBox[{
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"#", "[", 
         RowBox[{"[", "1", "]"}], "]"}], ",", 
        RowBox[{
         RowBox[{
          RowBox[{"#", "[", 
           RowBox[{"[", "2", "]"}], "]"}], "/", "n"}], "//", "N"}]}], "}"}], 
      "&"}], "/@", "AustenFrequencies"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.7771865837270613`*^9, 3.7771866329318247`*^9}, {
   3.7771866708986397`*^9, 3.777186697369362*^9}, {3.777187639933984*^9, 
   3.777187650609503*^9}, 3.779690788488057*^9, {3.779691000287889*^9, 
   3.77969100067276*^9}},
 CellLabel->"In[49]:=",ExpressionUUID->"5929e9e4-58ee-43cc-b3b5-b7b74946489b"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"\<\" \"\>", ",", "0.1770440251572327`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"\<\"e\"\>", ",", "0.10943396226415095`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"\<\"t\"\>", ",", "0.07232704402515723`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"\<\"o\"\>", ",", "0.06289308176100629`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"\<\"n\"\>", ",", "0.057232704402515724`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"\<\"h\"\>", ",", "0.05345911949685535`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"\<\"a\"\>", ",", "0.05345911949685535`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"\<\"i\"\>", ",", "0.0509433962264151`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"\<\"s\"\>", ",", "0.04874213836477988`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"\<\"r\"\>", ",", "0.04622641509433962`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"\<\"d\"\>", ",", "0.03679245283018868`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"\<\"l\"\>", ",", "0.031761006289308176`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"\<\"c\"\>", ",", "0.02232704402515723`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"\<\"u\"\>", ",", "0.020440251572327043`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"\<\"f\"\>", ",", "0.020440251572327043`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"\<\"w\"\>", ",", "0.016352201257861635`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"\<\"m\"\>", ",", "0.015723270440251572`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"\<\"g\"\>", ",", "0.014465408805031447`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"\<\",\"\>", ",", "0.014465408805031447`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"\<\"p\"\>", ",", "0.012578616352201259`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"\<\"y\"\>", ",", "0.011949685534591196`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"\<\"b\"\>", ",", "0.011635220125786163`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"\<\"v\"\>", ",", "0.007861635220125786`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"\<\".\"\>", ",", "0.005345911949685534`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"\<\";\"\>", ",", "0.003459119496855346`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"\<\"S\"\>", ",", "0.002830188679245283`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"\<\"k\"\>", ",", "0.00220125786163522`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"\<\"x\"\>", ",", "0.0018867924528301887`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"\<\"E\"\>", ",", "0.0018867924528301887`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"\<\"W\"\>", ",", "0.0015723270440251573`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"\<\"T\"\>", ",", "0.0012578616352201257`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"\<\"'\"\>", ",", "0.0012578616352201257`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"\<\"z\"\>", ",", "0.0009433962264150943`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"\<\"q\"\>", ",", "0.0009433962264150943`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"\<\"H\"\>", ",", "0.0009433962264150943`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"\<\"B\"\>", ",", "0.0009433962264150943`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"\<\"-\"\>", ",", "0.0009433962264150943`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"\<\"M\"\>", ",", "0.0006289308176100629`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"\<\"L\"\>", ",", "0.0006289308176100629`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"\<\"K\"\>", ",", "0.0006289308176100629`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"\<\"j\"\>", ",", "0.0006289308176100629`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"\<\"?\"\>", ",", "0.0006289308176100629`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"\<\"R\"\>", ",", "0.00031446540880503143`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"\<\"N\"\>", ",", "0.00031446540880503143`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"\<\"I\"\>", ",", "0.00031446540880503143`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"\<\"D\"\>", ",", "0.00031446540880503143`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"\<\"C\"\>", ",", "0.00031446540880503143`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"\<\"A\"\>", ",", "0.00031446540880503143`"}], "}"}]}], 
  "}"}]], "Output",
 CellChangeTimes->{
  3.7796907928230963`*^9, 3.779691001216156*^9, 3.779691317061199*^9, 
   3.780157593135363*^9, 3.7802156266337223`*^9, 3.780230186802148*^9, {
   3.78023028943618*^9, 3.780230313556209*^9}, 3.780230343662272*^9, 
   3.780230702075786*^9, 3.780414297820396*^9, 3.780582015237646*^9, 
   3.7808947881299257`*^9, 3.781245309593363*^9, {3.781249633846321*^9, 
   3.781249643401203*^9}, 3.781448054761847*^9, 3.781538132382468*^9, 
   3.7815392474143476`*^9, 3.782308670243691*^9, 3.78230956032377*^9, 
   3.7823157617174883`*^9, 3.782458027386973*^9, 3.782464377473927*^9, 
   3.78246443781819*^9},
 CellLabel->"Out[49]=",ExpressionUUID->"e43eec1a-d75f-406b-a808-2e6aa3c13625"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"Sum", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"AustenProbabilities", "[", 
       RowBox[{"[", "i", "]"}], "]"}], "[", 
      RowBox[{"[", "2", "]"}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"i", ",", "1", ",", 
       RowBox[{"Length", "[", "AustenProbabilities", "]"}]}], "}"}]}], "]"}], 
   ",", 
   RowBox[{
    RowBox[{"Entropy", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"#", "[", 
        RowBox[{"[", "2", "]"}], "]"}], "&"}], "/@", "AustenProbabilities"}], 
     "]"}], "//", "N"}]}], "}"}]], "Input",
 CellChangeTimes->{{3.782315469862483*^9, 3.782315485174617*^9}, {
  3.7823159844054728`*^9, 3.782315989752596*^9}},
 CellLabel->"In[50]:=",ExpressionUUID->"21ac65ae-b941-4a82-b194-a2671e06c883"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"1.000000000000001`", ",", "3.1675258495472915`"}], "}"}]], "Output",\

 CellChangeTimes->{3.782315485768523*^9, 3.782315761836832*^9, 
  3.782315990231029*^9, 3.782458027503714*^9, 3.782464377652279*^9, 
  3.78246443797206*^9},
 CellLabel->"Out[50]=",ExpressionUUID->"2630bde9-b42a-40d8-bc08-35f15ef091aa"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"AustenShannonEncoder", "=", 
  RowBox[{
   RowBox[{"ShannonEncoder", "[", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"#", "[", 
        RowBox[{"[", "2", "]"}], "]"}], "&"}], "/@", "AustenProbabilities"}], 
     ",", 
     RowBox[{
      RowBox[{
       RowBox[{"#", "[", 
        RowBox[{"[", "1", "]"}], "]"}], "&"}], "/@", 
      "AustenProbabilities"}]}], "]"}], "//", "Sort"}]}]], "Input",
 CellChangeTimes->{{3.782315015573889*^9, 3.782315024824794*^9}, {
  3.7823150567324953`*^9, 3.782315064198613*^9}, {3.782315211122788*^9, 
  3.7823152271115103`*^9}},
 CellLabel->"In[51]:=",ExpressionUUID->"1ebd9cf3-5651-4be6-b574-c310b0e04b02"],

Cell[BoxData[
 RowBox[{"\[LeftAssociation]", 
  RowBox[{
   RowBox[{"\<\" \"\>", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"0", ",", "0", ",", "0"}], "}"}]}], ",", 
   RowBox[{"\<\"e\"\>", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"0", ",", "0", ",", "1", ",", "0"}], "}"}]}], ",", 
   RowBox[{"\<\"t\"\>", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"0", ",", "1", ",", "0", ",", "0"}], "}"}]}], ",", 
   RowBox[{"\<\"o\"\>", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"0", ",", "1", ",", "0", ",", "1"}], "}"}]}], ",", 
   RowBox[{"\<\"n\"\>", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"0", ",", "1", ",", "1", ",", "0", ",", "1"}], "}"}]}], ",", 
   RowBox[{"\<\"h\"\>", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"0", ",", "1", ",", "1", ",", "1", ",", "1"}], "}"}]}], ",", 
   RowBox[{"\<\"a\"\>", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"1", ",", "0", ",", "0", ",", "0", ",", "1"}], "}"}]}], ",", 
   RowBox[{"\<\"i\"\>", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"1", ",", "0", ",", "0", ",", "1", ",", "0"}], "}"}]}], ",", 
   RowBox[{"\<\"s\"\>", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"1", ",", "0", ",", "1", ",", "0", ",", "0"}], "}"}]}], ",", 
   RowBox[{"\<\"r\"\>", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"1", ",", "0", ",", "1", ",", "0", ",", "1"}], "}"}]}], ",", 
   RowBox[{"\<\"d\"\>", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"1", ",", "0", ",", "1", ",", "1", ",", "1"}], "}"}]}], ",", 
   RowBox[{"\<\"l\"\>", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"1", ",", "1", ",", "0", ",", "0", ",", "0"}], "}"}]}], ",", 
   RowBox[{"\<\"c\"\>", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"1", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1"}], "}"}]}],
    ",", 
   RowBox[{"\<\"u\"\>", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"1", ",", "1", ",", "0", ",", "1", ",", "0", ",", "0"}], "}"}]}],
    ",", 
   RowBox[{"\<\"f\"\>", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"1", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1"}], "}"}]}],
    ",", 
   RowBox[{"\<\"w\"\>", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1"}], "}"}]}],
    ",", 
   RowBox[{"\<\"m\"\>", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0"}], "}"}]}],
    ",", 
   RowBox[{"\<\"g\"\>", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{
     "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", "0"}], 
     "}"}]}], ",", 
   RowBox[{"\<\",\"\>", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{
     "1", ",", "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", "0"}], 
     "}"}]}], ",", 
   RowBox[{"\<\"p\"\>", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{
     "1", ",", "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "0"}], 
     "}"}]}], ",", 
   RowBox[{"\<\"y\"\>", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{
     "1", ",", "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1"}], 
     "}"}]}], ",", 
   RowBox[{"\<\"b\"\>", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{
     "1", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1"}], 
     "}"}]}], ",", 
   RowBox[{"\<\"v\"\>", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{
     "1", ",", "1", ",", "1", ",", "1", ",", "0", ",", "1", ",", "0"}], 
     "}"}]}], ",", 
   RowBox[{"\<\".\"\>", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{
     "1", ",", "1", ",", "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", 
      "1"}], "}"}]}], ",", 
   RowBox[{"\<\";\"\>", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{
     "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
      "1", ",", "0"}], "}"}]}], ",", 
   RowBox[{"\<\"S\"\>", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{
     "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "0", ",", "1", ",", 
      "0", ",", "0"}], "}"}]}], ",", 
   RowBox[{"\<\"k\"\>", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{
     "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "0", ",", "1", ",", 
      "0", ",", "1"}], "}"}]}], ",", 
   RowBox[{"\<\"x\"\>", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{
     "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "0", ",", "1", ",", 
      "1", ",", "0", ",", "1"}], "}"}]}], ",", 
   RowBox[{"\<\"E\"\>", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{
     "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "0", ",", "1", ",", 
      "1", ",", "1", ",", "1"}], "}"}]}], ",", 
   RowBox[{"\<\"W\"\>", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{
     "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "0", ",", 
      "0", ",", "0", ",", "1"}], "}"}]}], ",", 
   RowBox[{"\<\"T\"\>", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{
     "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "0", ",", 
      "0", ",", "1", ",", "1"}], "}"}]}], ",", 
   RowBox[{"\<\"'\"\>", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{
     "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "0", ",", 
      "1", ",", "0", ",", "0"}], "}"}]}], ",", 
   RowBox[{"\<\"z\"\>", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{
     "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "0", ",", 
      "1", ",", "1", ",", "0", ",", "0"}], "}"}]}], ",", 
   RowBox[{"\<\"q\"\>", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{
     "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "0", ",", 
      "1", ",", "1", ",", "0", ",", "1"}], "}"}]}], ",", 
   RowBox[{"\<\"H\"\>", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{
     "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "0", ",", 
      "1", ",", "1", ",", "1", ",", "1"}], "}"}]}], ",", 
   RowBox[{"\<\"B\"\>", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{
     "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
      "0", ",", "0", ",", "0", ",", "1"}], "}"}]}], ",", 
   RowBox[{"\<\"-\"\>", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{
     "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
      "0", ",", "0", ",", "1", ",", "1"}], "}"}]}], ",", 
   RowBox[{"\<\"M\"\>", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{
     "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
      "0", ",", "1", ",", "0", ",", "1"}], "}"}]}], ",", 
   RowBox[{"\<\"L\"\>", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{
     "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
      "0", ",", "1", ",", "1", ",", "0"}], "}"}]}], ",", 
   RowBox[{"\<\"K\"\>", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{
     "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
      "1", ",", "0", ",", "0", ",", "0"}], "}"}]}], ",", 
   RowBox[{"\<\"j\"\>", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{
     "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
      "1", ",", "0", ",", "0", ",", "1"}], "}"}]}], ",", 
   RowBox[{"\<\"?\"\>", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{
     "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
      "1", ",", "0", ",", "1", ",", "0"}], "}"}]}], ",", 
   RowBox[{"\<\"R\"\>", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{
     "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
      "1", ",", "1", ",", "0", ",", "0", ",", "0"}], "}"}]}], ",", 
   RowBox[{"\<\"N\"\>", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{
     "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
      "1", ",", "1", ",", "0", ",", "0", ",", "1"}], "}"}]}], ",", 
   RowBox[{"\<\"I\"\>", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{
     "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
      "1", ",", "1", ",", "0", ",", "1", ",", "0"}], "}"}]}], ",", 
   RowBox[{"\<\"D\"\>", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{
     "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
      "1", ",", "1", ",", "1", ",", "0", ",", "0"}], "}"}]}], ",", 
   RowBox[{"\<\"C\"\>", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{
     "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
      "1", ",", "1", ",", "1", ",", "0", ",", "1"}], "}"}]}], ",", 
   RowBox[{"\<\"A\"\>", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{
     "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
      "1", ",", "1", ",", "1", ",", "1", ",", "0"}], "}"}]}]}], 
  "\[RightAssociation]"}]], "Output",
 CellChangeTimes->{3.7823152276764603`*^9, 3.782315762340908*^9, 
  3.782458027620023*^9, 3.7824643777737913`*^9, 3.782464438034137*^9},
 CellLabel->"Out[51]=",ExpressionUUID->"57fea959-2868-4421-84ec-82ca3b6e054e"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"AustenHuffmanEncoder", "=", 
  RowBox[{
   RowBox[{"HuffmanCode", "[", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"#", "[", 
        RowBox[{"[", "2", "]"}], "]"}], "&"}], "/@", "AustenProbabilities"}], 
     ",", 
     RowBox[{
      RowBox[{
       RowBox[{"#", "[", 
        RowBox[{"[", "1", "]"}], "]"}], "&"}], "/@", 
      "AustenProbabilities"}]}], "]"}], "//", "Sort"}]}]], "Input",
 CellChangeTimes->{{3.777186701546236*^9, 3.777186705873397*^9}, {
  3.7771876331898947`*^9, 3.777187633973756*^9}, {3.779690803700303*^9, 
  3.7796908098748827`*^9}, {3.779690923552145*^9, 3.779691019041192*^9}, {
  3.782315005033094*^9, 3.782315005820114*^9}, {3.782315198587872*^9, 
  3.782315201300496*^9}},
 CellLabel->"In[52]:=",ExpressionUUID->"0e24f456-f6cc-40a1-ada8-00f916856fd8"],

Cell[BoxData[
 RowBox[{"\[LeftAssociation]", 
  RowBox[{
   RowBox[{"\<\"e\"\>", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"0", ",", "1", ",", "1"}], "}"}]}], ",", 
   RowBox[{"\<\" \"\>", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"1", ",", "1", ",", "1"}], "}"}]}], ",", 
   RowBox[{"\<\"r\"\>", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"0", ",", "0", ",", "0", ",", "0"}], "}"}]}], ",", 
   RowBox[{"\<\"s\"\>", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"0", ",", "0", ",", "0", ",", "1"}], "}"}]}], ",", 
   RowBox[{"\<\"i\"\>", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"0", ",", "0", ",", "1", ",", "0"}], "}"}]}], ",", 
   RowBox[{"\<\"a\"\>", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"0", ",", "1", ",", "0", ",", "0"}], "}"}]}], ",", 
   RowBox[{"\<\"h\"\>", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"0", ",", "1", ",", "0", ",", "1"}], "}"}]}], ",", 
   RowBox[{"\<\"n\"\>", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"1", ",", "0", ",", "0", ",", "0"}], "}"}]}], ",", 
   RowBox[{"\<\"o\"\>", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"1", ",", "0", ",", "1", ",", "0"}], "}"}]}], ",", 
   RowBox[{"\<\"t\"\>", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"1", ",", "1", ",", "0", ",", "0"}], "}"}]}], ",", 
   RowBox[{"\<\"l\"\>", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"1", ",", "0", ",", "0", ",", "1", ",", "1"}], "}"}]}], ",", 
   RowBox[{"\<\"d\"\>", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"1", ",", "0", ",", "1", ",", "1", ",", "1"}], "}"}]}], ",", 
   RowBox[{"\<\"y\"\>", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0"}], "}"}]}],
    ",", 
   RowBox[{"\<\"p\"\>", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "1"}], "}"}]}],
    ",", 
   RowBox[{"\<\",\"\>", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "1"}], "}"}]}],
    ",", 
   RowBox[{"\<\"g\"\>", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0"}], "}"}]}],
    ",", 
   RowBox[{"\<\"m\"\>", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "1"}], "}"}]}],
    ",", 
   RowBox[{"\<\"w\"\>", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"1", ",", "0", ",", "1", ",", "1", ",", "0", ",", "1"}], "}"}]}],
    ",", 
   RowBox[{"\<\"f\"\>", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"1", ",", "1", ",", "0", ",", "1", ",", "0", ",", "0"}], "}"}]}],
    ",", 
   RowBox[{"\<\"u\"\>", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"1", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1"}], "}"}]}],
    ",", 
   RowBox[{"\<\"c\"\>", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1"}], "}"}]}],
    ",", 
   RowBox[{"\<\"v\"\>", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{
     "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0"}], 
     "}"}]}], ",", 
   RowBox[{"\<\"b\"\>", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{
     "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", "1"}], 
     "}"}]}], ",", 
   RowBox[{"\<\"S\"\>", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{
     "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
      "0"}], "}"}]}], ",", 
   RowBox[{"\<\";\"\>", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{
     "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "1", ",", 
      "0"}], "}"}]}], ",", 
   RowBox[{"\<\".\"\>", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{
     "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
      "1"}], "}"}]}], ",", 
   RowBox[{"\<\"W\"\>", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{
     "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
      "1", ",", "1"}], "}"}]}], ",", 
   RowBox[{"\<\"E\"\>", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{
     "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "1", ",", 
      "1", ",", "0"}], "}"}]}], ",", 
   RowBox[{"\<\"x\"\>", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{
     "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "1", ",", 
      "1", ",", "1"}], "}"}]}], ",", 
   RowBox[{"\<\"k\"\>", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{
     "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
      "1", ",", "0"}], "}"}]}], ",", 
   RowBox[{"\<\"-\"\>", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{
     "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
      "0", ",", "0", ",", "0"}], "}"}]}], ",", 
   RowBox[{"\<\"B\"\>", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{
     "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
      "0", ",", "0", ",", "1"}], "}"}]}], ",", 
   RowBox[{"\<\"H\"\>", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{
     "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
      "0", ",", "1", ",", "0"}], "}"}]}], ",", 
   RowBox[{"\<\"q\"\>", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{
     "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
      "0", ",", "1", ",", "1"}], "}"}]}], ",", 
   RowBox[{"\<\"z\"\>", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{
     "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
      "1", ",", "1", ",", "0"}], "}"}]}], ",", 
   RowBox[{"\<\"'\"\>", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{
     "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
      "1", ",", "1", ",", "1"}], "}"}]}], ",", 
   RowBox[{"\<\"T\"\>", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{
     "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
      "0", ",", "0", ",", "0"}], "}"}]}], ",", 
   RowBox[{"\<\"D\"\>", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{
     "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
      "1", ",", "0", ",", "0", ",", "0"}], "}"}]}], ",", 
   RowBox[{"\<\"I\"\>", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{
     "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
      "1", ",", "0", ",", "0", ",", "1"}], "}"}]}], ",", 
   RowBox[{"\<\"N\"\>", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{
     "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
      "1", ",", "0", ",", "1", ",", "0"}], "}"}]}], ",", 
   RowBox[{"\<\"R\"\>", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{
     "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
      "1", ",", "0", ",", "1", ",", "1"}], "}"}]}], ",", 
   RowBox[{"\<\"?\"\>", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{
     "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
      "0", ",", "0", ",", "1", ",", "0"}], "}"}]}], ",", 
   RowBox[{"\<\"j\"\>", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{
     "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
      "0", ",", "0", ",", "1", ",", "1"}], "}"}]}], ",", 
   RowBox[{"\<\"K\"\>", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{
     "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
      "0", ",", "1", ",", "0", ",", "0"}], "}"}]}], ",", 
   RowBox[{"\<\"L\"\>", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{
     "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
      "0", ",", "1", ",", "0", ",", "1"}], "}"}]}], ",", 
   RowBox[{"\<\"M\"\>", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{
     "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
      "0", ",", "1", ",", "1", ",", "0"}], "}"}]}], ",", 
   RowBox[{"\<\"A\"\>", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{
     "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
      "0", ",", "1", ",", "1", ",", "1", ",", "0"}], "}"}]}], ",", 
   RowBox[{"\<\"C\"\>", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{
     "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
      "0", ",", "1", ",", "1", ",", "1", ",", "1"}], "}"}]}]}], 
  "\[RightAssociation]"}]], "Output",
 CellChangeTimes->{
  3.777186706234165*^9, {3.777187634433206*^9, 3.7771876537687263`*^9}, 
   3.77718791907071*^9, 3.7771881932300653`*^9, 3.778348917692519*^9, 
   3.778504468514462*^9, 3.77886559464443*^9, 3.779631171548894*^9, 
   3.779690586298937*^9, 3.779690810759231*^9, 3.779690924551676*^9, {
   3.7796909581454067`*^9, 3.7796909893564577`*^9}, 3.779691019566349*^9, 
   3.779691317162208*^9, 3.7801575932357893`*^9, 3.780215626733185*^9, 
   3.780230186929237*^9, {3.780230289554788*^9, 3.7802303136853724`*^9}, 
   3.78023034379707*^9, 3.78023070222125*^9, 3.78041429791474*^9, 
   3.780582015356579*^9, 3.7808947883237143`*^9, 3.781245309694653*^9, {
   3.7812496211524277`*^9, 3.781249644159946*^9}, 3.78144805491084*^9, 
   3.781538132484026*^9, 3.781539247530575*^9, 3.7823086703500433`*^9, 
   3.7823095710160093`*^9, 3.782315007324018*^9, 3.782315201671802*^9, 
   3.782315762234597*^9, 3.782458027737688*^9, 3.782464378023035*^9, 
   3.782464438221567*^9},
 CellLabel->"Out[52]=",ExpressionUUID->"33f35dc6-45eb-4502-88b7-2dfb2939773d"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"AustenShannonEncoded", "=", 
  RowBox[{"Join", "@@", 
   RowBox[{"AustenShannonEncoder", "/@", 
    RowBox[{"Characters", "[", "Austen", "]"}]}]}]}]], "Input",
 CellChangeTimes->{{3.78231523969697*^9, 3.7823152445877647`*^9}},
 CellLabel->"In[53]:=",ExpressionUUID->"80d06d30-e113-4d9b-915b-f34f398fc646"],

Cell[BoxData[
 InterpretationBox[
  TagBox[
   FrameBox[GridBox[{
      {
       ItemBox[
        TagBox[
         RowBox[{"{", 
          RowBox[{
          "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "0", ",", "1", 
           ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", 
           "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", 
           ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
           "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "1", 
           ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
           "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", "0", 
           ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
           "1", ",", "1", ",", "1", ",", "1", ",", "0", ",", "1", ",", "1", 
           ",", "1", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
           "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "1", 
           ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "0", ",", 
           "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", 
           ",", "0", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
           "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "0", 
           ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
           "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "1", 
           ",", "1", ",", "1", ",", "1", ",", "1", ",", "0", ",", "1", ",", 
           "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", 
           ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
           TemplateBox[{"30219"},
            "OutputSizeLimit`Skeleton"], ",", "1", ",", "0", ",", "0", ",", 
           "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", 
           ",", "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
           "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", 
           ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
           "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", 
           ",", "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", 
           "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", "0", 
           ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
           "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "1", 
           ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
           "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", 
           ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
           "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "1", 
           ",", "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
           "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "0", 
           ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
           "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "1", 
           ",", "1", ",", "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", 
           "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "0", ",", "1", 
           ",", "1", ",", "1"}], "}"}],
         Short[#, 5]& ],
        BaseStyle->{Deployed -> False},
        StripOnInput->False]},
      {GridBox[{
         {
          TagBox[
           TooltipBox[
            StyleBox[
             StyleBox[
              DynamicBox[ToBoxes[
                FEPrivate`FrontEndResource[
                "FEStrings", "sizeBriefExplanation"], StandardForm],
               ImageSizeCache->{58., {2., 8.}}],
              StripOnInput->False,
              DynamicUpdating->True], "OSLText",
             StripOnInput->False],
            StyleBox[
             DynamicBox[
              ToBoxes[
               FEPrivate`FrontEndResource["FEStrings", "sizeExplanation"], 
               StandardForm]], DynamicUpdating -> True, StripOnInput -> 
             False]],
           Annotation[#, 
            Style[
             Dynamic[
              FEPrivate`FrontEndResource["FEStrings", "sizeExplanation"]], 
             DynamicUpdating -> True], "Tooltip"]& ], 
          ButtonBox[
           PaneSelectorBox[{False->
            StyleBox[
             StyleBox[
              DynamicBox[ToBoxes[
                FEPrivate`FrontEndResource["FEStrings", "sizeShowLess"], 
                StandardForm],
               ImageSizeCache->{50., {0., 8.}}],
              StripOnInput->False,
              DynamicUpdating->True], "OSLControl",
             StripOnInput->False], True->
            StyleBox[
             StyleBox[
              DynamicBox[ToBoxes[
                FEPrivate`FrontEndResource["FEStrings", "sizeShowLess"], 
                StandardForm]],
              StripOnInput->False,
              DynamicUpdating->True], "OSLControlActive",
             StripOnInput->False]}, Dynamic[
             CurrentValue["MouseOver"]],
            Alignment->Center,
            FrameMargins->0,
            ImageSize->{Automatic, 25}],
           Appearance->None,
           BaselinePosition->Baseline,
           
           ButtonFunction:>OutputSizeLimit`ButtonFunction[
            OutputSizeLimit`Defer, 53, 28838447223223352045, 5/2],
           Enabled->True,
           Evaluator->Automatic,
           Method->"Queued"], 
          ButtonBox[
           PaneSelectorBox[{False->
            StyleBox[
             StyleBox[
              DynamicBox[ToBoxes[
                FEPrivate`FrontEndResource["FEStrings", "sizeShowMore"], 
                StandardForm],
               ImageSizeCache->{56., {0., 8.}}],
              StripOnInput->False,
              DynamicUpdating->True], "OSLControl",
             StripOnInput->False], True->
            StyleBox[
             StyleBox[
              DynamicBox[ToBoxes[
                FEPrivate`FrontEndResource["FEStrings", "sizeShowMore"], 
                StandardForm]],
              StripOnInput->False,
              DynamicUpdating->True], "OSLControlActive",
             StripOnInput->False]}, Dynamic[
             CurrentValue["MouseOver"]],
            Alignment->Center,
            FrameMargins->0,
            ImageSize->{Automatic, 25}],
           Appearance->None,
           BaselinePosition->Baseline,
           
           ButtonFunction:>OutputSizeLimit`ButtonFunction[
            OutputSizeLimit`Defer, 53, 28838447223223352045, 5 2],
           Enabled->True,
           Evaluator->Automatic,
           Method->"Queued"], 
          ButtonBox[
           PaneSelectorBox[{False->
            StyleBox[
             StyleBox[
              DynamicBox[ToBoxes[
                FEPrivate`FrontEndResource["FEStrings", "sizeShowAll"], 
                StandardForm],
               ImageSizeCache->{42., {0., 8.}}],
              StripOnInput->False,
              DynamicUpdating->True], "OSLControl",
             StripOnInput->False], True->
            StyleBox[
             StyleBox[
              DynamicBox[ToBoxes[
                FEPrivate`FrontEndResource["FEStrings", "sizeShowAll"], 
                StandardForm]],
              StripOnInput->False,
              DynamicUpdating->True], "OSLControlActive",
             StripOnInput->False]}, Dynamic[
             CurrentValue["MouseOver"]],
            Alignment->Center,
            FrameMargins->0,
            ImageSize->{Automatic, 25}],
           Appearance->None,
           BaselinePosition->Baseline,
           
           ButtonFunction:>OutputSizeLimit`ButtonFunction[
            OutputSizeLimit`Defer, 53, 28838447223223352045, Infinity],
           Enabled->True,
           Evaluator->Automatic,
           Method->"Queued"], 
          ButtonBox[
           PaneSelectorBox[{False->
            StyleBox[
             StyleBox[
              DynamicBox[ToBoxes[
                FEPrivate`FrontEndResource["FEStrings", "sizeChangeLimit"], 
                StandardForm],
               ImageSizeCache->{74., {0., 8.}}],
              StripOnInput->False,
              DynamicUpdating->True], "OSLControl",
             StripOnInput->False], True->
            StyleBox[
             StyleBox[
              DynamicBox[ToBoxes[
                FEPrivate`FrontEndResource["FEStrings", "sizeChangeLimit"], 
                StandardForm]],
              StripOnInput->False,
              DynamicUpdating->True], "OSLControlActive",
             StripOnInput->False]}, Dynamic[
             CurrentValue["MouseOver"]],
            Alignment->Center,
            FrameMargins->0,
            ImageSize->{Automatic, 25}],
           Appearance->None,
           BaselinePosition->Baseline,
           ButtonFunction:>FrontEndExecute[{
              FrontEnd`SetOptions[
              FrontEnd`$FrontEnd, 
               FrontEnd`PreferencesSettings -> {"Page" -> "Advanced"}], 
              FrontEnd`FrontEndToken["PreferencesDialog"]}],
           Evaluator->None,
           Method->"Preemptive"]}
        },
        AutoDelete->False,
        FrameStyle->GrayLevel[0.85],
        GridBoxDividers->{"Columns" -> {False, {True}}},
        GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
        GridBoxSpacings->{"Columns" -> {{2}}}]}
     },
     DefaultBaseStyle->"Column",
     GridBoxAlignment->{
      "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
       "RowsIndexed" -> {}},
     GridBoxDividers->{
      "Columns" -> {{False}}, "ColumnsIndexed" -> {}, "Rows" -> {{False}}, 
       "RowsIndexed" -> {}},
     GridBoxItemSize->{
      "Columns" -> {{Automatic}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.5599999999999999]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], 
         Offset[1.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    BaseStyle->"OutputSizeLimit",
    FrameMargins->{{12, 12}, {0, 15}},
    FrameStyle->GrayLevel[0.85],
    RoundingRadius->5,
    StripOnInput->False],
   Deploy,
   DefaultBaseStyle->"Deploy"],
  If[28838447223223352045 === $SessionID, 
   Out[53], Message[
     MessageName[Syntax, "noinfoker"]]; Missing["NotAvailable"]; 
   Null]]], "Output",
 CellChangeTimes->{3.782315245312644*^9, 3.7823157626210623`*^9, 
  3.782458027848233*^9, 3.782464379031163*^9, 3.782464439451776*^9},
 CellLabel->"Out[53]=",ExpressionUUID->"10c393b2-d7ef-4c18-944a-d437cc737cd6"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"AustenHuffmanEncoded", "=", 
  RowBox[{"Join", "@@", 
   RowBox[{"AustenHuffmanEncoder", "/@", 
    RowBox[{"Characters", "[", "Austen", "]"}]}]}]}]], "Input",
 CellChangeTimes->{{3.7771880589631147`*^9, 3.777188115281012*^9}, {
  3.77969102811954*^9, 3.779691029335285*^9}, {3.7796914201229057`*^9, 
  3.7796914561279984`*^9}, {3.782315010382935*^9, 3.7823150111269407`*^9}, {
  3.782315205991728*^9, 3.7823152076250362`*^9}},
 CellLabel->"In[54]:=",ExpressionUUID->"122b94d1-99aa-4c05-a947-92007bad0e1d"],

Cell[BoxData[
 InterpretationBox[
  TagBox[
   FrameBox[GridBox[{
      {
       ItemBox[
        TagBox[
         RowBox[{"{", 
          RowBox[{
          "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", 
           ",", "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
           "1", ",", "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", 
           ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
           "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", "1", 
           ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
           "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", 
           ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", 
           "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", 
           ",", "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
           "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", 
           ",", "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
           "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", "1", 
           ",", "0", ",", "1", ",", "1", ",", "1", ",", "1", ",", "0", ",", 
           "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", 
           ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
           "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", "0", 
           ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
           "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", 
           ",", "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
           TemplateBox[{"27099"},
            "OutputSizeLimit`Skeleton"], ",", "1", ",", "0", ",", "0", ",", 
           "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", "1", 
           ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", 
           "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", 
           ",", "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
           "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", 
           ",", "1", ",", "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", 
           "1", ",", "1", ",", "1", ",", "1", ",", "0", ",", "1", ",", "0", 
           ",", "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
           "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", 
           ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
           "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", 
           ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
           "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", 
           ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
           "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", 
           ",", "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
           "1", ",", "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", 
           ",", "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
           "1", ",", "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "0", 
           ",", "0", ",", "1"}], "}"}],
         Short[#, 5]& ],
        BaseStyle->{Deployed -> False},
        StripOnInput->False]},
      {GridBox[{
         {
          TagBox[
           TooltipBox[
            StyleBox[
             StyleBox[
              DynamicBox[ToBoxes[
                FEPrivate`FrontEndResource[
                "FEStrings", "sizeBriefExplanation"], StandardForm],
               ImageSizeCache->{58., {2., 8.}}],
              StripOnInput->False,
              DynamicUpdating->True], "OSLText",
             StripOnInput->False],
            StyleBox[
             DynamicBox[
              ToBoxes[
               FEPrivate`FrontEndResource["FEStrings", "sizeExplanation"], 
               StandardForm]], DynamicUpdating -> True, StripOnInput -> 
             False]],
           Annotation[#, 
            Style[
             Dynamic[
              FEPrivate`FrontEndResource["FEStrings", "sizeExplanation"]], 
             DynamicUpdating -> True], "Tooltip"]& ], 
          ButtonBox[
           PaneSelectorBox[{False->
            StyleBox[
             StyleBox[
              DynamicBox[ToBoxes[
                FEPrivate`FrontEndResource["FEStrings", "sizeShowLess"], 
                StandardForm],
               ImageSizeCache->{50., {0., 8.}}],
              StripOnInput->False,
              DynamicUpdating->True], "OSLControl",
             StripOnInput->False], True->
            StyleBox[
             StyleBox[
              DynamicBox[ToBoxes[
                FEPrivate`FrontEndResource["FEStrings", "sizeShowLess"], 
                StandardForm]],
              StripOnInput->False,
              DynamicUpdating->True], "OSLControlActive",
             StripOnInput->False]}, Dynamic[
             CurrentValue["MouseOver"]],
            Alignment->Center,
            FrameMargins->0,
            ImageSize->{Automatic, 25}],
           Appearance->None,
           BaselinePosition->Baseline,
           
           ButtonFunction:>OutputSizeLimit`ButtonFunction[
            OutputSizeLimit`Defer, 54, 28838447223223352045, 5/2],
           Enabled->True,
           Evaluator->Automatic,
           Method->"Queued"], 
          ButtonBox[
           PaneSelectorBox[{False->
            StyleBox[
             StyleBox[
              DynamicBox[ToBoxes[
                FEPrivate`FrontEndResource["FEStrings", "sizeShowMore"], 
                StandardForm],
               ImageSizeCache->{56., {0., 8.}}],
              StripOnInput->False,
              DynamicUpdating->True], "OSLControl",
             StripOnInput->False], True->
            StyleBox[
             StyleBox[
              DynamicBox[ToBoxes[
                FEPrivate`FrontEndResource["FEStrings", "sizeShowMore"], 
                StandardForm]],
              StripOnInput->False,
              DynamicUpdating->True], "OSLControlActive",
             StripOnInput->False]}, Dynamic[
             CurrentValue["MouseOver"]],
            Alignment->Center,
            FrameMargins->0,
            ImageSize->{Automatic, 25}],
           Appearance->None,
           BaselinePosition->Baseline,
           
           ButtonFunction:>OutputSizeLimit`ButtonFunction[
            OutputSizeLimit`Defer, 54, 28838447223223352045, 5 2],
           Enabled->True,
           Evaluator->Automatic,
           Method->"Queued"], 
          ButtonBox[
           PaneSelectorBox[{False->
            StyleBox[
             StyleBox[
              DynamicBox[ToBoxes[
                FEPrivate`FrontEndResource["FEStrings", "sizeShowAll"], 
                StandardForm],
               ImageSizeCache->{42., {0., 8.}}],
              StripOnInput->False,
              DynamicUpdating->True], "OSLControl",
             StripOnInput->False], True->
            StyleBox[
             StyleBox[
              DynamicBox[ToBoxes[
                FEPrivate`FrontEndResource["FEStrings", "sizeShowAll"], 
                StandardForm]],
              StripOnInput->False,
              DynamicUpdating->True], "OSLControlActive",
             StripOnInput->False]}, Dynamic[
             CurrentValue["MouseOver"]],
            Alignment->Center,
            FrameMargins->0,
            ImageSize->{Automatic, 25}],
           Appearance->None,
           BaselinePosition->Baseline,
           
           ButtonFunction:>OutputSizeLimit`ButtonFunction[
            OutputSizeLimit`Defer, 54, 28838447223223352045, Infinity],
           Enabled->True,
           Evaluator->Automatic,
           Method->"Queued"], 
          ButtonBox[
           PaneSelectorBox[{False->
            StyleBox[
             StyleBox[
              DynamicBox[ToBoxes[
                FEPrivate`FrontEndResource["FEStrings", "sizeChangeLimit"], 
                StandardForm],
               ImageSizeCache->{74., {0., 8.}}],
              StripOnInput->False,
              DynamicUpdating->True], "OSLControl",
             StripOnInput->False], True->
            StyleBox[
             StyleBox[
              DynamicBox[ToBoxes[
                FEPrivate`FrontEndResource["FEStrings", "sizeChangeLimit"], 
                StandardForm]],
              StripOnInput->False,
              DynamicUpdating->True], "OSLControlActive",
             StripOnInput->False]}, Dynamic[
             CurrentValue["MouseOver"]],
            Alignment->Center,
            FrameMargins->0,
            ImageSize->{Automatic, 25}],
           Appearance->None,
           BaselinePosition->Baseline,
           ButtonFunction:>FrontEndExecute[{
              FrontEnd`SetOptions[
              FrontEnd`$FrontEnd, 
               FrontEnd`PreferencesSettings -> {"Page" -> "Advanced"}], 
              FrontEnd`FrontEndToken["PreferencesDialog"]}],
           Evaluator->None,
           Method->"Preemptive"]}
        },
        AutoDelete->False,
        FrameStyle->GrayLevel[0.85],
        GridBoxDividers->{"Columns" -> {False, {True}}},
        GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
        GridBoxSpacings->{"Columns" -> {{2}}}]}
     },
     DefaultBaseStyle->"Column",
     GridBoxAlignment->{
      "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
       "RowsIndexed" -> {}},
     GridBoxDividers->{
      "Columns" -> {{False}}, "ColumnsIndexed" -> {}, "Rows" -> {{False}}, 
       "RowsIndexed" -> {}},
     GridBoxItemSize->{
      "Columns" -> {{Automatic}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.5599999999999999]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], 
         Offset[1.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    BaseStyle->"OutputSizeLimit",
    FrameMargins->{{12, 12}, {0, 15}},
    FrameStyle->GrayLevel[0.85],
    RoundingRadius->5,
    StripOnInput->False],
   Deploy,
   DefaultBaseStyle->"Deploy"],
  If[28838447223223352045 === $SessionID, 
   Out[54], Message[
     MessageName[Syntax, "noinfoker"]]; Missing["NotAvailable"]; 
   Null]]], "Output",
 CellChangeTimes->{
  3.779691456440297*^9, 3.780157593339896*^9, 3.780215626852742*^9, 
   3.780230187078906*^9, {3.7802302897019157`*^9, 3.780230313838888*^9}, 
   3.780230343958465*^9, 3.780230702366951*^9, 3.7804142980161753`*^9, 
   3.780582015535964*^9, 3.780894788472444*^9, 3.781245309812765*^9, 
   3.781249655667123*^9, 3.781448055051258*^9, 3.781538132583027*^9, 
   3.781539247673265*^9, 3.78230867045747*^9, 3.78230958117309*^9, 
   3.782315011513351*^9, 3.782315208070745*^9, 3.782315762489423*^9, 
   3.782458027981534*^9, 3.782464382457583*^9, 3.782464439961791*^9},
 CellLabel->"Out[54]=",ExpressionUUID->"ea8d5c4e-b216-4ca9-ad1d-64ad0100e2d6"]
}, Open  ]],

Cell[CellGroupData[{

Cell["Example in Part B", "Subsubsection",
 CellChangeTimes->{{3.782458114760227*^9, 
  3.782458117255245*^9}},ExpressionUUID->"7853c72c-6637-4757-a249-\
f489f4f9361c"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"AustenHuffmanEncoder", "/@", 
  RowBox[{"{", 
   RowBox[{
   "\"\<S\>\"", ",", "\"\<u\>\"", ",", "\"\<c\>\"", ",", "\"\<h\>\"", ",", 
    "\"\< \>\"", ",", "\"\<w\>\"", ",", "\"\<e\>\"", ",", "\"\<r\>\"", ",", 
    "\"\<e\>\"", ",", "\"\< \>\"", ",", "\"\<E\>\"", ",", "\"\<l\>\"", ",", 
    "\"\<i\>\"", ",", "\"\<z\>\"", ",", "\"\<a\>\""}], "}"}]}]], "Input",
 CellChangeTimes->{{3.7824581183511353`*^9, 3.7824581678797693`*^9}},
 CellLabel->"In[55]:=",ExpressionUUID->"2c8be7f3-ba8d-43a1-9950-33d74d75cbe3"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
    "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
     "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1"}], "}"}], 
   ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1"}], "}"}], 
   ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "1", ",", "0", ",", "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "1", ",", "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "0", ",", "1", ",", "1", ",", "0", ",", "1"}], "}"}], 
   ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "1", ",", "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "1", ",", "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "1", ",", "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "1", ",", "1",
      ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "0", ",", "0", ",", "1", ",", "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "0", ",", "1", ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1",
      ",", "1", ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "1", ",", "0", ",", "0"}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{
  3.782458127218185*^9, {3.782458159081189*^9, 3.782458168230753*^9}, 
   3.782464383674623*^9, 3.782464440217247*^9},
 CellLabel->"Out[55]=",ExpressionUUID->"29afe240-318b-4e3a-8412-b5720dc8bec7"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
The entropy bound shows that optimally 4.267 bits are needed per character; \
the Shannon code uses 4.792 andthe Huffman code uses 4.302\
\>", "Subsubsection",
 CellChangeTimes->{{3.7823124055521593`*^9, 3.782312453556271*^9}, {
  3.78231491628648*^9, 3.7823149231693983`*^9}, {3.782315447154971*^9, 
  3.782315450031067*^9}, {3.782316038115336*^9, 3.7823160447799883`*^9}, {
  3.782316075343069*^9, 
  3.782316083419724*^9}},ExpressionUUID->"618a4b47-a446-4576-8bdb-\
e4598e04537e"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{
    RowBox[{"Entropy", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"#", "[", 
        RowBox[{"[", "2", "]"}], "]"}], "&"}], "/@", "AustenProbabilities"}], 
     "]"}], "//", "N"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"Length", "[", "AustenShannonEncoded", "]"}], "/", 
       RowBox[{"StringLength", "[", "Austen", "]"}]}], "//", "N"}], ",", 
     RowBox[{"ShannonExpectedLength", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"#", "[", 
         RowBox[{"[", "2", "]"}], "]"}], "&"}], "/@", "AustenProbabilities"}],
       "]"}]}], "}"}], ",", "\[IndentingNewLine]", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"Length", "[", "AustenHuffmanEncoded", "]"}], "/", 
       RowBox[{"StringLength", "[", "Austen", "]"}]}], "//", "N"}], ",", 
     RowBox[{"HuffmanExpectedLength", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"#", "[", 
         RowBox[{"[", "2", "]"}], "]"}], "&"}], "/@", "AustenProbabilities"}],
       "]"}]}], "}"}]}], "}"}]], "Input",
 CellChangeTimes->{{3.782312376741485*^9, 3.7823123886227207`*^9}, {
  3.7823124304452477`*^9, 3.782312447936468*^9}, {3.782314925911182*^9, 
  3.782314950965357*^9}, {3.782315252435109*^9, 3.7823152764766808`*^9}, {
  3.7823160502811327`*^9, 3.782316070401855*^9}},
 CellLabel->"In[56]:=",ExpressionUUID->"a2072291-7692-42fc-aad4-f89b30fe5ea5"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"3.1675258495472915`", ",", 
   RowBox[{"{", 
    RowBox[{"4.792138364779874`", ",", "4.792138364779878`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"4.301572327044025`", ",", "4.3015723270440285`"}], "}"}]}], 
  "}"}]], "Output",
 CellChangeTimes->{3.78231607081231*^9, 3.782458028150607*^9, 
  3.7824643839215517`*^9, 3.7824644404341383`*^9},
 CellLabel->"Out[56]=",ExpressionUUID->"c86b90f5-ba41-4d03-8be0-7759446e656d"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
Using the normal ASCII encoding, each character is represented by 8 bits. For \
example, e -> 01100101. So the Huffman code almost halves the number of bits \
required.\
\>", "Subsubsection",
 CellChangeTimes->{{3.777188261602186*^9, 3.777188271524025*^9}, {
  3.777188426514378*^9, 3.7771884318456373`*^9}, {3.777188505557745*^9, 
  3.777188515577199*^9}},ExpressionUUID->"1db2472c-a989-4ade-aa48-\
4233353d725e"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"8", "*", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"Characters", "[", "Austen", "]"}], "//", "Length"}], ")"}]}], 
   ",", 
   RowBox[{"AustenHuffmanEncoded", "//", "Length"}]}], "}"}]], "Input",
 CellChangeTimes->{{3.777188249763895*^9, 3.7771882591690493`*^9}, {
  3.7771884385181007`*^9, 3.7771884440712357`*^9}, {3.777188498263218*^9, 
  3.7771884999907217`*^9}, {3.782314589724774*^9, 3.782314594773744*^9}, {
  3.782314629189247*^9, 3.7823146303753147`*^9}},
 CellLabel->"In[57]:=",ExpressionUUID->"cd46ac3b-cc00-4ef3-ba51-2978a31a228d"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"50880", ",", "27358"}], "}"}]], "Output",
 CellChangeTimes->{
  3.777188255914494*^9, 3.777188444460505*^9, {3.777188475974008*^9, 
   3.777188500254863*^9}, 3.7783489179254093`*^9, 3.778504468745143*^9, 
   3.778865595123921*^9, 3.779631172840444*^9, 3.779690587245986*^9, 
   3.779691050869719*^9, {3.779691317474366*^9, 3.779691340978634*^9}, 
   3.779691460222003*^9, 3.780157593451477*^9, 3.780215626933712*^9, 
   3.7802301872202473`*^9, {3.780230289803555*^9, 3.780230313970612*^9}, 
   3.780230344145454*^9, 3.7802307024850483`*^9, 3.780414298174045*^9, 
   3.7805820156517878`*^9, 3.780894788910037*^9, 3.781245309912066*^9, 
   3.781249658627002*^9, 3.781448055238616*^9, 3.7815381327008038`*^9, 
   3.7815392478749857`*^9, 3.7823086705734386`*^9, 3.7823095945957003`*^9, 
   3.782314596686185*^9, 3.782315762854156*^9, 3.7824580285399218`*^9, 
   3.7824643840977917`*^9, 3.782464440483976*^9},
 CellLabel->"Out[57]=",ExpressionUUID->"09fe57f3-775f-4ad0-83b3-22e001987adb"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"CharacterToASCII", "[", "c_", "]"}], ":=", 
  RowBox[{"ToBinary", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"ToCharacterCode", "[", "c", "]"}], "[", 
     RowBox[{"[", "1", "]"}], "]"}], ",", "8"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.749807802414331*^9, 3.749807868837906*^9}, {
  3.749807950469593*^9, 3.749807951481634*^9}, {3.781249891805418*^9, 
  3.781249895761973*^9}},
 CellLabel->"In[58]:=",ExpressionUUID->"3c5738d6-58e5-42d0-bbcc-2713afc4cc0b"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"Table", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"c", ",", 
      RowBox[{
       RowBox[{"ToCharacterCode", "[", "c", "]"}], "[", 
       RowBox[{"[", "1", "]"}], "]"}], ",", 
      RowBox[{"CharacterToASCII", "[", "c", "]"}]}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"c", ",", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
        "\"\< \>\"", ",", "\"\<.\>\"", ",", "\"\<,\>\"", ",", "\"\<;\>\""}], 
        "}"}], "~", "Join", "~", 
       RowBox[{"CharacterRange", "[", 
        RowBox[{"\"\<A\>\"", ",", "\"\<E\>\""}], "]"}], "~", "Join", "~", 
       RowBox[{"CharacterRange", "[", 
        RowBox[{"\"\<a\>\"", ",", "\"\<e\>\""}], "]"}], "~", "Join", "~", 
       RowBox[{"{", "\"\<p,z\>\"", "}"}]}]}], "}"}]}], "]"}], "//", 
  "TF"}]], "Input",
 CellChangeTimes->{{3.749807815619893*^9, 3.749807839174074*^9}, {
  3.749807885822249*^9, 3.749807889588352*^9}, {3.7498079546107616`*^9, 
  3.749807955630142*^9}, {3.750248247050068*^9, 3.750248348631024*^9}, {
  3.75024854433115*^9, 3.750248549213098*^9}, {3.751041997525556*^9, 
  3.7510420154519367`*^9}, {3.751043040817678*^9, 3.75104304104712*^9}, {
  3.751286769722312*^9, 3.751286769845872*^9}, {3.751452144359498*^9, 
  3.751452144439777*^9}},
 CellLabel->"In[59]:=",ExpressionUUID->"d2bdc97d-ccdd-4fa2-9214-6cec0b8703c3"],

Cell[BoxData[
 TagBox[GridBox[{
    {"\<\" \"\>", "32", 
     RowBox[{"{", 
      RowBox[{
      "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
       "0"}], "}"}]},
    {"\<\".\"\>", "46", 
     RowBox[{"{", 
      RowBox[{
      "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "0"}], "}"}]},
    {"\<\",\"\>", "44", 
     RowBox[{"{", 
      RowBox[{
      "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
       "0"}], "}"}]},
    {"\<\";\"\>", "59", 
     RowBox[{"{", 
      RowBox[{
      "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "1", ",", 
       "1"}], "}"}]},
    {"\<\"A\"\>", "65", 
     RowBox[{"{", 
      RowBox[{
      "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
       "1"}], "}"}]},
    {"\<\"B\"\>", "66", 
     RowBox[{"{", 
      RowBox[{
      "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
       "0"}], "}"}]},
    {"\<\"C\"\>", "67", 
     RowBox[{"{", 
      RowBox[{
      "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
       "1"}], "}"}]},
    {"\<\"D\"\>", "68", 
     RowBox[{"{", 
      RowBox[{
      "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
       "0"}], "}"}]},
    {"\<\"E\"\>", "69", 
     RowBox[{"{", 
      RowBox[{
      "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
       "1"}], "}"}]},
    {"\<\"a\"\>", "97", 
     RowBox[{"{", 
      RowBox[{
      "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
       "1"}], "}"}]},
    {"\<\"b\"\>", "98", 
     RowBox[{"{", 
      RowBox[{
      "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
       "0"}], "}"}]},
    {"\<\"c\"\>", "99", 
     RowBox[{"{", 
      RowBox[{
      "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
       "1"}], "}"}]},
    {"\<\"d\"\>", "100", 
     RowBox[{"{", 
      RowBox[{
      "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
       "0"}], "}"}]},
    {"\<\"e\"\>", "101", 
     RowBox[{"{", 
      RowBox[{
      "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
       "1"}], "}"}]},
    {"\<\"p,z\"\>", "112", 
     RowBox[{"{", 
      RowBox[{
      "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
       "0"}], "}"}]}
   },
   GridBoxAlignment->{
    "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
     "RowsIndexed" -> {}},
   GridBoxSpacings->{"Columns" -> {
       Offset[0.27999999999999997`], {
        Offset[2.0999999999999996`]}, 
       Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
       Offset[0.2], {
        Offset[0.4]}, 
       Offset[0.2]}, "RowsIndexed" -> {}}],
  Function[BoxForm`e$, 
   TableForm[BoxForm`e$, TableDepth -> 2]]]], "Output",
 CellChangeTimes->{{3.750248304193478*^9, 3.750248317963942*^9}, 
   3.750248349411231*^9, 3.7502485545108433`*^9, 3.7503431505868187`*^9, 
   3.7507717079933643`*^9, {3.751042003148902*^9, 3.751042016117793*^9}, 
   3.7510430414438868`*^9, 3.7512713249735823`*^9, 3.7512867709084873`*^9, 
   3.751312605873796*^9, 3.751312660885002*^9, 3.751452128686022*^9, 
   3.751452187996818*^9, {3.751466075660329*^9, 3.75146613153771*^9}, 
   3.7516537640972643`*^9, 3.751654254877557*^9, 3.751794578895362*^9, 
   3.7523322723418694`*^9, 3.752339863055532*^9, 3.7523909118146677`*^9, 
   3.75251374641444*^9, 3.752513874779766*^9, 3.752513920328043*^9, 
   3.752596478748136*^9, 3.7528410188935328`*^9, 3.7528410648887997`*^9, 
   3.75284591186028*^9, 3.7528460200040817`*^9, 3.7532674244324703`*^9, 
   3.765797181638154*^9, 3.765797402886538*^9, 3.765809520742044*^9, 
   3.7756379064980907`*^9, 3.775663901400074*^9, 3.7757194937281322`*^9, 
   3.775720123654985*^9, 3.7757236029981537`*^9, 3.775723654602469*^9, 
   3.775723687306319*^9, 3.775723804365856*^9, 3.7757238873670197`*^9, 
   3.7758943672794037`*^9, 3.775907532846304*^9, 3.7770296903876963`*^9, 
   3.7771883270670233`*^9, 3.77756762131124*^9, 3.777568130415147*^9, 
   3.777568278903248*^9, 3.7776204228196907`*^9, 3.781096116418872*^9, 
   3.781249902083722*^9, 3.781448055542652*^9, 3.781538132856811*^9, 
   3.781539247993802*^9, 3.782308670686191*^9, 3.782315762982239*^9, 
   3.782458029281084*^9, 3.782464384298565*^9, 3.782464440706581*^9},
 CellLabel->
  "Out[59]//TableForm=",ExpressionUUID->"7b1b73f6-93e5-487f-8496-\
d247a19fa5c0"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"StringToASCIIBytes", "[", "str_", "]"}], ":=", 
  RowBox[{"Table", "[", 
   RowBox[{
    RowBox[{"CharacterToASCII", "[", 
     RowBox[{"StringTake", "[", 
      RowBox[{"str", ",", 
       RowBox[{"{", 
        RowBox[{"j", ",", "j"}], "}"}]}], "]"}], "]"}], ",", 
    RowBox[{"{", 
     RowBox[{"j", ",", "1", ",", 
      RowBox[{"StringLength", "[", "str", "]"}]}], "}"}]}], "]"}]}]], "Input",\

 CellChangeTimes->{{3.749807975852521*^9, 3.74980804004381*^9}, {
  3.7502485083245287`*^9, 3.750248508671074*^9}, {3.750340432897299*^9, 
  3.750340433750786*^9}, {3.750340568547821*^9, 3.750340589994907*^9}},
 CellLabel->"In[60]:=",ExpressionUUID->"17cbb892-0668-4627-b0e4-10e6ef606ffb"],

Cell[BoxData[
 RowBox[{
  RowBox[{"StringToASCIIBits", "[", "str_", "]"}], ":=", 
  RowBox[{"Join", "@@", 
   RowBox[{"StringToASCIIBytes", "[", "str", "]"}]}]}]], "Input",
 CellChangeTimes->{{3.7503409422009*^9, 3.7503409549375877`*^9}, {
  3.750341013817608*^9, 3.7503410368568373`*^9}},
 CellLabel->"In[61]:=",ExpressionUUID->"f74ee56f-acf7-4628-9b3e-0d2ca8edb175"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"AustenASCIIEncoded", "=", 
  RowBox[{"StringToASCIIBits", "[", "Austen", "]"}]}]], "Input",
 CellChangeTimes->{{3.7812499588684196`*^9, 3.781249969262905*^9}},
 CellLabel->"In[62]:=",ExpressionUUID->"7377e2fb-95c8-4e82-b806-905b5cca9631"],

Cell[BoxData[
 InterpretationBox[
  TagBox[
   FrameBox[GridBox[{
      {
       ItemBox[
        TagBox[
         RowBox[{"{", 
          RowBox[{
          "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", 
           ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", 
           "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "0", 
           ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", 
           "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", 
           ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
           "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "1", 
           ",", "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
           "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", 
           ",", "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
           "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "1", 
           ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
           "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", 
           ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", 
           "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "1", 
           ",", "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
           "0", ",", "1", ",", "1", ",", "1", ",", "1", ",", "0", ",", "1", 
           ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
           "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "0", 
           ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
           TemplateBox[{"50622"},
            "OutputSizeLimit`Skeleton"], ",", "0", ",", "0", ",", "1", ",", 
           "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", 
           ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
           "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", 
           ",", "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
           "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", 
           ",", "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
           "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", 
           ",", "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", 
           "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", 
           ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
           "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", 
           ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
           "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", 
           ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", 
           "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "0", 
           ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
           "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", 
           ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
           "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", 
           ",", "1", ",", "0"}], "}"}],
         Short[#, 5]& ],
        BaseStyle->{Deployed -> False},
        StripOnInput->False]},
      {GridBox[{
         {
          TagBox[
           TooltipBox[
            StyleBox[
             StyleBox[
              DynamicBox[ToBoxes[
                FEPrivate`FrontEndResource[
                "FEStrings", "sizeBriefExplanation"], StandardForm],
               ImageSizeCache->{58., {2., 8.}}],
              StripOnInput->False,
              DynamicUpdating->True], "OSLText",
             StripOnInput->False],
            StyleBox[
             DynamicBox[
              ToBoxes[
               FEPrivate`FrontEndResource["FEStrings", "sizeExplanation"], 
               StandardForm]], DynamicUpdating -> True, StripOnInput -> 
             False]],
           Annotation[#, 
            Style[
             Dynamic[
              FEPrivate`FrontEndResource["FEStrings", "sizeExplanation"]], 
             DynamicUpdating -> True], "Tooltip"]& ], 
          ButtonBox[
           PaneSelectorBox[{False->
            StyleBox[
             StyleBox[
              DynamicBox[ToBoxes[
                FEPrivate`FrontEndResource["FEStrings", "sizeShowLess"], 
                StandardForm],
               ImageSizeCache->{50., {0., 8.}}],
              StripOnInput->False,
              DynamicUpdating->True], "OSLControl",
             StripOnInput->False], True->
            StyleBox[
             StyleBox[
              DynamicBox[ToBoxes[
                FEPrivate`FrontEndResource["FEStrings", "sizeShowLess"], 
                StandardForm]],
              StripOnInput->False,
              DynamicUpdating->True], "OSLControlActive",
             StripOnInput->False]}, Dynamic[
             CurrentValue["MouseOver"]],
            Alignment->Center,
            FrameMargins->0,
            ImageSize->{Automatic, 25}],
           Appearance->None,
           BaselinePosition->Baseline,
           
           ButtonFunction:>OutputSizeLimit`ButtonFunction[
            OutputSizeLimit`Defer, 62, 28838447223223352045, 5/2],
           Enabled->True,
           Evaluator->Automatic,
           Method->"Queued"], 
          ButtonBox[
           PaneSelectorBox[{False->
            StyleBox[
             StyleBox[
              DynamicBox[ToBoxes[
                FEPrivate`FrontEndResource["FEStrings", "sizeShowMore"], 
                StandardForm],
               ImageSizeCache->{56., {0., 8.}}],
              StripOnInput->False,
              DynamicUpdating->True], "OSLControl",
             StripOnInput->False], True->
            StyleBox[
             StyleBox[
              DynamicBox[ToBoxes[
                FEPrivate`FrontEndResource["FEStrings", "sizeShowMore"], 
                StandardForm]],
              StripOnInput->False,
              DynamicUpdating->True], "OSLControlActive",
             StripOnInput->False]}, Dynamic[
             CurrentValue["MouseOver"]],
            Alignment->Center,
            FrameMargins->0,
            ImageSize->{Automatic, 25}],
           Appearance->None,
           BaselinePosition->Baseline,
           
           ButtonFunction:>OutputSizeLimit`ButtonFunction[
            OutputSizeLimit`Defer, 62, 28838447223223352045, 5 2],
           Enabled->True,
           Evaluator->Automatic,
           Method->"Queued"], 
          ButtonBox[
           PaneSelectorBox[{False->
            StyleBox[
             StyleBox[
              DynamicBox[ToBoxes[
                FEPrivate`FrontEndResource["FEStrings", "sizeShowAll"], 
                StandardForm],
               ImageSizeCache->{42., {0., 8.}}],
              StripOnInput->False,
              DynamicUpdating->True], "OSLControl",
             StripOnInput->False], True->
            StyleBox[
             StyleBox[
              DynamicBox[ToBoxes[
                FEPrivate`FrontEndResource["FEStrings", "sizeShowAll"], 
                StandardForm]],
              StripOnInput->False,
              DynamicUpdating->True], "OSLControlActive",
             StripOnInput->False]}, Dynamic[
             CurrentValue["MouseOver"]],
            Alignment->Center,
            FrameMargins->0,
            ImageSize->{Automatic, 25}],
           Appearance->None,
           BaselinePosition->Baseline,
           
           ButtonFunction:>OutputSizeLimit`ButtonFunction[
            OutputSizeLimit`Defer, 62, 28838447223223352045, Infinity],
           Enabled->True,
           Evaluator->Automatic,
           Method->"Queued"], 
          ButtonBox[
           PaneSelectorBox[{False->
            StyleBox[
             StyleBox[
              DynamicBox[ToBoxes[
                FEPrivate`FrontEndResource["FEStrings", "sizeChangeLimit"], 
                StandardForm],
               ImageSizeCache->{74., {0., 8.}}],
              StripOnInput->False,
              DynamicUpdating->True], "OSLControl",
             StripOnInput->False], True->
            StyleBox[
             StyleBox[
              DynamicBox[ToBoxes[
                FEPrivate`FrontEndResource["FEStrings", "sizeChangeLimit"], 
                StandardForm]],
              StripOnInput->False,
              DynamicUpdating->True], "OSLControlActive",
             StripOnInput->False]}, Dynamic[
             CurrentValue["MouseOver"]],
            Alignment->Center,
            FrameMargins->0,
            ImageSize->{Automatic, 25}],
           Appearance->None,
           BaselinePosition->Baseline,
           ButtonFunction:>FrontEndExecute[{
              FrontEnd`SetOptions[
              FrontEnd`$FrontEnd, 
               FrontEnd`PreferencesSettings -> {"Page" -> "Advanced"}], 
              FrontEnd`FrontEndToken["PreferencesDialog"]}],
           Evaluator->None,
           Method->"Preemptive"]}
        },
        AutoDelete->False,
        FrameStyle->GrayLevel[0.85],
        GridBoxDividers->{"Columns" -> {False, {True}}},
        GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
        GridBoxSpacings->{"Columns" -> {{2}}}]}
     },
     DefaultBaseStyle->"Column",
     GridBoxAlignment->{
      "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
       "RowsIndexed" -> {}},
     GridBoxDividers->{
      "Columns" -> {{False}}, "ColumnsIndexed" -> {}, "Rows" -> {{False}}, 
       "RowsIndexed" -> {}},
     GridBoxItemSize->{
      "Columns" -> {{Automatic}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.5599999999999999]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], 
         Offset[1.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    BaseStyle->"OutputSizeLimit",
    FrameMargins->{{12, 12}, {0, 15}},
    FrameStyle->GrayLevel[0.85],
    RoundingRadius->5,
    StripOnInput->False],
   Deploy,
   DefaultBaseStyle->"Deploy"],
  If[28838447223223352045 === $SessionID, 
   Out[62], Message[
     MessageName[Syntax, "noinfoker"]]; Missing["NotAvailable"]; 
   Null]]], "Output",
 CellChangeTimes->{3.781249971441236*^9, 3.781448055793935*^9, 
  3.781538133060473*^9, 3.7815392482079563`*^9, 3.78230867096838*^9, 
  3.78230960516227*^9, 3.782315763518692*^9, 3.7824580301316977`*^9, 
  3.782464384708344*^9, 3.782464441119892*^9},
 CellLabel->"Out[62]=",ExpressionUUID->"a12cb9d1-abe5-4dfb-8167-8403b3ca3e14"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
In fact 7 bit ASCII would be fine for Jane Austen, but still this only says 1 \
bit in every 8.\
\>", "Subsubsection",
 CellChangeTimes->{{3.778412921176352*^9, 
  3.778412936591576*^9}},ExpressionUUID->"cc953103-042d-4879-9ea3-\
01f3ab86918b"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"Length", "[", "AustenASCIIEncoded", "]"}], ",", 
   RowBox[{
    RowBox[{"Length", "[", "AustenASCIIEncoded", "]"}], "/", 
    RowBox[{"StringLength", "[", "Austen", "]"}]}]}], "}"}]], "Input",
 CellChangeTimes->{{3.782312493136509*^9, 3.782312509822946*^9}},
 CellLabel->"In[63]:=",ExpressionUUID->"008ed10e-2702-42db-a9f9-e1063d80122d"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"50880", ",", "8"}], "}"}]], "Output",
 CellChangeTimes->{{3.782312497211028*^9, 3.782312510273879*^9}, 
   3.7823157636922073`*^9, 3.782458030240087*^9, 3.7824643849312983`*^9, 
   3.782464441247548*^9},
 CellLabel->"Out[63]=",ExpressionUUID->"9c959bbe-9dca-4ca4-be21-aa0f14e74aef"]
}, Open  ]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Huffman code encoding pairs of characters", "Subsection",
 CellChangeTimes->{{3.7823098162843*^9, 
  3.782309822303879*^9}},ExpressionUUID->"ecc7815c-b83c-4b81-9670-\
5e42fc2269a2"],

Cell[BoxData[
 RowBox[{
  RowBox[{"AustenPairFrequencies", "=", 
   RowBox[{
    RowBox[{"SortBy", "[", 
     RowBox[{
      RowBox[{"Tally", "[", 
       RowBox[{"Partition", "[", 
        RowBox[{
         RowBox[{"Characters", "[", "Austen", "]"}], ",", "2"}], "]"}], "]"}],
       ",", 
      RowBox[{
       RowBox[{"#", "[", 
        RowBox[{"[", "2", "]"}], "]"}], "&"}]}], "]"}], "//", "Reverse"}]}], 
  ";"}]], "Input",
 CellChangeTimes->{{3.782309858238563*^9, 3.7823099074788723`*^9}, 
   3.782310020758848*^9},
 CellLabel->"In[64]:=",ExpressionUUID->"49d71aa3-0c53-4c3e-9bd9-ed9fee3bd24a"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"AustenPairProbabilities", "=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"n", "=", 
       RowBox[{
        RowBox[{"Length", "[", 
         RowBox[{"Characters", "[", "Austen", "]"}], "]"}], "/", "2"}]}], 
      "}"}], ",", 
     RowBox[{
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"#", "[", 
          RowBox[{"[", "1", "]"}], "]"}], ",", 
         RowBox[{
          RowBox[{
           RowBox[{"#", "[", 
            RowBox[{"[", "2", "]"}], "]"}], "/", "n"}], "//", "N"}]}], "}"}], 
       "&"}], "/@", "AustenPairFrequencies"}]}], "]"}]}], ";", " ", 
  RowBox[{"AustenPairProbabilities", "[", 
   RowBox[{"[", 
    RowBox[{"1", ";;", "20"}], "]"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.7771865837270613`*^9, 3.7771866329318247`*^9}, {
   3.7771866708986397`*^9, 3.777186697369362*^9}, {3.777187639933984*^9, 
   3.777187650609503*^9}, 3.779690788488057*^9, {3.779691000287889*^9, 
   3.77969100067276*^9}, {3.7823099381205053`*^9, 3.782309956748414*^9}, {
   3.7823100167441177`*^9, 3.782310041849584*^9}},
 CellLabel->"In[65]:=",ExpressionUUID->"e9ae3e79-0625-4fb3-ae2c-87299f9367cd"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"\<\"e\"\>", ",", "\<\" \"\>"}], "}"}], ",", 
     "0.03018867924528302`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"\<\"h\"\>", ",", "\<\"e\"\>"}], "}"}], ",", 
     "0.029559748427672956`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"\<\" \"\>", ",", "\<\"t\"\>"}], "}"}], ",", 
     "0.029245283018867925`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"\<\"s\"\>", ",", "\<\" \"\>"}], "}"}], ",", 
     "0.019182389937106917`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"\<\"t\"\>", ",", "\<\"h\"\>"}], "}"}], ",", 
     "0.018553459119496855`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"\<\" \"\>", ",", "\<\"a\"\>"}], "}"}], ",", 
     "0.016981132075471698`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"\<\",\"\>", ",", "\<\" \"\>"}], "}"}], ",", 
     "0.016037735849056604`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"\<\"d\"\>", ",", "\<\" \"\>"}], "}"}], ",", 
     "0.015723270440251572`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"\<\"e\"\>", ",", "\<\"n\"\>"}], "}"}], ",", 
     "0.014779874213836478`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"\<\"i\"\>", ",", "\<\"n\"\>"}], "}"}], ",", 
     "0.014465408805031447`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"\<\"r\"\>", ",", "\<\" \"\>"}], "}"}], ",", 
     "0.014150943396226415`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"\<\"e\"\>", ",", "\<\"r\"\>"}], "}"}], ",", 
     "0.014150943396226415`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"\<\"t\"\>", ",", "\<\" \"\>"}], "}"}], ",", 
     "0.013836477987421384`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"\<\"o\"\>", ",", "\<\" \"\>"}], "}"}], ",", 
     "0.013522012578616353`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"\<\" \"\>", ",", "\<\"w\"\>"}], "}"}], ",", 
     "0.01289308176100629`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"\<\" \"\>", ",", "\<\"h\"\>"}], "}"}], ",", 
     "0.01289308176100629`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"\<\" \"\>", ",", "\<\"s\"\>"}], "}"}], ",", 
     "0.011949685534591196`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"\<\"h\"\>", ",", "\<\"i\"\>"}], "}"}], ",", 
     "0.011635220125786163`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"\<\" \"\>", ",", "\<\"o\"\>"}], "}"}], ",", 
     "0.011635220125786163`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"\<\"t\"\>", ",", "\<\"o\"\>"}], "}"}], ",", 
     "0.011320754716981131`"}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{{3.782310031121196*^9, 3.782310042160389*^9}, 
   3.782315763870125*^9, 3.782458030694709*^9, 3.782464385194501*^9, 
   3.782464441418466*^9},
 CellLabel->"Out[65]=",ExpressionUUID->"cbd5ffd4-a49b-411b-b3bc-a409d5d2efd1"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"AustenPairCode", "=", 
   RowBox[{
    RowBox[{"HuffmanCode", "[", 
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{"#", "[", 
         RowBox[{"[", "2", "]"}], "]"}], "&"}], "/@", 
       "AustenPairProbabilities"}], ",", 
      RowBox[{
       RowBox[{
        RowBox[{"#", "[", 
         RowBox[{"[", "1", "]"}], "]"}], "&"}], "/@", 
       "AustenPairProbabilities"}]}], "]"}], "//", "Sort"}]}], ";", " ", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"AustenPairCode", "[", 
     RowBox[{"[", 
      RowBox[{"1", ";;", "20"}], "]"}], "]"}], ",", 
    RowBox[{"AustenPairCode", "[", 
     RowBox[{"[", 
      RowBox[{"320", ";;"}], "]"}], "]"}]}], "}"}]}]], "Input",
 CellChangeTimes->{{3.777186701546236*^9, 3.777186705873397*^9}, {
  3.7771876331898947`*^9, 3.777187633973756*^9}, {3.779690803700303*^9, 
  3.7796908098748827`*^9}, {3.779690923552145*^9, 3.779691019041192*^9}, {
  3.782309990060513*^9, 3.782310011088215*^9}, {3.7823100466952667`*^9, 
  3.7823100504718018`*^9}, {3.782321403080863*^9, 3.782321452542618*^9}},
 CellLabel->"In[66]:=",ExpressionUUID->"593f78c7-6509-4558-9504-0706a8f7df73"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"\[LeftAssociation]", 
    RowBox[{
     RowBox[{
      RowBox[{"{", 
       RowBox[{"\<\" \"\>", ",", "\<\"t\"\>"}], "}"}], "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"0", ",", "1", ",", "1", ",", "0", ",", "0"}], "}"}]}], ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"\<\"h\"\>", ",", "\<\"e\"\>"}], "}"}], "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"0", ",", "1", ",", "1", ",", "1", ",", "0"}], "}"}]}], ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"\<\"e\"\>", ",", "\<\" \"\>"}], "}"}], "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"1", ",", "0", ",", "0", ",", "0", ",", "0"}], "}"}]}], ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"\<\"t\"\>", ",", "\<\"o\"\>"}], "}"}], "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], 
       "}"}]}], ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"\<\" \"\>", ",", "\<\"o\"\>"}], "}"}], "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0"}], 
       "}"}]}], ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"\<\"h\"\>", ",", "\<\"i\"\>"}], "}"}], "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1"}], 
       "}"}]}], ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"\<\" \"\>", ",", "\<\"s\"\>"}], "}"}], "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0"}], 
       "}"}]}], ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"\<\" \"\>", ",", "\<\"h\"\>"}], "}"}], "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "1"}], 
       "}"}]}], ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"\<\" \"\>", ",", "\<\"w\"\>"}], "}"}], "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0"}], 
       "}"}]}], ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"\<\"o\"\>", ",", "\<\" \"\>"}], "}"}], "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0"}], 
       "}"}]}], ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"\<\"t\"\>", ",", "\<\" \"\>"}], "}"}], "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "0"}], 
       "}"}]}], ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"\<\"e\"\>", ",", "\<\"r\"\>"}], "}"}], "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1"}], 
       "}"}]}], ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"\<\"r\"\>", ",", "\<\" \"\>"}], "}"}], "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"0", ",", "1", ",", "0", ",", "1", ",", "0", ",", "0"}], 
       "}"}]}], ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"\<\"i\"\>", ",", "\<\"n\"\>"}], "}"}], "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "0"}], 
       "}"}]}], ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"\<\"e\"\>", ",", "\<\"n\"\>"}], "}"}], "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "1"}], 
       "}"}]}], ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"\<\"d\"\>", ",", "\<\" \"\>"}], "}"}], "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0"}], 
       "}"}]}], ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"\<\",\"\>", ",", "\<\" \"\>"}], "}"}], "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"1", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0"}], 
       "}"}]}], ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"\<\" \"\>", ",", "\<\"a\"\>"}], "}"}], "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"1", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0"}], 
       "}"}]}], ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"\<\"t\"\>", ",", "\<\"h\"\>"}], "}"}], "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0"}], 
       "}"}]}], ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"\<\"s\"\>", ",", "\<\" \"\>"}], "}"}], "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"1", ",", "1", ",", "0", ",", "1", ",", "0", ",", "0"}], 
       "}"}]}]}], "\[RightAssociation]"}], ",", 
   RowBox[{"\[LeftAssociation]", 
    RowBox[{
     RowBox[{
      RowBox[{"{", 
       RowBox[{"\<\"n\"\>", ",", "\<\"y\"\>"}], "}"}], "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
       "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
        "0", ",", "1", ",", "1", ",", "1", ",", "1"}], "}"}]}], ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"\<\"o\"\>", ",", "\<\"v\"\>"}], "}"}], "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
       "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
        "1", ",", "0", ",", "0", ",", "0", ",", "0"}], "}"}]}], ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"\<\"p\"\>", ",", "\<\"h\"\>"}], "}"}], "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
       "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
        "1", ",", "0", ",", "0", ",", "0", ",", "1"}], "}"}]}], ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"\<\"r\"\>", ",", "\<\"k\"\>"}], "}"}], "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
       "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
        "1", ",", "0", ",", "0", ",", "1", ",", "0"}], "}"}]}], ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"\<\"r\"\>", ",", "\<\"r\"\>"}], "}"}], "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
       "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
        "1", ",", "0", ",", "0", ",", "1", ",", "1"}], "}"}]}], ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"\<\"r\"\>", ",", "\<\"u\"\>"}], "}"}], "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
       "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
        "1", ",", "0", ",", "1", ",", "0", ",", "0"}], "}"}]}], ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"\<\"R\"\>", ",", "\<\"u\"\>"}], "}"}], "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
       "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
        "1", ",", "0", ",", "1", ",", "0", ",", "1"}], "}"}]}], ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"\<\"t\"\>", ",", "\<\".\"\>"}], "}"}], "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
       "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
        "1", ",", "0", ",", "1", ",", "1", ",", "0"}], "}"}]}], ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"\<\"t\"\>", ",", "\<\"g\"\>"}], "}"}], "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
       "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
        "1", ",", "0", ",", "1", ",", "1", ",", "1"}], "}"}]}]}], 
    "\[RightAssociation]"}]}], "}"}]], "Output",
 CellChangeTimes->{{3.7823214278472*^9, 3.782321452956244*^9}, 
   3.782458030829317*^9, 3.782464385509138*^9, 3.7824644415513897`*^9},
 CellLabel->"Out[66]=",ExpressionUUID->"d9901ce5-87e2-43c7-9345-303e4f8e8ad9"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"AustenHuffmanPairEncoded", "=", 
  RowBox[{"Join", "@@", 
   RowBox[{"AustenPairCode", "/@", 
    RowBox[{"Partition", "[", 
     RowBox[{
      RowBox[{"Characters", "[", "Austen", "]"}], ",", "2"}], 
     "]"}]}]}]}]], "Input",
 CellChangeTimes->{{3.7771880589631147`*^9, 3.777188115281012*^9}, {
  3.77969102811954*^9, 3.779691029335285*^9}, {3.7796914201229057`*^9, 
  3.7796914561279984`*^9}, {3.782310062335596*^9, 3.782310070638425*^9}},
 CellLabel->"In[67]:=",ExpressionUUID->"9f5ab251-c876-41fc-b966-a6e09fd02a86"],

Cell[BoxData[
 InterpretationBox[
  TagBox[
   FrameBox[GridBox[{
      {
       ItemBox[
        TagBox[
         RowBox[{"{", 
          RowBox[{
          "1", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", 
           ",", "1", ",", "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", 
           "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", "0", 
           ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
           "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", 
           ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
           "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", 
           ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
           "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", 
           ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
           "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", "0", 
           ",", "1", ",", "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", 
           "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", 
           ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
           "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", "1", 
           ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
           "1", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", 
           ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
           "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", 
           ",", "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", 
           TemplateBox[{"23461"},
            "OutputSizeLimit`Skeleton"], ",", "1", ",", "1", ",", "0", ",", 
           "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", 
           ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", 
           "1", ",", "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", "0", 
           ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "0", ",", 
           "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "0", 
           ",", "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
           "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", 
           ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
           "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", 
           ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
           "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", 
           ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "0", ",", 
           "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "1", 
           ",", "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
           "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", 
           ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", 
           "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", 
           ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
           "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "0", 
           ",", "1", ",", "0"}], "}"}],
         Short[#, 5]& ],
        BaseStyle->{Deployed -> False},
        StripOnInput->False]},
      {GridBox[{
         {
          TagBox[
           TooltipBox[
            StyleBox[
             StyleBox[
              DynamicBox[ToBoxes[
                FEPrivate`FrontEndResource[
                "FEStrings", "sizeBriefExplanation"], StandardForm],
               ImageSizeCache->{58., {2., 8.}}],
              StripOnInput->False,
              DynamicUpdating->True], "OSLText",
             StripOnInput->False],
            StyleBox[
             DynamicBox[
              ToBoxes[
               FEPrivate`FrontEndResource["FEStrings", "sizeExplanation"], 
               StandardForm]], DynamicUpdating -> True, StripOnInput -> 
             False]],
           Annotation[#, 
            Style[
             Dynamic[
              FEPrivate`FrontEndResource["FEStrings", "sizeExplanation"]], 
             DynamicUpdating -> True], "Tooltip"]& ], 
          ButtonBox[
           PaneSelectorBox[{False->
            StyleBox[
             StyleBox[
              DynamicBox[ToBoxes[
                FEPrivate`FrontEndResource["FEStrings", "sizeShowLess"], 
                StandardForm],
               ImageSizeCache->{50., {0., 8.}}],
              StripOnInput->False,
              DynamicUpdating->True], "OSLControl",
             StripOnInput->False], True->
            StyleBox[
             StyleBox[
              DynamicBox[ToBoxes[
                FEPrivate`FrontEndResource["FEStrings", "sizeShowLess"], 
                StandardForm]],
              StripOnInput->False,
              DynamicUpdating->True], "OSLControlActive",
             StripOnInput->False]}, Dynamic[
             CurrentValue["MouseOver"]],
            Alignment->Center,
            FrameMargins->0,
            ImageSize->{Automatic, 25}],
           Appearance->None,
           BaselinePosition->Baseline,
           
           ButtonFunction:>OutputSizeLimit`ButtonFunction[
            OutputSizeLimit`Defer, 67, 28838447223223352045, 5/2],
           Enabled->True,
           Evaluator->Automatic,
           Method->"Queued"], 
          ButtonBox[
           PaneSelectorBox[{False->
            StyleBox[
             StyleBox[
              DynamicBox[ToBoxes[
                FEPrivate`FrontEndResource["FEStrings", "sizeShowMore"], 
                StandardForm],
               ImageSizeCache->{56., {0., 8.}}],
              StripOnInput->False,
              DynamicUpdating->True], "OSLControl",
             StripOnInput->False], True->
            StyleBox[
             StyleBox[
              DynamicBox[ToBoxes[
                FEPrivate`FrontEndResource["FEStrings", "sizeShowMore"], 
                StandardForm]],
              StripOnInput->False,
              DynamicUpdating->True], "OSLControlActive",
             StripOnInput->False]}, Dynamic[
             CurrentValue["MouseOver"]],
            Alignment->Center,
            FrameMargins->0,
            ImageSize->{Automatic, 25}],
           Appearance->None,
           BaselinePosition->Baseline,
           
           ButtonFunction:>OutputSizeLimit`ButtonFunction[
            OutputSizeLimit`Defer, 67, 28838447223223352045, 5 2],
           Enabled->True,
           Evaluator->Automatic,
           Method->"Queued"], 
          ButtonBox[
           PaneSelectorBox[{False->
            StyleBox[
             StyleBox[
              DynamicBox[ToBoxes[
                FEPrivate`FrontEndResource["FEStrings", "sizeShowAll"], 
                StandardForm],
               ImageSizeCache->{42., {0., 8.}}],
              StripOnInput->False,
              DynamicUpdating->True], "OSLControl",
             StripOnInput->False], True->
            StyleBox[
             StyleBox[
              DynamicBox[ToBoxes[
                FEPrivate`FrontEndResource["FEStrings", "sizeShowAll"], 
                StandardForm]],
              StripOnInput->False,
              DynamicUpdating->True], "OSLControlActive",
             StripOnInput->False]}, Dynamic[
             CurrentValue["MouseOver"]],
            Alignment->Center,
            FrameMargins->0,
            ImageSize->{Automatic, 25}],
           Appearance->None,
           BaselinePosition->Baseline,
           
           ButtonFunction:>OutputSizeLimit`ButtonFunction[
            OutputSizeLimit`Defer, 67, 28838447223223352045, Infinity],
           Enabled->True,
           Evaluator->Automatic,
           Method->"Queued"], 
          ButtonBox[
           PaneSelectorBox[{False->
            StyleBox[
             StyleBox[
              DynamicBox[ToBoxes[
                FEPrivate`FrontEndResource["FEStrings", "sizeChangeLimit"], 
                StandardForm],
               ImageSizeCache->{74., {0., 8.}}],
              StripOnInput->False,
              DynamicUpdating->True], "OSLControl",
             StripOnInput->False], True->
            StyleBox[
             StyleBox[
              DynamicBox[ToBoxes[
                FEPrivate`FrontEndResource["FEStrings", "sizeChangeLimit"], 
                StandardForm]],
              StripOnInput->False,
              DynamicUpdating->True], "OSLControlActive",
             StripOnInput->False]}, Dynamic[
             CurrentValue["MouseOver"]],
            Alignment->Center,
            FrameMargins->0,
            ImageSize->{Automatic, 25}],
           Appearance->None,
           BaselinePosition->Baseline,
           ButtonFunction:>FrontEndExecute[{
              FrontEnd`SetOptions[
              FrontEnd`$FrontEnd, 
               FrontEnd`PreferencesSettings -> {"Page" -> "Advanced"}], 
              FrontEnd`FrontEndToken["PreferencesDialog"]}],
           Evaluator->None,
           Method->"Preemptive"]}
        },
        AutoDelete->False,
        FrameStyle->GrayLevel[0.85],
        GridBoxDividers->{"Columns" -> {False, {True}}},
        GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
        GridBoxSpacings->{"Columns" -> {{2}}}]}
     },
     DefaultBaseStyle->"Column",
     GridBoxAlignment->{
      "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
       "RowsIndexed" -> {}},
     GridBoxDividers->{
      "Columns" -> {{False}}, "ColumnsIndexed" -> {}, "Rows" -> {{False}}, 
       "RowsIndexed" -> {}},
     GridBoxItemSize->{
      "Columns" -> {{Automatic}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.5599999999999999]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], 
         Offset[1.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    BaseStyle->"OutputSizeLimit",
    FrameMargins->{{12, 12}, {0, 15}},
    FrameStyle->GrayLevel[0.85],
    RoundingRadius->5,
    StripOnInput->False],
   Deploy,
   DefaultBaseStyle->"Deploy"],
  If[28838447223223352045 === $SessionID, 
   Out[67], Message[
     MessageName[Syntax, "noinfoker"]]; Missing["NotAvailable"]; 
   Null]]], "Output",
 CellChangeTimes->{
  3.779691456440297*^9, 3.780157593339896*^9, 3.780215626852742*^9, 
   3.780230187078906*^9, {3.7802302897019157`*^9, 3.780230313838888*^9}, 
   3.780230343958465*^9, 3.780230702366951*^9, 3.7804142980161753`*^9, 
   3.780582015535964*^9, 3.780894788472444*^9, 3.781245309812765*^9, 
   3.781249655667123*^9, 3.781448055051258*^9, 3.781538132583027*^9, 
   3.781539247673265*^9, 3.78230867045747*^9, 3.78230958117309*^9, 
   3.782310072255516*^9, 3.782315764269538*^9, 3.782458031056789*^9, 
   3.7824643859328423`*^9, 3.7824644417085752`*^9},
 CellLabel->"Out[67]=",ExpressionUUID->"0ede1a63-976e-403a-a6bc-5dd4aed8ea9b"]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
Encoding by pairs uses 3.730 bits per character, an improvement on the 4.302 \
used by the Huffman code on single characters. This is expected given the \
asymptotic nature of Shannon\[CloseCurlyQuote]s Source Coding Theorem \
(Theorem 4.7). Data below used for table.\
\>", "Subsubsection",
 CellChangeTimes->{{3.778412921176352*^9, 3.778412936591576*^9}, {
  3.782312720207367*^9, 3.782312785552511*^9}, {3.7823161888216248`*^9, 
  3.782316197600458*^9}},ExpressionUUID->"e789133b-1954-4cfc-ba20-\
bf2b14a1a931"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{
    RowBox[{"H", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"#", "[", 
        RowBox[{"[", "2", "]"}], "]"}], "&"}], "/@", "AustenProbabilities"}], 
     "]"}], "//", "N"}], ",", 
   RowBox[{"H", "[", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"#", "[", 
        RowBox[{"[", "2", "]"}], "]"}], "&"}], "/@", 
      "AustenPairProbabilities"}], "//", "N"}], "]"}], ",", 
   "\[IndentingNewLine]", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"Length", "[", "AustenASCIIEncoded", "]"}], ",", 
     RowBox[{
      RowBox[{"Length", "[", "AustenASCIIEncoded", "]"}], "/", 
      RowBox[{"StringLength", "[", "Austen", "]"}]}]}], "}"}], ",", 
   "\[IndentingNewLine]", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"Length", "[", "AustenShannonEncoded", "]"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{
       RowBox[{"Length", "[", "AustenShannonEncoded", "]"}], "/", 
       RowBox[{"StringLength", "[", "Austen", "]"}]}], "//", "N"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"ShannonExpectedLength", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"#", "[", 
         RowBox[{"[", "2", "]"}], "]"}], "&"}], "/@", "AustenProbabilities"}],
       "]"}]}], "}"}], ",", "\[IndentingNewLine]", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"Length", "[", "AustenHuffmanEncoded", "]"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{
       RowBox[{"Length", "[", "AustenHuffmanEncoded", "]"}], "/", 
       RowBox[{"StringLength", "[", "Austen", "]"}]}], "//", "N"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"HuffmanExpectedLength", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"#", "[", 
         RowBox[{"[", "2", "]"}], "]"}], "&"}], "/@", "AustenProbabilities"}],
       "]"}]}], "}"}], ",", "\[IndentingNewLine]", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"Length", "[", "AustenHuffmanPairEncoded", "]"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{
       RowBox[{"Length", "[", "AustenHuffmanPairEncoded", "]"}], "/", 
       RowBox[{"StringLength", "[", "Austen", "]"}]}], "//", "N"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"HuffmanExpectedLength", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"#", "[", 
          RowBox[{"[", "2", "]"}], "]"}], "&"}], "/@", 
        "AustenPairProbabilities"}], "]"}], "/", "2"}]}], "}"}]}], 
  "}"}]], "Input",
 CellChangeTimes->{{3.782312376741485*^9, 3.7823123886227207`*^9}, {
  3.7823124304452477`*^9, 3.782312447936468*^9}, {3.782314925911182*^9, 
  3.782314950965357*^9}, {3.782315252435109*^9, 3.7823152764766808`*^9}, {
  3.7823160502811327`*^9, 3.782316070401855*^9}, {3.7823161139453707`*^9, 
  3.7823162432247047`*^9}, {3.782316293059564*^9, 3.782316308831382*^9}, {
  3.782316485632015*^9, 3.7823164919718933`*^9}, {3.7824643358504143`*^9, 
  3.782464336367734*^9}, {3.782464564012884*^9, 3.7824645710880938`*^9}},
 CellLabel->
  "In[120]:=",ExpressionUUID->"a20a5b18-1a03-41d7-99b5-06ce875b8d4b"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"4.267443907665111`", ",", "7.43471010325961`", ",", 
   RowBox[{"{", 
    RowBox[{"50880", ",", "8"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"30478", ",", "4.792138364779874`", ",", "4.792138364779878`"}], 
    "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"27358", ",", "4.301572327044025`", ",", "4.3015723270440285`"}], 
    "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"23720", ",", "3.729559748427673`", ",", "3.7295597484276963`"}], 
    "}"}]}], "}"}]], "Output",
 CellChangeTimes->{3.782464571667707*^9},
 CellLabel->
  "Out[120]=",ExpressionUUID->"a51eef86-1525-459e-a287-b2b3ec65c2d8"]
}, Open  ]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Final part of Example 5.11: subword frequencies", "Subsection",
 CellChangeTimes->{{3.782312693516883*^9, 
  3.782312699117948*^9}},ExpressionUUID->"0b860d49-f4dc-42f3-901c-\
4fbc83e19d86"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"Table", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"m", ",", 
      RowBox[{"SubwordFrequencies", "[", 
       RowBox[{"AustenASCIIEncoded", ",", "m"}], "]"}]}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"m", ",", "1", ",", "6"}], "}"}]}], "]"}], "//", "TF"}]], "Input",\

 CellChangeTimes->{{3.782312541527269*^9, 3.7823125453019533`*^9}},
 CellLabel->"In[69]:=",ExpressionUUID->"26d26d2d-ca62-4fa2-befb-ae8d0f7d27e9"],

Cell[BoxData[
 TagBox[GridBox[{
    {"1", 
     RowBox[{"{", 
      RowBox[{"27850", ",", "23030"}], "}"}]},
    {"2", 
     RowBox[{"{", 
      RowBox[{"15017", ",", "12832", ",", "12832", ",", "10198"}], "}"}]},
    {"3", 
     RowBox[{"{", 
      RowBox[{
      "8076", ",", "6941", ",", "5708", ",", "7124", ",", "6941", ",", "5890",
        ",", "7124", ",", "3074"}], "}"}]},
    {"4", 
     RowBox[{"{", 
      RowBox[{
      "4675", ",", "3401", ",", "3429", ",", "3512", ",", "3290", ",", "2418",
        ",", "4556", ",", "2568", ",", "3401", ",", "3540", ",", "2278", ",", 
       "3612", ",", "3651", ",", "3472", ",", "2568", ",", "506"}], "}"}]},
    {"5", 
     RowBox[{"{", 
      RowBox[{
      "2398", ",", "2277", ",", "1189", ",", "2212", ",", "1872", ",", "1557",
        ",", "2682", ",", "830", ",", "2304", ",", "986", ",", "888", ",", 
       "1530", ",", "2334", ",", "2222", ",", "2070", ",", "498", ",", "2277",
        ",", "1124", ",", "2240", ",", "1300", ",", "1418", ",", "860", ",", 
       "1874", ",", "1738", ",", "1097", ",", "2554", ",", "1390", ",", 
       "2082", ",", "1317", ",", "1250", ",", "498", ",", "8"}], "}"}]},
    {"6", 
     RowBox[{"{", 
      RowBox[{
      "1154", ",", "1244", ",", "852", ",", "1425", ",", "746", ",", "443", 
       ",", "1658", ",", "554", ",", "1494", ",", "378", ",", "745", ",", 
       "812", ",", "1384", ",", "1298", ",", "766", ",", "64", ",", "1729", 
       ",", "575", ",", "660", ",", "326", ",", "264", ",", "624", ",", "902",
        ",", "628", ",", "902", ",", "1432", ",", "792", ",", "1430", ",", 
       "1137", ",", "932", ",", "494", ",", "4", ",", "1244", ",", "1033", 
       ",", "337", ",", "787", ",", "1126", ",", "1114", ",", "1024", ",", 
       "276", ",", "810", ",", "608", ",", "142", ",", "718", ",", "950", ",",
        "924", ",", "1304", ",", "434", ",", "548", ",", "549", ",", "1580", 
       ",", "974", ",", "1154", ",", "236", ",", "972", ",", "1110", ",", 
       "195", ",", "1122", ",", "598", ",", "652", ",", "180", ",", "318", 
       ",", "4", ",", "4"}], "}"}]}
   },
   GridBoxAlignment->{
    "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
     "RowsIndexed" -> {}},
   GridBoxSpacings->{"Columns" -> {
       Offset[0.27999999999999997`], {
        Offset[2.0999999999999996`]}, 
       Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
       Offset[0.2], {
        Offset[0.4]}, 
       Offset[0.2]}, "RowsIndexed" -> {}}],
  Function[BoxForm`e$, 
   TableForm[BoxForm`e$, TableDepth -> 2]]]], "Output",
 CellChangeTimes->{3.782317553858198*^9, 3.7824580319577827`*^9, 
  3.782464387615314*^9, 3.782464442177167*^9},
 CellLabel->
  "Out[69]//TableForm=",ExpressionUUID->"8ed00638-8ece-4a0d-85a2-\
5c5e5564e68a"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"Table", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"m", ",", 
      RowBox[{"SubwordFrequencies", "[", 
       RowBox[{"AustenShannonEncoded", ",", "m"}], "]"}]}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"m", ",", "1", ",", "6"}], "}"}]}], "]"}], "//", "TF"}]], "Input",\

 CellChangeTimes->{{3.7823175602189617`*^9, 3.7823175629471083`*^9}},
 CellLabel->"In[70]:=",ExpressionUUID->"73752c60-b4b2-49c7-a64f-345633781f13"],

Cell[BoxData[
 TagBox[GridBox[{
    {"1", 
     RowBox[{"{", 
      RowBox[{"15858", ",", "14620"}], "}"}]},
    {"2", 
     RowBox[{"{", 
      RowBox[{"7927", ",", "7931", ",", "7931", ",", "6688"}], "}"}]},
    {"3", 
     RowBox[{"{", 
      RowBox[{
      "3973", ",", "3954", ",", "4736", ",", "3195", ",", "3954", ",", "3977",
        ",", "3195", ",", "3492"}], "}"}]},
    {"4", 
     RowBox[{"{", 
      RowBox[{
      "1737", ",", "2236", ",", "2357", ",", "1597", ",", "2448", ",", "2288",
        ",", "1356", ",", "1839", ",", "2236", ",", "1718", ",", "2379", ",", 
       "1598", ",", "1506", ",", "1689", ",", "1839", ",", "1652"}], "}"}]},
    {"5", 
     RowBox[{"{", 
      RowBox[{
      "770", ",", "967", ",", "1177", ",", "1059", ",", "1227", ",", "1130", 
       ",", "784", ",", "813", ",", "1502", ",", "946", ",", "1452", ",", 
       "836", ",", "396", ",", "960", ",", "865", ",", "973", ",", "967", ",",
        "1269", ",", "1180", ",", "538", ",", "1221", ",", "1158", ",", "572",
        ",", "1026", ",", "734", ",", "772", ",", "927", ",", "762", ",", 
       "1110", ",", "729", ",", "974", ",", "678"}], "}"}]},
    {"6", 
     RowBox[{"{", 
      RowBox[{
      "216", ",", "554", ",", "629", ",", "338", ",", "587", ",", "590", ",", 
       "426", ",", "633", ",", "713", ",", "514", ",", "674", ",", "456", ",",
        "186", ",", "598", ",", "278", ",", "535", ",", "732", ",", "770", 
       ",", "610", ",", "336", ",", "730", ",", "722", ",", "356", ",", "480",
        ",", "198", ",", "198", ",", "500", ",", "460", ",", "478", ",", 
       "387", ",", "596", ",", "377", ",", "554", ",", "413", ",", "548", ",",
        "721", ",", "640", ",", "540", ",", "358", ",", "180", ",", "789", 
       ",", "432", ",", "778", ",", "380", ",", "210", ",", "362", ",", "587",
        ",", "438", ",", "235", ",", "499", ",", "570", ",", "202", ",", 
       "491", ",", "436", ",", "216", ",", "546", ",", "536", ",", "574", ",",
        "427", ",", "302", ",", "632", ",", "342", ",", "378", ",", "300"}], 
      "}"}]}
   },
   GridBoxAlignment->{
    "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
     "RowsIndexed" -> {}},
   GridBoxSpacings->{"Columns" -> {
       Offset[0.27999999999999997`], {
        Offset[2.0999999999999996`]}, 
       Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
       Offset[0.2], {
        Offset[0.4]}, 
       Offset[0.2]}, "RowsIndexed" -> {}}],
  Function[BoxForm`e$, 
   TableForm[BoxForm`e$, TableDepth -> 2]]]], "Output",
 CellChangeTimes->{3.7823175649530973`*^9, 3.782458032418853*^9, 
  3.78246438788955*^9, 3.7824644425082703`*^9},
 CellLabel->
  "Out[70]//TableForm=",ExpressionUUID->"97749f03-cd8d-48db-8bc4-\
45e823b0c2a4"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"Table", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"m", ",", 
      RowBox[{"SubwordFrequencies", "[", 
       RowBox[{"AustenHuffmanEncoded", ",", "m"}], "]"}]}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"m", ",", "1", ",", "6"}], "}"}]}], "]"}], "//", "TF"}]], "Input",\

 CellChangeTimes->{{3.782312525587658*^9, 3.782312526470319*^9}, 
   3.782317538279752*^9},
 CellLabel->"In[71]:=",ExpressionUUID->"dd27cb1c-cca5-43f4-ac02-e503f89a68b0"],

Cell[BoxData[
 TagBox[GridBox[{
    {"1", 
     RowBox[{"{", 
      RowBox[{"12518", ",", "14840"}], "}"}]},
    {"2", 
     RowBox[{"{", 
      RowBox[{"5654", ",", "6864", ",", "6863", ",", "7976"}], "}"}]},
    {"3", 
     RowBox[{"{", 
      RowBox[{
      "2602", ",", "3052", ",", "3458", ",", "3405", ",", "3051", ",", "3812",
        ",", "3405", ",", "4571"}], "}"}]},
    {"4", 
     RowBox[{"{", 
      RowBox[{
      "1202", ",", "1400", ",", "1430", ",", "1621", ",", "1392", ",", "2066",
        ",", "1462", ",", "1943", ",", "1400", ",", "1651", ",", "2028", ",", 
       "1784", ",", "1659", ",", "1746", ",", "1943", ",", "2628"}], "}"}]},
    {"5", 
     RowBox[{"{", 
      RowBox[{
      "540", ",", "662", ",", "680", ",", "720", ",", "524", ",", "906", ",", 
       "616", ",", "1005", ",", "624", ",", "768", ",", "1048", ",", "1018", 
       ",", "792", ",", "670", ",", "868", ",", "1075", ",", "662", ",", 
       "738", ",", "750", ",", "900", ",", "868", ",", "1160", ",", "846", 
       ",", "938", ",", "776", ",", "883", ",", "980", ",", "766", ",", "867",
        ",", "1076", ",", "1075", ",", "1553"}], "}"}]},
    {"6", 
     RowBox[{"{", 
      RowBox[{
      "190", ",", "350", ",", "242", ",", "420", ",", "222", ",", "458", ",", 
       "252", ",", "468", ",", "244", ",", "280", ",", "566", ",", "340", ",",
        "342", ",", "274", ",", "436", ",", "569", ",", "328", ",", "296", 
       ",", "416", ",", "352", ",", "486", ",", "562", ",", "464", ",", "554",
        ",", "382", ",", "410", ",", "440", ",", "230", ",", "450", ",", 
       "418", ",", "344", ",", "731", ",", "350", ",", "312", ",", "438", ",",
        "300", ",", "302", ",", "448", ",", "364", ",", "536", ",", "380", 
       ",", "488", ",", "482", ",", "678", ",", "450", ",", "396", ",", "432",
        ",", "506", ",", "334", ",", "442", ",", "334", ",", "548", ",", 
       "382", ",", "598", ",", "382", ",", "384", ",", "394", ",", "473", ",",
        "540", ",", "536", ",", "417", ",", "658", ",", "731", ",", "822"}], 
      "}"}]}
   },
   GridBoxAlignment->{
    "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
     "RowsIndexed" -> {}},
   GridBoxSpacings->{"Columns" -> {
       Offset[0.27999999999999997`], {
        Offset[2.0999999999999996`]}, 
       Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
       Offset[0.2], {
        Offset[0.4]}, 
       Offset[0.2]}, "RowsIndexed" -> {}}],
  Function[BoxForm`e$, 
   TableForm[BoxForm`e$, TableDepth -> 2]]]], "Output",
 CellChangeTimes->{3.7823175700288973`*^9, 3.782458032671773*^9, 
  3.7824643881512957`*^9, 3.7824644427816467`*^9},
 CellLabel->
  "Out[71]//TableForm=",ExpressionUUID->"6540ccf0-601b-474c-b73b-\
fb7484ce593e"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"Table", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"m", ",", 
      RowBox[{"SubwordFrequencies", "[", 
       RowBox[{"AustenHuffmanPairEncoded", ",", "m"}], "]"}]}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"m", ",", "1", ",", "6"}], "}"}]}], "]"}], "//", "TF"}]], "Input",\

 CellChangeTimes->{{3.7812490369333763`*^9, 3.781249089508657*^9}, {
  3.782310095808251*^9, 3.782310096217312*^9}, {3.782317572675852*^9, 
  3.7823175742633963`*^9}},
 CellLabel->"In[72]:=",ExpressionUUID->"e0b845cb-1c5c-4098-a167-18e7dd0325cb"],

Cell[BoxData[
 TagBox[GridBox[{
    {"1", 
     RowBox[{"{", 
      RowBox[{"11355", ",", "12365"}], "}"}]},
    {"2", 
     RowBox[{"{", 
      RowBox[{"5444", ",", "5910", ",", "5911", ",", "6454"}], "}"}]},
    {"3", 
     RowBox[{"{", 
      RowBox[{
      "2620", ",", "2824", ",", "2813", ",", "3097", ",", "2824", ",", "3086",
        ",", "3098", ",", "3356"}], "}"}]},
    {"4", 
     RowBox[{"{", 
      RowBox[{
      "1233", ",", "1387", ",", "1342", ",", "1482", ",", "1296", ",", "1516",
        ",", "1486", ",", "1611", ",", "1387", ",", "1437", ",", "1471", ",", 
       "1615", ",", "1528", ",", "1570", ",", "1612", ",", "1744"}], "}"}]},
    {"5", 
     RowBox[{"{", 
      RowBox[{
      "595", ",", "638", ",", "638", ",", "749", ",", "604", ",", "738", ",", 
       "687", ",", "795", ",", "604", ",", "692", ",", "723", ",", "793", ",",
        "745", ",", "741", ",", "791", ",", "820", ",", "638", ",", "749", 
       ",", "704", ",", "733", ",", "692", ",", "778", ",", "799", ",", "816",
        ",", "783", ",", "745", ",", "748", ",", "822", ",", "783", ",", 
       "829", ",", "821", ",", "923"}], "}"}]},
    {"6", 
     RowBox[{"{", 
      RowBox[{
      "313", ",", "282", ",", "323", ",", "315", ",", "278", ",", "360", ",", 
       "338", ",", "411", ",", "332", ",", "272", ",", "331", ",", "407", ",",
        "365", ",", "322", ",", "414", ",", "381", ",", "289", ",", "315", 
       ",", "338", ",", "354", ",", "352", ",", "371", ",", "401", ",", "392",
        ",", "409", ",", "336", ",", "355", ",", "386", ",", "391", ",", 
       "400", ",", "374", ",", "446", ",", "282", ",", "356", ",", "315", ",",
        "434", ",", "326", ",", "378", ",", "349", ",", "384", ",", "272", 
       ",", "420", ",", "392", ",", "386", ",", "380", ",", "419", ",", "377",
        ",", "439", ",", "349", ",", "434", ",", "366", ",", "379", ",", 
       "340", ",", "407", ",", "398", ",", "424", ",", "374", ",", "409", ",",
        "393", ",", "436", ",", "392", ",", "429", ",", "446", ",", "477"}], 
      "}"}]}
   },
   GridBoxAlignment->{
    "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
     "RowsIndexed" -> {}},
   GridBoxSpacings->{"Columns" -> {
       Offset[0.27999999999999997`], {
        Offset[2.0999999999999996`]}, 
       Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
       Offset[0.2], {
        Offset[0.4]}, 
       Offset[0.2]}, "RowsIndexed" -> {}}],
  Function[BoxForm`e$, 
   TableForm[BoxForm`e$, TableDepth -> 2]]]], "Output",
 CellChangeTimes->{3.782317575858305*^9, 3.782458032911708*^9, 
  3.7824643884722223`*^9, 3.782464443054109*^9},
 CellLabel->
  "Out[72]//TableForm=",ExpressionUUID->"3896a470-8b72-48ba-bd74-\
68deaeda5a4e"]
}, Open  ]],

Cell[BoxData[{
 RowBox[{
  RowBox[{"subwordsAustenASCIIEncoded", "=", " ", 
   RowBox[{"SubwordFrequencyPairs", "[", 
    RowBox[{"AustenASCIIEncoded", ",", "5"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"lengthAustenASCIIEncoded", "=", 
   RowBox[{"Length", "[", "AustenASCIIEncoded", "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"subwordDistributionAustenASCIIEncoded", "=", 
   RowBox[{
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"#", "[", 
        RowBox[{"[", "1", "]"}], "]"}], ",", 
       RowBox[{
        RowBox[{
         RowBox[{"#", "[", 
          RowBox[{"[", "2", "]"}], "]"}], "/", "lengthAustenASCIIEncoded"}], "//",
         "N"}]}], "}"}], "&"}], "/@", "subwordsAustenASCIIEncoded"}]}], 
  ";"}]}], "Input",
 CellChangeTimes->{{3.782464915594833*^9, 3.782464923510869*^9}, {
  3.7824649725640078`*^9, 3.782464976904455*^9}},
 CellLabel->
  "In[140]:=",ExpressionUUID->"00080832-f465-4080-a4d7-4c713daee180"],

Cell[BoxData[
 RowBox[{
  RowBox[{"subwordsAustenShannonEncoded", " ", "=", " ", 
   RowBox[{"SubwordFrequencyPairs", "[", 
    RowBox[{"AustenShannonEncoded", ",", "5"}], "]"}]}], ";", 
  RowBox[{"lengthAustenShannonEncoded", "=", 
   RowBox[{"Length", "[", "AustenShannonEncoded", "]"}]}], ";", 
  RowBox[{"subwordDistributionAustenShannonEncoded", " ", "=", 
   RowBox[{
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"#", "[", 
        RowBox[{"[", "1", "]"}], "]"}], ",", 
       RowBox[{
        RowBox[{
         RowBox[{"#", "[", 
          RowBox[{"[", "2", "]"}], "]"}], "/", "lengthAustenShannonEncoded"}],
         "//", "N"}]}], "}"}], "&"}], "/@", 
    "subwordsAustenShannonEncoded"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.782464927655188*^9, 3.782464932462419*^9}, {
  3.782464980344119*^9, 3.782464984433279*^9}},
 CellLabel->
  "In[143]:=",ExpressionUUID->"1ef10bf9-8c61-4f4f-bcce-2e66c718913c"],

Cell[BoxData[
 RowBox[{
  RowBox[{"subwordsAustenHuffmanEncoded", "=", 
   RowBox[{"SubwordFrequencyPairs", "[", 
    RowBox[{"AustenHuffmanEncoded", ",", "5"}], "]"}]}], ";", 
  RowBox[{"lengthAustenHuffmanEncoded", "=", 
   RowBox[{"Length", "[", "AustenHuffmanEncoded", "]"}]}], ";", 
  RowBox[{"subwordDistributionAustenHuffmanEncoded", "=", " ", 
   RowBox[{
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"#", "[", 
        RowBox[{"[", "1", "]"}], "]"}], ",", 
       RowBox[{
        RowBox[{
         RowBox[{"#", "[", 
          RowBox[{"[", "2", "]"}], "]"}], "/", "lengthAustenHuffmanEncoded"}],
         "//", "N"}]}], "}"}], "&"}], "/@", 
    "subwordsAustenHuffmanEncoded"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.782464935925706*^9, 3.7824649921461773`*^9}},
 CellLabel->
  "In[144]:=",ExpressionUUID->"660eaa68-05d0-4498-8d7c-c3e55a80ba6e"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"subwordsAustenHuffmanPairEncoded", "=", " ", 
    RowBox[{"SubwordFrequencyPairs", "[", 
     RowBox[{"AustenHuffmanPairEncoded", ",", "5"}], "]"}]}], ";"}], 
  " "}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"lengthAustenHuffmanPairEncoded", "=", " ", 
   RowBox[{"Length", "[", "AustenHuffmanPairEncoded", "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"subwordDistributionAustenHuffmanPairEncoded", " ", "=", " ", 
   RowBox[{
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"#", "[", 
        RowBox[{"[", "1", "]"}], "]"}], ",", 
       RowBox[{
        RowBox[{
         RowBox[{"#", "[", 
          RowBox[{"[", "2", "]"}], "]"}], "/", 
         "lengthAustenHuffmanPairEncoded"}], "//", "N"}]}], "}"}], "&"}], "/@",
     "subwordsAustenHuffmanPairEncoded"}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.782310456309273*^9, 3.7823106216992083`*^9}, {
   3.782311457761278*^9, 3.782311699689824*^9}, {3.782311832954496*^9, 
   3.782311894272608*^9}, {3.782311959571348*^9, 3.782311959928665*^9}, {
   3.782312596034582*^9, 3.782312632023118*^9}, {3.78231758601757*^9, 
   3.7823176223771563`*^9}, {3.78231765715567*^9, 3.782317699471176*^9}, {
   3.782317915704958*^9, 3.782317935988072*^9}, {3.78246463230577*^9, 
   3.782464735208843*^9}, {3.782464878565353*^9, 3.782464886267498*^9}, {
   3.782464947340439*^9, 3.782464964378962*^9}, {3.7824649962468157`*^9, 
   3.782464998371847*^9}, {3.7824651141753807`*^9, 3.782465114972226*^9}, 
   3.7824692547861834`*^9},ExpressionUUID->"b952a643-0840-4d6b-8569-\
9cfcfa054a10"],

Cell[CellGroupData[{

Cell["Demonstration in Lecture 16", "Subsubsection",
 CellChangeTimes->{{3.782469256527493*^9, 
  3.7824692637516623`*^9}},ExpressionUUID->"bdca3593-f3da-4cf1-aff0-\
5a41eb212a75"],

Cell[CellGroupData[{

Cell[BoxData["subwordsAustenASCIIEncoded"], "Input",
 CellChangeTimes->{{3.782464757830533*^9, 3.782464764371176*^9}},
 CellLabel->
  "In[176]:=",ExpressionUUID->"54f51ba9-9a2d-4455-9ab7-c2725035218e"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"0", ",", "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
     "2398"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"0", ",", "0", ",", "0", ",", "0", ",", "1"}], "}"}], ",", 
     "2277"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"0", ",", "0", ",", "0", ",", "1", ",", "0"}], "}"}], ",", 
     "1189"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"0", ",", "0", ",", "0", ",", "1", ",", "1"}], "}"}], ",", 
     "2212"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"0", ",", "0", ",", "1", ",", "0", ",", "0"}], "}"}], ",", 
     "1872"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"0", ",", "0", ",", "1", ",", "0", ",", "1"}], "}"}], ",", 
     "1557"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"0", ",", "0", ",", "1", ",", "1", ",", "0"}], "}"}], ",", 
     "2682"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"0", ",", "0", ",", "1", ",", "1", ",", "1"}], "}"}], ",", 
     "830"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"0", ",", "1", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
     "2304"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"0", ",", "1", ",", "0", ",", "0", ",", "1"}], "}"}], ",", 
     "986"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"0", ",", "1", ",", "0", ",", "1", ",", "0"}], "}"}], ",", 
     "888"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"0", ",", "1", ",", "0", ",", "1", ",", "1"}], "}"}], ",", 
     "1530"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"0", ",", "1", ",", "1", ",", "0", ",", "0"}], "}"}], ",", 
     "2334"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"0", ",", "1", ",", "1", ",", "0", ",", "1"}], "}"}], ",", 
     "2222"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"0", ",", "1", ",", "1", ",", "1", ",", "0"}], "}"}], ",", 
     "2070"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"0", ",", "1", ",", "1", ",", "1", ",", "1"}], "}"}], ",", 
     "498"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"1", ",", "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
     "2277"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"1", ",", "0", ",", "0", ",", "0", ",", "1"}], "}"}], ",", 
     "1124"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"1", ",", "0", ",", "0", ",", "1", ",", "0"}], "}"}], ",", 
     "2240"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"1", ",", "0", ",", "0", ",", "1", ",", "1"}], "}"}], ",", 
     "1300"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"1", ",", "0", ",", "1", ",", "0", ",", "0"}], "}"}], ",", 
     "1418"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"1", ",", "0", ",", "1", ",", "0", ",", "1"}], "}"}], ",", 
     "860"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"1", ",", "0", ",", "1", ",", "1", ",", "0"}], "}"}], ",", 
     "1874"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"1", ",", "0", ",", "1", ",", "1", ",", "1"}], "}"}], ",", 
     "1738"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"1", ",", "1", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
     "1097"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"1", ",", "1", ",", "0", ",", "0", ",", "1"}], "}"}], ",", 
     "2554"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"1", ",", "1", ",", "0", ",", "1", ",", "0"}], "}"}], ",", 
     "1390"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"1", ",", "1", ",", "0", ",", "1", ",", "1"}], "}"}], ",", 
     "2082"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"1", ",", "1", ",", "1", ",", "0", ",", "0"}], "}"}], ",", 
     "1317"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"1", ",", "1", ",", "1", ",", "0", ",", "1"}], "}"}], ",", 
     "1250"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"1", ",", "1", ",", "1", ",", "1", ",", "0"}], "}"}], ",", 
     "498"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"1", ",", "1", ",", "1", ",", "1", ",", "1"}], "}"}], ",", 
     "8"}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{3.78247329477274*^9},
 CellLabel->
  "Out[176]=",ExpressionUUID->"84b83a50-571c-43e5-a189-cf717ad645ff"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData["subwordsAustenHuffmanPairEncoded"], "Input",
 CellChangeTimes->{{3.782473402506453*^9, 3.782473405532246*^9}},
 CellLabel->
  "In[183]:=",ExpressionUUID->"c10ea41c-15ab-465d-b3a1-26ae664ed1f0"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"0", ",", "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
     "595"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"0", ",", "0", ",", "0", ",", "0", ",", "1"}], "}"}], ",", 
     "638"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"0", ",", "0", ",", "0", ",", "1", ",", "0"}], "}"}], ",", 
     "638"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"0", ",", "0", ",", "0", ",", "1", ",", "1"}], "}"}], ",", 
     "749"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"0", ",", "0", ",", "1", ",", "0", ",", "0"}], "}"}], ",", 
     "604"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"0", ",", "0", ",", "1", ",", "0", ",", "1"}], "}"}], ",", 
     "738"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"0", ",", "0", ",", "1", ",", "1", ",", "0"}], "}"}], ",", 
     "687"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"0", ",", "0", ",", "1", ",", "1", ",", "1"}], "}"}], ",", 
     "795"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"0", ",", "1", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
     "604"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"0", ",", "1", ",", "0", ",", "0", ",", "1"}], "}"}], ",", 
     "692"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"0", ",", "1", ",", "0", ",", "1", ",", "0"}], "}"}], ",", 
     "723"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"0", ",", "1", ",", "0", ",", "1", ",", "1"}], "}"}], ",", 
     "793"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"0", ",", "1", ",", "1", ",", "0", ",", "0"}], "}"}], ",", 
     "745"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"0", ",", "1", ",", "1", ",", "0", ",", "1"}], "}"}], ",", 
     "741"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"0", ",", "1", ",", "1", ",", "1", ",", "0"}], "}"}], ",", 
     "791"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"0", ",", "1", ",", "1", ",", "1", ",", "1"}], "}"}], ",", 
     "820"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"1", ",", "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
     "638"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"1", ",", "0", ",", "0", ",", "0", ",", "1"}], "}"}], ",", 
     "749"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"1", ",", "0", ",", "0", ",", "1", ",", "0"}], "}"}], ",", 
     "704"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"1", ",", "0", ",", "0", ",", "1", ",", "1"}], "}"}], ",", 
     "733"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"1", ",", "0", ",", "1", ",", "0", ",", "0"}], "}"}], ",", 
     "692"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"1", ",", "0", ",", "1", ",", "0", ",", "1"}], "}"}], ",", 
     "778"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"1", ",", "0", ",", "1", ",", "1", ",", "0"}], "}"}], ",", 
     "799"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"1", ",", "0", ",", "1", ",", "1", ",", "1"}], "}"}], ",", 
     "816"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"1", ",", "1", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
     "783"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"1", ",", "1", ",", "0", ",", "0", ",", "1"}], "}"}], ",", 
     "745"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"1", ",", "1", ",", "0", ",", "1", ",", "0"}], "}"}], ",", 
     "748"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"1", ",", "1", ",", "0", ",", "1", ",", "1"}], "}"}], ",", 
     "822"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"1", ",", "1", ",", "1", ",", "0", ",", "0"}], "}"}], ",", 
     "783"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"1", ",", "1", ",", "1", ",", "0", ",", "1"}], "}"}], ",", 
     "829"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"1", ",", "1", ",", "1", ",", "1", ",", "0"}], "}"}], ",", 
     "821"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"1", ",", "1", ",", "1", ",", "1", ",", "1"}], "}"}], ",", 
     "923"}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{3.782473406537731*^9},
 CellLabel->
  "Out[183]=",ExpressionUUID->"20900223-f803-4909-9418-f4aa5492e9f0"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData["subwordDistributionAustenHuffmanEncoded"], "Input",
 CellChangeTimes->{{3.7824650576753397`*^9, 3.7824650629983187`*^9}},
 CellLabel->
  "In[177]:=",ExpressionUUID->"0bd4b734-2f1f-4f31-8085-76111d72bb55"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"0", ",", "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
     "0.019738284962351048`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"0", ",", "0", ",", "0", ",", "0", ",", "1"}], "}"}], ",", 
     "0.02419767526865999`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"0", ",", "0", ",", "0", ",", "1", ",", "0"}], "}"}], ",", 
     "0.024855618100738358`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"0", ",", "0", ",", "0", ",", "1", ",", "1"}], "}"}], ",", 
     "0.02631771328313473`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"0", ",", "0", ",", "1", ",", "0", ",", "0"}], "}"}], ",", 
     "0.019153446889392498`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"0", ",", "0", ",", "1", ",", "0", ",", "1"}], "}"}], ",", 
     "0.03311645588127787`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"0", ",", "0", ",", "1", ",", "1", ",", "0"}], "}"}], ",", 
     "0.02251626580890416`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"0", ",", "0", ",", "1", ",", "1", ",", "1"}], "}"}], ",", 
     "0.0367351414577089`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"0", ",", "1", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
     "0.022808684845383436`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"0", ",", "1", ",", "0", ",", "0", ",", "1"}], "}"}], ",", 
     "0.02807222750201038`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"0", ",", "1", ",", "0", ",", "1", ",", "0"}], "}"}], ",", 
     "0.038306893778784996`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"0", ",", "1", ",", "0", ",", "1", ",", "1"}], "}"}], ",", 
     "0.03721032239198772`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"0", ",", "1", ",", "1", ",", "0", ",", "0"}], "}"}], ",", 
     "0.028949484611448206`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"0", ",", "1", ",", "1", ",", "0", ",", "1"}], "}"}], ",", 
     "0.024490094305139265`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"0", ",", "1", ",", "1", ",", "1", ",", "0"}], "}"}], ",", 
     "0.031727465458001314`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"0", ",", "1", ",", "1", ",", "1", ",", "1"}], "}"}], ",", 
     "0.03929380802690255`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"1", ",", "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
     "0.02419767526865999`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"1", ",", "0", ",", "0", ",", "0", ",", "1"}], "}"}], ",", 
     "0.0269756561152131`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"1", ",", "0", ",", "0", ",", "1", ",", "0"}], "}"}], ",", 
     "0.027414284669932013`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"1", ",", "0", ",", "0", ",", "1", ",", "1"}], "}"}], ",", 
     "0.03289714160391841`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"1", ",", "0", ",", "1", ",", "0", ",", "0"}], "}"}], ",", 
     "0.031727465458001314`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"1", ",", "0", ",", "1", ",", "0", ",", "1"}], "}"}], ",", 
     "0.04240076028949485`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"1", ",", "0", ",", "1", ",", "1", ",", "0"}], "}"}], ",", 
     "0.03092331310768331`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"1", ",", "0", ",", "1", ",", "1", ",", "1"}], "}"}], ",", 
     "0.03428613202719497`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"1", ",", "1", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
     "0.028364646538489656`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"1", ",", "1", ",", "0", ",", "0", ",", "1"}], "}"}], ",", 
     "0.03227575115139995`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"1", ",", "1", ",", "0", ",", "1", ",", "0"}], "}"}], ",", 
     "0.035821331968711165`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"1", ",", "1", ",", "0", ",", "1", ",", "1"}], "}"}], ",", 
     "0.027999122742890563`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"1", ",", "1", ",", "1", ",", "0", ",", "0"}], "}"}], ",", 
     "0.03169091307844141`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"1", ",", "1", ",", "1", ",", "0", ",", "1"}], "}"}], ",", 
     "0.03933036040646246`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"1", ",", "1", ",", "1", ",", "1", ",", "0"}], "}"}], ",", 
     "0.03929380802690255`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"1", ",", "1", ",", "1", ",", "1", ",", "1"}], "}"}], ",", 
     "0.05676584545653922`"}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{3.7824732968173447`*^9},
 CellLabel->
  "Out[177]=",ExpressionUUID->"694c0974-2b15-4cff-ad9a-cc7e85b8242d"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"subwordDistributionAustenHuffmanPairEncoded", " "}]], "Input",
 CellChangeTimes->{{3.782465070111299*^9, 3.782465119323813*^9}},
 CellLabel->
  "In[178]:=",ExpressionUUID->"efe9e089-b63b-40ad-b3d6-cd00c85804df"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"0", ",", "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
     "0.025084317032040473`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"0", ",", "0", ",", "0", ",", "0", ",", "1"}], "}"}], ",", 
     "0.026897133220910623`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"0", ",", "0", ",", "0", ",", "1", ",", "0"}], "}"}], ",", 
     "0.026897133220910623`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"0", ",", "0", ",", "0", ",", "1", ",", "1"}], "}"}], ",", 
     "0.03157672849915683`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"0", ",", "0", ",", "1", ",", "0", ",", "0"}], "}"}], ",", 
     "0.025463743676222596`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"0", ",", "0", ",", "1", ",", "0", ",", "1"}], "}"}], ",", 
     "0.031112984822934234`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"0", ",", "0", ",", "1", ",", "1", ",", "0"}], "}"}], ",", 
     "0.02896290050590219`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"0", ",", "0", ",", "1", ",", "1", ",", "1"}], "}"}], ",", 
     "0.03351602023608769`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"0", ",", "1", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
     "0.025463743676222596`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"0", ",", "1", ",", "0", ",", "0", ",", "1"}], "}"}], ",", 
     "0.02917369308600337`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"0", ",", "1", ",", "0", ",", "1", ",", "0"}], "}"}], ",", 
     "0.03048060708263069`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"0", ",", "1", ",", "0", ",", "1", ",", "1"}], "}"}], ",", 
     "0.03343170320404722`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"0", ",", "1", ",", "1", ",", "0", ",", "0"}], "}"}], ",", 
     "0.03140809443507588`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"0", ",", "1", ",", "1", ",", "0", ",", "1"}], "}"}], ",", 
     "0.03123946037099494`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"0", ",", "1", ",", "1", ",", "1", ",", "0"}], "}"}], ",", 
     "0.03334738617200675`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"0", ",", "1", ",", "1", ",", "1", ",", "1"}], "}"}], ",", 
     "0.03456998313659359`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"1", ",", "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
     "0.026897133220910623`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"1", ",", "0", ",", "0", ",", "0", ",", "1"}], "}"}], ",", 
     "0.03157672849915683`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"1", ",", "0", ",", "0", ",", "1", ",", "0"}], "}"}], ",", 
     "0.029679595278246207`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"1", ",", "0", ",", "0", ",", "1", ",", "1"}], "}"}], ",", 
     "0.03090219224283305`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"1", ",", "0", ",", "1", ",", "0", ",", "0"}], "}"}], ",", 
     "0.02917369308600337`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"1", ",", "0", ",", "1", ",", "0", ",", "1"}], "}"}], ",", 
     "0.03279932546374368`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"1", ",", "0", ",", "1", ",", "1", ",", "0"}], "}"}], ",", 
     "0.033684654300168634`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"1", ",", "0", ",", "1", ",", "1", ",", "1"}], "}"}], ",", 
     "0.034401349072512646`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"1", ",", "1", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
     "0.033010118043844856`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"1", ",", "1", ",", "0", ",", "0", ",", "1"}], "}"}], ",", 
     "0.03140809443507588`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"1", ",", "1", ",", "0", ",", "1", ",", "0"}], "}"}], ",", 
     "0.03153456998313659`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"1", ",", "1", ",", "0", ",", "1", ",", "1"}], "}"}], ",", 
     "0.034654300168634064`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"1", ",", "1", ",", "1", ",", "0", ",", "0"}], "}"}], ",", 
     "0.033010118043844856`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"1", ",", "1", ",", "1", ",", "0", ",", "1"}], "}"}], ",", 
     "0.034949409780775716`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"1", ",", "1", ",", "1", ",", "1", ",", "0"}], "}"}], ",", 
     "0.03461214165261383`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"1", ",", "1", ",", "1", ",", "1", ",", "1"}], "}"}], ",", 
     "0.03891231028667791`"}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{3.78247329825078*^9},
 CellLabel->
  "Out[178]=",ExpressionUUID->"95eb70ea-715f-428f-8610-f9f819625ecb"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["ASCII, Shannon, Huffman (characters black, pairs blue)", "Subsubsection",
 CellChangeTimes->{{3.7823177363399057`*^9, 
  3.782317745032721*^9}},ExpressionUUID->"f0076efb-21e8-48da-8073-\
8c36fa4a20e4"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"{", 
   RowBox[{
    RowBox[{"BigListPlot", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{
         RowBox[{"#", "[", 
          RowBox[{"[", "2", "]"}], "]"}], "&"}], "/@", 
        "subwordsAustenASCIIEncoded"}], "}"}], ",", "0", ",", "3000", ",", 
      RowBox[{"{", "Black", "}"}]}], "]"}], ",", "\[IndentingNewLine]", 
    RowBox[{"BigListPlot", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{
         RowBox[{"#", "[", 
          RowBox[{"[", "2", "]"}], "]"}], "&"}], "/@", 
        "subwordsAustenHuffmanEncoded"}], "}"}], ",", "0", ",", "1800", ",", 
      RowBox[{"{", "Black", "}"}]}], "]"}], ",", "\[IndentingNewLine]", 
    RowBox[{"BigListPlot", "[", 
     RowBox[{
      RowBox[{"{", " ", 
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{"#", "[", 
           RowBox[{"[", "2", "]"}], "]"}], "&"}], "/@", 
         "subwordsAustenHuffmanEncoded"}], ",", 
        RowBox[{
         RowBox[{
          RowBox[{"#", "[", 
           RowBox[{"[", "2", "]"}], "]"}], "&"}], "/@", 
         "subwordsAustenHuffmanPairEncoded"}]}], "}"}], ",", "400", ",", 
      "1600", ",", 
      RowBox[{"{", 
       RowBox[{"Black", ",", "Blue"}], "}"}]}], "]"}]}], " ", "}"}], 
  "\[IndentingNewLine]"}]], "Input",
 CellChangeTimes->{{3.782310646318658*^9, 3.7823106712188*^9}, {
  3.7823107553044252`*^9, 3.782310775286071*^9}, {3.7823108450680113`*^9, 
  3.7823108485786467`*^9}, {3.782311362856043*^9, 3.782311363262412*^9}, {
  3.782317732736792*^9, 3.7823178038484087`*^9}, {3.782317866587418*^9, 
  3.782317886879224*^9}, {3.782464784532865*^9, 3.782464847351603*^9}, {
  3.782465137478827*^9, 3.7824651520315228`*^9}},
 CellLabel->
  "In[179]:=",ExpressionUUID->"87761660-9601-47c2-8d9b-4ef606425b3c"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   GraphicsBox[{{}, {
      {GrayLevel[0], AbsolutePointSize[6], AbsoluteThickness[1.6], 
       GeometricTransformationBox[InsetBox[
         StyleBox[
          StyleBox["\<\"+\"\>",
           StripOnInput->False,
           FontSize->18],
          StripOnInput->False,
          FontSize->1], {0., 0.}], CompressedData["
1:eJw90LkOAUEcx/FFo1QoFIolIiIi7pvdQrGliFIlUXsESkcijnUkInE9hEKh
VnkEpVLhAWz8fv/dZPLJd2cnM7OBTq/ZdSmKolrDYQ2nIs9H+3M76XwBH0e2
G5oLtgcaMu+F+p7tg60t2w+/F7YKPyN2kMr+IficssPwPmFH4HvDjsKKrI/B
tpwvDmMHdgKqfXYS2vdNwdmcnYYDmc/AhsnOwsianYOvMTsPDfk/BX6/Yxdh
SPYrwe+ZXYbXFbsC63KfKjTlPDU4XLI1aN9Xp6r+A5ZfObE=
        
        "]]}, {}}, {}, {}, {}, {}},
    AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
    Axes->{True, True},
    AxesLabel->{None, None},
    AxesOrigin->{0., 0},
    DisplayFunction->Identity,
    Frame->{{False, False}, {False, False}},
    FrameLabel->{{None, None}, {None, None}},
    FrameTicks->{{Automatic, Automatic}, {Automatic, Automatic}},
    GridLines->{None, None},
    GridLinesStyle->Directive[
      GrayLevel[0.5, 0.4]],
    ImagePadding->All,
    Method->{"CoordinatesToolOptions" -> {"DisplayFunction" -> ({
          (Identity[#]& )[
           Part[#, 1]], 
          (Identity[#]& )[
           Part[#, 2]]}& ), "CopiedValueFunction" -> ({
          (Identity[#]& )[
           Part[#, 1]], 
          (Identity[#]& )[
           Part[#, 2]]}& )}},
    PlotRange->{{0., 32.}, {0, 3000}},
    PlotRangeClipping->True,
    PlotRangePadding->{{
       Scaled[0.02], 
       Scaled[0.02]}, {0, 0}},
    Ticks->{Automatic, Automatic}], ",", 
   GraphicsBox[{{}, {
      {GrayLevel[0], AbsolutePointSize[6], AbsoluteThickness[1.6], 
       GeometricTransformationBox[InsetBox[
         StyleBox[
          StyleBox["\<\"+\"\>",
           StripOnInput->False,
           FontSize->18],
          StripOnInput->False,
          FontSize->1], {0., 0.}], CompressedData["
1:eJxdjzsKwkAURUdtLFNYpLCIIiIi4v+vmcIFBFcggmCnSwj4xT9WKV2CS3AB
FlmCS8gSFO99KQwMhzOZd3k3NZmPpjGllPU9ke+JKvkC+4e3q3kBPlb0OKjX
dAN0N/QEOJZ5E3SO9CTnl3QLnF3oaebJ/wy5I7PMv9JzoC/zefAp7wtgIPsX
QetAL4EvySuDYd8KaGzpVXAhXmOe9Kv/5TfoN3qT83t6C3RO9DaoZf8O6Ele
F7yf6T32k336oCnvB6Av/Www7KvBoac/hCk37g==
        "]]}, {}}, {}, {}, {}, {}},
    AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
    Axes->{True, True},
    AxesLabel->{None, None},
    AxesOrigin->{0., 0},
    DisplayFunction->Identity,
    Frame->{{False, False}, {False, False}},
    FrameLabel->{{None, None}, {None, None}},
    FrameTicks->{{Automatic, Automatic}, {Automatic, Automatic}},
    GridLines->{None, None},
    GridLinesStyle->Directive[
      GrayLevel[0.5, 0.4]],
    ImagePadding->All,
    Method->{"CoordinatesToolOptions" -> {"DisplayFunction" -> ({
          (Identity[#]& )[
           Part[#, 1]], 
          (Identity[#]& )[
           Part[#, 2]]}& ), "CopiedValueFunction" -> ({
          (Identity[#]& )[
           Part[#, 1]], 
          (Identity[#]& )[
           Part[#, 2]]}& )}},
    PlotRange->{{0., 32.}, {0, 1800}},
    PlotRangeClipping->True,
    PlotRangePadding->{{
       Scaled[0.02], 
       Scaled[0.02]}, {0, 0}},
    Ticks->{Automatic, Automatic}], ",", 
   GraphicsBox[{{}, {
      {GrayLevel[0], AbsolutePointSize[6], AbsoluteThickness[1.6], 
       GeometricTransformationBox[InsetBox[
         StyleBox[
          StyleBox["\<\"+\"\>",
           StripOnInput->False,
           FontSize->18],
          StripOnInput->False,
          FontSize->1], {0., 0.}], CompressedData["
1:eJxdjzsKwkAURUdtLFNYpLCIIiIi4v+vmcIFBFcggmCnSwj4xT9WKV2CS3AB
FlmCS8gSFO99KQwMhzOZd3k3NZmPpjGllPU9ke+JKvkC+4e3q3kBPlb0OKjX
dAN0N/QEOJZ5E3SO9CTnl3QLnF3oaebJ/wy5I7PMv9JzoC/zefAp7wtgIPsX
QetAL4EvySuDYd8KaGzpVXAhXmOe9Kv/5TfoN3qT83t6C3RO9DaoZf8O6Ele
F7yf6T32k336oCnvB6Av/Www7KvBoac/hCk37g==
        "]]}, 
      {RGBColor[0, 0, 1], AbsolutePointSize[6], AbsoluteThickness[1.6], 
       GeometricTransformationBox[InsetBox[
         StyleBox[
          StyleBox["\<\"+\"\>",
           StripOnInput->False,
           FontSize->18],
          StripOnInput->False,
          FontSize->1], {0., 0.}], CompressedData["
1:eJxTTMoPSmVmYGBQAGJGIGZigIEP9mBqRpMDVABCf2iG8jnQ+AIQOqMdyheB
0A9g+iUgtABMXgZCV7RC+QoQ+kYHlK+Epl8FQi+AqVeD0DPaoHwNCH0Cpl8L
QnvA7NOB0Bowvh6E3gFTbwA1vxPKN4TQcP8ZQWi4/4yhNMx+Ewj9AsY3RXOv
GYQOgNlnDqF/wPgWELoBZr8lhK6AyVuh+ccaQifA+DYQegNMvy2afjuo+2Dy
9hB6BYzvAKFv9DgAAO0HPAE=
        "]]}, {}}, {}, {}, {}, {}},
    AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
    Axes->{True, True},
    AxesLabel->{None, None},
    AxesOrigin->{0., 406.},
    DisplayFunction->Identity,
    Frame->{{False, False}, {False, False}},
    FrameLabel->{{None, None}, {None, None}},
    FrameTicks->{{Automatic, Automatic}, {Automatic, Automatic}},
    GridLines->{None, None},
    GridLinesStyle->Directive[
      GrayLevel[0.5, 0.4]],
    ImagePadding->All,
    Method->{"CoordinatesToolOptions" -> {"DisplayFunction" -> ({
          (Identity[#]& )[
           Part[#, 1]], 
          (Identity[#]& )[
           Part[#, 2]]}& ), "CopiedValueFunction" -> ({
          (Identity[#]& )[
           Part[#, 1]], 
          (Identity[#]& )[
           Part[#, 2]]}& )}},
    PlotRange->{{0., 32.}, {400, 1600}},
    PlotRangeClipping->True,
    PlotRangePadding->{{
       Scaled[0.02], 
       Scaled[0.02]}, {0, 0}},
    Ticks->{Automatic, Automatic}]}], "}"}]], "Output",
 CellChangeTimes->{3.782473325923484*^9},
 CellLabel->
  "Out[179]=",ExpressionUUID->"62d5d288-e041-46cc-8ac6-57d38e471fc7"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
For a fair comparison should normalize so have probabilities of each binary \
word of length 5\
\>", "Subsubsection",
 CellChangeTimes->{{3.782311423039143*^9, 3.782311427890335*^9}, {
  3.782464600142408*^9, 
  3.7824646057863207`*^9}},ExpressionUUID->"53369676-0b9c-4673-9ecb-\
4064a30a317c"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"BigListPlot", "[", 
    RowBox[{
     RowBox[{"{", " ", 
      RowBox[{
       RowBox[{
        RowBox[{"#", "[", 
         RowBox[{"[", "2", "]"}], "]"}], "&"}], "/@", 
       "subwordDistributionAustenASCIIEncoded"}], "}"}], ",", "0", ",", 
     "0.058"}], "]"}], ",", 
   RowBox[{"BigListPlot", "[", 
    RowBox[{
     RowBox[{"{", " ", 
      RowBox[{
       RowBox[{
        RowBox[{"#", "[", 
         RowBox[{"[", "2", "]"}], "]"}], "&"}], "/@", 
       "subwordDistributionAustenShannonEncoded"}], "}"}], ",", "0", ",", 
     "0.058"}], "]"}], ",", "\[IndentingNewLine]", 
   RowBox[{"BigListPlot", "[", 
    RowBox[{
     RowBox[{"{", " ", 
      RowBox[{
       RowBox[{
        RowBox[{"#", "[", 
         RowBox[{"[", "2", "]"}], "]"}], "&"}], "/@", 
       "subwordDistributionAustenHuffmanEncoded"}], "}"}], ",", "0.015", ",", 
     "0.058"}], "]"}], " ", ",", "\[IndentingNewLine]", 
   RowBox[{"BigListPlot", "[", 
    RowBox[{
     RowBox[{"{", " ", 
      RowBox[{
       RowBox[{
        RowBox[{"#", "[", 
         RowBox[{"[", "2", "]"}], "]"}], "&"}], "/@", 
       "subwordDistributionAustenHuffmanPairEncoded"}], "}"}], ",", "0.015", 
     ",", "0.058"}], "]"}]}], "}"}]], "Input",
 CellChangeTimes->{{3.782312018716833*^9, 3.782312033206497*^9}, {
  3.782312072335771*^9, 3.7823121151080933`*^9}, {3.782318160414175*^9, 
  3.782318178560225*^9}, {3.782465164421589*^9, 3.782465198191512*^9}},
 CellLabel->
  "In[180]:=",ExpressionUUID->"ddb72c67-de72-4f8b-91b3-ce68b49745c3"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   GraphicsBox[{{}, {
      {GrayLevel[0], AbsolutePointSize[6], AbsoluteThickness[1.6], 
       GeometricTransformationBox[InsetBox[
         StyleBox[
          StyleBox["\<\"+\"\>",
           StripOnInput->False,
           FontSize->18],
          StripOnInput->False,
          FontSize->1], {0., 0.}], CompressedData["
1:eJxTTMoPSmVmYGBQAGJGIGZigIEP9qzffJxrFVfYQwUcmPpcfxx/uQzK53A4
pLN+wfe306F8AYfX+48sD3WCyYs4dCZ53S69tgjKl3AobtQy+RU6H8qXcaje
6SAq9XcVlK/gkO6gsTN4ywQoX8kBrFx/OZSv4nA5IJ5D6MZkKF/NQdKsY7b6
/YlQvoZDiYevwb1T86B8LYeUGwp582pg+nUcepYIV0rEwNyn5wBUbNd+ZQmU
bwB2zHTuFijfEM2/Rg5TJ6z9LzR/GpRv7PCQh0O1vAsmb+LQZqww5Y7mLCjf
1OHIAyO3S51zoHwzB905jAuf+MHca+5QdvjzxTm3YeFj4dDEAgrwhVC+pcO0
8Au/vwnD7LNysK57kRWzeSWUb+1ww22Nd//P2VC+jcM+5cNshZ9h/rF1cF4c
/7WoEeYeOwcbV25gEM+E8u3R/OvgwLileemt2Sr2AC+viVA=
        
        "]]}, {}}, {}, {}, {}, {}},
    AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
    Axes->{True, True},
    AxesLabel->{None, None},
    AxesOrigin->{0., 0},
    DisplayFunction->Identity,
    Frame->{{False, False}, {False, False}},
    FrameLabel->{{None, None}, {None, None}},
    FrameTicks->{{Automatic, Automatic}, {Automatic, Automatic}},
    GridLines->{None, None},
    GridLinesStyle->Directive[
      GrayLevel[0.5, 0.4]],
    ImagePadding->All,
    Method->{"CoordinatesToolOptions" -> {"DisplayFunction" -> ({
          (Identity[#]& )[
           Part[#, 1]], 
          (Identity[#]& )[
           Part[#, 2]]}& ), "CopiedValueFunction" -> ({
          (Identity[#]& )[
           Part[#, 1]], 
          (Identity[#]& )[
           Part[#, 2]]}& )}},
    PlotRange->{{0., 32.}, {0, 0.058}},
    PlotRangeClipping->True,
    PlotRangePadding->{{
       Scaled[0.02], 
       Scaled[0.02]}, {0, 0}},
    Ticks->{Automatic, Automatic}], ",", 
   GraphicsBox[{{}, {
      {GrayLevel[0], AbsolutePointSize[6], AbsoluteThickness[1.6], 
       GeometricTransformationBox[InsetBox[
         StyleBox[
          StyleBox["\<\"+\"\>",
           StripOnInput->False,
           FontSize->18],
          StripOnInput->False,
          FontSize->1], {0., 0.}], CompressedData["
1:eJxTTMoPSmVmYGBQAGJGIGZigIEP9t8u9O+8dm+mPVTAYc0k47wFdgugfA6H
+Qy82/YeXQzlCzg8bt102+3UQihfxOHm3WPrjsxZAuVLOMi8O9c39/ciKF/G
wasrg90xfBaUr+BwQE+8ZX3AbChfyWG63FG2bOuVUL6KQzT/ovSFJ+ZD+WoO
sY7cfCkpK6B8DYeYFdd2NYnNgfK1HA5LBPELzOmC8nUcwlP23mpVgLlfz+GS
T6v5R/65UL6Bg6SGtmBeBEzeEM2/Rg7XPncrpwQuhfKNHcJOd7QvuQTzv4mD
y1qpK0nCk6B8U4ccj/Pc35tg/jdzKFi+/A57CUy9ucMxr91bL5lPhvItHLgu
JNyOtoGFn6XDtfNfRI1XzoDyrRymmnRVc32AxYe1w5+Y61tMVWHhYeNQ57Rs
I/ssmLytA+ufV0dmLYWFt53D6WtMGw3rYObZOzAeXMm4OwbmPweHjlcT73Ue
n2YPAClMi8Q=
        "]]}, {}}, {}, {}, {}, {}},
    AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
    Axes->{True, True},
    AxesLabel->{None, None},
    AxesOrigin->{0., 0},
    DisplayFunction->Identity,
    Frame->{{False, False}, {False, False}},
    FrameLabel->{{None, None}, {None, None}},
    FrameTicks->{{Automatic, Automatic}, {Automatic, Automatic}},
    GridLines->{None, None},
    GridLinesStyle->Directive[
      GrayLevel[0.5, 0.4]],
    ImagePadding->All,
    Method->{"CoordinatesToolOptions" -> {"DisplayFunction" -> ({
          (Identity[#]& )[
           Part[#, 1]], 
          (Identity[#]& )[
           Part[#, 2]]}& ), "CopiedValueFunction" -> ({
          (Identity[#]& )[
           Part[#, 1]], 
          (Identity[#]& )[
           Part[#, 2]]}& )}},
    PlotRange->{{0., 32.}, {0, 0.058}},
    PlotRangeClipping->True,
    PlotRangePadding->{{
       Scaled[0.02], 
       Scaled[0.02]}, {0, 0}},
    Ticks->{Automatic, Automatic}], ",", 
   GraphicsBox[{{}, {
      {GrayLevel[0], AbsolutePointSize[6], AbsoluteThickness[1.6], 
       GeometricTransformationBox[InsetBox[
         StyleBox[
          StyleBox["\<\"+\"\>",
           StripOnInput->False,
           FontSize->18],
          StripOnInput->False,
          FontSize->1], {0., 0.}], CompressedData["
1:eJxTTMoPSmVmYGBQAGJGIGZigIEP9mY3Jj50NZtiDxVwiNRYU+92fAaUz+Gg
4VnqfaB4JpQv4OChkHud/fMsKF/EQbPpN/+3OZOhfAmHgJQPdxd/WQDlyzh8
+SDN2sg3HcpXcOioizz36dwiKF/J4bf087ca0TB5FYd8JQOf7/vmQPlqUPMX
Q/kaDrUT66yteWF8LYfmxRPZ3i+ZC+XrOCQEl2e8E4a5V89B4R6v6FQ7mHsM
HI5EXcoIlFsC5Rui+dfIQdzRbHHj/NlQvrHDQsb0hlohmHtMHHRNljx7ch1m
nima+WYO4es7c3u3LoXyzR3es77NjFk1H8q3cIjd1bb+c+9CKN/Socz3t8l8
bpj7rRzKwnzqi9pg5lk7+HHPKdIJh4WXjcO68L+BZ1fD3GPrUKDdOO2UJUy9
nUMpb/xzaWWY/+zR/OvgoMbQsTlTYK09AFM6hcE=
        "]]}, {}}, {}, {}, {}, {}},
    AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
    Axes->{True, True},
    AxesLabel->{None, None},
    AxesOrigin->{0., 0.015215},
    DisplayFunction->Identity,
    Frame->{{False, False}, {False, False}},
    FrameLabel->{{None, None}, {None, None}},
    FrameTicks->{{Automatic, Automatic}, {Automatic, Automatic}},
    GridLines->{None, None},
    GridLinesStyle->Directive[
      GrayLevel[0.5, 0.4]],
    ImagePadding->All,
    Method->{"CoordinatesToolOptions" -> {"DisplayFunction" -> ({
          (Identity[#]& )[
           Part[#, 1]], 
          (Identity[#]& )[
           Part[#, 2]]}& ), "CopiedValueFunction" -> ({
          (Identity[#]& )[
           Part[#, 1]], 
          (Identity[#]& )[
           Part[#, 2]]}& )}},
    PlotRange->{{0., 32.}, {0.015, 0.058}},
    PlotRangeClipping->True,
    PlotRangePadding->{{
       Scaled[0.02], 
       Scaled[0.02]}, {0, 0}},
    Ticks->{Automatic, Automatic}], ",", 
   GraphicsBox[{{}, {
      {GrayLevel[0], AbsolutePointSize[6], AbsoluteThickness[1.6], 
       GeometricTransformationBox[InsetBox[
         StyleBox[
          StyleBox["\<\"+\"\>",
           StripOnInput->False,
           FontSize->18],
          StripOnInput->False,
          FontSize->1], {0., 0.}], CompressedData["
1:eJxTTMoPSmVmYGBQAGJGIGZigIEP9uaGeqxb1s+0hwo4vH6jwfemazaUz4HG
F3A4+DTf4LLWAihfxKHqttdLLeFZUL6Ew8JOPUHRO/OhfBmH8vyHkcUr5kL5
Cg6BW+ewMmsuhPKV0PSrODS8upK29T5MvZpDq0TIKz8zmHkaDk2Zl85/lYXp
13JQ9rt9ZIcIzD06Djy5vZts/sLU6zlskeWY9UIIpt7A4XnGX1WNzTC+IZr/
jND8Z+xgUBHwJjhlHpRv4jCdz5rl8hKY+aZo7jVz+GqQukfoNEy/ucM7H8NC
WXuYfRYOXhczdvHOhfEtHSrf3Tu0+RlMvRWaf6wdbu7vmuqjCuPbOGzbcjza
dB9Mvy2afjsHzn3cMx4/gcnbO5zve3Rg3Q4Y38Hhxwp9oI8W2wMAynWQzg==

        "]]}, {}}, {}, {}, {}, {}},
    AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
    Axes->{True, True},
    AxesLabel->{None, None},
    AxesOrigin->{0., 0.015215},
    DisplayFunction->Identity,
    Frame->{{False, False}, {False, False}},
    FrameLabel->{{None, None}, {None, None}},
    FrameTicks->{{Automatic, Automatic}, {Automatic, Automatic}},
    GridLines->{None, None},
    GridLinesStyle->Directive[
      GrayLevel[0.5, 0.4]],
    ImagePadding->All,
    Method->{"CoordinatesToolOptions" -> {"DisplayFunction" -> ({
          (Identity[#]& )[
           Part[#, 1]], 
          (Identity[#]& )[
           Part[#, 2]]}& ), "CopiedValueFunction" -> ({
          (Identity[#]& )[
           Part[#, 1]], 
          (Identity[#]& )[
           Part[#, 2]]}& )}},
    PlotRange->{{0., 32.}, {0.015, 0.058}},
    PlotRangeClipping->True,
    PlotRangePadding->{{
       Scaled[0.02], 
       Scaled[0.02]}, {0, 0}},
    Ticks->{Automatic, Automatic}]}], "}"}]], "Output",
 CellChangeTimes->{3.78247333009256*^9},
 CellLabel->
  "Out[180]=",ExpressionUUID->"bdc43eef-3f44-4842-be65-f2ab573382de"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Entropy and expected lengths", "Subsubsection",
 CellChangeTimes->{{3.782465227926146*^9, 3.782465229195549*^9}, {
  3.782465270445437*^9, 3.782465271145708*^9}, {3.782465409407897*^9, 
  3.7824654114178963`*^9}},ExpressionUUID->"b811dd74-5fcf-4ef7-96df-\
0a0470f04621"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      RowBox[{"H", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"#", "[", 
          RowBox[{"[", "2", "]"}], "]"}], "&"}], "/@", 
        "AustenProbabilities"}], "]"}], "//", "N"}], ",", 
     RowBox[{"HuffmanExpectedLength", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"#", "[", 
         RowBox[{"[", "2", "]"}], "]"}], "&"}], "/@", "AustenProbabilities"}],
       "]"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"H", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"#", "[", 
         RowBox[{"[", "2", "]"}], "]"}], "&"}], "/@", 
       "AustenPairProbabilities"}], "]"}], ",", 
     RowBox[{"HuffmanExpectedLength", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"#", "[", 
         RowBox[{"[", "2", "]"}], "]"}], "&"}], "/@", 
       "AustenPairProbabilities"}], "]"}]}], "}"}]}], "}"}]], "Input",
 CellChangeTimes->{{3.7824652719576187`*^9, 3.782465328037788*^9}, {
  3.782465367529664*^9, 3.782465402396944*^9}},
 CellLabel->
  "In[181]:=",ExpressionUUID->"f9521149-ab0a-4392-8580-c764575d1350"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"4.267443907665111`", ",", "4.3015723270440285`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"7.43471010325961`", ",", "7.459119496855393`"}], "}"}]}], 
  "}"}]], "Output",
 CellChangeTimes->{{3.7824653830665693`*^9, 3.782465403054542*^9}, 
   3.782473334233604*^9},
 CellLabel->
  "Out[181]=",ExpressionUUID->"a4aac865-5f6c-4eb7-98ad-66f3c23c4318"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"BigListPlot", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{"#", "[", 
         RowBox[{"[", "2", "]"}], "]"}], "&"}], "/@", 
       "subwordDistributionAustenASCIIEncoded"}], ",", 
      RowBox[{
       RowBox[{
        RowBox[{"#", "[", 
         RowBox[{"[", "2", "]"}], "]"}], "&"}], "/@", 
       "subwordDistributionAustenShannonEncoded"}], ",", " ", 
      RowBox[{
       RowBox[{
        RowBox[{"#", "[", 
         RowBox[{"[", "2", "]"}], "]"}], "&"}], "/@", 
       "subwordDistributionAustenHuffmanEncoded"}], ",", 
      RowBox[{
       RowBox[{
        RowBox[{"#", "[", 
         RowBox[{"[", "2", "]"}], "]"}], "&"}], "/@", 
       "subwordDistributionAustenHuffmanPairEncoded"}]}], "}"}], ",", "0", 
    ",", "0.06"}], "]"}], " "}]], "Input",
 CellChangeTimes->{{3.78231172621246*^9, 3.7823117824234257`*^9}, {
  3.782311906499886*^9, 3.782311906829867*^9}, {3.782311941714716*^9, 
  3.7823119520013437`*^9}, {3.782311997971249*^9, 3.782311998994096*^9}, {
  3.782318195721816*^9, 3.782318218147708*^9}, {3.782465208440847*^9, 
  3.782465222681422*^9}},
 CellLabel->
  "In[182]:=",ExpressionUUID->"1364786c-704e-497c-98d1-0a7b5b716095"],

Cell[BoxData[
 GraphicsBox[{{}, {
    {GrayLevel[0], AbsolutePointSize[6], AbsoluteThickness[1.6], 
     GeometricTransformationBox[InsetBox[
       StyleBox[
        StyleBox["\<\"+\"\>",
         StripOnInput->False,
         FontSize->18],
        StripOnInput->False,
        FontSize->1], {0., 0.}], CompressedData["
1:eJxTTMoPSmVmYGBQAGJGIGZigIEP9qzffJxrFVfYQwUcmPpcfxx/uQzK53A4
pLN+wfe306F8AYfX+48sD3WCyYs4dCZ53S69tgjKl3AobtQy+RU6H8qXcaje
6SAq9XcVlK/gkO6gsTN4ywQoX8kBrFx/OZSv4nA5IJ5D6MZkKF/NQdKsY7b6
/YlQvoZDiYevwb1T86B8LYeUGwp582pg+nUcepYIV0rEwNyn5wBUbNd+ZQmU
bwB2zHTuFijfEM2/Rg5TJ6z9LzR/GpRv7PCQh0O1vAsmb+LQZqww5Y7mLCjf
1OHIAyO3S51zoHwzB905jAuf+MHca+5QdvjzxTm3YeFj4dDEAgrwhVC+pcO0
8Au/vwnD7LNysK57kRWzeSWUb+1ww22Nd//P2VC+jcM+5cNshZ9h/rF1cF4c
/7WoEeYeOwcbV25gEM+E8u3R/OvgwLileemt2Sr2AC+viVA=
      "]]}, 
    {RGBColor[0, 0, 1], AbsolutePointSize[6], AbsoluteThickness[1.6], 
     GeometricTransformationBox[InsetBox[
       StyleBox[
        StyleBox["\<\"+\"\>",
         StripOnInput->False,
         FontSize->18],
        StripOnInput->False,
        FontSize->1], {0., 0.}], CompressedData["
1:eJxTTMoPSmVmYGBQAGJGIGZigIEP9t8u9O+8dm+mPVTAYc0k47wFdgugfA6H
+Qy82/YeXQzlCzg8bt102+3UQihfxOHm3WPrjsxZAuVLOMi8O9c39/ciKF/G
wasrg90xfBaUr+BwQE+8ZX3AbChfyWG63FG2bOuVUL6KQzT/ovSFJ+ZD+WoO
sY7cfCkpK6B8DYeYFdd2NYnNgfK1HA5LBPELzOmC8nUcwlP23mpVgLlfz+GS
T6v5R/65UL6Bg6SGtmBeBEzeEM2/Rg7XPncrpwQuhfKNHcJOd7QvuQTzv4mD
y1qpK0nCk6B8U4ccj/Pc35tg/jdzKFi+/A57CUy9ucMxr91bL5lPhvItHLgu
JNyOtoGFn6XDtfNfRI1XzoDyrRymmnRVc32AxYe1w5+Y61tMVWHhYeNQ57Rs
I/ssmLytA+ufV0dmLYWFt53D6WtMGw3rYObZOzAeXMm4OwbmPweHjlcT73Ue
n2YPAClMi8Q=
      "]]}, 
    {RGBColor[1, 0, 0], AbsolutePointSize[6], AbsoluteThickness[1.6], 
     GeometricTransformationBox[InsetBox[
       StyleBox[
        StyleBox["\<\"+\"\>",
         StripOnInput->False,
         FontSize->15],
        StripOnInput->False,
        FontSize->1], {0., 0.}], CompressedData["
1:eJxTTMoPSmVmYGBQAGJGIGZigIEP9mY3Jj50NZtiDxVwiNRYU+92fAaUz+Gg
4VnqfaB4JpQv4OChkHud/fMsKF/EQbPpN/+3OZOhfAmHgJQPdxd/WQDlyzh8
+SDN2sg3HcpXcOioizz36dwiKF/J4bf087ca0TB5FYd8JQOf7/vmQPlqUPMX
Q/kaDrUT66yteWF8LYfmxRPZ3i+ZC+XrOCQEl2e8E4a5V89B4R6v6FQ7mHsM
HI5EXcoIlFsC5Rui+dfIQdzRbHHj/NlQvrHDQsb0hlohmHtMHHRNljx7ch1m
nima+WYO4es7c3u3LoXyzR3es77NjFk1H8q3cIjd1bb+c+9CKN/Socz3t8l8
bpj7rRzKwnzqi9pg5lk7+HHPKdIJh4WXjcO68L+BZ1fD3GPrUKDdOO2UJUy9
nUMpb/xzaWWY/+zR/OvgoMbQsTlTYK09AFM6hcE=
      "]]}, 
    {RGBColor[1, 0.5, 0], AbsolutePointSize[6], AbsoluteThickness[1.6], 
     GeometricTransformationBox[InsetBox[
       StyleBox[
        StyleBox["\<\"+\"\>",
         StripOnInput->False,
         FontSize->18],
        StripOnInput->False,
        FontSize->1], {0., 0.}], CompressedData["
1:eJxTTMoPSmVmYGBQAGJGIGZigIEP9uaGeqxb1s+0hwo4vH6jwfemazaUz4HG
F3A4+DTf4LLWAihfxKHqttdLLeFZUL6Ew8JOPUHRO/OhfBmH8vyHkcUr5kL5
Cg6BW+ewMmsuhPKV0PSrODS8upK29T5MvZpDq0TIKz8zmHkaDk2Zl85/lYXp
13JQ9rt9ZIcIzD06Djy5vZts/sLU6zlskeWY9UIIpt7A4XnGX1WNzTC+IZr/
jND8Z+xgUBHwJjhlHpRv4jCdz5rl8hKY+aZo7jVz+GqQukfoNEy/ucM7H8NC
WXuYfRYOXhczdvHOhfEtHSrf3Tu0+RlMvRWaf6wdbu7vmuqjCuPbOGzbcjza
dB9Mvy2afjsHzn3cMx4/gcnbO5zve3Rg3Q4Y38Hhxwp9oI8W2wMAynWQzg==

      "]]}, {}}, {}, {}, {}, {}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->{True, True},
  AxesLabel->{None, None},
  AxesOrigin->{0., 0},
  DisplayFunction->Identity,
  Frame->{{False, False}, {False, False}},
  FrameLabel->{{None, None}, {None, None}},
  FrameTicks->{{Automatic, Automatic}, {Automatic, Automatic}},
  GridLines->{None, None},
  GridLinesStyle->Directive[
    GrayLevel[0.5, 0.4]],
  ImagePadding->All,
  Method->{"CoordinatesToolOptions" -> {"DisplayFunction" -> ({
        (Identity[#]& )[
         Part[#, 1]], 
        (Identity[#]& )[
         Part[#, 2]]}& ), "CopiedValueFunction" -> ({
        (Identity[#]& )[
         Part[#, 1]], 
        (Identity[#]& )[
         Part[#, 2]]}& )}},
  PlotRange->{{0., 32.}, {0, 0.06}},
  PlotRangeClipping->True,
  PlotRangePadding->{{
     Scaled[0.02], 
     Scaled[0.02]}, {0, 0}},
  Ticks->{Automatic, Automatic}]], "Output",
 CellChangeTimes->{{3.7823117591014843`*^9, 3.7823117830115757`*^9}, 
   3.782311816119747*^9, {3.782311933340658*^9, 3.7823119542756147`*^9}, {
   3.7823119948938026`*^9, 3.782311999674473*^9}, 3.782312055774646*^9, 
   3.7823126726802692`*^9, 3.782315766426491*^9, {3.782318208815227*^9, 
   3.782318218860971*^9}, 3.782318257990671*^9, 3.782458039413704*^9, 
   3.782464389414071*^9, 3.782464444197728*^9, 3.7824652236646547`*^9, 
   3.782473340132619*^9},
 CellLabel->
  "Out[182]=",ExpressionUUID->"82c4c6e9-bbc1-4b31-b583-b0cfa902d334"]
}, Open  ]]
}, Open  ]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Exercise 1.2, Exercise 1.4, Exercise 3.4(iv)", "Section",
 CellChangeTimes->{{3.7815381999715033`*^9, 3.781538202954155*^9}, {
  3.781538362466671*^9, 
  3.781538368597868*^9}},ExpressionUUID->"91193c89-b79e-4131-aa9b-\
b5e3c24f0c6e"],

Cell[CellGroupData[{

Cell["\<\
Huffman codes for the guessing game on numbers in {0,1,...,15} in Exercise \
1.2 (uniform) and Exercise 1.4 (skewed)\
\>", "Subsection",
 CellChangeTimes->{{3.778348939533286*^9, 3.7783489409592743`*^9}, {
  3.77840318961716*^9, 3.778403196383113*^9}, {3.77969146979456*^9, 
  3.779691473285241*^9}, {3.781538211178239*^9, 3.781538216453539*^9}, {
  3.781538252949408*^9, 
  3.781538286159037*^9}},ExpressionUUID->"f2e75d25-52b7-4b74-8af4-\
34f67cddabe4"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"HuffmanCode", "[", 
  RowBox[{"Table", "[", 
   RowBox[{
    RowBox[{"1", "/", "16"}], ",", 
    RowBox[{"{", 
     RowBox[{"i", ",", "0", ",", "15"}], "}"}]}], "]"}], "]"}]], "Input",
 CellChangeTimes->{{3.778403213233411*^9, 3.7784032294583282`*^9}},
 CellLabel->"In[84]:=",ExpressionUUID->"7fd419ad-0203-4baf-bb67-a3b1c5dfe1dd"],

Cell[BoxData[
 RowBox[{"\[LeftAssociation]", 
  RowBox[{
   RowBox[{"1", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"0", ",", "0", ",", "0", ",", "0"}], "}"}]}], ",", 
   RowBox[{"2", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"0", ",", "0", ",", "0", ",", "1"}], "}"}]}], ",", 
   RowBox[{"3", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"0", ",", "0", ",", "1", ",", "0"}], "}"}]}], ",", 
   RowBox[{"4", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"0", ",", "0", ",", "1", ",", "1"}], "}"}]}], ",", 
   RowBox[{"5", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"0", ",", "1", ",", "0", ",", "0"}], "}"}]}], ",", 
   RowBox[{"6", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"0", ",", "1", ",", "0", ",", "1"}], "}"}]}], ",", 
   RowBox[{"7", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"0", ",", "1", ",", "1", ",", "0"}], "}"}]}], ",", 
   RowBox[{"8", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"0", ",", "1", ",", "1", ",", "1"}], "}"}]}], ",", 
   RowBox[{"9", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"1", ",", "0", ",", "0", ",", "0"}], "}"}]}], ",", 
   RowBox[{"10", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"1", ",", "0", ",", "0", ",", "1"}], "}"}]}], ",", 
   RowBox[{"11", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"1", ",", "0", ",", "1", ",", "0"}], "}"}]}], ",", 
   RowBox[{"12", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"1", ",", "0", ",", "1", ",", "1"}], "}"}]}], ",", 
   RowBox[{"13", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"1", ",", "1", ",", "0", ",", "0"}], "}"}]}], ",", 
   RowBox[{"14", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"1", ",", "1", ",", "0", ",", "1"}], "}"}]}], ",", 
   RowBox[{"15", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"1", ",", "1", ",", "1", ",", "0"}], "}"}]}], ",", 
   RowBox[{"16", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"1", ",", "1", ",", "1", ",", "1"}], "}"}]}]}], 
  "\[RightAssociation]"}]], "Output",
 CellChangeTimes->{
  3.778403229911559*^9, 3.77850446884442*^9, 3.778865595225662*^9, 
   3.7796311731717176`*^9, 3.779690587333712*^9, 3.779691061025256*^9, 
   3.779691317584536*^9, 3.78015759355925*^9, 3.780215627030868*^9, 
   3.780230187335599*^9, {3.7802302899213953`*^9, 3.780230314121521*^9}, 
   3.780230344418927*^9, 3.780230702616341*^9, 3.780414298270426*^9, 
   3.7805820157399387`*^9, 3.780894789101655*^9, 3.7812453100113173`*^9, 
   3.78144807320861*^9, 3.781538146779911*^9, 3.781539264222453*^9, 
   3.782308686928669*^9, 3.782315766523663*^9, 3.782458039451674*^9, 
   3.7824643894750633`*^9, 3.7824644442339907`*^9},
 CellLabel->"Out[84]=",ExpressionUUID->"15781d4c-5cbc-4068-a9ad-6a7ada7419df"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"HuffmanCode", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"{", 
      RowBox[{"1", "/", "2"}], "}"}], "~", "Join", "~", 
     RowBox[{"Table", "[", 
      RowBox[{
       RowBox[{"1", "/", "30"}], ",", 
       RowBox[{"{", 
        RowBox[{"i", ",", "1", ",", "15"}], "}"}]}], "]"}]}], "//", 
    "Reverse"}], "]"}], "//", "Reverse"}]], "Input",
 CellChangeTimes->{{3.7784032373460207`*^9, 3.7784032438363743`*^9}, {
   3.778403274559969*^9, 3.778403275560721*^9}, {3.778403311493437*^9, 
   3.778403311870566*^9}, {3.778403364477009*^9, 3.778403373122985*^9}, 
   3.778403476825078*^9},
 CellLabel->"In[85]:=",ExpressionUUID->"6d9f4c6c-5bd8-473f-9f60-003f6f0c41d5"],

Cell[BoxData[
 RowBox[{"\[LeftAssociation]", 
  RowBox[{
   RowBox[{"16", "\[Rule]", 
    RowBox[{"{", "0", "}"}]}], ",", 
   RowBox[{"15", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"1", ",", "0", ",", "0", ",", "0"}], "}"}]}], ",", 
   RowBox[{"14", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"1", ",", "1", ",", "1", ",", "1", ",", "1"}], "}"}]}], ",", 
   RowBox[{"13", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"1", ",", "1", ",", "1", ",", "1", ",", "0"}], "}"}]}], ",", 
   RowBox[{"12", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"1", ",", "1", ",", "1", ",", "0", ",", "1"}], "}"}]}], ",", 
   RowBox[{"11", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"1", ",", "1", ",", "1", ",", "0", ",", "0"}], "}"}]}], ",", 
   RowBox[{"10", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"1", ",", "1", ",", "0", ",", "1", ",", "1"}], "}"}]}], ",", 
   RowBox[{"9", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"1", ",", "1", ",", "0", ",", "1", ",", "0"}], "}"}]}], ",", 
   RowBox[{"8", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"1", ",", "1", ",", "0", ",", "0", ",", "1"}], "}"}]}], ",", 
   RowBox[{"7", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"1", ",", "1", ",", "0", ",", "0", ",", "0"}], "}"}]}], ",", 
   RowBox[{"6", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"1", ",", "0", ",", "1", ",", "1", ",", "1"}], "}"}]}], ",", 
   RowBox[{"5", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"1", ",", "0", ",", "1", ",", "1", ",", "0"}], "}"}]}], ",", 
   RowBox[{"4", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"1", ",", "0", ",", "1", ",", "0", ",", "1"}], "}"}]}], ",", 
   RowBox[{"3", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"1", ",", "0", ",", "1", ",", "0", ",", "0"}], "}"}]}], ",", 
   RowBox[{"2", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"1", ",", "0", ",", "0", ",", "1", ",", "1"}], "}"}]}], ",", 
   RowBox[{"1", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"1", ",", "0", ",", "0", ",", "1", ",", "0"}], "}"}]}]}], 
  "\[RightAssociation]"}]], "Output",
 CellChangeTimes->{
  3.778403244707362*^9, 3.7784032759303713`*^9, 3.778403312230591*^9, {
   3.778403365956935*^9, 3.778403373442273*^9}, 3.778504468934548*^9, 
   3.778865595311447*^9, 3.779631173505907*^9, 3.779690587417912*^9, 
   3.779691061905302*^9, 3.779691317759235*^9, 3.7801575936545362`*^9, 
   3.780215627133305*^9, 3.7802301875514383`*^9, {3.780230290039138*^9, 
   3.780230314243507*^9}, 3.780230344590767*^9, 3.78023070273792*^9, 
   3.7804142984432707`*^9, 3.7805820158388443`*^9, 3.7808947892667437`*^9, 
   3.781245310111435*^9, 3.7814480733403683`*^9, 3.7815381468858833`*^9, 
   3.781539264373497*^9, 3.7823086870658903`*^9, 3.782315766623108*^9, 
   3.782458039590234*^9, 3.782464389629154*^9, 3.782464444361006*^9},
 CellLabel->"Out[85]=",ExpressionUUID->"1b54b56b-eed6-4de6-a6a9-5347d185db2e"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
Huffman code for probability measure (1/5, 1/5, 1/5, 1/5, 1/5) in Exercise \
3.4(iv)\
\>", "Subsection",
 CellChangeTimes->{{3.77969147587169*^9, 3.779691503685835*^9}, {
  3.779691573698928*^9, 
  3.779691591059916*^9}},ExpressionUUID->"9d8b200a-03a5-4f3d-bab0-\
9195c55aa339"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"HuffmanCode", "[", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"1", "/", "5"}], ",", 
    RowBox[{"1", "/", "5"}], ",", 
    RowBox[{"1", "/", "5"}], ",", 
    RowBox[{"1", "/", "5"}], ",", 
    RowBox[{"1", "/", "5"}]}], "}"}], "]"}]], "Input",
 CellChangeTimes->{{3.7796915044861813`*^9, 3.7796915112417088`*^9}},
 CellLabel->"In[86]:=",ExpressionUUID->"5f163ee7-9cab-48e9-9a85-992064125b66"],

Cell[BoxData[
 RowBox[{"\[LeftAssociation]", 
  RowBox[{
   RowBox[{"1", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"1", ",", "1", ",", "0"}], "}"}]}], ",", 
   RowBox[{"2", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"1", ",", "1", ",", "1"}], "}"}]}], ",", 
   RowBox[{"3", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"0", ",", "0"}], "}"}]}], ",", 
   RowBox[{"4", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"0", ",", "1"}], "}"}]}], ",", 
   RowBox[{"5", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"1", ",", "0"}], "}"}]}]}], "\[RightAssociation]"}]], "Output",
 CellChangeTimes->{
  3.77969151151974*^9, 3.7801575937423553`*^9, 3.780215627233264*^9, 
   3.780230187694708*^9, {3.780230290217864*^9, 3.78023031441784*^9}, 
   3.780230344745145*^9, 3.7802307028908987`*^9, 3.780414298691716*^9, 
   3.780582016036865*^9, 3.780894789405384*^9, 3.7812453103244963`*^9, 
   3.781448073456506*^9, 3.7815381469947557`*^9, 3.7815392646344767`*^9, 
   3.78230868719808*^9, 3.7823157667210703`*^9, 3.782458039738984*^9, 
   3.782464389750327*^9, 3.782464444481904*^9},
 CellLabel->"Out[86]=",ExpressionUUID->"062b0e2b-5129-43bd-bb04-67731404842a"]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
The expected length is lower than for the Shannon code (five codewords of \
length 3), even when pruned to 1, 000, 001, 010, 011 with \
\>", "Subsubsection",
 CellChangeTimes->{{3.779691518422223*^9, 3.779691520541024*^9}, {
  3.779691569161992*^9, 3.7796916294999113`*^9}, {3.779692169160132*^9, 
  3.779692172634639*^9}, {3.781538302105969*^9, 
  3.781538330804236*^9}},ExpressionUUID->"e10fa885-34c3-4b53-8408-\
6306511cbc12"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{
    RowBox[{"1", "/", "5"}], "*", 
    RowBox[{"(", 
     RowBox[{"3", "+", "3", "+", "2", "+", "2", "+", "2"}], ")"}]}], ",", 
   RowBox[{
    RowBox[{"1", "/", "5"}], "*", 
    RowBox[{"(", 
     RowBox[{"1", "+", "3", "+", "3", "+", "3", "+", "3"}], ")"}]}]}], 
  "}"}]], "Input",
 CellChangeTimes->{{3.779691522399791*^9, 3.779691525694334*^9}, {
  3.7815383326707497`*^9, 3.781538343754222*^9}},
 CellLabel->"In[87]:=",ExpressionUUID->"1fd03017-cbfe-4db5-8dad-36d020b5749a"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   FractionBox["12", "5"], ",", 
   FractionBox["13", "5"]}], "}"}]], "Output",
 CellChangeTimes->{
  3.7796915260070553`*^9, 3.780157593885686*^9, 3.780215627364196*^9, 
   3.780230187818542*^9, {3.780230290322624*^9, 3.780230314586082*^9}, 
   3.780230344877597*^9, 3.7802307030036507`*^9, 3.780414299097042*^9, 
   3.7805820161199083`*^9, 3.780894789537037*^9, 3.781245310427835*^9, 
   3.781448073563732*^9, 3.781538147100996*^9, 3.781538344528187*^9, 
   3.781539264991465*^9, 3.782308687348386*^9, 3.7823157668237467`*^9, 
   3.7824580400212803`*^9, 3.782464389846965*^9, 3.78246444459794*^9},
 CellLabel->"Out[87]=",ExpressionUUID->"bb2840c2-8a93-4135-8d01-4ead6a5eaf73"]
}, Open  ]]
}, Open  ]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Coding multiple symbols at once: Example 4.5", "Section",
 CellChangeTimes->{{3.7801576228234386`*^9, 3.78015762939894*^9}, {
  3.781538468997913*^9, 3.781538479259905*^9}, {3.781539597136097*^9, 
  3.781539603763578*^9}},ExpressionUUID->"ce0d20e7-36a1-49c2-bb13-\
ae64f2832fc1"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Convolution", "[", 
    RowBox[{"ps_", ",", "r_"}], "]"}], "/;", 
   RowBox[{"r", "\[LessEqual]", "0"}]}], ":=", 
  RowBox[{"{", "}"}]}]], "Input",
 CellChangeTimes->{{3.7802305289215097`*^9, 3.780230544975851*^9}, 
   3.781538431222508*^9},
 CellLabel->"In[88]:=",ExpressionUUID->"d8d4421a-9d8a-4a71-adda-a69879e28620"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Convolution", "[", 
   RowBox[{"ps_", ",", "1"}], "]"}], ":=", "ps"}]], "Input",
 CellChangeTimes->{{3.7802153408700027`*^9, 3.780215366518487*^9}},
 CellLabel->"In[89]:=",ExpressionUUID->"9d30dcea-89a3-4eee-80cd-c2f12fc0a723"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Convolution", "[", 
   RowBox[{"ps_", ",", "r_"}], "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"qs", " ", "=", 
      RowBox[{"Convolution", "[", 
       RowBox[{"ps", ",", 
        RowBox[{"r", "-", "1"}]}], "]"}]}], "}"}], ",", 
    RowBox[{"Flatten", "[", 
     RowBox[{
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"q", "*", "p"}], ",", 
        RowBox[{"{", 
         RowBox[{"p", ",", "ps"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"q", ",", "qs"}], "}"}]}], "]"}], ",", "2"}], "]"}]}], 
   "]"}]}]], "Input",
 CellChangeTimes->{{3.780215367641431*^9, 3.780215403703018*^9}, {
  3.7802193545146523`*^9, 3.780219355975935*^9}},
 CellLabel->"In[90]:=",ExpressionUUID->"4ab56f97-982e-4034-81b9-2c350a9de3a1"],

Cell[CellGroupData[{

Cell["Example: (p,q,r)", "Subsection",
 CellChangeTimes->{{3.7802122823842688`*^9, 3.780212283309321*^9}, {
  3.780213175402804*^9, 3.780213178311795*^9}, {3.780215068106681*^9, 
  3.78021507598349*^9}, {3.780216439494223*^9, 3.780216440492557*^9}, {
  3.781538514497251*^9, 
  3.7815385150830793`*^9}},ExpressionUUID->"4ff1706f-52af-4470-87fe-\
f15e526df0f3"],

Cell[BoxData[
 RowBox[{
  RowBox[{"ELengthsAll", "[", "ps_", "]"}], ":=", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"ShannonCode", "[", "ps", "]"}], ",", 
    RowBox[{"HuffmanCode", "[", "ps", "]"}], ",", 
    RowBox[{"ShannonExpectedLength", "[", "ps", "]"}], ",", 
    RowBox[{"HuffmanExpectedLength", "[", "ps", "]"}], ",", 
    RowBox[{"N", "[", 
     RowBox[{
      RowBox[{"H", "[", "ps", "]"}], ",", "10"}], "]"}]}], "}"}]}]], "Input",
 CellChangeTimes->{{3.780216318495736*^9, 3.7802163537930737`*^9}},
 CellLabel->"In[91]:=",ExpressionUUID->"0a9c1bc8-8cf6-4d43-a412-3594d73f096a"],

Cell[BoxData[
 RowBox[{
  RowBox[{"ETable", "[", 
   RowBox[{"ps_", ",", 
    RowBox[{"rMax_:", "7"}]}], "]"}], ":=", 
  RowBox[{
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"f", ",", "g"}], "}"}], ",", 
     RowBox[{
      RowBox[{
       RowBox[{"f", "[", "r_", "]"}], ":=", " ", 
       RowBox[{"ShannonExpectedLength", "[", 
        RowBox[{"Convolution", "[", 
         RowBox[{"ps", ",", "r"}], "]"}], "]"}]}], ";", " ", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"r", ",", 
          RowBox[{"f", "[", "r", "]"}], ",", 
          RowBox[{"N", "[", 
           RowBox[{
            RowBox[{"r", "*", 
             RowBox[{"H", "[", "ps", "]"}]}], ",", "3"}], "]"}], ",", 
          RowBox[{"N", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"f", "[", "r", "]"}], "-", 
             RowBox[{"r", "*", 
              RowBox[{"H", "[", "ps", "]"}]}]}], ",", "3"}], "]"}], ",", 
          RowBox[{"N", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{"f", "[", "r", "]"}], "-", 
               RowBox[{"r", "*", 
                RowBox[{"H", "[", "ps", "]"}]}]}], ")"}], "/", "r"}], ",", 
            "3"}], "]"}]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"r", ",", "1", ",", "rMax"}], "}"}]}], "]"}]}]}], "]"}], "//",
    "TF"}]}]], "Input",
 CellChangeTimes->{{3.780216374691704*^9, 3.780216391484235*^9}, {
   3.78021647580896*^9, 3.780216521773348*^9}, {3.7802166087361603`*^9, 
   3.780216612623149*^9}, {3.780218209491886*^9, 3.780218241236949*^9}, {
   3.7802188033611307`*^9, 3.780218818737274*^9}, 3.7802425808666353`*^9, {
   3.7802452168112173`*^9, 3.780245276029654*^9}, {3.781538627431335*^9, 
   3.781538638606942*^9}},
 CellLabel->"In[92]:=",ExpressionUUID->"fa131073-5fc6-45c3-8b32-809f2ed717c9"],

Cell[CellGroupData[{

Cell["\<\
Showing Shannon code, Huffman code, Shannon expected length, Huffman expected \
length, entropy bound for (1/2,2/5,1/10)\
\>", "Subsubsection",
 CellChangeTimes->{{3.7815385182786493`*^9, 
  3.781538558081524*^9}},ExpressionUUID->"af267e85-1bfb-455a-99cd-\
f314f488b7a1"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ELengthsAll", "[", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"1", "/", "2"}], ",", 
    RowBox[{"2", "/", "5"}], ",", 
    RowBox[{"1", "/", "10"}]}], "}"}], "]"}]], "Input",
 CellChangeTimes->{{3.780216396480215*^9, 3.78021640191956*^9}, {
  3.7802171129621267`*^9, 3.780217117259039*^9}},
 CellLabel->"In[93]:=",ExpressionUUID->"4c844271-12c9-4b2d-9a6d-cacd7f4d5204"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", "0", "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "0"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "1", ",", "1", ",", "0"}], "}"}]}], "}"}], ",", 
   RowBox[{"\[LeftAssociation]", 
    RowBox[{
     RowBox[{"1", "\[Rule]", 
      RowBox[{"{", "0", "}"}]}], ",", 
     RowBox[{"2", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"1", ",", "1"}], "}"}]}], ",", 
     RowBox[{"3", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"1", ",", "0"}], "}"}]}]}], "\[RightAssociation]"}], ",", 
   FractionBox["17", "10"], ",", 
   FractionBox["3", "2"], ",", 
   "1.36096404744368117393515971474469508794`10."}], "}"}]], "Output",
 CellChangeTimes->{
  3.780216402182955*^9, 3.780216600714795*^9, 3.780217117716288*^9, 
   3.780218219549163*^9, 3.78021882103076*^9, 3.780230188183775*^9, {
   3.780230290663878*^9, 3.780230315031773*^9}, 3.780230345185851*^9, 
   3.780230703296241*^9, 3.780242583467498*^9, 3.780414300035631*^9, 
   3.7805820164637833`*^9, 3.780894789877366*^9, 3.781245310673835*^9, 
   3.7814480738364687`*^9, 3.7815381474613457`*^9, 3.781539265255515*^9, 
   3.782308687524777*^9, 3.782315766982254*^9, 3.78245804048624*^9, 
   3.782464390120406*^9, 3.782464444758094*^9},
 CellLabel->"Out[93]=",ExpressionUUID->"750cd906-737d-4cde-8ee3-1cecf6caf191"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
Encoding two messages at a time the Shannon code is less wasteful: from the \
table below, it is 0.428 bits worse than the entropy bound, but per symbol, \
this is 0.214, an improvement on the 0.339 encoding one symbol at a time.\
\>", "Subsubsection",
 CellChangeTimes->{{3.781538560888178*^9, 3.7815385762618437`*^9}, {
  3.781538657443207*^9, 
  3.78153868679193*^9}},ExpressionUUID->"0d852c54-1cec-4510-8622-\
c81fa6f8b2f7"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"Length", "/@", 
    RowBox[{"ShannonCode", "[", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"1", "/", "2"}], ",", 
       RowBox[{"2", "/", "5"}], ",", 
       RowBox[{"1", "/", "10"}]}], "}"}], "]"}]}], ",", 
   RowBox[{"Convolution", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"1", "/", "2"}], ",", 
       RowBox[{"2", "/", "5"}], ",", 
       RowBox[{"1", "/", "10"}]}], "}"}], ",", "2"}], "]"}], ",", 
   RowBox[{"Length", "/@", 
    RowBox[{"ShannonCode", "[", 
     RowBox[{"Convolution", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"1", "/", "2"}], ",", 
         RowBox[{"2", "/", "5"}], ",", 
         RowBox[{"1", "/", "10"}]}], "}"}], ",", "2"}], "]"}], "]"}]}]}], 
  "}"}]], "Input",
 CellChangeTimes->{{3.780217658409627*^9, 3.780217687588263*^9}, {
  3.7802193379244347`*^9, 3.780219340097402*^9}},
 CellLabel->"In[94]:=",ExpressionUUID->"cdc7622a-23ea-47fa-b94b-94b55f5069db"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"1", ",", "2", ",", "4"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     FractionBox["1", "4"], ",", 
     FractionBox["1", "5"], ",", 
     FractionBox["1", "20"], ",", 
     FractionBox["1", "5"], ",", 
     FractionBox["4", "25"], ",", 
     FractionBox["1", "25"], ",", 
     FractionBox["1", "20"], ",", 
     FractionBox["1", "25"], ",", 
     FractionBox["1", "100"]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "2", ",", "3", ",", "5", ",", "3", ",", "3", ",", "5", ",", "5", ",", "5",
      ",", "7"}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{{3.7802176655268993`*^9, 3.7802176878972673`*^9}, 
   3.780218220648609*^9, 3.780218821705441*^9, {3.7802193409494658`*^9, 
   3.78021935829497*^9}, 3.780230188322558*^9, {3.780230290774884*^9, 
   3.780230315332098*^9}, 3.780230345906808*^9, 3.7802307034150867`*^9, 
   3.7802425840978193`*^9, 3.780414300124794*^9, 3.7805820165680313`*^9, 
   3.78089479001061*^9, 3.781245310778369*^9, 3.781448073931684*^9, 
   3.781538147568344*^9, 3.781539265423582*^9, 3.782308687666916*^9, 
   3.782315767072*^9, 3.782458040655589*^9, 3.7824643902126713`*^9, 
   3.782464444787973*^9},
 CellLabel->"Out[94]=",ExpressionUUID->"c160ca77-f333-4f84-8340-af47d3ece228"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"ETable", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"1", "/", "2"}], ",", "0.4", ",", "0.1"}], "}"}], ",", "10"}], 
    "]"}], ",", 
   RowBox[{"ETable", "[", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"1", "/", "2"}], ",", 
      RowBox[{"1", "/", "3"}], ",", 
      RowBox[{"1", "/", "6"}]}], "}"}], "]"}]}], "}"}]], "Input",
 CellChangeTimes->{{3.780216449767702*^9, 3.780216450970014*^9}, {
  3.780216641349921*^9, 3.78021664868987*^9}, {3.780216773539513*^9, 
  3.780216841019011*^9}, {3.7802182231245337`*^9, 3.780218253530581*^9}, {
  3.780230282664968*^9, 3.7802302831488123`*^9}, {3.7815387072184677`*^9, 
  3.781538707506117*^9}},
 CellLabel->"In[95]:=",ExpressionUUID->"cb3d5eb3-c91b-491e-9a83-cefc6f6d9226"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   TagBox[GridBox[{
      {"1", "1.7000000000000002`", "1.3609640474436813`", 
       "0.3390359525563189`", "0.3390359525563189`"},
      {"2", "3.1500000000000004`", "2.7219280948873625`", 
       "0.4280719051126378`", "0.2140359525563189`"},
      {"3", "4.475000000000001`", "4.082892142331044`", "0.3921078576689574`",
        "0.1307026192229858`"},
      {"4", "5.799999999999999`", "5.443856189774725`", 
       "0.35614381022527386`", "0.08903595255631847`"},
      {"5", "7.156250000000009`", "6.804820237218406`", 
       "0.35142976278160276`", "0.07028595255632056`"},
      {"6", "8.528125000000042`", "8.165784284662088`", 
       "0.36234071533795387`", "0.06039011922299231`"},
      {"7", "9.899999999999922`", "9.526748332105768`", "0.373251667894154`", 
       "0.053321666842022`"},
      {"8", "11.267968750000016`", "10.88771237954945`", 
       "0.3802563704505655`", "0.047532046306320686`"},
      {"9", "12.633984374998736`", "12.248676426993132`", 
       "0.38530794800560386`", "0.042811994222844874`"},
      {"10", "13.999999999998199`", "13.609640474436812`", 
       "0.39035952556138653`", "0.039035952556138655`"}
     },
     GridBoxAlignment->{
      "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[2.0999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    Function[BoxForm`e$, 
     TableForm[BoxForm`e$, TableDepth -> 2]]], ",", 
   TagBox[GridBox[{
      {"1", 
       FractionBox["5", "3"], "1.4591479170272447575`3.", 
       "0.2075187496394219092`3.", "0.2075187496394219092`3."},
      {"2", 
       FractionBox["10", "3"], "2.918295834054489515`3.", 
       "0.4150374992788438184`3.", "0.2075187496394219092`3."},
      {"3", 
       FractionBox["39", "8"], "4.3774437510817342724`3.", 
       "0.4975562489182657276`3.", "0.1658520829727552425`3."},
      {"4", 
       FractionBox["305", "48"], "5.8365916681089790299`3.", 
       "0.5175749985576876368`3.", "0.1293937496394219092`3."},
      {"5", 
       FractionBox["749", "96"], "7.2957395851362237874`3.", 
       "0.5063437481971095459`3.", "0.1012687496394219092`3."},
      {"6", 
       FractionBox["591", "64"], "8.7548875021634685449`3.", 
       "0.4794874978365314551`3.", "0.0799145829727552425`3."},
      {"7", 
       FractionBox["32", "3"], "10.2140354191907133023`3.", 
       "0.4526312474759533644`3.", "0.064661606782279052`3."}
     },
     GridBoxAlignment->{
      "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[2.0999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    Function[BoxForm`e$, 
     TableForm[BoxForm`e$, TableDepth -> 2]]]}], "}"}]], "Output",
 CellChangeTimes->{
  3.7802164534291563`*^9, {3.780216603654172*^9, 3.780216616381855*^9}, 
   3.780216650086969*^9, {3.78021677982859*^9, 3.780216843205357*^9}, {
   3.7802182260205307`*^9, 3.780218274576311*^9}, 3.780218846826974*^9, 
   3.7802302122588577`*^9, {3.780230291971628*^9, 3.780230316933338*^9}, 
   3.780230348342884*^9, 3.7802307055982513`*^9, 3.780242585728166*^9, 
   3.780245287088716*^9, 3.780414305702675*^9, 3.780582021675992*^9, 
   3.7808947948552723`*^9, 3.781245315484577*^9, 3.781448078559402*^9, 
   3.781538152017974*^9, 3.7815386430528812`*^9, 3.781538723208115*^9, 
   3.781539289579166*^9, 3.782308704518111*^9, 3.782315783102479*^9, 
   3.78245805730805*^9, 3.782464409599354*^9, 3.782464467846397*^9},
 CellLabel->"Out[95]=",ExpressionUUID->"2a5cb12a-9ac9-4195-aad0-93f4404ff132"]
}, Open  ]]
}, Open  ]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Sheet 2 Question 3", "Section",
 CellChangeTimes->{{3.7805820453330393`*^9, 3.7805820476831083`*^9}, {
  3.78154010431236*^9, 
  3.781540106609913*^9}},ExpressionUUID->"dfb10116-0d62-4c07-89f0-\
4e9a9119abee"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ShannonExpectedLength", "/@", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"1", "/", "2"}], ",", 
      RowBox[{"1", "/", "4"}], ",", 
      RowBox[{"1", "/", "8"}], ",", 
      RowBox[{"1", "/", "8"}]}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"1", "/", "5"}], ",", 
      RowBox[{"1", "/", "5"}], ",", 
      RowBox[{"1", "/", "5"}], ",", 
      RowBox[{"1", "/", "5"}], ",", 
      RowBox[{"1", "/", "5"}]}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"1", "/", "3"}], ",", 
      RowBox[{"1", "/", "3"}], ",", 
      RowBox[{"1", "/", "9"}], ",", 
      RowBox[{"1", "/", "9"}], ",", 
      RowBox[{"1", "/", "9"}]}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"1", "/", "4"}], ",", 
      RowBox[{"1", "/", "4"}], ",", 
      RowBox[{"1", "/", "8"}], ",", 
      RowBox[{"1", "/", "8"}], ",", 
      RowBox[{"1", "/", "16"}], ",", 
      RowBox[{"1", "/", "16"}], ",", 
      RowBox[{"1", "/", "16"}], ",", 
      RowBox[{"1", "/", "32"}], ",", 
      RowBox[{"1", "/", "32"}]}], "}"}]}], "}"}]}]], "Input",
 CellChangeTimes->{{3.780582051013579*^9, 3.780582080004507*^9}, {
  3.7805823527953176`*^9, 3.7805823639818583`*^9}},
 CellLabel->"In[96]:=",ExpressionUUID->"226a408c-e1b8-4891-9f4d-3e629172443b"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   FractionBox["7", "4"], ",", "3", ",", 
   FractionBox["8", "3"], ",", 
   FractionBox["45", "16"]}], "}"}]], "Output",
 CellChangeTimes->{3.780582364319075*^9, 3.7808948116690598`*^9, 
  3.7812453317797003`*^9, 3.781448096915771*^9, 3.7815381683885202`*^9, 
  3.7815392897672577`*^9, 3.782308704685275*^9, 3.782315783241737*^9, 
  3.782458057498663*^9, 3.782464409765353*^9, 3.782464467901021*^9},
 CellLabel->"Out[96]=",ExpressionUUID->"181109ca-2b91-4edb-98ab-86ce0c0af9be"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"H", "/@", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"1", "/", "2"}], ",", 
      RowBox[{"1", "/", "4"}], ",", 
      RowBox[{"1", "/", "8"}], ",", 
      RowBox[{"1", "/", "8"}]}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"1", "/", "5"}], ",", 
      RowBox[{"1", "/", "5"}], ",", 
      RowBox[{"1", "/", "5"}], ",", 
      RowBox[{"1", "/", "5"}], ",", 
      RowBox[{"1", "/", "5"}]}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"1", "/", "3"}], ",", 
      RowBox[{"1", "/", "3"}], ",", 
      RowBox[{"1", "/", "9"}], ",", 
      RowBox[{"1", "/", "9"}], ",", 
      RowBox[{"1", "/", "9"}]}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"1", "/", "4"}], ",", 
      RowBox[{"1", "/", "4"}], ",", 
      RowBox[{"1", "/", "8"}], ",", 
      RowBox[{"1", "/", "8"}], ",", 
      RowBox[{"1", "/", "16"}], ",", 
      RowBox[{"1", "/", "16"}], ",", 
      RowBox[{"1", "/", "16"}], ",", 
      RowBox[{"1", "/", "32"}], ",", 
      RowBox[{"1", "/", "32"}]}], "}"}]}], "}"}]}]], "Input",
 CellChangeTimes->{{3.780582095243631*^9, 3.78058209713962*^9}, {
  3.7805823779651327`*^9, 3.7805823781186647`*^9}},
 CellLabel->"In[97]:=",ExpressionUUID->"b03ae8d0-4473-4cd8-9477-d2f3d5d5022a"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   FractionBox["7", "4"], ",", 
   FractionBox[
    RowBox[{"Log", "[", "5", "]"}], 
    RowBox[{"Log", "[", "2", "]"}]], ",", 
   RowBox[{
    FractionBox[
     RowBox[{"2", " ", 
      RowBox[{"Log", "[", "3", "]"}]}], 
     RowBox[{"3", " ", 
      RowBox[{"Log", "[", "2", "]"}]}]], "+", 
    FractionBox[
     RowBox[{"Log", "[", "9", "]"}], 
     RowBox[{"3", " ", 
      RowBox[{"Log", "[", "2", "]"}]}]]}], ",", 
   FractionBox["45", "16"]}], "}"}]], "Output",
 CellChangeTimes->{3.780582097570562*^9, 3.7805823790212793`*^9, 
  3.780894811806683*^9, 3.781245331871263*^9, 3.78144809697832*^9, 
  3.781538168501849*^9, 3.781539289880219*^9, 3.782308704790552*^9, 
  3.782315783355008*^9, 3.782458057641045*^9, 3.78246440999516*^9, 
  3.7824644680152397`*^9},
 CellLabel->"Out[97]=",ExpressionUUID->"0792408d-48b3-41dd-803a-9d68e5f0494c"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"H", "/@", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"1", "/", "2"}], ",", 
       RowBox[{"1", "/", "4"}], ",", 
       RowBox[{"1", "/", "8"}], ",", 
       RowBox[{"1", "/", "8"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"1", "/", "5"}], ",", 
       RowBox[{"1", "/", "5"}], ",", 
       RowBox[{"1", "/", "5"}], ",", 
       RowBox[{"1", "/", "5"}], ",", 
       RowBox[{"1", "/", "5"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"1", "/", "3"}], ",", 
       RowBox[{"1", "/", "3"}], ",", 
       RowBox[{"1", "/", "9"}], ",", 
       RowBox[{"1", "/", "9"}], ",", 
       RowBox[{"1", "/", "9"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"1", "/", "4"}], ",", 
       RowBox[{"1", "/", "4"}], ",", 
       RowBox[{"1", "/", "8"}], ",", 
       RowBox[{"1", "/", "8"}], ",", 
       RowBox[{"1", "/", "16"}], ",", 
       RowBox[{"1", "/", "16"}], ",", 
       RowBox[{"1", "/", "16"}], ",", 
       RowBox[{"1", "/", "32"}], ",", 
       RowBox[{"1", "/", "32"}]}], "}"}]}], "}"}]}], "//", "N"}]], "Input",
 CellChangeTimes->{{3.780582137146904*^9, 3.780582138248291*^9}, {
  3.780582382220813*^9, 3.780582383111961*^9}},
 CellLabel->"In[98]:=",ExpressionUUID->"648e80fa-1330-47f8-bf97-36b07d3fe554"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "1.75`", ",", "2.321928094887362`", ",", "2.113283334294875`", ",", 
   "2.8125`"}], "}"}]], "Output",
 CellChangeTimes->{3.7805821385740633`*^9, 3.780582384054117*^9, 
  3.780894811937695*^9, 3.7812453319645033`*^9, 3.781448097045353*^9, 
  3.781538168621516*^9, 3.781539289982288*^9, 3.782308704887203*^9, 
  3.782315783472926*^9, 3.7824580577885933`*^9, 3.782464410224671*^9, 
  3.782464468050837*^9},
 CellLabel->"Out[98]=",ExpressionUUID->"cb57eab8-f5e9-470e-8e68-138dcabf9787"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"4", "*", 
   RowBox[{
    RowBox[{"Log", "[", 
     RowBox[{"2", ",", "3"}], "]"}], "/", "3"}]}], " ", "//", "N"}]], "Input",\

 CellChangeTimes->{{3.7805822571754007`*^9, 3.780582263757777*^9}},
 CellLabel->"In[99]:=",ExpressionUUID->"d861d627-d30d-46a0-8632-ca5757ede8c3"],

Cell[BoxData["2.113283334294875`"], "Output",
 CellChangeTimes->{{3.780582260404676*^9, 3.7805822639962797`*^9}, 
   3.7808948120731077`*^9, 3.781245332054538*^9, 3.7814480971127367`*^9, 
   3.7815381687363033`*^9, 3.781539290077177*^9, 3.782308705061433*^9, 
   3.782315783599245*^9, 3.782458057939324*^9, 3.782464410364625*^9, 
   3.7824644680900393`*^9},
 CellLabel->"Out[99]=",ExpressionUUID->"dc4c5e3f-6f91-4f41-a80f-4b855f63d799"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Sheet 2 Question 4", "Section",
 CellChangeTimes->{{3.780583406566759*^9, 3.7805834084919033`*^9}, {
  3.781540109348175*^9, 
  3.7815401110779343`*^9}},ExpressionUUID->"d56be952-ec9d-4981-bd05-\
fef57f2f03cc"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"FractionalBinaryForm", "[", 
  RowBox[{
   RowBox[{"1", "/", "9"}], ",", "20"}], "]"}]], "Input",
 CellChangeTimes->{{3.780583471041829*^9, 3.780583475364802*^9}},
 CellLabel->
  "In[100]:=",ExpressionUUID->"e12fae7f-4bb7-49db-a077-132c0059cd6e"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", 
   ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
   "1", ",", "1", ",", "1", ",", "0", ",", "0"}], "}"}]], "Output",
 CellChangeTimes->{3.780583475660453*^9, 3.780894812222896*^9, 
  3.781245332148242*^9, 3.781448097181322*^9, 3.781538168853403*^9, 
  3.78153929018266*^9, 3.7823087051617937`*^9, 3.782315783717719*^9, 
  3.7824580581078568`*^9, 3.782464410524551*^9, 3.782464468333555*^9},
 CellLabel->
  "Out[100]=",ExpressionUUID->"5396ca36-e798-4fd8-bf61-69335b8e38d1"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"{", 
     RowBox[{"#", ",", 
      RowBox[{"FractionalBinaryForm", "[", 
       RowBox[{"#", ",", "20"}], "]"}]}], "}"}], "&"}], "/@", 
   RowBox[{"{", 
    RowBox[{"0", ",", 
     RowBox[{"1", "/", "3"}], ",", 
     RowBox[{
      RowBox[{"1", "/", "3"}], "+", 
      RowBox[{"1", "/", "3"}]}], ",", 
     RowBox[{
      RowBox[{"1", "/", "3"}], "+", 
      RowBox[{"1", "/", "3"}], "+", 
      RowBox[{"1", "/", "9"}]}], ",", 
     RowBox[{
      RowBox[{"1", "/", "3"}], "+", 
      RowBox[{"1", "/", "3"}], "+", 
      RowBox[{"1", "/", "9"}], "+", 
      RowBox[{"1", "/", "9"}]}]}], "}"}]}], "//", "TF"}]], "Input",
 CellChangeTimes->{{3.779689199593246*^9, 3.779689222693983*^9}, {
  3.780583415967546*^9, 3.780583419837228*^9}, {3.780583453340952*^9, 
  3.780583465174637*^9}},
 CellLabel->
  "In[101]:=",ExpressionUUID->"47e336a2-4be7-4905-8e7e-691d9b21e165"],

Cell[BoxData[
 TagBox[GridBox[{
    {"0", 
     RowBox[{"{", 
      RowBox[{
      "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
       "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
       "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], "}"}]},
    {
     FractionBox["1", "3"], 
     RowBox[{"{", 
      RowBox[{
      "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
       "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
       "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1"}], "}"}]},
    {
     FractionBox["2", "3"], 
     RowBox[{"{", 
      RowBox[{
      "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
       "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
       "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0"}], "}"}]},
    {
     FractionBox["7", "9"], 
     RowBox[{"{", 
      RowBox[{
      "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1"}], "}"}]},
    {
     FractionBox["8", "9"], 
     RowBox[{"{", 
      RowBox[{
      "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
       "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1"}], "}"}]}
   },
   GridBoxAlignment->{
    "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
     "RowsIndexed" -> {}},
   GridBoxSpacings->{"Columns" -> {
       Offset[0.27999999999999997`], {
        Offset[2.0999999999999996`]}, 
       Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
       Offset[0.2], {
        Offset[0.4]}, 
       Offset[0.2]}, "RowsIndexed" -> {}}],
  Function[BoxForm`e$, 
   TableForm[BoxForm`e$, TableDepth -> 2]]]], "Output",
 CellChangeTimes->{{3.779689216869351*^9, 3.779689222885769*^9}, 
   3.779690584078912*^9, 3.779691316077292*^9, 3.7801575921922197`*^9, 
   3.780215625664057*^9, 3.780230181965021*^9, {3.780230288370966*^9, 
   3.780230338614717*^9}, 3.780230697763772*^9, 3.780414296501688*^9, 
   3.780582014221079*^9, 3.780583420230617*^9, {3.780583455085677*^9, 
   3.7805834654465647`*^9}, 3.780894812369884*^9, 3.781245332239696*^9, 
   3.781448097253221*^9, 3.781538168999194*^9, 3.781539290285047*^9, 
   3.782308705262382*^9, 3.782315783919235*^9, 3.782458058295393*^9, 
   3.782464410665648*^9, 3.78246446848584*^9},
 CellLabel->
  "Out[101]//TableForm=",ExpressionUUID->"5db1b542-e271-41a5-bee3-\
1b718f411b92"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"{", 
     RowBox[{"#", ",", 
      RowBox[{"FractionalBinaryForm", "[", 
       RowBox[{"#", ",", "20"}], "]"}]}], "}"}], "&"}], "/@", 
   RowBox[{"{", 
    RowBox[{"0", ",", 
     RowBox[{"1", "/", "5"}], ",", 
     RowBox[{"2", "/", "5"}], ",", 
     RowBox[{"3", "/", "5"}], ",", 
     RowBox[{"4", "/", "5"}]}], "}"}]}], "//", "TF"}]], "Input",
 CellChangeTimes->{{3.780591682633582*^9, 3.780591693160873*^9}},
 CellLabel->
  "In[102]:=",ExpressionUUID->"3ea39784-f828-46a3-81d8-6e33e0a8b8ca"],

Cell[BoxData[
 TagBox[GridBox[{
    {"0", 
     RowBox[{"{", 
      RowBox[{
      "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
       "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
       "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], "}"}]},
    {
     FractionBox["1", "5"], 
     RowBox[{"{", 
      RowBox[{
      "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
       "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1"}], "}"}]},
    {
     FractionBox["2", "5"], 
     RowBox[{"{", 
      RowBox[{
      "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0"}], "}"}]},
    {
     FractionBox["3", "5"], 
     RowBox[{"{", 
      RowBox[{
      "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
       "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1"}], "}"}]},
    {
     FractionBox["4", "5"], 
     RowBox[{"{", 
      RowBox[{
      "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
       "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0"}], "}"}]}
   },
   GridBoxAlignment->{
    "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
     "RowsIndexed" -> {}},
   GridBoxSpacings->{"Columns" -> {
       Offset[0.27999999999999997`], {
        Offset[2.0999999999999996`]}, 
       Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
       Offset[0.2], {
        Offset[0.4]}, 
       Offset[0.2]}, "RowsIndexed" -> {}}],
  Function[BoxForm`e$, 
   TableForm[BoxForm`e$, TableDepth -> 2]]]], "Output",
 CellChangeTimes->{3.78059169389847*^9, 3.7808948125476227`*^9, 
  3.781245332339675*^9, 3.781448097329262*^9, 3.781538169099769*^9, 
  3.7815392903793*^9, 3.782308705360422*^9, 3.782315784232689*^9, 
  3.782458058520213*^9, 3.782464410834427*^9, 3.782464468648601*^9},
 CellLabel->
  "Out[102]//TableForm=",ExpressionUUID->"3bfc70de-16b8-4953-ba35-\
499550cda4c6"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Sheet 3 Question 3", "Section",
 CellChangeTimes->{{3.781538745149191*^9, 
  3.781538776719158*^9}},ExpressionUUID->"ff3fc54d-b5d2-4675-ad91-\
16c0c7a91801"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ETable", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"1", "/", "5"}], ",", 
     RowBox[{"1", "/", "5"}], ",", 
     RowBox[{"1", "/", "5"}], ",", 
     RowBox[{"1", "/", "5"}], ",", 
     RowBox[{"1", "/", "5"}]}], "}"}], ",", "5"}], "]"}]], "Input",
 CellChangeTimes->{{3.7802454580294743`*^9, 3.780245467865464*^9}, {
  3.780245523223284*^9, 3.7802455273547564`*^9}, {3.780246238705461*^9, 
  3.78024623911327*^9}, {3.780248941684881*^9, 3.780248946760696*^9}},
 CellLabel->
  "In[103]:=",ExpressionUUID->"501f51ef-f39b-462b-b4e8-e4e0614db894"],

Cell[BoxData[
 TagBox[GridBox[{
    {"1", "3", "2.3219280948873623479`3.", "0.6780719051126376521`3.", 
     "0.6780719051126376521`3."},
    {"2", "5", "4.6438561897747246957`3.", "0.3561438102252753043`3.", 
     "0.1780719051126376522`3."},
    {"3", "7", "6.9657842846620870435`3.", "0.0342157153379129564`3.", 
     "0.0114052384459709855`3."},
    {"4", "10", "9.2877123795494493913`3.", "0.7122876204505506087`3.", 
     "0.1780719051126376522`3."},
    {"5", "12", "11.6096404744368117392`3.", "0.3903595255631882608`3.", 
     "0.0780719051126376522`3."}
   },
   GridBoxAlignment->{
    "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
     "RowsIndexed" -> {}},
   GridBoxSpacings->{"Columns" -> {
       Offset[0.27999999999999997`], {
        Offset[2.0999999999999996`]}, 
       Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
       Offset[0.2], {
        Offset[0.4]}, 
       Offset[0.2]}, "RowsIndexed" -> {}}],
  Function[BoxForm`e$, 
   TableForm[BoxForm`e$, TableDepth -> 2]]]], "Output",
 CellChangeTimes->{{3.780245520234033*^9, 3.78024553644556*^9}, {
   3.780248943890853*^9, 3.7802489563697*^9}, 3.780414322185595*^9, 
   3.7805820394745398`*^9, 3.780894811035227*^9, 3.781245331279991*^9, 
   3.781448096440813*^9, 3.781538167790345*^9, 3.7815387832099323`*^9, 
   3.781539290940104*^9, 3.782308705905816*^9, 3.782315785278428*^9, 
   3.782458059209733*^9, 3.7824644116071177`*^9, 3.782464469279593*^9},
 CellLabel->
  "Out[103]//TableForm=",ExpressionUUID->"6ca406cf-2f30-4374-9224-\
76d9f93284d5"]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
For example, when r = 5, we have 2^11 < 5^5 = 3125 <= 2^12, so all codewords \
in the Shannon code have length 12. Per symbol sent, we waste 12/5 - H(X) = \
12/5 - Log[2,5] bits.\
\>", "Subsubsection",
 CellChangeTimes->{{3.78153879326405*^9, 3.781538822288104*^9}, {
  3.78153885281052*^9, 3.781538904196382*^9}, {3.781539037358426*^9, 
  3.78153904698597*^9}},ExpressionUUID->"c369fa26-c180-4bb0-b03f-\
04e302a75da4"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"12", "/", "5"}], "-", 
   RowBox[{"Log", "[", 
    RowBox[{"2", ",", "5"}], "]"}]}], "//", "N"}]], "Input",
 CellChangeTimes->{{3.78024892265368*^9, 3.780248928698997*^9}},
 CellLabel->
  "In[104]:=",ExpressionUUID->"a47f3824-e4bd-4eac-baba-769d34df5a8c"],

Cell[BoxData["0.07807190511263773`"], "Output",
 CellChangeTimes->{{3.780248926508925*^9, 3.7802489289705772`*^9}, 
   3.78041432229886*^9, 3.7805820395612373`*^9, 3.7808948111869783`*^9, 
   3.781245331384137*^9, 3.7814480965674467`*^9, 3.781538167936821*^9, 
   3.7815392910380173`*^9, 3.7823087060238953`*^9, 3.782315785884185*^9, 
   3.782458059378862*^9, 3.782464411765801*^9, 3.782464469326199*^9},
 CellLabel->
  "Out[104]=",ExpressionUUID->"76784db3-6da6-4ab8-b8fb-85d42a47764e"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
Using the optimal Huffman code the expected length is 12/5, so same \
situation. Therefore the Shannon code is as good as the Huffman code for l=5. \
From the table below, the Shannon code is better for all r >= 5 except r = 7.\
\
\>", "Subsubsection",
 CellChangeTimes->{{3.781539048885303*^9, 
  3.7815391462844467`*^9}},ExpressionUUID->"cd1925a4-4bc4-4a8b-9332-\
b33dd4abdc99"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"HuffmanCode", "[", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"1", "/", "5"}], ",", 
    RowBox[{"1", "/", "5"}], ",", 
    RowBox[{"1", "/", "5"}], ",", 
    RowBox[{"1", "/", "5"}], ",", 
    RowBox[{"1", "/", "5"}]}], "}"}], "]"}]], "Input",
 CellChangeTimes->{{3.7815390523110123`*^9, 3.781539062221146*^9}},
 CellLabel->
  "In[105]:=",ExpressionUUID->"063d99ae-2f99-4d04-a72f-ca6f56c99814"],

Cell[BoxData[
 RowBox[{"\[LeftAssociation]", 
  RowBox[{
   RowBox[{"1", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"1", ",", "1", ",", "0"}], "}"}]}], ",", 
   RowBox[{"2", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"1", ",", "1", ",", "1"}], "}"}]}], ",", 
   RowBox[{"3", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"0", ",", "0"}], "}"}]}], ",", 
   RowBox[{"4", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"0", ",", "1"}], "}"}]}], ",", 
   RowBox[{"5", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"1", ",", "0"}], "}"}]}]}], "\[RightAssociation]"}]], "Output",
 CellChangeTimes->{3.7815390625586157`*^9, 3.781539291127907*^9, 
  3.78230870612965*^9, 3.782315785988611*^9, 3.782458059550818*^9, 
  3.782464411984634*^9, 3.782464469452757*^9},
 CellLabel->
  "Out[105]=",ExpressionUUID->"cba48619-c07a-439e-8106-36ae9e13c9ef"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"Table", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"r", ",", 
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{"Ceiling", "[", 
          RowBox[{"r", "*", 
           RowBox[{"Log", "[", 
            RowBox[{"2", ",", "5"}], "]"}]}], "]"}], "/", "r"}], "-", 
        RowBox[{"12", "/", "5"}]}], "//", "N"}], ",", 
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{"Ceiling", "[", 
          RowBox[{"r", "*", 
           RowBox[{"Log", "[", 
            RowBox[{"2", ",", "5"}], "]"}]}], "]"}], "/", "r"}], "-", 
        RowBox[{"Log", "[", 
         RowBox[{"2", ",", "5"}], "]"}]}], "//", "N"}], ",", 
      RowBox[{
       RowBox[{
        RowBox[{"12", "/", "5"}], "-", 
        RowBox[{"Log", "[", 
         RowBox[{"2", ",", "5"}], "]"}]}], "//", "N"}]}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"r", ",", "1", ",", "20"}], "}"}]}], "]"}], "//", 
  "TF"}]], "Input",
 CellChangeTimes->{{3.780248956255258*^9, 3.780249016268835*^9}, {
  3.7816035930958033`*^9, 3.781603612296002*^9}},
 CellLabel->
  "In[106]:=",ExpressionUUID->"7344b8a8-5462-493d-8944-76576eb05e1c"],

Cell[BoxData[
 TagBox[GridBox[{
    {"1", "0.6`", "0.6780719051126378`", "0.07807190511263773`"},
    {"2", "0.1`", "0.17807190511263782`", "0.07807190511263773`"},
    {"3", 
     RowBox[{"-", "0.06666666666666667`"}], "0.0114052384459713`", 
     "0.07807190511263773`"},
    {"4", "0.1`", "0.17807190511263782`", "0.07807190511263773`"},
    {"5", "0.`", "0.07807190511263773`", "0.07807190511263773`"},
    {"6", 
     RowBox[{"-", "0.06666666666666667`"}], "0.0114052384459713`", 
     "0.07807190511263773`"},
    {"7", "0.02857142857142857`", "0.1066433336840662`", 
     "0.07807190511263773`"},
    {"8", 
     RowBox[{"-", "0.025`"}], "0.05307190511263782`", 
     "0.07807190511263773`"},
    {"9", 
     RowBox[{"-", "0.06666666666666667`"}], "0.0114052384459713`", 
     "0.07807190511263773`"},
    {"10", "0.`", "0.07807190511263773`", "0.07807190511263773`"},
    {"11", 
     RowBox[{"-", "0.03636363636363636`"}], "0.041708268749001576`", 
     "0.07807190511263773`"},
    {"12", 
     RowBox[{"-", "0.06666666666666667`"}], "0.0114052384459713`", 
     "0.07807190511263773`"},
    {"13", 
     RowBox[{"-", "0.015384615384615385`"}], "0.0626872897280224`", 
     "0.07807190511263773`"},
    {"14", 
     RowBox[{"-", "0.04285714285714286`"}], "0.035214762255495025`", 
     "0.07807190511263773`"},
    {"15", 
     RowBox[{"-", "0.06666666666666667`"}], "0.0114052384459713`", 
     "0.07807190511263773`"},
    {"16", 
     RowBox[{"-", "0.025`"}], "0.05307190511263782`", 
     "0.07807190511263773`"},
    {"17", 
     RowBox[{"-", "0.047058823529411764`"}], "0.031013081583226132`", 
     "0.07807190511263773`"},
    {"18", 
     RowBox[{"-", "0.06666666666666667`"}], "0.0114052384459713`", 
     "0.07807190511263773`"},
    {"19", 
     RowBox[{"-", "0.031578947368421054`"}], "0.04649295774421658`", 
     "0.07807190511263773`"},
    {"20", 
     RowBox[{"-", "0.05`"}], "0.028071905112637907`", "0.07807190511263773`"}
   },
   GridBoxAlignment->{
    "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
     "RowsIndexed" -> {}},
   GridBoxSpacings->{"Columns" -> {
       Offset[0.27999999999999997`], {
        Offset[2.0999999999999996`]}, 
       Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
       Offset[0.2], {
        Offset[0.4]}, 
       Offset[0.2]}, "RowsIndexed" -> {}}],
  Function[BoxForm`e$, 
   TableForm[BoxForm`e$, TableDepth -> 2]]]], "Output",
 CellChangeTimes->{{3.780248993596033*^9, 3.7802490165723886`*^9}, 
   3.780414322385716*^9, 3.7805820396427603`*^9, 3.7808948113146467`*^9, 
   3.781245331482737*^9, 3.781448096635503*^9, 3.781538168039569*^9, 
   3.7815392912466793`*^9, {3.781603606443481*^9, 3.7816036126383877`*^9}, 
   3.782308706320059*^9, 3.782315786100359*^9, 3.782458059726366*^9, 
   3.782464412139464*^9, 3.782464469572297*^9},
 CellLabel->
  "Out[106]//TableForm=",ExpressionUUID->"21b2a030-8ffa-40be-a504-\
4a97281d24eb"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"1", "/", "13"}], "//", "N"}]], "Input",
 CellChangeTimes->{{3.781603319652027*^9, 3.7816033209754667`*^9}},
 CellLabel->
  "In[107]:=",ExpressionUUID->"c35bbaf7-0a26-469b-bec0-948716a6959a"],

Cell[BoxData["0.07692307692307693`"], "Output",
 CellChangeTimes->{3.781603322325335*^9, 3.782308706604463*^9, 
  3.782315786205057*^9, 3.7824580598775177`*^9, 3.782464412300633*^9, 
  3.782464469690366*^9},
 CellLabel->
  "Out[107]=",ExpressionUUID->"edfd8b44-dc6b-4bbd-a1de-1ad912e498b7"]
}, Open  ]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Concatenating codewords and unique decipherability", "Section",
 CellChangeTimes->{{3.781539611719468*^9, 
  3.781539617605875*^9}},ExpressionUUID->"494b2e01-65e8-48ea-bc71-\
3f8a3af6d80f"],

Cell[BoxData[
 RowBox[{
  RowBox[{"ConcatenationsWithCodewords", "[", 
   RowBox[{"0", ",", "_"}], "]"}], ":=", 
  RowBox[{"{", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", "}"}], ",", 
     RowBox[{"{", "}"}]}], "}"}], "}"}]}]], "Input",
 CellChangeTimes->{{3.7815396308959503`*^9, 3.781539637944049*^9}, {
  3.7815397605932817`*^9, 3.781539760971023*^9}, {3.78153983531936*^9, 
  3.781539852607975*^9}, {3.781539941443941*^9, 3.781539942987795*^9}},
 CellLabel->
  "In[108]:=",ExpressionUUID->"3a47052e-1290-4a9e-b79c-40103249e311"],

Cell[BoxData[
 RowBox[{
  RowBox[{"ConcatenationsWithCodewords", "[", 
   RowBox[{"r_", ",", "us_"}], "]"}], ":=", "\[IndentingNewLine]", 
  RowBox[{"Flatten", "[", 
   RowBox[{
    RowBox[{"Table", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{
         RowBox[{"v", "[", 
          RowBox[{"[", "1", "]"}], "]"}], "~", "Join", "~", "u"}], ",", 
        RowBox[{
         RowBox[{"v", "[", 
          RowBox[{"[", "2", "]"}], "]"}], "~", "Join", "~", 
         RowBox[{"{", "u", "}"}]}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"u", ",", "us"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"v", ",", " ", 
        RowBox[{"ConcatenationsWithCodewords", "[", 
         RowBox[{
          RowBox[{"r", "-", "1"}], ",", "us"}], "]"}]}], "}"}]}], "]"}], ",", 
    "1"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.7815396183804827`*^9, 3.781539783104515*^9}, {
  3.781539813170632*^9, 3.781539857791087*^9}, {3.781539945540351*^9, 
  3.781539954846291*^9}},
 CellLabel->
  "In[109]:=",ExpressionUUID->"09db2460-c3dd-46c3-b2c6-48b46e7a5f93"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Concatenations", "[", 
   RowBox[{"r_", ",", "us_"}], "]"}], ":=", 
  RowBox[{
   RowBox[{
    RowBox[{"#", "[", 
     RowBox[{"[", "1", "]"}], "]"}], "&"}], "/@", 
   RowBox[{"ConcatenationsWithCodewords", "[", 
    RowBox[{"r", ",", "us"}], "]"}]}]}]], "Input",
 CellChangeTimes->{{3.781539860589032*^9, 3.781539874776968*^9}, {
  3.7815399588277617`*^9, 3.781539960878388*^9}},
 CellLabel->
  "In[110]:=",ExpressionUUID->"089d3919-2354-46e5-8483-cf195d3b58fe"],

Cell[BoxData[
 RowBox[{
  RowBox[{"ConcatenationsWithCodewordsAll", "[", 
   RowBox[{"rMax_", ",", "us_"}], "]"}], ":=", 
  RowBox[{"Join", "@@", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"ConcatenationsWithCodewords", "[", 
      RowBox[{"r", ",", "us"}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"r", ",", "0", ",", "rMax"}], "}"}]}], "]"}]}]}]], "Input",
 CellChangeTimes->{{3.7815399658306093`*^9, 3.7815399930818377`*^9}, 
   3.781540063363347*^9},
 CellLabel->
  "In[111]:=",ExpressionUUID->"9091b994-e032-4709-8484-3d92fd423ed2"],

Cell[CellGroupData[{

Cell["\<\
Example: 0, 10, 010 is not uniquely decipherable because the concatenation of \
0 and 10 is the codeword 010. This can be seen from the output below, taking \
the two rows labelled 010.\
\>", "Subsubsection",
 CellChangeTimes->{{3.78153999779004*^9, 3.781540015303378*^9}, {
  3.781540070927462*^9, 
  3.781540079228692*^9}},ExpressionUUID->"48cdaf46-f621-4eaf-bfa5-\
67ef4ec6e341"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"ConcatenationsWithCodewordsAll", "[", 
    RowBox[{"2", ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", "0", "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"1", ",", "0"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0", ",", "1", ",", "0"}], "}"}]}], "}"}]}], "]"}], "//", 
   "Sort"}], "//", "TF"}]], "Input",
 CellChangeTimes->{{3.7815400184887733`*^9, 3.7815400567985973`*^9}},
 CellLabel->
  "In[112]:=",ExpressionUUID->"c834a20b-5e04-483c-86dd-561b6a06777a"],

Cell[BoxData[
 TagBox[GridBox[{
    {
     RowBox[{"{", "}"}], 
     RowBox[{"{", "}"}]},
    {
     RowBox[{"{", "0", "}"}], 
     RowBox[{"{", 
      RowBox[{"{", "0", "}"}], "}"}]},
    {
     RowBox[{"{", 
      RowBox[{"0", ",", "0"}], "}"}], 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", "0", "}"}], ",", 
       RowBox[{"{", "0", "}"}]}], "}"}]},
    {
     RowBox[{"{", 
      RowBox[{"1", ",", "0"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"{", 
       RowBox[{"1", ",", "0"}], "}"}], "}"}]},
    {
     RowBox[{"{", 
      RowBox[{"0", ",", "1", ",", "0"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"{", 
       RowBox[{"0", ",", "1", ",", "0"}], "}"}], "}"}]},
    {
     RowBox[{"{", 
      RowBox[{"0", ",", "1", ",", "0"}], "}"}], 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", "0", "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"1", ",", "0"}], "}"}]}], "}"}]},
    {
     RowBox[{"{", 
      RowBox[{"1", ",", "0", ",", "0"}], "}"}], 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"1", ",", "0"}], "}"}], ",", 
       RowBox[{"{", "0", "}"}]}], "}"}]},
    {
     RowBox[{"{", 
      RowBox[{"0", ",", "0", ",", "1", ",", "0"}], "}"}], 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", "0", "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0", ",", "1", ",", "0"}], "}"}]}], "}"}]},
    {
     RowBox[{"{", 
      RowBox[{"0", ",", "1", ",", "0", ",", "0"}], "}"}], 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"0", ",", "1", ",", "0"}], "}"}], ",", 
       RowBox[{"{", "0", "}"}]}], "}"}]},
    {
     RowBox[{"{", 
      RowBox[{"1", ",", "0", ",", "1", ",", "0"}], "}"}], 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"1", ",", "0"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"1", ",", "0"}], "}"}]}], "}"}]},
    {
     RowBox[{"{", 
      RowBox[{"0", ",", "1", ",", "0", ",", "1", ",", "0"}], "}"}], 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"0", ",", "1", ",", "0"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"1", ",", "0"}], "}"}]}], "}"}]},
    {
     RowBox[{"{", 
      RowBox[{"1", ",", "0", ",", "0", ",", "1", ",", "0"}], "}"}], 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"1", ",", "0"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0", ",", "1", ",", "0"}], "}"}]}], "}"}]},
    {
     RowBox[{"{", 
      RowBox[{"0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "0"}], "}"}], 
     
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"0", ",", "1", ",", "0"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0", ",", "1", ",", "0"}], "}"}]}], "}"}]}
   },
   GridBoxAlignment->{
    "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
     "RowsIndexed" -> {}},
   GridBoxSpacings->{"Columns" -> {
       Offset[0.27999999999999997`], {
        Offset[2.0999999999999996`]}, 
       Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
       Offset[0.2], {
        Offset[0.4]}, 
       Offset[0.2]}, "RowsIndexed" -> {}}],
  Function[BoxForm`e$, 
   TableForm[BoxForm`e$, TableDepth -> 2]]]], "Output",
 CellChangeTimes->{{3.781540029488015*^9, 3.7815400652223473`*^9}, 
   3.78230870838137*^9, 3.782315786361923*^9, 3.7824580601589003`*^9, 
   3.782464412564886*^9, 3.7824644698160343`*^9},
 CellLabel->
  "Out[112]//TableForm=",ExpressionUUID->"29f1a850-9da0-4cd2-85b2-\
bd531df8541e"]
}, Open  ]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Sheet 3 Question 1(iii)", "Section",
 CellChangeTimes->{{3.781540121217566*^9, 3.781540128589517*^9}, {
  3.7815401786610518`*^9, 3.781540194623335*^9}, {3.781540653644951*^9, 
  3.781540673035975*^9}},ExpressionUUID->"c22ceda4-09a0-4fa3-9083-\
abb2d2e333ef"],

Cell[CellGroupData[{

Cell["\<\
 Shortest non-unique concatenation is 0001001 = 000 1001 = 0001 001; more \
interesting is 0000001001\
\>", "Subsection",
 CellChangeTimes->{{3.781540674664379*^9, 
  3.7815406892672377`*^9}},ExpressionUUID->"8fdbbf62-dcf9-4eb6-9843-\
90aecc9334ed"],

Cell[BoxData[
 RowBox[{"ClearAll", "[", "Duplicates", "]"}]], "Input",
 CellChangeTimes->{{3.78154051928625*^9, 3.781540521568576*^9}},
 CellLabel->
  "In[113]:=",ExpressionUUID->"bc8ef057-11e5-4595-a240-1b3de3d50089"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Duplicates", "[", 
   RowBox[{"{", "}"}], "]"}], ":=", 
  RowBox[{"{", "}"}]}]], "Input",
 CellChangeTimes->{{3.781540243169104*^9, 3.7815402552623043`*^9}},
 CellLabel->
  "In[114]:=",ExpressionUUID->"3c2545d7-d0de-4110-a196-4fe99247b5ec"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Duplicates", "[", 
   RowBox[{"{", 
    RowBox[{"p_", ",", "qs___"}], "}"}], "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"qsL", "=", 
       RowBox[{"qs", "//", "List"}]}], ",", "rs", ",", "ss"}], "}"}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"rs", "=", 
      RowBox[{"Select", "[", 
       RowBox[{"qsL", ",", 
        RowBox[{
         RowBox[{
          RowBox[{"#", "[", 
           RowBox[{"[", "1", "]"}], "]"}], "\[Equal]", 
          RowBox[{"p", "[", 
           RowBox[{"[", "1", "]"}], "]"}]}], "&"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"ss", "=", 
      RowBox[{"Select", "[", 
       RowBox[{"qsL", ",", 
        RowBox[{
         RowBox[{"Not", "[", 
          RowBox[{
           RowBox[{"#", "[", 
            RowBox[{"[", "1", "]"}], "]"}], "\[Equal]", 
           RowBox[{"p", "[", 
            RowBox[{"[", "1", "]"}], "]"}]}], "]"}], "&"}]}], "]"}]}], ";", 
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{"rs", "\[Equal]", 
        RowBox[{"{", "}"}]}], ",", 
       RowBox[{"Duplicates", "[", "qsL", "]"}], ",", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{"{", "p", "}"}], "~", "Join", "~", "rs"}], ")"}], "~", 
        "Join", "~", 
        RowBox[{"Duplicates", "[", "ss", "]"}]}]}], "]"}]}]}], 
   "]"}]}]], "Input",
 CellChangeTimes->{{3.78154025675912*^9, 3.7815404191844187`*^9}, {
  3.781540454067069*^9, 3.781540507006735*^9}, {3.781540619026313*^9, 
  3.78154063021216*^9}},
 CellLabel->
  "In[115]:=",ExpressionUUID->"71e38156-7c52-40a9-9ce2-1c40213245cd"],

Cell[BoxData[
 RowBox[{
  RowBox[{"$RecursionLimit", "=", "10000"}], ";"}]], "Input",
 CellChangeTimes->{{3.781541204126618*^9, 3.78154122091647*^9}},
 CellLabel->
  "In[116]:=",ExpressionUUID->"5a2dda3b-6cc7-4abd-b7cf-ac740dd7d728"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"ConcatenationsWithCodewordsAll", "[", 
     RowBox[{"3", ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"0", ",", "0", ",", "0"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"1", ",", "1", ",", "1"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"0", ",", "0", ",", "1"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"0", ",", "0", ",", "0", ",", "1"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"1", ",", "0", ",", "0", ",", "1"}], "}"}]}], "}"}]}], "]"}],
     "//", "Sort"}], "//", "Duplicates"}], "//", "TF"}]], "Input",
 CellChangeTimes->{{3.781540138934266*^9, 3.781540154323778*^9}, {
   3.7815401995061407`*^9, 3.781540241814324*^9}, 3.781541192630557*^9, 
   3.782308722261436*^9},
 CellLabel->
  "In[117]:=",ExpressionUUID->"b1674b3b-964d-4dcf-a0cf-c44de41d71a1"],

Cell[BoxData[
 TagBox[GridBox[{
    {
     RowBox[{"{", 
      RowBox[{
      "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1"}], 
      "}"}], 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"0", ",", "0", ",", "0"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"1", ",", "0", ",", "0", ",", "1"}], "}"}]}], "}"}]},
    {
     RowBox[{"{", 
      RowBox[{
      "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1"}], 
      "}"}], 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"0", ",", "0", ",", "0", ",", "1"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0", ",", "0", ",", "1"}], "}"}]}], "}"}]},
    {
     RowBox[{"{", 
      RowBox[{
      "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
       "0", ",", "0", ",", "1"}], "}"}], 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"0", ",", "0", ",", "0"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0", ",", "0", ",", "0"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"1", ",", "0", ",", "0", ",", "1"}], "}"}]}], "}"}]},
    {
     RowBox[{"{", 
      RowBox[{
      "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
       "0", ",", "0", ",", "1"}], "}"}], 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"0", ",", "0", ",", "0"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0", ",", "0", ",", "0", ",", "1"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0", ",", "0", ",", "1"}], "}"}]}], "}"}]},
    {
     RowBox[{"{", 
      RowBox[{
      "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
       "0", ",", "0", ",", "0"}], "}"}], 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"0", ",", "0", ",", "0"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"1", ",", "0", ",", "0", ",", "1"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0", ",", "0", ",", "0"}], "}"}]}], "}"}]},
    {
     RowBox[{"{", 
      RowBox[{
      "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
       "0", ",", "0", ",", "0"}], "}"}], 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"0", ",", "0", ",", "0", ",", "1"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0", ",", "0", ",", "1"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0", ",", "0", ",", "0"}], "}"}]}], "}"}]},
    {
     RowBox[{"{", 
      RowBox[{
      "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
       "0", ",", "0", ",", "1"}], "}"}], 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"0", ",", "0", ",", "0"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"1", ",", "0", ",", "0", ",", "1"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0", ",", "0", ",", "1"}], "}"}]}], "}"}]},
    {
     RowBox[{"{", 
      RowBox[{
      "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
       "0", ",", "0", ",", "1"}], "}"}], 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"0", ",", "0", ",", "0", ",", "1"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0", ",", "0", ",", "1"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0", ",", "0", ",", "1"}], "}"}]}], "}"}]},
    {
     RowBox[{"{", 
      RowBox[{
      "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
       "1", ",", "1", ",", "1"}], "}"}], 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"0", ",", "0", ",", "0"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"1", ",", "0", ",", "0", ",", "1"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"1", ",", "1", ",", "1"}], "}"}]}], "}"}]},
    {
     RowBox[{"{", 
      RowBox[{
      "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
       "1", ",", "1", ",", "1"}], "}"}], 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"0", ",", "0", ",", "0", ",", "1"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0", ",", "0", ",", "1"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"1", ",", "1", ",", "1"}], "}"}]}], "}"}]},
    {
     RowBox[{"{", 
      RowBox[{
      "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
       "0", ",", "0", ",", "1"}], "}"}], 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"0", ",", "0", ",", "0"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"1", ",", "1", ",", "1"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"1", ",", "0", ",", "0", ",", "1"}], "}"}]}], "}"}]},
    {
     RowBox[{"{", 
      RowBox[{
      "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
       "0", ",", "0", ",", "1"}], "}"}], 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"0", ",", "0", ",", "0", ",", "1"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"1", ",", "1", ",", "1"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0", ",", "0", ",", "1"}], "}"}]}], "}"}]},
    {
     RowBox[{"{", 
      RowBox[{
      "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
       "0", ",", "0", ",", "1"}], "}"}], 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"0", ",", "0", ",", "1"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0", ",", "0", ",", "0"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"1", ",", "0", ",", "0", ",", "1"}], "}"}]}], "}"}]},
    {
     RowBox[{"{", 
      RowBox[{
      "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
       "0", ",", "0", ",", "1"}], "}"}], 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"0", ",", "0", ",", "1"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0", ",", "0", ",", "0", ",", "1"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0", ",", "0", ",", "1"}], "}"}]}], "}"}]},
    {
     RowBox[{"{", 
      RowBox[{
      "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
       "0", ",", "0", ",", "1"}], "}"}], 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"1", ",", "1", ",", "1"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0", ",", "0", ",", "0"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"1", ",", "0", ",", "0", ",", "1"}], "}"}]}], "}"}]},
    {
     RowBox[{"{", 
      RowBox[{
      "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
       "0", ",", "0", ",", "1"}], "}"}], 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"1", ",", "1", ",", "1"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0", ",", "0", ",", "0", ",", "1"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0", ",", "0", ",", "1"}], "}"}]}], "}"}]},
    {
     RowBox[{"{", 
      RowBox[{
      "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
       "1", ",", "0", ",", "0", ",", "1"}], "}"}], 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"0", ",", "0", ",", "0", ",", "1"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0", ",", "0", ",", "0"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"1", ",", "0", ",", "0", ",", "1"}], "}"}]}], "}"}]},
    {
     RowBox[{"{", 
      RowBox[{
      "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
       "1", ",", "0", ",", "0", ",", "1"}], "}"}], 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"0", ",", "0", ",", "0", ",", "1"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0", ",", "0", ",", "0", ",", "1"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0", ",", "0", ",", "1"}], "}"}]}], "}"}]},
    {
     RowBox[{"{", 
      RowBox[{
      "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
       "0", ",", "0", ",", "0", ",", "1"}], "}"}], 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"0", ",", "0", ",", "0"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"1", ",", "0", ",", "0", ",", "1"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0", ",", "0", ",", "0", ",", "1"}], "}"}]}], "}"}]},
    {
     RowBox[{"{", 
      RowBox[{
      "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
       "0", ",", "0", ",", "0", ",", "1"}], "}"}], 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"0", ",", "0", ",", "0", ",", "1"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0", ",", "0", ",", "1"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0", ",", "0", ",", "0", ",", "1"}], "}"}]}], "}"}]},
    {
     RowBox[{"{", 
      RowBox[{
      "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1"}], "}"}], 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"0", ",", "0", ",", "0"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"1", ",", "0", ",", "0", ",", "1"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"1", ",", "0", ",", "0", ",", "1"}], "}"}]}], "}"}]},
    {
     RowBox[{"{", 
      RowBox[{
      "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "1"}], "}"}], 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"0", ",", "0", ",", "0", ",", "1"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0", ",", "0", ",", "1"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"1", ",", "0", ",", "0", ",", "1"}], "}"}]}], "}"}]},
    {
     RowBox[{"{", 
      RowBox[{
      "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
       "1", ",", "0", ",", "0", ",", "1"}], "}"}], 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"1", ",", "0", ",", "0", ",", "1"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0", ",", "0", ",", "0"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"1", ",", "0", ",", "0", ",", "1"}], "}"}]}], "}"}]},
    {
     RowBox[{"{", 
      RowBox[{
      "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
       "1", ",", "0", ",", "0", ",", "1"}], "}"}], 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"1", ",", "0", ",", "0", ",", "1"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0", ",", "0", ",", "0", ",", "1"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0", ",", "0", ",", "1"}], "}"}]}], "}"}]}
   },
   GridBoxAlignment->{
    "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
     "RowsIndexed" -> {}},
   GridBoxSpacings->{"Columns" -> {
       Offset[0.27999999999999997`], {
        Offset[2.0999999999999996`]}, 
       Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
       Offset[0.2], {
        Offset[0.4]}, 
       Offset[0.2]}, "RowsIndexed" -> {}}],
  Function[BoxForm`e$, 
   TableForm[BoxForm`e$, TableDepth -> 2]]]], "Output",
 CellChangeTimes->{
  3.781540158415011*^9, 3.781540200408619*^9, 3.781540647554009*^9, {
   3.781541201532138*^9, 3.781541223081175*^9}, {3.782308709302333*^9, 
   3.7823087228455267`*^9}, 3.7823157865261173`*^9, 3.782458060554017*^9, 
   3.7824644127986526`*^9, 3.782464469972364*^9},
 CellLabel->
  "Out[117]//TableForm=",ExpressionUUID->"e1ff11c1-245a-4cfa-aa2e-\
3706ac35effb"]
}, Open  ]]
}, Open  ]]
}, Open  ]]
},
ScreenStyleEnvironment->"SlideShow",
WindowSize->{1248, 854},
WindowMargins->{{Automatic, 31}, {Automatic, 0}},
FrontEndVersion->"11.3 for Mac OS X x86 (32-bit, 64-bit Kernel) (March 5, \
2018)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[422, 15, 447, 8, 172, "Section",ExpressionUUID->"a875ba7e-0401-48f1-bd1d-340ae123d0b2"],
Cell[872, 25, 453, 7, 135, "Subsection",ExpressionUUID->"d2025e46-bb02-4812-8ab3-e707a367bb69"],
Cell[CellGroupData[{
Cell[1350, 36, 491, 9, 143, "Subsection",ExpressionUUID->"6a89dd2c-12c2-49ec-8975-c2d9c5ff035b"],
Cell[CellGroupData[{
Cell[1866, 49, 169, 3, 54, "Subsubsection",ExpressionUUID->"1b0f790f-c4fe-4051-a49e-af4b4163ea9e"],
Cell[2038, 54, 326, 7, 49, "Input",ExpressionUUID->"abda408d-17e1-43d5-94eb-fc90a3813f4e"],
Cell[2367, 63, 344, 7, 49, "Input",ExpressionUUID->"ff795b01-60d6-453b-be34-9b3e34dca02c"],
Cell[2714, 72, 877, 24, 114, "Input",ExpressionUUID->"88cbb730-8203-4642-91c4-ec1847364828"],
Cell[3594, 98, 279, 6, 49, "Input",ExpressionUUID->"858c1861-dc1d-448f-9a7e-6fb5163b10de"],
Cell[3876, 106, 642, 17, 82, "Input",ExpressionUUID->"a2644d18-4a99-4420-8d13-d396863e5458"],
Cell[4521, 125, 274, 6, 49, "Input",ExpressionUUID->"24adcfbd-b4ce-4d94-9235-7609494842cd"],
Cell[4798, 133, 528, 14, 49, "Input",ExpressionUUID->"f57e00c3-5abf-4b3d-a465-0a9034543394"],
Cell[5329, 149, 347, 8, 49, "Input",ExpressionUUID->"f46a9341-9ceb-415b-ab6f-840062ba9eb6"],
Cell[5679, 159, 331, 7, 49, "Input",ExpressionUUID->"f02a61d3-7f82-4082-a61a-02a7a2a6d875"],
Cell[6013, 168, 938, 24, 114, "Input",ExpressionUUID->"f6f54314-8df0-4735-bf50-1deecc5a4b94"],
Cell[6954, 194, 2245, 54, 178, "Input",ExpressionUUID->"5be75c4e-f687-4947-a80f-39b60ba731a0"],
Cell[9202, 250, 545, 10, 49, "Input",ExpressionUUID->"f8cf1a7d-76ce-478e-9d28-7adcc1190609"],
Cell[9750, 262, 328, 7, 49, "Input",ExpressionUUID->"9b78d3f7-db55-474a-bf13-0488e06afc48"],
Cell[CellGroupData[{
Cell[10103, 273, 293, 6, 49, "Input",ExpressionUUID->"6d3a8497-29a4-477e-b654-a375a06662cd"],
Cell[10399, 281, 422, 11, 49, "Output",ExpressionUUID->"18c10ed7-753d-4466-8910-cdcd09478dda"]
}, Open  ]],
Cell[10836, 295, 577, 16, 49, "Input",ExpressionUUID->"9e322fe7-e590-4946-9251-f7ac5e283531"],
Cell[11416, 313, 443, 10, 49, "Input",ExpressionUUID->"bcf4c60b-6c50-48b6-a96c-8e2616f109f9"],
Cell[11862, 325, 441, 11, 49, "Input",ExpressionUUID->"e2be2bee-5c81-411d-a5db-cfbdf5011fc4"]
}, Open  ]],
Cell[CellGroupData[{
Cell[12340, 341, 273, 6, 54, "Subsubsection",ExpressionUUID->"deb9df8e-0913-47ef-bafe-b7b6e48c083c"],
Cell[12616, 349, 709, 19, 146, "Input",ExpressionUUID->"6aedb948-00c4-4673-adae-5f7170a977ab"]
}, Open  ]],
Cell[CellGroupData[{
Cell[13362, 373, 250, 6, 92, "Subsubsection",ExpressionUUID->"21c41a8a-245f-4a7c-824d-25f56ece8c98"],
Cell[CellGroupData[{
Cell[13637, 383, 229, 4, 49, "Input",ExpressionUUID->"2d9b37c7-0e8f-4adf-a4d8-cbf7df2312cd"],
Cell[13869, 389, 712, 12, 49, "Output",ExpressionUUID->"1ded3356-105d-449b-b08e-0eb412f5bea7"]
}, Open  ]],
Cell[CellGroupData[{
Cell[14618, 406, 268, 5, 49, "Input",ExpressionUUID->"c47092a3-9db4-4447-897a-a2c4daec6707"],
Cell[14889, 413, 881, 14, 49, "Output",ExpressionUUID->"7f4d796e-b260-4ccd-bce2-4913a0fc6dd0"]
}, Open  ]]
}, Open  ]]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[15843, 435, 286, 4, 119, "Section",ExpressionUUID->"d8af78ac-0d51-4fe4-b5b1-da4288f32242"],
Cell[CellGroupData[{
Cell[16154, 443, 541, 10, 130, "Subsubsection",ExpressionUUID->"dfb9e7be-b114-4bc9-a592-311603257294"],
Cell[16698, 455, 412, 11, 49, "Input",ExpressionUUID->"7e33cdfb-bebc-44fd-a0ae-c86d01fa302e"],
Cell[17113, 468, 1505, 38, 114, "Input",ExpressionUUID->"42ebe7f3-051d-4f9a-92e0-c77c2a1b1f76"],
Cell[18621, 508, 832, 23, 82, "Input",ExpressionUUID->"901d1a02-a693-4bc5-bf32-400901396d72"]
}, Open  ]],
Cell[CellGroupData[{
Cell[19490, 536, 488, 9, 130, "Subsubsection",ExpressionUUID->"8e02664d-fb42-4de5-bc36-82e528f1527b"],
Cell[CellGroupData[{
Cell[20003, 549, 661, 19, 49, "Input",ExpressionUUID->"5d1f1b22-a0b2-4a1d-ba42-04b286a07dda"],
Cell[20667, 570, 1810, 48, 162, "Output",ExpressionUUID->"f4adf490-dddf-49f0-b959-5b83f1e016b2"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[22526, 624, 219, 4, 54, "Subsubsection",ExpressionUUID->"3b0fd21b-1038-4fd6-a6d5-0f21a76c9255"],
Cell[CellGroupData[{
Cell[22770, 632, 392, 9, 49, "Input",ExpressionUUID->"4364d70a-96f0-43df-a80b-24462d9b007d"],
Cell[23165, 643, 715, 11, 49, "Output",ExpressionUUID->"0e7b8196-3654-4168-adbd-689c48695225"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[23929, 660, 349, 7, 92, "Subsubsection",ExpressionUUID->"9681e551-6473-4ef0-ab36-8de42933c212"],
Cell[CellGroupData[{
Cell[24303, 671, 379, 9, 49, "Input",ExpressionUUID->"c78dfb08-c4f6-4813-bdb5-51285b619d7c"],
Cell[24685, 682, 953, 19, 49, "Output",ExpressionUUID->"acac196b-1c97-42af-96be-f111edcbab86"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[25687, 707, 199, 3, 92, "Subsection",ExpressionUUID->"8f239119-e3c6-4f01-8672-77d43d1c8d38"],
Cell[25889, 712, 754, 21, 82, "Input",ExpressionUUID->"542c6b6c-794e-40ca-91ab-36be20d1d5e0"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[26692, 739, 155, 3, 119, "Section",ExpressionUUID->"e4065850-46e4-4a56-86ef-c295f4464e0d"],
Cell[CellGroupData[{
Cell[26872, 746, 571, 10, 221, "Subsection",ExpressionUUID->"338b820d-21e1-40ec-b0a5-267e7c261a0f"],
Cell[CellGroupData[{
Cell[27468, 760, 434, 8, 92, "Subsubsection",ExpressionUUID->"2a5f42ea-c0bf-4daf-ba1e-464727d1e2c5"],
Cell[27905, 770, 624, 17, 49, "Input",ExpressionUUID->"2648a8c6-0f83-4213-976e-1d4741c1aabf"]
}, Open  ]],
Cell[CellGroupData[{
Cell[28566, 792, 394, 8, 54, "Subsubsection",ExpressionUUID->"83ff3f6b-5727-47ec-8603-9ca7ccb5acdb"],
Cell[28963, 802, 1183, 28, 114, "Input",ExpressionUUID->"41cfd7cf-2de8-433d-a294-4c7a2b1d66cd"],
Cell[30149, 832, 1519, 37, 146, "Input",ExpressionUUID->"51ae24fa-e0fc-458f-9676-162ec125f542"],
Cell[31671, 871, 606, 15, 49, "Input",ExpressionUUID->"d1a0c254-0b80-43c4-8f24-51a5e8bb37a3"],
Cell[32280, 888, 395, 7, 49, "Input",ExpressionUUID->"bb02457a-01bc-46f4-9d47-b5080a3e40cc"]
}, Open  ]],
Cell[CellGroupData[{
Cell[32712, 900, 231, 4, 54, "Subsubsection",ExpressionUUID->"a94eafad-81cd-4e7a-a0e1-17cd63f712e1"],
Cell[CellGroupData[{
Cell[32968, 908, 498, 10, 49, "Input",ExpressionUUID->"1e0865b0-fa5b-4dd6-ae35-a01945a1c26f"],
Cell[33469, 920, 1343, 29, 82, "Output",ExpressionUUID->"c1107dec-204a-4c6e-a583-7a8e0c78c5c9"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[34861, 955, 563, 10, 130, "Subsubsection",ExpressionUUID->"02f5db8b-cf6f-447b-b61d-16d2df5f8554"],
Cell[35427, 967, 323, 6, 49, "Input",ExpressionUUID->"fa2a2989-3895-4262-9c2f-6395cede1f53"],
Cell[CellGroupData[{
Cell[35775, 977, 669, 19, 49, "Input",ExpressionUUID->"9ab72c29-b8fc-4780-aa04-a2dbc51c4ed8"],
Cell[36447, 998, 1515, 40, 74, "Output",ExpressionUUID->"a6cb3993-e428-4161-a2a0-9ea94bc0ca33"]
}, Open  ]],
Cell[CellGroupData[{
Cell[37999, 1043, 1080, 29, 82, "Input",ExpressionUUID->"4ccf0b60-2978-480b-9d6c-b920af6c4ceb"],
Cell[39082, 1074, 2414, 58, 74, "Output",ExpressionUUID->"8635fee6-52ce-40a4-b8a2-d9e2b5ad641d"]
}, Open  ]]
}, Open  ]]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[41569, 1140, 430, 5, 119, "Section",ExpressionUUID->"66de8343-baef-47dd-b60d-1aa031dfa333"],
Cell[CellGroupData[{
Cell[42024, 1149, 271, 6, 92, "Subsubsection",ExpressionUUID->"10dc3dca-8126-44a3-9a45-5ad2eb440d49"],
Cell[42298, 1157, 2158, 52, 114, "Input",ExpressionUUID->"b7b747e8-e529-4bf9-ac17-3dd639ad6a00"],
Cell[44459, 1211, 1356, 36, 178, "Input",ExpressionUUID->"68c72cdd-3595-421b-b2c8-4fe88ff2da9f"],
Cell[45818, 1249, 280, 5, 49, "Input",ExpressionUUID->"d5dcb474-4d19-42fa-bf55-8a4c6c27996f"],
Cell[46101, 1256, 1609, 32, 114, "Input",ExpressionUUID->"bc6eff28-3986-4e10-a16e-fc9dab13383b"],
Cell[47713, 1290, 1709, 42, 146, "Input",ExpressionUUID->"1f8bae97-8a4a-43ae-8d00-a76c345c49e5"]
}, Open  ]],
Cell[CellGroupData[{
Cell[49459, 1337, 327, 5, 92, "Subsection",ExpressionUUID->"42028e1b-fea8-4433-a867-53272c7bab79"],
Cell[49789, 1344, 735, 20, 82, "Input",ExpressionUUID->"27b789cf-e627-4f78-b9e3-2efb29dab7cf"]
}, Open  ]],
Cell[CellGroupData[{
Cell[50561, 1369, 169, 3, 92, "Subsection",ExpressionUUID->"b6450b4f-c27c-44b4-b5e3-4b1bedb857fa"],
Cell[CellGroupData[{
Cell[50755, 1376, 3175, 87, 302, "Input",ExpressionUUID->"d06c0043-0150-4890-a5bf-9728d628d63b"],
Cell[53933, 1465, 9065, 250, 298, "Output",ExpressionUUID->"5ccd64ca-7326-4e95-ba5c-a15f0239fd33"]
}, Open  ]],
Cell[CellGroupData[{
Cell[63035, 1720, 394, 10, 49, "Input",ExpressionUUID->"de47cfb2-0e50-4ac0-89de-ab179b4acdde"],
Cell[63432, 1732, 1164, 27, 72, "Output",ExpressionUUID->"511094c9-f046-4d25-b710-90e8b169a753"]
}, Open  ]]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[64657, 1766, 413, 6, 119, "Section",ExpressionUUID->"fc73fc71-97a3-4516-b1cd-1a356800bb37"],
Cell[CellGroupData[{
Cell[65095, 1776, 315, 7, 135, "Subsection",ExpressionUUID->"98fd4dd2-3dda-4d7b-bbca-89e32035b328"],
Cell[65413, 1785, 3666, 49, 1362, "Input",ExpressionUUID->"8d0550bb-8534-4f79-b65d-42b9e95180e4"],
Cell[69082, 1836, 3538, 47, 1362, "Input",ExpressionUUID->"2617b313-80fc-43bc-89c6-6e3bdfb7c83e"],
Cell[72623, 1885, 324, 6, 49, "Input",ExpressionUUID->"108614e1-a8f8-48ac-b2e6-d856866e145c"],
Cell[CellGroupData[{
Cell[72972, 1895, 607, 14, 49, "Input",ExpressionUUID->"eb005118-280c-4431-84ec-274fa3c29295"],
Cell[73582, 1911, 3987, 108, 178, "Output",ExpressionUUID->"9e5bfc7c-834e-4641-96cb-b745c09f1865"]
}, Open  ]],
Cell[CellGroupData[{
Cell[77606, 2024, 898, 23, 82, "Input",ExpressionUUID->"5929e9e4-58ee-43cc-b3b5-b7b74946489b"],
Cell[78507, 2049, 4940, 110, 370, "Output",ExpressionUUID->"e43eec1a-d75f-406b-a808-2e6aa3c13625"]
}, Open  ]],
Cell[CellGroupData[{
Cell[83484, 2164, 779, 22, 82, "Input",ExpressionUUID->"21ac65ae-b941-4a82-b194-a2671e06c883"],
Cell[84266, 2188, 346, 7, 49, "Output",ExpressionUUID->"2630bde9-b42a-40d8-bc08-35f15ef091aa"]
}, Open  ]],
Cell[CellGroupData[{
Cell[84649, 2200, 680, 18, 82, "Input",ExpressionUUID->"1ebd9cf3-5651-4be6-b574-c310b0e04b02"],
Cell[85332, 2220, 8456, 217, 598, "Output",ExpressionUUID->"57fea959-2868-4421-84ec-82ca3b6e054e"]
}, Open  ]],
Cell[CellGroupData[{
Cell[93825, 2442, 821, 20, 82, "Input",ExpressionUUID->"0e24f456-f6cc-40a1-ada8-00f916856fd8"],
Cell[94649, 2464, 9014, 226, 598, "Output",ExpressionUUID->"33f35dc6-45eb-4502-88b7-2dfb2939773d"]
}, Open  ]],
Cell[CellGroupData[{
Cell[103700, 2695, 329, 6, 49, "Input",ExpressionUUID->"80d06d30-e113-4d9b-915b-f34f398fc646"],
Cell[104032, 2703, 10645, 241, 375, "Output",ExpressionUUID->"10c393b2-d7ef-4c18-944a-d437cc737cd6"]
}, Open  ]],
Cell[CellGroupData[{
Cell[114714, 2949, 530, 9, 49, "Input",ExpressionUUID->"122b94d1-99aa-4c05-a947-92007bad0e1d"],
Cell[115247, 2960, 11093, 248, 375, "Output",ExpressionUUID->"ea8d5c4e-b216-4ca9-ad1d-64ad0100e2d6"]
}, Open  ]],
Cell[CellGroupData[{
Cell[126377, 3213, 168, 3, 54, "Subsubsection",ExpressionUUID->"7853c72c-6637-4757-a249-f489f4f9361c"],
Cell[CellGroupData[{
Cell[126570, 3220, 534, 9, 82, "Input",ExpressionUUID->"2c8be7f3-ba8d-43a1-9950-33d74d75cbe3"],
Cell[127107, 3231, 1681, 45, 146, "Output",ExpressionUUID->"29afe240-318b-4e3a-8412-b5720dc8bec7"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[128837, 3282, 493, 9, 92, "Subsubsection",ExpressionUUID->"618a4b47-a446-4576-8bdb-e4598e04537e"],
Cell[CellGroupData[{
Cell[129355, 3295, 1447, 38, 178, "Input",ExpressionUUID->"a2072291-7692-42fc-aad4-f89b30fe5ea5"],
Cell[130805, 3335, 464, 10, 49, "Output",ExpressionUUID->"c86b90f5-ba41-4d03-8be0-7759446e656d"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[131318, 3351, 424, 8, 130, "Subsubsection",ExpressionUUID->"1db2472c-a989-4ade-aa48-4233353d725e"],
Cell[CellGroupData[{
Cell[131767, 3363, 600, 13, 49, "Input",ExpressionUUID->"cd46ac3b-cc00-4ef3-ba51-2978a31a228d"],
Cell[132370, 3378, 1023, 16, 49, "Output",ExpressionUUID->"09fe57f3-775f-4ad0-83b3-22e001987adb"]
}, Open  ]],
Cell[133408, 3397, 497, 11, 49, "Input",ExpressionUUID->"3c5738d6-58e5-42d0-bbcc-2713afc4cc0b"],
Cell[CellGroupData[{
Cell[133930, 3412, 1342, 30, 82, "Input",ExpressionUUID->"d2bdc97d-ccdd-4fa2-9214-6cec0b8703c3"],
Cell[135275, 3444, 4497, 113, 438, "Output",ExpressionUUID->"7b1b73f6-93e5-487f-8496-d247a19fa5c0"]
}, Open  ]],
Cell[139787, 3560, 723, 17, 82, "Input",ExpressionUUID->"17cbb892-0668-4627-b0e4-10e6ef606ffb"],
Cell[140513, 3579, 368, 7, 49, "Input",ExpressionUUID->"f74ee56f-acf7-4628-9b3e-0d2ca8edb175"],
Cell[CellGroupData[{
Cell[140906, 3590, 262, 4, 49, "Input",ExpressionUUID->"7377e2fb-95c8-4e82-b806-905b5cca9631"],
Cell[141171, 3596, 10751, 243, 375, "Output",ExpressionUUID->"a12cb9d1-abe5-4dfb-8167-8403b3ca3e14"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[151971, 3845, 254, 6, 54, "Subsubsection",ExpressionUUID->"cc953103-042d-4879-9ea3-01f3ab86918b"],
Cell[CellGroupData[{
Cell[152250, 3855, 390, 8, 49, "Input",ExpressionUUID->"008ed10e-2702-42db-a9f9-e1063d80122d"],
Cell[152643, 3865, 322, 6, 49, "Output",ExpressionUUID->"9c959bbe-9dca-4ca4-be21-aa0f14e74aef"]
}, Open  ]]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[153026, 3878, 187, 3, 92, "Subsection",ExpressionUUID->"ecc7815c-b83c-4b81-9670-5e42fc2269a2"],
Cell[153216, 3883, 601, 17, 82, "Input",ExpressionUUID->"49d71aa3-0c53-4c3e-9bd9-ed9fee3bd24a"],
Cell[CellGroupData[{
Cell[153842, 3904, 1189, 30, 114, "Input",ExpressionUUID->"e9ae3e79-0625-4fb3-ae2c-87299f9367cd"],
Cell[155034, 3936, 3371, 106, 178, "Output",ExpressionUUID->"cbd5ffd4-a49b-411b-b3bc-a409d5d2efd1"]
}, Open  ]],
Cell[CellGroupData[{
Cell[158442, 4047, 1154, 29, 114, "Input",ExpressionUUID->"593f78c7-6509-4558-9504-0706a8f7df73"],
Cell[159599, 4078, 7252, 190, 412, "Output",ExpressionUUID->"d9901ce5-87e2-43c7-9345-303e4f8e8ad9"]
}, Open  ]],
Cell[CellGroupData[{
Cell[166888, 4273, 547, 11, 49, "Input",ExpressionUUID->"9f5ab251-c876-41fc-b966-a6e09fd02a86"],
Cell[167438, 4286, 11075, 248, 375, "Output",ExpressionUUID->"0ede1a63-976e-403a-a6bc-5dd4aed8ea9b"]
}, Open  ]],
Cell[CellGroupData[{
Cell[178550, 4539, 524, 9, 168, "Subsubsection",ExpressionUUID->"e789133b-1954-4cfc-ba20-bf2b14a1a931"],
Cell[CellGroupData[{
Cell[179099, 4552, 3043, 80, 370, "Input",ExpressionUUID->"a20a5b18-1a03-41d7-99b5-06ce875b8d4b"],
Cell[182145, 4634, 632, 16, 82, "Output",ExpressionUUID->"a51eef86-1525-459e-a287-b2b3ec65c2d8"]
}, Open  ]]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[182838, 4657, 195, 3, 92, "Subsection",ExpressionUUID->"0b860d49-f4dc-42f3-901c-4fbc83e19d86"],
Cell[CellGroupData[{
Cell[183058, 4664, 462, 12, 49, "Input",ExpressionUUID->"26d26d2d-ca62-4fa2-befb-ae8d0f7d27e9"],
Cell[183523, 4678, 2785, 60, 186, "Output",ExpressionUUID->"8ed00638-8ece-4a0d-85a2-5c5e5564e68a"]
}, Open  ]],
Cell[CellGroupData[{
Cell[186345, 4743, 466, 12, 49, "Input",ExpressionUUID->"73752c60-b4b2-49c7-a64f-345633781f13"],
Cell[186814, 4757, 2757, 60, 186, "Output",ExpressionUUID->"97749f03-cd8d-48db-8bc4-45e823b0c2a4"]
}, Open  ]],
Cell[CellGroupData[{
Cell[189608, 4822, 488, 13, 49, "Input",ExpressionUUID->"dd27cb1c-cca5-43f4-ac02-e503f89a68b0"],
Cell[190099, 4837, 2756, 60, 186, "Output",ExpressionUUID->"6540ccf0-601b-474c-b73b-fb7484ce593e"]
}, Open  ]],
Cell[CellGroupData[{
Cell[192892, 4902, 568, 14, 49, "Input",ExpressionUUID->"e0b845cb-1c5c-4098-a167-18e7dd0325cb"],
Cell[193463, 4918, 2744, 60, 186, "Output",ExpressionUUID->"3896a470-8b72-48ba-bd74-68deaeda5a4e"]
}, Open  ]],
Cell[196222, 4981, 986, 27, 146, "Input",ExpressionUUID->"00080832-f465-4080-a4d7-4c713daee180"],
Cell[197211, 5010, 932, 23, 146, "Input",ExpressionUUID->"1ef10bf9-8c61-4f4f-bcce-2e66c718913c"],
Cell[198146, 5035, 875, 22, 146, "Input",ExpressionUUID->"660eaa68-05d0-4498-8d7c-c3e55a80ba6e"],
Cell[199024, 5059, 1607, 35, 210, "Input",ExpressionUUID->"b952a643-0840-4d6b-8569-9cfcfa054a10"],
Cell[CellGroupData[{
Cell[200656, 5098, 180, 3, 54, "Subsubsection",ExpressionUUID->"bdca3593-f3da-4cf1-aff0-5a41eb212a75"],
Cell[CellGroupData[{
Cell[200861, 5105, 201, 3, 49, "Input",ExpressionUUID->"54f51ba9-9a2d-4455-9ab7-c2725035218e"],
Cell[201065, 5110, 5000, 165, 370, "Output",ExpressionUUID->"84b83a50-571c-43e5-a189-cf717ad645ff"]
}, Open  ]],
Cell[CellGroupData[{
Cell[206102, 5280, 207, 3, 49, "Input",ExpressionUUID->"c10ea41c-15ab-465d-b3a1-26ae664ed1f0"],
Cell[206312, 5285, 4978, 165, 370, "Output",ExpressionUUID->"20900223-f803-4909-9418-f4aa5492e9f0"]
}, Open  ]],
Cell[CellGroupData[{
Cell[211327, 5455, 218, 3, 49, "Input",ExpressionUUID->"0bd4b734-2f1f-4f31-8085-76111d72bb55"],
Cell[211548, 5460, 5535, 165, 370, "Output",ExpressionUUID->"694c0974-2b15-4cff-ad9a-cc7e85b8242d"]
}, Open  ]],
Cell[CellGroupData[{
Cell[217120, 5630, 235, 4, 49, "Input",ExpressionUUID->"efe9e089-b63b-40ad-b3d6-cd00c85804df"],
Cell[217358, 5636, 5535, 165, 370, "Output",ExpressionUUID->"95eb70ea-715f-428f-8610-f9f819625ecb"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[222942, 5807, 207, 3, 54, "Subsubsection",ExpressionUUID->"f0076efb-21e8-48da-8073-8c36fa4a20e4"],
Cell[CellGroupData[{
Cell[223174, 5814, 1813, 47, 178, "Input",ExpressionUUID->"87761660-9601-47c2-8d9b-4ef606425b3c"],
Cell[224990, 5863, 5556, 146, 145, "Output",ExpressionUUID->"62d5d288-e041-46cc-8ac6-57d38e471fc7"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[230595, 6015, 304, 7, 92, "Subsubsection",ExpressionUUID->"53369676-0b9c-4673-9ecb-4064a30a317c"],
Cell[CellGroupData[{
Cell[230924, 6026, 1552, 43, 178, "Input",ExpressionUUID->"ddb72c67-de72-4f8b-91b3-ce68b49745c3"],
Cell[232479, 6071, 7293, 187, 141, "Output",ExpressionUUID->"bdc43eef-3f44-4842-be65-f2ab573382de"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[239821, 6264, 276, 4, 54, "Subsubsection",ExpressionUUID->"b811dd74-5fcf-4ef7-96df-0a0470f04621"],
Cell[CellGroupData[{
Cell[240122, 6272, 1138, 35, 146, "Input",ExpressionUUID->"f9521149-ab0a-4392-8580-c764575d1350"],
Cell[241263, 6309, 419, 11, 49, "Output",ExpressionUUID->"a4aac865-5f6c-4eb7-98ad-66f3c23c4318"]
}, Open  ]],
Cell[CellGroupData[{
Cell[241719, 6325, 1240, 33, 146, "Input",ExpressionUUID->"1364786c-704e-497c-98d1-0a7b5b716095"],
Cell[242962, 6360, 4588, 106, 259, "Output",ExpressionUUID->"82c4c6e9-bbc1-4b31-b583-b0cfa902d334"]
}, Open  ]]
}, Open  ]]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[247623, 6474, 240, 4, 119, "Section",ExpressionUUID->"91193c89-b79e-4131-aa9b-b5e3c24f0c6e"],
Cell[CellGroupData[{
Cell[247888, 6482, 465, 9, 135, "Subsection",ExpressionUUID->"f2e75d25-52b7-4b74-8af4-34f67cddabe4"],
Cell[CellGroupData[{
Cell[248378, 6495, 355, 8, 49, "Input",ExpressionUUID->"7fd419ad-0203-4baf-bb67-a3b1c5dfe1dd"],
Cell[248736, 6505, 2591, 62, 146, "Output",ExpressionUUID->"15781d4c-5cbc-4068-a9ad-6a7ada7419df"]
}, Open  ]],
Cell[CellGroupData[{
Cell[251364, 6572, 701, 17, 49, "Input",ExpressionUUID->"6d9f4c6c-5bd8-473f-9f60-003f6f0c41d5"],
Cell[252068, 6591, 2787, 62, 146, "Output",ExpressionUUID->"1b54b56b-eed6-4de6-a6a9-5347d185db2e"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[254904, 6659, 288, 7, 92, "Subsection",ExpressionUUID->"9d8b200a-03a5-4f3d-bab0-9195c55aa339"],
Cell[CellGroupData[{
Cell[255217, 6670, 415, 10, 49, "Input",ExpressionUUID->"5f163ee7-9cab-48e9-9a85-992064125b66"],
Cell[255635, 6682, 1140, 26, 49, "Output",ExpressionUUID->"062b0e2b-5129-43bd-bb04-67731404842a"]
}, Open  ]],
Cell[CellGroupData[{
Cell[256812, 6713, 439, 8, 92, "Subsubsection",ExpressionUUID->"e10fa885-34c3-4b53-8408-6306511cbc12"],
Cell[CellGroupData[{
Cell[257276, 6725, 531, 14, 49, "Input",ExpressionUUID->"1fd03017-cbfe-4db5-8dad-36d020b5749a"],
Cell[257810, 6741, 718, 13, 68, "Output",ExpressionUUID->"bb2840c2-8a93-4135-8d01-4ead6a5eaf73"]
}, Open  ]]
}, Open  ]]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[258601, 6762, 285, 4, 119, "Section",ExpressionUUID->"ce0d20e7-36a1-49c2-bb13-ae64f2832fc1"],
Cell[258889, 6768, 367, 9, 49, "Input",ExpressionUUID->"d8d4421a-9d8a-4a71-adda-a69879e28620"],
Cell[259259, 6779, 262, 5, 49, "Input",ExpressionUUID->"9d30dcea-89a3-4eee-80cd-c2f12fc0a723"],
Cell[259524, 6786, 814, 23, 82, "Input",ExpressionUUID->"4ab56f97-982e-4034-81b9-2c350a9de3a1"],
Cell[CellGroupData[{
Cell[260363, 6813, 360, 6, 92, "Subsection",ExpressionUUID->"4ff1706f-52af-4470-87fe-f15e526df0f3"],
Cell[260726, 6821, 588, 13, 82, "Input",ExpressionUUID->"0a9c1bc8-8cf6-4d43-a412-3594d73f096a"],
Cell[261317, 6836, 1891, 49, 146, "Input",ExpressionUUID->"fa131073-5fc6-45c3-8b32-809f2ed717c9"],
Cell[CellGroupData[{
Cell[263233, 6889, 281, 6, 92, "Subsubsection",ExpressionUUID->"af267e85-1bfb-455a-99cd-f314f488b7a1"],
Cell[CellGroupData[{
Cell[263539, 6899, 392, 9, 49, "Input",ExpressionUUID->"4c844271-12c9-4b2d-9a6d-cacd7f4d5204"],
Cell[263934, 6910, 1376, 32, 68, "Output",ExpressionUUID->"750cd906-737d-4cde-8ee3-1cecf6caf191"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[265359, 6948, 438, 8, 130, "Subsubsection",ExpressionUUID->"0d852c54-1cec-4510-8622-c81fa6f8b2f7"],
Cell[CellGroupData[{
Cell[265822, 6960, 1007, 29, 82, "Input",ExpressionUUID->"cdc7622a-23ea-47fa-b94b-94b55f5069db"],
Cell[266832, 6991, 1288, 29, 68, "Output",ExpressionUUID->"c160ca77-f333-4f84-8340-af47d3ece228"]
}, Open  ]],
Cell[CellGroupData[{
Cell[268157, 7025, 800, 20, 49, "Input",ExpressionUUID->"cb3d5eb3-c91b-491e-9a83-cefc6f6d9226"],
Cell[268960, 7047, 4022, 83, 603, "Output",ExpressionUUID->"2a5cb12a-9ac9-4195-aad0-93f4404ff132"]
}, Open  ]]
}, Open  ]]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[273055, 7138, 215, 4, 119, "Section",ExpressionUUID->"dfb10116-0d62-4c07-89f0-4e9a9119abee"],
Cell[CellGroupData[{
Cell[273295, 7146, 1315, 37, 82, "Input",ExpressionUUID->"226a408c-e1b8-4891-9f4d-3e629172443b"],
Cell[274613, 7185, 519, 10, 68, "Output",ExpressionUUID->"181109ca-2b91-4edb-98ab-86ce0c0af9be"]
}, Open  ]],
Cell[CellGroupData[{
Cell[275169, 7200, 1294, 37, 82, "Input",ExpressionUUID->"b03ae8d0-4473-4cd8-9477-d2f3d5d5022a"],
Cell[276466, 7239, 885, 23, 72, "Output",ExpressionUUID->"0792408d-48b3-41dd-803a-9d68e5f0494c"]
}, Open  ]],
Cell[CellGroupData[{
Cell[277388, 7267, 1348, 38, 82, "Input",ExpressionUUID->"648e80fa-1330-47f8-bf97-36b07d3fe554"],
Cell[278739, 7307, 525, 10, 49, "Output",ExpressionUUID->"cb57eab8-f5e9-470e-8e68-138dcabf9787"]
}, Open  ]],
Cell[CellGroupData[{
Cell[279301, 7322, 309, 8, 49, "Input",ExpressionUUID->"d861d627-d30d-46a0-8632-ca5757ede8c3"],
Cell[279613, 7332, 436, 6, 49, "Output",ExpressionUUID->"dc4c5e3f-6f91-4f41-a80f-4b855f63d799"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[280098, 7344, 216, 4, 119, "Section",ExpressionUUID->"d56be952-ec9d-4981-bd05-fef57f2f03cc"],
Cell[CellGroupData[{
Cell[280339, 7352, 270, 6, 49, "Input",ExpressionUUID->"e12fae7f-4bb7-49db-a077-132c0059cd6e"],
Cell[280612, 7360, 621, 11, 49, "Output",ExpressionUUID->"5396ca36-e798-4fd8-bf61-69335b8e38d1"]
}, Open  ]],
Cell[CellGroupData[{
Cell[281270, 7376, 928, 27, 82, "Input",ExpressionUUID->"47e336a2-4be7-4905-8e7e-691d9b21e165"],
Cell[282201, 7405, 2682, 60, 202, "Output",ExpressionUUID->"5db1b542-e271-41a5-bee3-1b718f411b92"]
}, Open  ]],
Cell[CellGroupData[{
Cell[284920, 7470, 557, 16, 49, "Input",ExpressionUUID->"3ea39784-f828-46a3-81d8-6e33e0a8b8ca"],
Cell[285480, 7488, 2341, 55, 202, "Output",ExpressionUUID->"3bfc70de-16b8-4953-ba35-499550cda4c6"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[287870, 7549, 163, 3, 119, "Section",ExpressionUUID->"ff3fc54d-b5d2-4675-ad91-16c0c7a91801"],
Cell[CellGroupData[{
Cell[288058, 7556, 587, 14, 49, "Input",ExpressionUUID->"501f51ef-f39b-462b-b4e8-e4e0614db894"],
Cell[288648, 7572, 1569, 33, 152, "Output",ExpressionUUID->"6ca406cf-2f30-4374-9224-76d9f93284d5"]
}, Open  ]],
Cell[CellGroupData[{
Cell[290254, 7610, 429, 8, 130, "Subsubsection",ExpressionUUID->"c369fa26-c180-4bb0-b03f-04e302a75da4"],
Cell[CellGroupData[{
Cell[290708, 7622, 302, 8, 49, "Input",ExpressionUUID->"a47f3824-e4bd-4eac-baba-769d34df5a8c"],
Cell[291013, 7632, 487, 7, 49, "Output",ExpressionUUID->"76784db3-6da6-4ab8-b8fb-85d42a47764e"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[291549, 7645, 390, 8, 130, "Subsubsection",ExpressionUUID->"cd1925a4-4bc4-4a8b-9332-b33dd4abdc99"],
Cell[CellGroupData[{
Cell[291964, 7657, 417, 11, 49, "Input",ExpressionUUID->"063d99ae-2f99-4d04-a72f-ca6f56c99814"],
Cell[292384, 7670, 827, 22, 49, "Output",ExpressionUUID->"cba48619-c07a-439e-8106-36ae9e13c9ef"]
}, Open  ]],
Cell[CellGroupData[{
Cell[293248, 7697, 1149, 34, 82, "Input",ExpressionUUID->"7344b8a8-5462-493d-8944-76576eb05e1c"],
Cell[294400, 7733, 2943, 71, 558, "Output",ExpressionUUID->"21b2a030-8ffa-40be-a504-4a97281d24eb"]
}, Open  ]],
Cell[CellGroupData[{
Cell[297380, 7809, 225, 5, 49, "Input",ExpressionUUID->"c35bbaf7-0a26-469b-bec0-948716a6959a"],
Cell[297608, 7816, 290, 5, 49, "Output",ExpressionUUID->"edfd8b44-dc6b-4bbd-a1de-1ad912e498b7"]
}, Open  ]]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[297959, 7828, 195, 3, 119, "Section",ExpressionUUID->"494b2e01-65e8-48ea-bc71-3f8a3af6d80f"],
Cell[298157, 7833, 538, 13, 49, "Input",ExpressionUUID->"3a47052e-1290-4a9e-b79c-40103249e311"],
Cell[298698, 7848, 1075, 29, 114, "Input",ExpressionUUID->"09db2460-c3dd-46c3-b2c6-48b46e7a5f93"],
Cell[299776, 7879, 498, 13, 49, "Input",ExpressionUUID->"089d3919-2354-46e5-8483-cf195d3b58fe"],
Cell[300277, 7894, 552, 14, 82, "Input",ExpressionUUID->"9091b994-e032-4709-8484-3d92fd423ed2"],
Cell[CellGroupData[{
Cell[300854, 7912, 392, 8, 130, "Subsubsection",ExpressionUUID->"48cdaf46-f621-4eaf-bfa5-67ef4ec6e341"],
Cell[CellGroupData[{
Cell[301271, 7924, 533, 15, 49, "Input",ExpressionUUID->"c834a20b-5e04-483c-86dd-561b6a06777a"],
Cell[301807, 7941, 3473, 115, 380, "Output",ExpressionUUID->"29f1a850-9da0-4cd2-85b2-bd531df8541e"]
}, Open  ]]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[305341, 8063, 265, 4, 119, "Section",ExpressionUUID->"c22ceda4-09a0-4fa3-9083-abb2d2e333ef"],
Cell[CellGroupData[{
Cell[305631, 8071, 259, 6, 135, "Subsection",ExpressionUUID->"8fdbbf62-dcf9-4eb6-9843-90aecc9334ed"],
Cell[305893, 8079, 218, 4, 49, "Input",ExpressionUUID->"bc8ef057-11e5-4595-a240-1b3de3d50089"],
Cell[306114, 8085, 275, 7, 49, "Input",ExpressionUUID->"3c2545d7-d0de-4110-a196-4fe99247b5ec"],
Cell[306392, 8094, 1661, 49, 146, "Input",ExpressionUUID->"71e38156-7c52-40a9-9ce2-1c40213245cd"],
Cell[308056, 8145, 233, 5, 49, "Input",ExpressionUUID->"5a2dda3b-6cc7-4abd-b7cf-ac740dd7d728"],
Cell[CellGroupData[{
Cell[308314, 8154, 901, 23, 82, "Input",ExpressionUUID->"b1674b3b-964d-4dcf-a0cf-c44de41d71a1"],
Cell[309218, 8179, 11358, 330, 690, "Output",ExpressionUUID->"e1ff11c1-245a-4cfa-aa2e-3706ac35effb"]
}, Open  ]]
}, Open  ]]
}, Open  ]]
}
]
*)

